// -*- c -*-
// (setq c-basic-offset 4)
// ("clsFilename.cpp")

#ifndef _FILENAME_H_
#define _FILENAME_H_

#define _FN_FULLPATH        0
#define _FN_DRIVE           1
#define _FN_DIR             2
#define _FN_DRIVE_DIR       3
#define _FN_FNAME           4
#define _FN_DRIVE_DIR_FNAME 7
#define _FN_EXT             8
#define _FN_FNAME_EXT       12

#define _FN_INCREMENT_TAIL  0
#define _FN_INCREMENT_EXT   1

#include <string>
#include <vector>
#include <wx/wx.h>

class SplitPath_cls{ 
 public:
    std::wstring msFullPath;
    std::wstring msFullPathMinusExt;
    std::wstring msDirPlusDrive;
    std::wstring msFilename;
    std::wstring msExt;
    
    std::wstring GetPathStr(int flag = _FN_FULLPATH);
    std::wstring GetPathDirLast();
    SplitPath_cls(std::wstring pathStr);
};

class SplitPathWX_cls{
 public:
    SplitPathWX_cls(wxString pathStr);

    wxString mwsFullPath;
    wxString mwsFullPathMinusExt;
    wxString mwsDirPlusDrive;
    wxString mwsFilename;
    wxString mwsExt; // .t
    
    wxString GetPathWXStr(int flag = _FN_FULLPATH);
    wxString GetPathDirLast();
    wxString GetImageTypeStr();
};

class Filename_cls{ 
 public:
    std::wstring mSPath;
        
    Filename_cls();
    Filename_cls(const wxChar *path);
    Filename_cls(const std::wstring pathStr);

    std::wstring GetPathStr();
    
    const wchar_t* c_str();

    void  Set(std::wstring strPath);

    static void DoubleSlash(std::wstring &str);
    static void DoubleSlash(wxString &str);
};

class FilenameWX_cls{
 public:
    wxString mwsPath;
    FilenameWX_cls();
    FilenameWX_cls(const wxChar *path);
    FilenameWX_cls(wxString pathStr);

    wxString GetPathWXStr(int flag = _FN_FULLPATH);

    const wxChar* c_str();

    void  Set(wxString strPath);

    static void DoubleSlash(wxString &str);
};

class FileSequenceWX_cls : public FilenameWX_cls {
 public:
    FileSequenceWX_cls();
    FileSequenceWX_cls(const wxChar* path);
    FileSequenceWX_cls(wxString pathStr);

    void Set(const wxString pathStr);

    int SequenceFormatPos();

    void InitFormat();
    void SplitFormat(int pos);
    void CalcMaxOffset();

    // abc/def0000.ext
    // abc/def         msFileHead; 
    // anc/def%03d.ext msFormat;
    wxString mwsFileHead;
    wxString mwsFormat;
    wxString mwsExt;
    
    int         mChannel;     // (KvȂ)RGB
    int         mDigit;       // AԂ̍ŏ̐
    int         mDigitLength; // AԂ̌
    int         mSeqLength;   // t@C
    int         mZSliceInit;  // zXCX̍ŏ̐
    wxString GetFormat();
    int      CountNumericalExpression(wxString strFormat, 
				      std::vector <int> &VOrder);
    wxString GetModifiedWXStr(int index, int stereo = 0, 
			      bool bModifyAll = TRUE);
    wxString GetInfoStr();
    wxString GetChannelStr();
    void AppendDefaultSequenceTag();
};

    /*
    static void  Err(std::wstring messageStr);
 
    Filename_cls operator += (std::wstring argStr);
  
    char  GetLastChar();
    
    static std::wstring GetStr(const char* pPath, int flag);
    std::wstring GetStr(int flag);

    // sIhext
    static std::wstring GetExtentionStr(const char *pPath);
    static std::wstring GetExtentionStr(std::wstring pathStr);
    std::wstring GetExtentionStr();
  
    std::wstring ChangeExtension(std::wstring newext); 
    const char* ChangeFilenameInFrontOfSeq(char *pcNew); //AԕȊO̖OύX
    static std::wstring CapitalizeDriveLetter(std::wstring pathStr);
  
    // t@C̍Ōɕ
    const char* InsertCharInFrontOfExt(const char *ipToAdd); 
    // t@C̘Aԕ̑Oɕ
    const char* InsertCharInFrontOfSeq(char *toadd); 

    const char* Increment(int type, int inc);

    static std::wstring GetExeDirStr();
    
    // ~t̃t@Cɂ
    static std::wstring GetCollapsedPath(std::wstring pathStrOrg);
    void  CollapsePath();

    // ~t̃t@CWJ
    static std::wstring GetExpandedPath(std::wstring pathStr);
    void  ExpandPath();

    // Nt@C̃N𓾂
    static std::wstring GetLinkedFileStr(const char *ipLinkFile);
};
    */

bool operator==(const Filename_cls& CLeft,
		const Filename_cls& CRight);


#endif //_FILENAME_H_
