
#ifndef _IMPORT_LIST_H_
#define _IMPORT_LIST_H_

#include "../CONFITEM/clsConfItem.h"
#include "../WIDGETCTRL/clsMultiNumericalInputs.h"
#include "../WIDGETCTRL/clsDialogEXKey.h"
#include "../WIDGETCTRL/clsDialogController.h"

#define _IMPORT_LIST_ALL    0
#define _IMPORT_LIST_RENDER 1
#define _IMPORT_LIST_PATH   2

class ImportList_cls;
class FrameMain_cls;

class ImportListGUI_cls : public wxDialogEXKey {
 public:
    ImportListGUI_cls(ImportList_cls *pCParent, wxWindow *pC,
		      wxPoint pos, wxSize size);
    ~ImportListGUI_cls();

    void OnButtonOK       (wxCommandEvent &event);
    void OnButtonClose    (wxCommandEvent &event);

    ImportList_cls *mpCParent;

    static MultiNumericalInputsPanel_cls* mpCMNumMainParam;
    void SetMNumMainParam(wxBoxSizer *pBoxSizer);

 private:
    // any class wishing to process wxWidgets events must use this macro
    DECLARE_EVENT_TABLE();
};

class ImportList_cls : 
public DialogControl_cls{
 public:
    ImportList_cls(FrameMain_cls *pC);
    ~ImportList_cls();
    void UpdateItems(bool bForce = FALSE);
    void SetToDefault(unsigned int type);

    ConfItemList_cls mCConfList;

    ConfItemBOOL_cls mCbPathLine;
    ConfItemBOOL_cls mCbStereo;
    ConfItemBOOL_cls mCbHotSpot;
    ConfItemBOOL_cls mCbLight;
    ConfItemBOOL_cls mCbBoxSize;
    ConfItemBOOL_cls mCbAlpha;
    ConfItemBOOL_cls mCbSceneInfo;
    
    ConfItemBOOL_cls mCbDF3Seq;
    ConfItemBOOL_cls mCbPovRay;
    ConfItemBOOL_cls mCbFilters;
    ConfItemBOOL_cls mCbCustomColor;

    ImportListGUI_cls* mpCGUI;
    FrameMain_cls* mpCParentFrame;
    wxRect mCScreenRect;

    void InitGUI(wxWindow *pC);
};

#endif
