// (setq c-basic-offset 4)

#include "clsExportDF3.h"
#include "../clsDF3Sequence.h"
#include "../clsDF3.h"
#include "../GL/clsPreviewProperty.h"

#include "../../COMMON/MyEndian.h"
#include "../../MYAPI/MsgBox.h"

#include <fstream>

#define X 0
#define Y 1
#define Z 2
#define LOOP_XYZ for (int xyz = 0; xyz < 3; xyz++)

ExportDF3_cls::
ExportDF3_cls(DF3_cls *pCParent){
    mpCParent = pCParent;
}

bool ExportDF3_cls::
OutputDF3(wxString strFilename, bool bMirroring[3]){
    
    std::fstream ifstream(wxFNCONV(strFilename), std::ios::in | std::ios::binary);
    if (! ifstream.fail()) { // Ă܂t@C
	MsgBox(NULL,
	       wxString::Format(wxT("%s %s"),
				strFilename.c_str(),
				_("overwrite forbidden")),
	       _("Write Error") );
	return FALSE;
    }
    
    std::fstream ofstream(wxFNCONV(strFilename), std::ios::out | std::ios::binary);

    if (ofstream.fail()) {
	MsgBox(NULL,
	       wxString::Format(wxT("%s can not open"),
				strFilename.c_str()),
				_("Write Error"));
	return FALSE;
    }

    short buffer[3];
    int   size[3], newsize[3];
    LOOP_XYZ buffer[xyz] = mpCParent->GetCurrSize(xyz);
    LOOP_XYZ size[xyz] = buffer[xyz];
    LOOP_XYZ if (bMirroring[xyz] == TRUE) buffer[xyz] *= 2;
    LOOP_XYZ newsize[xyz] = buffer[xyz];
    
    LOOP_XYZ MyEndian::SwapByte((void*)&buffer[xyz], 2);
    
    ofstream.write((char*)buffer, 6);

    bool bIsFilterProcessRequired = 
	mpCParent->mspCProperty->IsFilterProcessRequired(mpCParent->mpCParent->mSelfIndex);

    unsigned char *pTarget = mpCParent->mpMainXYZ[Z];
    if (bIsFilterProcessRequired == TRUE && 
	mpCParent->mbProcessFinished == TRUE)
	pTarget = mpCParent->mpProcessedXYZ[Z];
    else if (bIsFilterProcessRequired == TRUE && 
	     mpCParent->mbProcessFinished == FALSE){
	mpCParent->ProcessXYZData();
	pTarget = mpCParent->mpProcessedXYZ[Z];
    }
    
    if (bMirroring[X] == FALSE && bMirroring[Y] == FALSE && 
	bMirroring[Z] == FALSE)
	ofstream.write((char*)pTarget, mpCParent->GetCurrentTotalSize());
    else{
	unsigned char *pData = 
	    new unsigned char [newsize[X] * newsize[Y] * newsize[Z]];
	
	for (int z = 0; z < newsize[Z]; z++){
	    int offsetZ = z * newsize[Y] * newsize[X];
	    for (int y = 0; y < newsize[Y]; y++){
		int offsetY = offsetZ + y * newsize[X];
		for (int x = 0; x < newsize[X]; x++)
		    pData[offsetY + x] = 255;
	    }
	}

	int baseOffset = 0;
	if (bMirroring[Z] == TRUE)
	    baseOffset += newsize[X] * newsize[Y] * newsize[Z] / 2;
	if (bMirroring[Y] == TRUE)
	    baseOffset += newsize[X] * newsize[Y] / 2;
	if (bMirroring[X] == TRUE)
	    baseOffset += newsize[X] / 2;

	for (int z = 0; z < size[Z]; z++){
	    int orgOffsetZ = z * size[Y] * size[X];
	    int newOffsetZ = baseOffset + z * newsize[Y] * newsize[X];
	    for (int y = 0; y < size[Y]; y++){
		int orgOffset = orgOffsetZ + y * size[X];
		int newOffset = newOffsetZ + y * newsize[X];
		memcpy(pData+newOffset, pTarget+orgOffset, size[X]);
	    }
	}
	
	if (bMirroring[X] == TRUE)
	    for (int z = 0; z < size[Z]; z++){
		int offsetZ = baseOffset + z * newsize[Y] * newsize[X];
		for (int y = 0; y < size[Y]; y++){
		    int offsetY = offsetZ + y * newsize[X];
		    for (int x = 0; x < size[X]; x++)
			pData[offsetY - x - 1] = pData[offsetY + x];
		}
	    }

	if (bMirroring[Y] == TRUE){
	    baseOffset = newsize[X] * newsize[Y] / 2;
	    if (bMirroring[Z] == TRUE)
		baseOffset += newsize[X] * newsize[Y] * newsize[Z] / 2;
	    for (int z = 0; z < size[Z]; z++){
		int offsetZ = baseOffset + z * newsize[Y] * newsize[X];
		for (int y = 0; y < size[Y]; y++){
		    int offsetYorg = offsetZ + y * newsize[X];
		    int offsetYnew = offsetZ - (y+1) * newsize[X];
		    /*
		    for (int x = 0; x < newsize[X]; x++)
			pData[offsetYnew + x] = pData[offsetYorg + x];
		    */
		    memcpy(pData+offsetYnew, pData+offsetYorg, newsize[X]);
		}
	    }
	}

	if (bMirroring[Z] == TRUE){
	    baseOffset = newsize[X] * newsize[Y] * newsize[Z] / 2;
	    for (int z = 0; z < size[Z]; z++){
		int offsetZorg = baseOffset + z * newsize[Y] * newsize[X];
		int offsetZnew = baseOffset - (z+1) * newsize[Y] * newsize[X];
		for (int y = 0; y < newsize[Y]; y++){
		    int offsetYorg = offsetZorg + y * newsize[X];
		    int offsetYnew = offsetZnew + y * newsize[X];
		    memcpy(pData+offsetYnew, pData+offsetYorg, newsize[X]);
		}
	    }
	}
	
	ofstream.write((char*)pData, newsize[X] * newsize[Y] * newsize[Z]);
	
	delete [] pData;
    }
    
    // ꎞIȃ[`
    /*
    LOOP_XYZ buffer[xyz] /= 2;
    LOOP_XYZ MyEndian::SwapByte((void*)&buffer[xyz], 2);

    ofstream.write((char*)buffer, 6);

    for (int z = 0; z < mpCParent->GetCurrSize(Z)/2; z++)
	for (int y = 0; y < mpCParent->GetCurrSize(Y)/2; y++)
	    for (int x = 0; x < mpCParent->GetCurrSize(X)/2; x++){
		int offset = z*2 * mpCParent->GetCurrSize(X) * mpCParent->GetCurrSize(Y)
		    + y * 2 * mpCParent->GetCurrSize(Y) 
		    + x * 2;
		ofstream.write((char*)mpCParent->mpMainXYZ[Z]+offset,
			       1);
	    }
    */
    
    
    return TRUE;
}
