// (setq c-basic-offset 4)

#include "clsExportImgSeq.h"
#include "../clsDF3Sequence.h"
#include "../clsDF3.h"
#include "../GL/clsPreviewProperty.h"

//#include "../../COMMON/MyEndian.h"
#include "../../MYAPI/MsgBox.h"

#include <fstream>

#define X 0
#define Y 1
#define Z 2
#define LOOP_XYZ for (int xyz = 0; xyz < 3; xyz++)

ExportIMGSeq_cls::
ExportIMGSeq_cls(DF3_cls *pCParent){
    mpCParent = pCParent;
}

bool ExportIMGSeq_cls::
OutputIMGSeq(FileSequenceWX_cls CFileSequence, wxStatusBar *pCStatusBar){

    for (unsigned int z = 0; z < mpCParent->GetCurrSize(Z); z++){
	wxString strFileOut = CFileSequence.GetModifiedWXStr(z);
	
	std::fstream ifstream(wxFNCONV(strFileOut), std::ios::in | std::ios::binary);
	if (! ifstream.fail()) { // Ă܂t@C
	    MsgBox(NULL,
		   wxString::Format(strFileOut + wxT("%s"),
				    _("overwrite forbidden")),
		   _("Write Error") );
	    return FALSE;
	}

	wxImage CImage(mpCParent->GetCurrSize(X), mpCParent->GetCurrSize(Y));
	unsigned char *pData = (unsigned char*)malloc (mpCParent->GetCurrSize(X) * mpCParent->GetCurrSize(Y) * 3);

	int offsetZ = z * mpCParent->GetCurrSize(Y) * mpCParent->GetCurrSize(X);

	if (mpCParent->mspCProperty->IsFilterProcessRequired
	    (mpCParent->mpCParent->mSelfIndex) == TRUE && 
	    mpCParent->mbProcessFinished == TRUE){
	    for (int unsigned y = 0; y < mpCParent->GetCurrSize(Y); y++){
		int offsetY = y * mpCParent->GetCurrSize(X);
		for (int unsigned x = 0; x < mpCParent->GetCurrSize(X); x++){
		    int offsetXY = offsetY + x;
		    int offsetXYZ = offsetZ + offsetXY;
		    pData[offsetXY * 3]   =
			mpCParent->mpProcessedXYZ[Z][offsetXYZ];
		    pData[offsetXY * 3+1] =
			mpCParent->mpProcessedXYZ[Z][offsetXYZ];
		    pData[offsetXY * 3+2] =
			mpCParent->mpProcessedXYZ[Z][offsetXYZ];
		}
	    }
	}
	else{
	    for (int unsigned y = 0; y < mpCParent->GetCurrSize(Y); y++){
		int offsetY = y * mpCParent->GetCurrSize(X);
		for (int unsigned x = 0; x < mpCParent->GetCurrSize(X); x++){
		    int offsetXY = offsetY + x;
		    int offsetXYZ = offsetZ + offsetXY;
		    pData[offsetXY * 3] = mpCParent->mpMainXYZ[Z][offsetXYZ];
		    pData[offsetXY * 3+1] = mpCParent->mpMainXYZ[Z][offsetXYZ];
		    pData[offsetXY * 3+2] = mpCParent->mpMainXYZ[Z][offsetXYZ];
		}
	    }
	}
	
	CImage.SetData(pData); // delete 󂯓n

	if (CImage.SaveFile(strFileOut) == FALSE){
	    MsgBox(NULL, strFileOut + wxT("%s save failed"), _("Write Error"));
	    return FALSE;
	}

	pCStatusBar->SetStatusText(wxString::Format(wxT("export %d/%d"), z, mpCParent->GetCurrSize(Z), 2));
	pCStatusBar->Refresh();
	pCStatusBar->Update();
	
    }
    
    return TRUE;
}
    
