// (setq c-basic-offset 4)

#include "clsReadBodyDF3.h"
#include "../clsDF3.h"
#include "../GL/clsColoring.h"
extern Coloring_cls GCColoring;

#include "../../COMMON/MyEndian.h"

#include "../../MYAPI/MsgBox.h"

#include <wx/utils.h>
#include <wx/wx.h>
#include <fstream>
#include <time.h>

#define X 0
#define Y 1
#define Z 2
#define LOOP_XYZ for (int xyz = 0; xyz < 3; xyz++)

#define ENDLWX wxT("\n")

/*
void ReadBodyDF3_cls::
DensityModifier(unsigned char *pIni, unsigned int size){
    for (unsigned int i = 0; i < size; i++){
	float value = ((float)pIni[i]) / 255;
	pIni[i] =  (unsigned char)(GCColoring.GetModulator(value) * 255);
    }
}
*/

bool ReadBodyDF3_cls::
MainProcess(bool type, wxWindow *pC){
    Initialize(mpC->GetCurrSize(Z));

    mpC->mOldPointXYZ = 10;
    assert(mpC->IsAllocated() == TRUE);

    std::fstream ifstream(wxFNCONV(mpC->GetFilePathWXStr()),
			  std::ios::in | std::ios::binary);

    size_t fileSize = (size_t)ifstream.seekg(0, std::ios::end).tellg();
    ifstream.seekg(0, std::ios::beg);
    if (fileSize != mpC->GetCurrentTotalSize() + 6){
	wxString strMessage = _("File Size Inconsistency");
	strMessage << ENDLWX << mpC->GetFilePathWXStr() << ENDLWX;
	strMessage << wxString::Format(_T("Filesize = %d : Expected size = %d"), fileSize, mpC->GetCurrentTotalSize() + 6);
	MsgBox(pC, strMessage, _T("read Error Main"));
	return FALSE; }
    
    if (ifstream.fail()) {
	MsgBox(pC, _T("read Error Main"),
	       mpC->GetFilePathWXStr() + _("can not open"));
	return FALSE; }
    
    if (mpC->mpDownSizeSrc[X] == 1 &&
	mpC->mpDownSizeSrc[Y] == 1 && 
	mpC->mpDownSizeSrc[Z] == 1)
	for (unsigned int z = mNext; z < mpC->mCurrSize[Z]; z+= 8){
	    int zWidth = 8;
	    if (z > mpC->mCurrSize[Z] - 8) zWidth = mpC->mCurrSize[Z] - z;
	    ifstream.seekg(6 + 
			   mpC->GetCurrSizeSxT(Z) * z,
			   std::ios::beg);
	    ifstream.read((char*)mpC->mpMainXYZ[Z] +
			  mpC->GetCurrSizeSxT(Z) * z,
			  mpC->GetCurrSizeSxT(Z) * zWidth);
	    /*
	    if (GCColoring.mCbErf.mbBody == TRUE ||
		GCColoring.mCbGammaCurve.mbBody == TRUE)
		DensityModifier(mpC->mpMainXYZ[Z] +
				mpC->GetCurrSizeSxT(Z) * z,
				mpC->GetCurrSizeSxT(Z) * zWidth);
	    */
	    mNext = z + 8;
	    if (IsResumeConditionSatisfied(type) == TRUE) break;
	}
    else{
	// ---- READ with DownSize ----
	for (unsigned int z = mNext; z < mpC->mCurrSize[Z]; z += 1){
	    unsigned char *buf;
	    buf = new unsigned char [mpC->GetTrueSizeSxT(Z)];
	    ifstream.seekg(6 + 
			   mpC->GetTrueSizeSxT(Z) * z * mpC->mpDownSizeSrc[Z],
			   std::ios::beg);
	    ifstream.read((char*)buf,
			  mpC->GetTrueSizeSxT(Z));
	    
	    for (unsigned int y = 0; y < mpC->mCurrSize[Y]; y++)
		for (unsigned int x = 0; x < mpC->mCurrSize[X]; x++)
		    *(mpC->mpMainXYZ[Z] + 
		      mpC->GetCurrSizeSxT(Z) * z +
		      mpC->GetCurrSizeS(Z) * y + x) = 
			buf[mpC->GetTrueSizeS(Z) * y *  mpC->mpDownSizeSrc[Y]
			   + x * mpC->mpDownSizeSrc[X]];
	    
	    delete buf;
	    mNext = z + 1;
	    if (IsResumeConditionSatisfied(type) == TRUE) break;
	}
    }
    
    if (IsFinishConditionSatisfied() == FALSE) return TRUE;
    
    Finalize();
    mpC->mbDirty = TRUE;

    return TRUE;
}

bool ReadBodyDF3_cls::
ReadHeaderInfo(wxWindow *pCWindow){
    
    std::fstream ifstream(wxFNCONV(mpC->GetFilePathWXStr()), std::ios::in | std::ios::binary);
    
    if (ifstream.fail()) {
	MsgBox(pCWindow, mpC->GetFilePathWXStr() + _("can not open"),
	       _("read error Header DF3"));
	return FALSE; }

    short buffer[3];
    ifstream.read((char*)buffer, 6);
    
    LOOP_XYZ{
	MyEndian::SwapByte((void*)&buffer[xyz], 2);
	mpC->mTrueSize[xyz] = buffer[xyz];
    }

    return TRUE;
}
