// -*- c -*- 
// "clsPanelAA.cpp"

#ifndef _ACTIVE_AREA_PANEL_H_
#define _ACTIVE_AREA_PANEL_H_

#include <wx/wx.h>

//#include "clsDF3Sequence.h"
class DF3Sequence_cls; 

#define _AA_SEL_MIN 1
#define _AA_SEL_MAX 2
#define _AA_SEL_REGION 3

class PanelAA_cls : public wxPanel {
 public:
    PanelAA_cls(DF3Sequence_cls *pParent,
		wxWindow *parent, wxWindowID id, wxPoint pos, wxSize size);
    ~PanelAA_cls();

    void UpdateDisplay();
    void OnPaint(wxPaintEvent& event);
    
    void SetMemberSize(wxSize size);
    int  GetDeviceX(float x);

    int  mWidth, mHeight;
    int  mOffset;

    void OnMouse(wxMouseEvent& event);
    void OnChar(wxKeyEvent& event);

 private:
    DF3Sequence_cls *mpCParent;

    bool  mbCaptureMouse;
    int   mSelected;
    int   mFrameAtClick, mMinAtClick, mMaxAtClick;
    int   mPosCurrent, mFrameCurrent;
    int   mX0, mX1;
    void  CalcCoordinateX0X1(unsigned int frame, unsigned int step,
			     unsigned int minIndex, unsigned int maxIndex);
    int   CalcFrameFromPosition(int position, unsigned int minIndex, unsigned int maxIndex);
    
    // any class wishing to process wxWidgets events must use this macro
    DECLARE_EVENT_TABLE()
};
    
#endif
