//(setq c-basic-offset 4)

#ifndef _FILTER_BASE_H_
#define _FILTER_BASE_H_

#include "../CONFITEM/clsConfItem.h"

class DF3SeqGUI_cls;
class DF3SeqCtrl_cls;
class DF3Sequence_cls;
class FilterBase_cls;
class FilterCtrl_cls;
class FilterPanels_cls;
class MultiNumericalInputsPanel_cls;
class MultiNumericalInputs_cls;
class PovIsosurfaceGUI_cls;
class PovRay_cls;
class Preference_cls;
class TreeBoxRule_cls;
class wxButtonEX;
class wxCheckBoxEX;
class wxBoxSizer;
class PositionAndDirection_cls;

#define _FILTER_ISOSURFACE 0
#define _FILTER_FOG        1
#define _FILTER_BOXCOPY    2
#define _FILTER_CLIPPING   3
#define _FILTER_VOLUME     4
#define _FILTER_BLURING    5
#define _FILTER_LEVEL_GAMMA 6
#define _FILTER_INV_DIFFUSE 7
#define _FILTER_FIX_POSITION 8
#define _FILTER_DATA_ROTATE 9
#define _FILTER_LAYER_COLOR_CURVE 10
#define _FILTER_CROSS_SECTION 11
#define _FILTER_POV_OBJECT 12
#define _FILTER_CENTEROFMASS 13
#define _FILTER_POV_DIFFOBJECT 14
#define _FILTER_MORPH_OPENCLOSE 15
#define _FILTER_THREEVIEW 16
#define _FILTER_STREAMLINE 17
#define _FILTER_VELOCITY_FIELD 18
#define _MAX_FILTER 19

// _MAX_FILTER 𑝂₵AFilterData_cls::msDataBlockTagStr[_MAX_FILTER]
// ̐ݒYꂸ

#define _KERNEL_SPHERE 0
#define _KERNEL_ELLIPSOID 1

#ifdef _DEBUG
#include <stdlib.h>
#include <crtdbg.h>
#define new new(_NORMAL_BLOCK, __FILE__, __LINE__)
#endif

class FilterGUI_cls {
 public:
    FilterGUI_cls(FilterBase_cls *pCParent);
    virtual ~FilterGUI_cls();
 public:
    FilterBase_cls *mpCParentBase;
    static DF3SeqCtrl_cls *mspCDF3SeqCtrlLink;
    
    unsigned int mFilterType;
    bool         mbSelected;

    MultiNumericalInputsPanel_cls *mpCMNumPanel;
    MultiNumericalInputsPanel_cls* 
	InitializeMNumPanel(wxWindow *pCParentWindow);
    
    wxButtonEX *mpBTNShow;
    wxCheckBoxEX *mpCheckBoxValid;
    //void     *mpObjectForDelete;
    void     *mpObjectForCustomA;
    void     *mpObjectForCustomB;
    void     *mpObjectForCustomC;

    void    SetFilterBaseCommonSettings(wxString strTitle, bool *pbValid);
    void    SetValueFLOAT(int index, float value);
    void    SetValueINT(int index, int value);
    void    SetValueBOOL(int index, bool value);

    virtual void HideAndShowItems() = 0;
    virtual void CustomA() = 0;
    virtual void CustomB() = 0;
    virtual void CustomC() = 0;
};

#define MACRO_DefGUIMainSettings(Filter)\
    public:			     \
    Filter##GUI_cls(Filter##_cls *pCParent);			\
    Filter##_cls *mpCParent;					\
    Filter##GUI_cls *mpCThis;					\
    void SetMNumPanel(wxBoxSizer *pBoxSizer, wxWindow *pCParentWindow,\
		      unsigned int index);\

#define MACRO_DefVirtualCustmFunctions		\
    void HideAndShowItems();\
    void CustomA();\
    void CustomB();\
    void CustomC();

#define MACRO_FilterConstructor(FILTER,Type,Command)			\
    FILTER##GUI_cls::							\
    FILTER##GUI_cls(FILTER##_cls *pCParent) : Filter##Type##GUI_cls(pCParent) {\
    mpCParent = pCParent;\
    mFilterType = pCParent->mFilterType;\
    Command;\
    }

#define MACRO_SetCustomFunctions(FilterGUI_cls,a,b,c)	\
void FilterGUI_cls::\
 CustomA(){ a; }				\
void FilterGUI_cls::\
 CustomB(){ b; }				\
void FilterGUI_cls::\
 CustomC(){ c; }    \

#define MACRO_HideAndShowEmpty(FilterGUI_cls)\
void FilterGUI_cls::\
 HideAndShowItems(){}

// ---

class FilterData_cls{
 public:
    FilterData_cls();
    virtual ~FilterData_cls();

    void ReDefineListBase();
    virtual void ReDefineList() = 0;

    static wxString msDataBlockTagStr[_MAX_FILTER];
    virtual wxString SerializeConfPolymorph();
    wxString SerializeConf(int mFilterType);

    virtual void MakeFilterInstanceAndAddToList
	(int index, FilterCtrl_cls *pCParentCtrl) = 0;
    
    virtual void ReadStrLinePolymorph(std::wistream &istream, std::wstring strLine);
    void ReadStrLine(std::wistream &istream, std::wstring strLine);

    ConfItemList_cls     mCConfList; 
    ConfItemBOOL_cls     mCbShow;
    ConfItemBOOL_cls     mCbValid;
    ConfItemSTR_cls      mCstrCustomName;
};

#define MACRO_MakeInstanceAndAddToList(Filter) \
void Filter##Data_cls::\
MakeFilterInstanceAndAddToList(int index, FilterCtrl_cls *pCParentCtrl){\
    pCParentCtrl->AddToList(index, new Filter##_cls(pCParentCtrl, this)); }

// ---

class FilterBase_cls {
 public:
    FilterBase_cls(FilterCtrl_cls *pCParentCtrl);
    virtual ~FilterBase_cls();
    void ConstructorCommon(FilterCtrl_cls *pCParentCtrl, 
			   wxString strDefaultLabel, int filterType);

    bool mbWithParameter;
    bool mbWithSelect;
    bool mbWithTexture;
    bool mbRefreshWhenComming;

    FilterCtrl_cls *mpCParentCtrl;
    static DF3SeqGUI_cls  *mspCDF3SeqGUI;
    static DF3SeqCtrl_cls *mspCDF3SeqCtrlLink;
    static Preference_cls *mspCPreferenceLink;
    static PovRay_cls *mspCPovRayLink;
    static TreeBoxRule_cls *mspCTreeBoxRuleLink;
    static double msABoxScale[3];
    static float msBestLineWidth; 
    static bool msbConstructedFromMenu;
    static PositionAndDirection_cls *mspCCamPos;

    wxString       mstrLabel; // ex.) Isosurface00
    wxString       mstrId;    // ex.) 00
    unsigned int   mFilterType;
    bool           mbProcessData;
    wxBoxSizer*    mpBoxSizer;
    FilterGUI_cls* mpCGUIPanel;
    wxString       mstrFilterStatus;
    int     GetDF3Index();
    int     GetRemappedIndex();
    double  GetRemappedIndexDouble();
    bool    IsClippingEmpty();
    void    GetClippingInformation(double min[3], double max[3],
				   wxString queryStr = wxT(""));
    wxString GetLocaleIndependentStrLabel(wxString strLabel);
    wxString GetLocaleStrLabel(wxString strLabel);
    
    void    SelectPanel(bool bSelected, bool bExclusive = FALSE, 
			bool bTerminate = FALSE);
    void    RefreshTop();
    wxString GetTargetLabelStr();

    virtual FilterData_cls* GetPData() = 0; 
    // ĂяoŃNX̎ނǗ

    MultiNumericalInputs_cls *mpCMNumAdvanced;
    void AdvancedSettingCommon(bool bRefresh = FALSE);
    virtual void SetMNumAdvanced(wxWindow *pCParentWindow);
    virtual void AddFilterItemPolymorph
	(wxBoxSizer *pBoxSizer, 
	 FilterPanels_cls *pCFilterPanels, unsigned int index);
    void AddFilterItem
	(FilterPanels_cls *pCFilterPanels, unsigned int index);
    void RemoveFilterItem();

    //virtual void UpdateList();
    void UpdateCommonData();

    std::vector < wxString > mVSAlreadyOutputedTag;
    std::vector < wxString > mVSAlreadyOutputedTagDProfile;
    std::vector < wxString > mVSAlreadyOutputedTagDFile;

    virtual wxString GetFilterStatusStr() = 0;
    virtual wxString SerializeConf() = 0;
};

// Isofurface  HeightField̋ʕ
class FilterObject_cls {
 public:
    static bool msbRetex;
};

// -----------------------------------------------------------------

#define MACRO_Filter_Destructor_Basic(Filter)\
    Filter##_cls::				     \
    ~Filter##_cls(){				     \
    if (mspCDF3SeqGUI != NULL)			\
	mspCDF3SeqGUI->mpCPanelList->Remove(mstrLabel);\
    }						       

#define MACRO_FuncHookHideItem(Filter)		\
    void Filter##GUI_cls::\
    FuncHookHideItem(void *pArg, void *pEvent){\
    ((Filter##GUI_cls*)DF3SeqCtrl_cls::GetPFilterGUI(pArg))->HideAndShowItems();\
    }

// Parametert̃tB^̂
#define MACRO_AddFilterItemPolymorphP(Filter,Command)	\
    void Filter##_cls::\
    AddFilterItemPolymorph(wxBoxSizer *pBoxSizer, FilterPanels_cls *pCFilterPanel,\
			   unsigned int index){				\
	((Filter##GUI_cls*)mpCGUIPanel)->				\
	    SetMNumPanel(pBoxSizer, pCFilterPanel, index);		\
	ConnectParameterToTL();						\
	Command;							\
    }

#define MACRO_AddFilterItemPolymorph(Filter)	\
    void Filter##_cls::\
    AddFilterItemPolymorph(wxBoxSizer *pBoxSizer, FilterPanels_cls *pCFilterPanel,\
			   unsigned int index){				\
	((Filter##GUI_cls*)mpCGUIPanel)->				\
	    SetMNumPanel(pBoxSizer, pCFilterPanel, index);		\
	if (mbRefreshWhenComming == TRUE)				\
	    mpCParentCtrl->FuncHookRefreshTop(mpCGUIPanel->mpCMNumPanel, NULL);\
    }

// Parametert̃tB^statico
#define MACRO_InitializeStaticMemberP(Filter)\
    void Filter##_cls::						\
    InitializeStaticMember(int df3index){			\
	Filter##Data_cls::InitializeStaticMember(df3index);	\
    }

#define MACRO_GetPData(Filter)			\
    FilterData_cls* Filter##_cls::		\
    GetPData(){					\
	return &mCData;				\
    }

#define MACRO_GetPCData(Filter)\
    Filter##Data_cls* Filter##_cls::	\
    GetPCData(){\
	return (Filter##Data_cls*)GetPData();/*mpCData;*/	\
    }

// Parametert̃tB^VACY
#define MACRO_SerializeConfP(Filter)\
    wxString Filter##_cls::	   \
    SerializeConf(){				\
	UpdateCommonData();			\
	return mpCData->SerializeConf(mFilterType);	\
    }

// Parameter̖tB^VACY
#define MACRO_SerializeConf(Filter)\
    wxString Filter##_cls::	   \
    SerializeConf(){				\
	UpdateCommonData();			\
	return mCData.SerializeConf(mFilterType);	\
    }

// Parametert̃tB^̓ǂ݂
#define MACRO_GetNewPReadDataBlock(Filter)				\
    Filter##Data_cls* Filter##_cls::			\
    GetNewPReadDataBlock(FilterCtrl_cls* pCCtrl, std::wistream &istream){ \
	Filter##Data_cls *pCData = new Filter##Data_cls(pCCtrl);	\
    std::wstring wstrLine;						\
    while (TRUE){							\
	std::getline(istream, wstrLine);				\
	pCData->ReadStrLine(istream, wstrLine);				\
	if (wstrLine.find(L"--END") != std::wstring::npos) break;	\
    }									\
    return pCData;\
    }

// Parameter̖tB^̓ǂ݂
#define MACRO_ReadDataBlock(Filter)		\
    Filter##Data_cls Filter##_cls::		\
    ReadDataBlock(std::wistream &istream){	\
    Filter##Data_cls CData;			\
    std::wstring wstrLine;			\
    while (TRUE){				\
	std::getline(istream, wstrLine);				\
	CData.ReadStrLine(istream, wstrLine);				\
	if (wstrLine.find(L"--END") != std::wstring::npos) break;	\
    }									\
    return CData;							\
    }

#endif
