
#ifndef _FILTER_CTRL_H_
#define _FILTER_CTRL_H_

#include <list>
#include <vector>
#include <wx/wx.h>

#include "../CONFITEM/clsConfItem.h"
#include "../MYGL/clsPositionAndDirection.h"

class BoxCopyData_cls;
class BlurGaussData_cls;
class DataRotateData_cls;
class DF3SeqCtrl_cls;
class DF3Sequence_cls;
class DrawingBlock_cls;
class FilterBase_cls;
class FilterGUI_cls;
class FilterClippingData_cls;
class FilterData_cls;
class FilterFixPositionData_cls;
class FilterPanels_cls;
class InvDiffuseData_cls;
class LayerColorCurveData_cls;
class LevelAndGammaData_cls;
//class LightSRC_cls;
class Parameters_cls;
class Preference_cls;
class PreviewPanel_cls;
class PovIsosurfaceData_cls;
class PovCrossSectionData_cls;
class PovFogData_cls;
class PovRay_cls;
class PreviewProperty_cls;
class PovVolumeData_cls;
class PovThreeViewData_cls;
class TreeBoxRule_cls;

#include <vector>

#define _FILTER_ALLINFO -2
#define _FILTER_INCLUDE_INVALID 1

#define _POV_VOLUME_MONOCOLOR 0

class FilterCtrlGUI_cls{
    // ꂱɕ̃pl̓ڐAׂ
};

class FilterCtrl_cls {
 public:
    FilterCtrl_cls(DF3Sequence_cls *pCDF3SeqParent);
    ~FilterCtrl_cls();
    
    int mSelfDF3Index;
    bool DoesFilterExist(int type, int condition = 0, FilterBase_cls **pFilter = NULL, int skip = 0);
    bool DoesSameFilterNameExist(wxString strTag, FilterBase_cls *pCException);
    bool DoesVolumeBoxRequired();
    FilterBase_cls* GetPFilterBase(int type);
    FilterData_cls* GetPFilterData(int type);
    std::list<FilterBase_cls*>::iterator GetIterator(int index);

    DF3Sequence_cls  *mpCDF3SeqParent;
    FilterPanels_cls *mpCFilterPanelsLink;

    unsigned char *mpBuffer[2];
    bool mbBufferAllocated;
    int  mBufferAllocatedSize;
    int  mBufferIndex;

    std::vector < wxString > mVstrFilterStatusSum;
    //std::vector < wxString > mVstrFilterStatusSumAtVolume;

    void SetFilterPanelsLinkMutual(FilterPanels_cls *pCFilterPanels);

    int GetIndexFromTag(wxString strTag);
    int GetSelfIndex(FilterBase_cls *pC);
    wxString GetIdString(unsigned int type);
    wxString GetIdStringFromTag(wxString strTag);
    //TLɂParam̃Xg
    std::vector < Parameters_cls* > GetVpCPrimParam(); 

    void ClearData();
    void ClearFilter();
    void DeleteFilter(void *pObjectForDelete);
    void Rename();
    void AdvancedSetting();
    void SwapFilterList(int index, int direction);
    void SwapFilterExecute(int index, int direction);
    void SwapFilter(int direction);
    void ChangeConfFLOATExecute(wxString mstrTag, int mIndex, float mValue);
    void ChangeConfINTExecute(wxString mstrTag, int mIndex, int mValue);
    void ChangeConfBOOLExecute(wxString mstrTag, int mIndex, bool mValue);

    int   GetSelectedItemIndex();
    FilterBase_cls* GetPSelectedItem();
    void* GetPSelectedItemDeleteObject();
    
    void UpdateTarget();
    void UpdateColors();
    void UpdateColorBar();
    void UpdateList();
    void UpdateParameters(double doubleIndex);
    //void UpdateHideAndShows();
    void DeselectFilter(wxString strLabel);
    void SelectFilter(wxString strLabel, bool bExclusive = TRUE, 
		      bool bTerminate = FALSE);

    void FilterCustomA(void *pObjectForCustom);
    void FilterCustomB(void *pObjectForCustom);
    void FilterCustomC(void *pObjectForCustom);

    void DeleteSelectedItem();
    void DeleteFilterItem(int index);
    
    void AddToList(int index, FilterBase_cls *pCFilter);
    void AddVolume    (int index = -1,  PovVolumeData_cls *pInitData = NULL);

    void DrawItems(double center[3], double scale[3]);
    void DrawObject(double scale, bool bPositiveObject, bool bNegativeObject);
    double GetRemappedDoubleIndex();
    int   GetRemappedTimeIndex(); // mMaxIndexɃgĕԂ
    bool  GetVolumeValidity();
    int   GetVolumeColorType();
    int   GetVolumeDataType();
    double GetVolumeParameter(int type);
    float GetVolumeColor(int index);
    void  GetTranslate(double pTrans[3], int frame, int frameMax, unsigned int size[3]);
    bool  GetClippingInformation(wxString quertStr,
				 double min[3], double max[3],
				 std::vector < std::vector < double > > *pVVMin,
				 std::vector < std::vector < double > > *pVVmax,
				 std::vector < bool > *pVActive = NULL,
				 std::vector < bool > *pVVisible = NULL,
				 bool bFlagForTransrate = TRUE,
				 wxString strStopLabel = wxT(""),
				 bool *pbFlagSkip = NULL);
    double GetFogAbsorption();
    double GetFogEmission();
    double GetFogDistAndClr(float pColor[3], wxString strTag = _("Volume"));
    double GetTotalLevelMapping(double value, FilterBase_cls *pCStop = NULL);
    bool IsReprocessRequired(int remappedTimeIndex, 
			     double remappedTimeIndexDouble,
			     FilterBase_cls *pAtThisFilter = NULL);
    bool IsNextFilterIsVolume(std::list<FilterBase_cls*>::iterator itrCur);
    void ProcessXYZData(unsigned char *pTo, unsigned char *pFrom, unsigned int size[3], bool bTimeRemap, float remapFactor, unsigned char *pFromNext);
    int  CountDataFilterNumber();
    bool IsIsosurfTargetingMeExist(wxString quertStr/*int index*/);

    FilterBase_cls* GetPFogTargettingMe(wxString quertStr, /*int index, */bool bStart = TRUE);
    FilterBase_cls* GetPFromTag(wxString strTag);
    wxString GetColorMaps();

    FilterGUI_cls* GetPFilterGUI(void *pArg);
    void SelectLastItem();
    void SelectItem(FilterGUI_cls *pTgt, bool bAdditive);
    static void FuncHookMouse(void *pArg, void *pEvent);
    static void FuncHookValidityCheckbox(void *pArg, void *pEvent);
    static void FuncHookRetexture(void *pArg, void *pEvent);
    static void FuncHookRefreshTop(void *pArg, void *pEvent);
    static void FuncHookShow(void *pArg, void *pbShow);
    static void FuncHookAssign(void *pArg, void *pEvent);
    static void FuncHookChanged(void *pArg, void *pEvent);

    static int msOmitUpdateList; // vWFNgǂݍݎ͂܂Ƃ߂ď
    static int msStereoTmpFileIOMode;
    static void PushListOmit();
    static void PopListOmit();

    std::list <FilterBase_cls*> mVpCFilter;
    
    static Preference_cls *mspCPreferenceLink;
    static DF3SeqCtrl_cls *mspCDF3SeqCtrlLink;
    static PreviewProperty_cls *mspCPreviewPropertyLink;
    static void InitializeStaticMembers
	(Preference_cls  *pCPreference,
	 DF3SeqCtrl_cls* pCDF3SeqCtrl, 
	 PovRay_cls* pCPov, TreeBoxRule_cls* pCTreeRule,
	 PreviewProperty_cls *pCPrevProp);

    // -----

    wxString GetPovStrFog();
    wxString GetPovStrGlobalObject
	(wxString strTag, PositionAndDirection_cls CCamLocalCoord,
	 std::vector < wxString > VstrFilePath);
    wxString GetPovStrDensityFile
	(wxString strTag, std::vector < wxString > VstrFilePath,
	 bool bTimeRemap, float remapFactor);
    void GetPovStrDProfile
	(std::wfstream &ofstream,
	 wxString strTag, std::vector < wxString > VstrFilePath,
	 DrawingBlock_cls *pCDrawingBlock,
	 bool bTimeRemap, float remapFactor);
    void GetPovStrDensityBox
	(std::wfstream &ofstream, double baseAlpha, double doubeIndex,
	 wxString strTag, wxString strFilePath,
	 wxString strGeometry, DrawingBlock_cls *pCDrawingBlock,
	 std::vector < wxString > *pVstrInteriorTag,
	 PositionAndDirection_cls CCamLocalCoord,
	 int frame);
    wxString GetPovStrDiffObj(wxString strCoordinateInv);
    
    // -----
    
    void ReadStrLine(std::wistream &istream, std::wstring strLine);
    wxString SerializeConf();
};

// -------------------

#endif 
