// -*- c -*- 
// (setq c-basic-offset 4)
// "clsBoxCopy.h"

#include "clsInvDiffuse.h"
#include "../DF3/clsDF3SeqGUI.h"
#include "../FILTER/clsFilterCtrl.h"
#include "../WIDGETCTRL/clsMultiNumericalInputs.h"
#include "../MAINCANVAS/clsPreference.h"
#include "../MAINCANVAS/clsPreviewPanel.h"
#include "../WIDGETCTRL/clsMultiNumericalInputs.h"
#include "../WIDGETCTRL/EX/clsCheckBoxEX.h"
#include "../../clsFrameMain.h"
#include "../../wxWidgetEnum.h"

#include "../MYAPI/MsgBox.h"

//SSE2
#include <malloc.h>
#include <emmintrin.h>

extern bool GbGLLockForMultithread;

#define X 0
#define Y 1
#define Z 2
#define _BLUR_DIRECTION_XY 0
#define _BLUR_DIRECTION_X  1
#define _BLUR_DIRECTION_Y  2
#define _BLUR_DIRECTION_Z  3
#define LOOP_XYZ for (int xyz = 0; xyz < 3; xyz++)

MACRO_FilterConstructor(InvDiffuse,,)

void InvDiffuseGUI_cls::
SetMNumPanel(wxBoxSizer *pBoxSizer, wxWindow *pCParentWindow, 
	     unsigned int index){
    
    MultiNumericalInputsPanel_cls* pCurr = InitializeMNumPanel(pCParentWindow);

#ifdef WIN32
    pCurr->mTextWidth = 60;
#else
    pCurr->mTextWidth = 80;
#endif
    
    int boxWidth = 3;
    pCurr->CombinePointer(_GP_BOXSIZERHORIZONTAL, &boxWidth, 
			  _("Iteration"));
    pCurr->CombinePointer
	(_GP_INTEGER_SPIN, &mpCParent->mCData.mCIteration.mBody, wxT(""));
    pCurr->SetRange(1, 6);
    
    pCurr->mProportion = 1;
    pCurr->FinishSetting(pBoxSizer, FALSE, index);
    
    pCurr->SetFuncHook(&FilterCtrl_cls::FuncHookChanged, _MN_HOOK_CHANGE);
}

MACRO_SetCustomFunctions(InvDiffuseGUI_cls,,,);
MACRO_HideAndShowEmpty(InvDiffuseGUI_cls);

// -----

ThreadDiffuse::
ThreadDiffuse(wxThreadKind kind) : MultiThreadThread_cls(kind) {
}

void ThreadDiffuse::
SetParameters(InvDiffuse_cls *pCParent,
	      float *pTo, float *pFrom, unsigned int size[3],
	      int initY, int finY, int direction){
    mpCParent = pCParent;
    mpTo = pTo;
    mpFrom = pFrom;
    LOOP_XYZ mSize[xyz] = size[xyz];
    mInitY = initY;
    mFinY = finY;
    mDirection = direction;
    if ( Create() != wxTHREAD_NO_ERROR) 
	MsgBoxExit(NULL, "Error!", "Can't create thread");
}

void ThreadDiffuse::
Initialize(float *pSRC, float *pDST,
	   int sizeX, int sizeY, int sizeZ){
    int sizeXY = sizeX * sizeY;

    for (int z = 0 ; z < 2; z++){
	int indexZ = z * sizeXY;
	for (int y = mInitY; y < mFinY; y++){
	    int indexY = indexZ + y * sizeX;
	    memcpy(pDST+indexY, pSRC+indexY, sizeof(float) * sizeX);
	    /*
	    for (int x = 0; x < sizeX; x++){
		int index = indexY + x;	pDST[index] = pSRC[index];
	    } 
	    */
	} }
    for (int z = 2 ; z < sizeZ-2; z++){
	int indexZ = z * sizeXY;
	for (int y = mInitY; y < mFinY; y++){
	    int indexY = indexZ + y * sizeX;
	    for (int x = 0; x < sizeX; x++){
		int index = indexY + x;	pDST[index] = 0;
	    } } }
    for (int z = sizeZ-2 ; z < sizeZ; z++){
	int indexZ = z * sizeXY;
	for (int y = mInitY; y < mFinY; y++){
	    int indexY = indexZ + y * sizeX;
	    memcpy(pDST+indexY, pSRC+indexY, sizeof(float) * sizeX);
	    /*
	    for (int x = 0; x < sizeX; x++){
		int index = indexY + x; pDST[index] = pSRC[index];
	    }
	    */
	} }
}

wxThread::ExitCode ThreadDiffuse::
Entry(){
    int totalSize = mSize[X] * mSize[Y] * mSize[Z];
    int sizeXY = mSize[X] * mSize[Y];
    int sizeXY2 = sizeXY*2;
    int sizeXY3 = sizeXY*3;
    int sizeX = mSize[X], sizeY = mSize[Y], sizeZ = mSize[Z];

    float *pTmp = new float [totalSize];

    float *pSRC = NULL;
    float *pDST = mpFrom;

    int iterationSize = mpCParent->mCData.mCIteration.mBody;

    for (int iteration = 0; iteration < iterationSize; iteration++){

	pSRC = pDST;
	if (iteration == iterationSize - 1) pDST = mpTo;
	else{
	    if (pSRC == mpFrom) pDST = pTmp;
	    else pDST = mpFrom;
	}

	Initialize(pSRC, pDST, sizeX, sizeY, sizeZ);
	
	// [v̏ԂςΑȂ\͂邪c
	for (int y = mInitY; y < mFinY; y++){
	    int indexY = y * sizeX;
	    for (int x = 0; x < sizeX; x++){
		int indexX = indexY + x;
		for (int z = 2 ; z < sizeZ-2; z++){
		    int index = z * sizeXY + indexX;
		    
		    float incline;
		    if (z > 3 && z < sizeZ - 3)
			incline = (pSRC[index + sizeXY3] + pSRC[index + sizeXY2] + pSRC[index + sizeXY ] - pSRC [index - sizeXY] - pSRC[index - sizeXY2] - pSRC[index - sizeXY3]) / 768;
		    else
			incline = (pSRC[index + sizeXY2] + pSRC[index + sizeXY ] - pSRC [index - sizeXY] - pSRC[index - sizeXY2]) / 512;
		    
		    incline *= (256 - pSRC[index]) / 128;
		    if (incline > 1) incline = 1;
		    
		    if (z == 2 || z == sizeZ - 2) incline *= 0.5;
		    
		    if (incline > 0){
			pDST[index + sizeXY] += pSRC[index] * incline;
			pDST[index] += pSRC[index] * (1.0 - incline); 
		    }
		    else{
			incline *= -1;
			pDST[index - sizeXY] += pSRC[index] * incline;
			pDST[index] += pSRC[index] * (1.0 - incline); 
		    }
		    
		    /*
			+ 
			(pSRC[index + 2*sizeXY] + pSRC[index - 2*sizeXY] - 
			2 * pSRC[index]) * -0.1;
		    */
		}
	    }
	}
	
	for (int z = 0 ; z < sizeZ; z++){
	    int indexZ = z * sizeXY;
	    for (int y = mInitY; y < mFinY; y++){
		int indexY = indexZ + y * sizeX;
		for (int x = 0; x < sizeX; x++){
		    int index = indexY + x;
		    float *pTgt = pDST + index;
		    if (*pTgt < 0) *pTgt = 0;
		    if (*pTgt > 255) *pTgt = 255;
		} } }
    }

    delete pTmp;
    
    return 0;
}

// -----

InvDiffuseData_cls::
InvDiffuseData_cls(){
    ReDefineList();
    mCConfList.mbSetWithInitValue = FALSE;
}

void InvDiffuseData_cls::
ReDefineList(){
    // ʂ̃Xgɒǉ
    FilterData_cls::ReDefineListBase();
    mCConfList.Add(&mCIteration, wxT("InvDiffuseIteration="), L"1");
}

MACRO_MakeInstanceAndAddToList(InvDiffuse)

// -----

#include "../MYAPI/MsgBox.h"

InvDiffuse_cls::
InvDiffuse_cls(FilterCtrl_cls *pCParentCtrl, InvDiffuseData_cls *pCInitData) 
: FilterBase_cls(pCParentCtrl){
    if (pCInitData != NULL) mCData = *pCInitData;
    mbProcessData = TRUE;
    ConstructorCommon(pCParentCtrl, _("Inverse Diffuse"), _FILTER_INV_DIFFUSE);
    mpCGUIPanel = new InvDiffuseGUI_cls(this);
}

MACRO_Filter_Destructor_Basic(InvDiffuse);
MACRO_GetPData(InvDiffuse);

MACRO_AddFilterItemPolymorph(InvDiffuse);

InvDiffuseData_cls* InvDiffuse_cls::
GetPCData(){
    return &mCData;
}

// ----

bool InvDiffuse_cls::
ProcessXYZData(unsigned char *pTo, unsigned char *pFrom, unsigned int size[3]){
    int totalSize = size[X] * size[Y] * size[Z];
    
    if (mCData.mCbValid.mbBody == FALSE){
	memcpy(pTo, pFrom, totalSize);
	return FALSE;
    }

    float *pFromF;
    float *pToF;

    try{
	pFromF = new float [totalSize];
    }
    catch(std::bad_alloc e){
        MsgBox(mpCGUIPanel->mpCMNumPanel, e.what(),
	       "Memory Allocation for temporal buffer *pFrom fails. Ingnore InvDiffuse");
        return FALSE;
    }

    try{
	pToF = new float [totalSize];
    }
    catch(std::bad_alloc e){
	MsgBox(mpCGUIPanel->mpCMNumPanel, e.what(), 
	       "Memory Allocation for temporal buffer *pTo fails. Ingnore InvDiffuse");
	delete pFromF;
        return FALSE;
    }

    float *pEnd  = pFromF+totalSize;
    unsigned char *pCurrUC = pFrom;
    for (float *pCurrFloat = pFromF; pCurrFloat < pEnd; pCurrFloat++, pCurrUC++)
	*pCurrFloat = *pCurrUC;

    /*
    int core;
    if (mspCPreferenceLink->mCbMultiThreadFilter.mbBody == FALSE)
	core = 1;
    else
	core = mspCPreferenceLink->mCThreadNumFilter.mBody;
    */

    InitializeThreadCtrl();

    GbGLLockForMultithread = TRUE;

    ThreadDiffuse *pThread[8];
    
    for (int th = 0; th < mThreadNum; th++){
	int ini = (th * size[Y]) / mThreadNum;
	int fin = ((th + 1) * size[Y]) / mThreadNum;
	pThread[th] = new ThreadDiffuse(wxTHREAD_JOINABLE);
	pThread[th]->SetParameters(this, pToF, pFromF, size, ini, fin, 0);
    }

    for (int th = 0; th < mThreadNum; th++) pThread[th]->Run();
    for (int th = 0; th < mThreadNum; th++) pThread[th]->Wait();
    for (int th = 0; th < mThreadNum; th++) delete pThread[th];
    
    GbGLLockForMultithread = FALSE;
    
    pEnd = pToF+totalSize;
    pCurrUC = pTo;
    for (float *pCurrFloat = pToF; pCurrFloat < pEnd; pCurrFloat++, pCurrUC++)
	*pCurrUC = *pCurrFloat;
    
    delete pFromF;
    delete pToF;

    return TRUE;
}

// ----

wxString InvDiffuse_cls::
GetFilterStatusStr(){
    wxString strStatus;
    strStatus << wxT("InvDiffuse::") << mCData.mCbValid.mbBody;
    
    if (mCData.mCbValid.mbBody == FALSE)
	strStatus<< wxT("::");
    else
	strStatus << wxT(":") <<
	    GetPCData()->mCIteration.mBody << wxT(":");
    
    return strStatus;
}

MACRO_SerializeConf(InvDiffuse)
MACRO_ReadDataBlock(InvDiffuse)
