// -*- c++ -*- 
// (setq c-basic-offset 4)
// "clsBoxCopy.h"

#include "clsLevelAndGamma.h"
#include "../DF3/clsDF3SeqGUI.h"
#include "../FILTER/clsFilterCtrl.h"
#include "../WIDGETCTRL/clsMultiNumericalInputs.h"
#include "../MAINCANVAS/clsPreference.h"
#include "../MAINCANVAS/clsPreviewPanel.h"
#include "../WIDGETCTRL/clsMultiNumericalInputs.h"
#include "../WIDGETCTRL/EX/clsCheckBoxEX.h"
#include "../../clsFrameMain.h"
#include "../../wxWidgetEnum.h"

extern bool GbGLLockForMultithread;

#define X 0
#define Y 1
#define Z 2
#define LOOP_XYZ for (int xyz = 0; xyz < 3; xyz++)

MACRO_FilterConstructor(LevelAndGamma,,)

void LevelAndGammaGUI_cls::
SetMNumPanel(wxBoxSizer *pBoxSizer, wxWindow *pCParentWindow, 
	     unsigned int index){
    
    LevelAndGammaData_cls *pCData = 
	(LevelAndGammaData_cls*)mpCParent->GetPData();
    
    MultiNumericalInputsPanel_cls* pCurr = InitializeMNumPanel(pCParentWindow);

#ifdef WIN32
    pCurr->mTextWidth = 50;
#else
    pCurr->mTextWidth = 60;
#endif
    
    // lݒ肵Ă
    pCData->GetPInterpolated()[_LEVEL_IN_MIN] = 0;
    pCData->GetPInterpolated()[_LEVEL_IN_MAX] = 1;
    pCData->GetPInterpolated()[_LEVEL_OUT_MIN] = 0;
    pCData->GetPInterpolated()[_LEVEL_OUT_MAX] = 1;
    pCData->GetPInterpolated()[_LEVEL_GAMMA] = 1;
    pCData->GetPInterpolated()[_LEVEL_OFFSET] = 0;
    
    int boxWidth = 3;
    
    pCurr->CombinePointer(_GP_BOXSIZERHORIZONTAL, &boxWidth, wxT("IN"));
    pCurr->mItemWidth = 25;
    pCurr->CombinePointer(_GP_DOUBLE, 
			  &pCData->GetPInterpolated()[_LEVEL_IN_MIN]);
    pCurr->mItemWidth = -1;
    pCurr->CombinePointer(_GP_DUALSLIDER,
			  &pCData->GetPInterpolated()[_LEVEL_IN_MIN]);
    pCurr->SetRange(0, 100, _MN_LASTITEM, 100);
    pCurr->mItemWidth = 25;
    pCurr->CombinePointer(_GP_DOUBLE, 
			  &pCData->GetPInterpolated()[_LEVEL_IN_MAX]);

    pCurr->mItemWidth = -1;
    pCurr->CombinePointer(_GP_BOXSIZERHORIZONTAL, &boxWidth, 
			  _("OUT"));
    pCurr->mItemWidth = 25;
    pCurr->CombinePointer(_GP_DOUBLE, 
			  &pCData->GetPInterpolated()[_LEVEL_OUT_MIN]);
    pCurr->mItemWidth = -1;
    pCurr->CombinePointer(_GP_DUALSLIDER,
			  &pCData->GetPInterpolated()[_LEVEL_OUT_MIN]);
    pCurr->SetRange(0, 100, _MN_LASTITEM, 100);
    pCurr->mItemWidth = 25;
    pCurr->CombinePointer(_GP_DOUBLE, 
			  &pCData->GetPInterpolated()[_LEVEL_OUT_MAX]);

#ifdef WIN32
    pCurr->mTextWidth = 50;
#else
    pCurr->mTextWidth = 60;
#endif
    boxWidth = 2;
    pCurr->mItemWidth = -1;
    pCurr->CombinePointer(_GP_BOXSIZERHORIZONTAL, &boxWidth, 
			  _("Gamma"));
    pCurr->CombinePointer(_GP_DOUBLE, 
			  &pCData->GetPInterpolated()[_LEVEL_GAMMA]);
    pCurr->CombinePointer(_GP_DOUBLE, 
			  &pCData->GetPInterpolated()[_LEVEL_OFFSET]);
    
    pCurr->mProportion = 1;
    pCurr->FinishSetting(pBoxSizer, FALSE, index);
    
    //mpObjectForCustomA = pCurr->mVCPointers[indexCustomA].mpPointerCtrl;
    
    pCurr->SetFuncHook(&FilterCtrl_cls::FuncHookAssign, _MN_HOOK_ASSIGN);
    pCurr->SetFuncHook(&FilterCtrl_cls::FuncHookRefreshTop, _MN_HOOK_ASSIGN);
    
    pCurr->SetFuncHook(&FilterCtrl_cls::FuncHookChanged, _MN_HOOK_CHANGE);
}

MACRO_SetCustomFunctions(LevelAndGammaGUI_cls,,,)
MACRO_HideAndShowEmpty(LevelAndGammaGUI_cls);

// -----

LevelAndGammaData_cls::
LevelAndGammaData_cls(FilterCtrl_cls* pCCtrl,
		      bool bConnectToStaticParam) :
FilterWithParameterData_cls(pCCtrl)
{
    // ʂ̃Xgɒǉ
    mCConfList.Add(&mCbLevelSmooth, wxT("FilterLevelSmooth"), L"0");

    // 傾ϐ͎ԕωL
    Parameters_cls CParam(6, L"LevelAndGamma");
    double iniParam[6] = {0, 1, 0, 1, 1, 0};
    CParam.ExecCommandInitSet(iniParam);

    // !! todo !! _MAX_PARAMETER_NUMBER 𒴂̏
    if (bConnectToStaticParam == TRUE){
	mParamNumber = -1;
	for (size_t i = 0; i < msVbParamUsed[mpCCtrl->mSelfDF3Index].size(); i++)
	    if (msVbParamUsed[mpCCtrl->mSelfDF3Index][i] == FALSE){
		mParamNumber = (int)i;
		msVCParam[mpCCtrl->mSelfDF3Index][mParamNumber].CopyFromP(&CParam);
		msVbParamUsed[mpCCtrl->mSelfDF3Index][mParamNumber] = TRUE;
		i = _MAX_PARAMETER_NUMBER;
	    }
	if (mParamNumber == -1){
	    mParamNumber = (int)msVbParamUsed[mpCCtrl->mSelfDF3Index].size();
	    msVCParam[mpCCtrl->mSelfDF3Index].push_back(CParam);
	    msVbParamUsed[mpCCtrl->mSelfDF3Index].push_back(TRUE);
	}
    }
}

void LevelAndGammaData_cls::
ReDefineList(){
    FilterData_cls::ReDefineListBase();
    mCConfList.Add(&mCbLevelSmooth, wxT("FilterLevelSmooth"));
}

void LevelAndGammaData_cls::
InitializeStaticMember(int df3index){
    msVCParam[df3index].reserve(_MAX_PARAMETER_NUMBER);
    msVbParamUsed[df3index].reserve(_MAX_PARAMETER_NUMBER);
}

Parameters_cls* LevelAndGammaData_cls::
GetPParamActive(){
    return &msVCParam[mpCCtrl->mSelfDF3Index][mParamNumber];
}

MACRO_MakeInstanceAndAddToList(LevelAndGamma)

wxString LevelAndGammaData_cls::
SerializeConfPolymorph(){
    return msVCParam[mpCCtrl->mSelfDF3Index][mParamNumber].Serialize();
}

void LevelAndGammaData_cls::
ReadStrLinePolymorph(std::wistream &istream, std::wstring strLine){
    //mCTexProperty.ReadStrLine(strLine);
    msVCParam[mpCCtrl->mSelfDF3Index][mParamNumber].ReadStrLine(istream, strLine);
}

std::vector < Parameters_cls > LevelAndGammaData_cls::msVCParam[_DF3_MAX_SLOT];
std::vector < bool > LevelAndGammaData_cls::msVbParamUsed[_DF3_MAX_SLOT];

// -----

#include "../MYAPI/MsgBox.h"

ThreadLevel::
ThreadLevel() : wxThread(wxTHREAD_JOINABLE) {}

void ThreadLevel::
SetParameters(LevelAndGamma_cls *pCParent,
	      unsigned char *pTo, unsigned char *pFrom, 
	      int ini, int fin,
	      unsigned char *pLevelMap){
    mpCParent = pCParent;
    mpTo = pTo; mpFrom = pFrom;
    mIni = ini; mFin = fin;
    mpLevelMap = pLevelMap;

    if ( Create() != wxTHREAD_NO_ERROR) 
	MsgBoxExit(NULL, "Error!", "Can't create thread");
}

wxThread::ExitCode ThreadLevel::
Entry(){
    unsigned char *pToIndex = mpTo + mIni;
    unsigned char *pFromIndex = mpFrom + mIni;
    unsigned char *pToIndexEnd = mpTo + mFin;
    unsigned char *pLevelMap = mpLevelMap;

    // [v̒ŷŁAłꉞ኱͂Ȃc
    if ((int)(pToIndexEnd - pToIndex) % 8 == 0)
	for (; pToIndex < pToIndexEnd; pToIndex+=8, pFromIndex+=8){
	    *pToIndex = pLevelMap[*pFromIndex];
	    *(pToIndex+1) = pLevelMap[*(pFromIndex+1)];
	    *(pToIndex+2) = pLevelMap[*(pFromIndex+2)];
	    *(pToIndex+3) = pLevelMap[*(pFromIndex+3)];
	    *(pToIndex+4) = pLevelMap[*(pFromIndex+4)];
	    *(pToIndex+5) = pLevelMap[*(pFromIndex+5)];
	    *(pToIndex+6) = pLevelMap[*(pFromIndex+6)];
	    *(pToIndex+7) = pLevelMap[*(pFromIndex+7)];
	}
    else if ((int)(pToIndexEnd - pToIndex) % 4 == 0)
	for (; pToIndex < pToIndexEnd; pToIndex+=4, pFromIndex+=4){
	    *pToIndex = pLevelMap[*pFromIndex];
	    *(pToIndex+1) = pLevelMap[*(pFromIndex+1)];
	    *(pToIndex+2) = pLevelMap[*(pFromIndex+2)];
	    *(pToIndex+3) = pLevelMap[*(pFromIndex+3)];
	}
    else if ((int)(pToIndexEnd - pToIndex) % 2 == 0)
	for (; pToIndex < pToIndexEnd; pToIndex+=2, pFromIndex+=2){
	    *pToIndex = pLevelMap[*pFromIndex];
	    *(pToIndex+1) = pLevelMap[*(pFromIndex+1)];
	}
    else
	for (; pToIndex < pToIndexEnd; pToIndex++, pFromIndex++)
	    *pToIndex = pLevelMap[*pFromIndex];
    
    return 0;
}

// -----

LevelAndGamma_cls::
LevelAndGamma_cls(FilterCtrl_cls *pCParentCtrl, LevelAndGammaData_cls *pCInitData) : FilterWithParameter_cls(pCParentCtrl)
{
    mpCData = new LevelAndGammaData_cls(pCParentCtrl, (pCInitData == NULL));
    if (pCInitData != NULL) *(LevelAndGammaData_cls*)mpCData = *pCInitData;
    mbProcessData = TRUE;
    ConstructorCommon(pCParentCtrl, _("Level Gamma"), _FILTER_LEVEL_GAMMA);
    mpCGUIPanel = new LevelAndGammaGUI_cls(this);
}

MACRO_Filter_Destructor_Basic(LevelAndGamma);

void LevelAndGamma_cls::
SetMNumAdvanced(wxWindow *pCParentWindow){
    MultiNumericalInputs_cls* pCurr =
	wxDialogEXKey::InitializeMNumDLG(&mpCMNumAdvanced, pCParentWindow, wxT("Advanced Setting"));
    
     pCurr->mTextWidth = 100;
     
     pCurr->CombinePointer
	 (_GP_BOOL, &GetPCData()->mCbLevelSmooth.mbBody, _("Smooth"));

     pCurr->FinishSettingDLG(FALSE);
}

MACRO_AddFilterItemPolymorphP(LevelAndGamma,RefreshTop());
MACRO_InitializeStaticMemberP(LevelAndGamma);
MACRO_GetPCData(LevelAndGamma);

// ----

double LevelAndGamma_cls::
GetErfApprox(double value){
    double retval = sqrt(1 - exp( - 4 * value * value / M_PI));
    if (value < 0) retval *= -1;
    return retval;
}

double LevelAndGamma_cls::
GetLevelIn(double value){
    double modulate;

    if (mpCData->GetPInterpolated()[_LEVEL_IN_MIN] < mpCData->GetPInterpolated()[_LEVEL_IN_MAX]){
	if (mpCData->GetPInterpolated()[_LEVEL_IN_MAX] == mpCData->GetPInterpolated()[_LEVEL_IN_MIN]) 
	    modulate = 0.5;
	else
	    modulate = (value - mpCData->GetPInterpolated()[_LEVEL_IN_MIN]) /
		(mpCData->GetPInterpolated()[_LEVEL_IN_MAX] - mpCData->GetPInterpolated()[_LEVEL_IN_MIN]);
	if (value < mpCData->GetPInterpolated()[_LEVEL_IN_MIN]) modulate = 0;
	if (value >= mpCData->GetPInterpolated()[_LEVEL_IN_MAX]) modulate = 1;
    }
    else{
	if (mpCData->GetPInterpolated()[_LEVEL_IN_MAX] == mpCData->GetPInterpolated()[_LEVEL_IN_MIN])
	    modulate = 0.5;
	else
	    modulate = 1.0 - (value - mpCData->GetPInterpolated()[_LEVEL_IN_MAX]) /
		(mpCData->GetPInterpolated()[_LEVEL_IN_MIN] - mpCData->GetPInterpolated()[_LEVEL_IN_MAX]);
	if (value < mpCData->GetPInterpolated()[_LEVEL_IN_MAX]) modulate = 1;
	if (value >= mpCData->GetPInterpolated()[_LEVEL_IN_MIN]) modulate = 0;
    }
    return modulate;
}

double LevelAndGamma_cls::
GetLevelMapping(double value){
    if (((LevelAndGammaData_cls*)mpCData)->mCbValid.mbBody == FALSE) return value;

    double modulate;
    
    if (((LevelAndGammaData_cls*)mpCData)->mCbLevelSmooth.mbBody == TRUE){
	double converted = 2 * value / 
	    (mpCData->GetPInterpolated()[_LEVEL_IN_MAX] - mpCData->GetPInterpolated()[_LEVEL_IN_MIN]) -
	    (mpCData->GetPInterpolated()[_LEVEL_IN_MAX] + mpCData->GetPInterpolated()[_LEVEL_IN_MIN]) /
	    (mpCData->GetPInterpolated()[_LEVEL_IN_MAX] - mpCData->GetPInterpolated()[_LEVEL_IN_MIN]);
        modulate = (GetErfApprox(converted) + 1) / 2;
    }
    else
	modulate = GetLevelIn(value);

    modulate = pow(modulate, mpCData->GetPInterpolated()[_LEVEL_GAMMA]);
    modulate += mpCData->GetPInterpolated()[_LEVEL_OFFSET];
    if (modulate < 0) modulate = 0;
    
    modulate = (mpCData->GetPInterpolated()[_LEVEL_OUT_MAX] - mpCData->GetPInterpolated()[_LEVEL_OUT_MIN]) * modulate + mpCData->GetPInterpolated()[_LEVEL_OUT_MIN];
    
    return modulate;
}

void LevelAndGamma_cls::
MakeLevelMap(unsigned char ALevelMap[256]){
    for (int i = 0; i < 256; i++){
	double value = (double)i / 255;
	ALevelMap[i] = GetLevelMapping(value) * 255;
    }
}

bool LevelAndGamma_cls::
ProcessXYZData(unsigned char *pTo, unsigned char *pFrom, unsigned int size[3]){
    int totalSize = size[X] * size[Y] * size[Z];
    
    if (mpCData->mCbValid.mbBody == FALSE){
	memcpy(pTo, pFrom, totalSize);
	return FALSE;
    }

    unsigned char ALevelMap[256];
    MakeLevelMap(ALevelMap);

    int threadNum = mspCPreferenceLink->GetThreadNumFilter();
    if (threadNum > 1){
	// Core2 ƍő10%Ȃx
	GbGLLockForMultithread = TRUE;
	
	ThreadLevel *pThread[2];
	for (int thread = 0; thread < 2; thread++){
	    pThread[thread] = new ThreadLevel;
	    pThread[thread]->SetParameters(this, pTo, pFrom,
					   thread * totalSize / 2,
					   (thread + 1) * totalSize / 2,
					   ALevelMap);
	}
	for (int thread = 0; thread < 2; thread++) pThread[thread]->Run();
	for (int thread = 0; thread < 2; thread++) pThread[thread]->Wait();
	for (int thread = 0; thread < 2; thread++) delete pThread[thread];

	GbGLLockForMultithread = FALSE;
    }
    else{
	unsigned char *pToIndex = pTo;
	unsigned char *pFromIndex = pFrom;
	unsigned char *pToIndexEnd = pTo + totalSize;
	for (; pToIndex < pToIndexEnd; pToIndex++, pFromIndex++)
	    *pToIndex = ALevelMap[*pFromIndex];
    }

    return TRUE;
}

// ----

wxString LevelAndGamma_cls::GetFilterStatusStr(){
    wxString strStatus;

    strStatus << wxT("LevelAndGamma::") << mpCData->mCbValid.mbBody;
    
    if (GetPCData()->mCbValid.mbBody == FALSE)
	strStatus<< wxT("::");
    else
	strStatus << wxT(":") <<
	    mpCData->GetPInterpolated()[_LEVEL_IN_MIN] << wxT(":") <<
	    mpCData->GetPInterpolated()[_LEVEL_IN_MAX] << wxT(":") <<
	    mpCData->GetPInterpolated()[_LEVEL_OUT_MIN] << wxT(":") <<
	    mpCData->GetPInterpolated()[_LEVEL_OUT_MAX] << wxT(":") <<
	    mpCData->GetPInterpolated()[_LEVEL_GAMMA] << wxT(":") <<
	    mpCData->GetPInterpolated()[_LEVEL_OFFSET] << wxT("::") ;
    
    return strStatus;
}

MACRO_SerializeConfP(LevelAndGamma)
MACRO_GetNewPReadDataBlock(LevelAndGamma)
