// "clsGLButton.h"
// (setq c-basic-offset 4)

#include "clsGLButton.h"

GLButton_cls::
GLButton_cls(int offsetType, int offsetX, int offsetY){
    mOffsetType = offsetType;
    mOffsetX = offsetX;
    mOffsetY = offsetY;
}

void GLButton_cls::
MakeTextureFromImage(wxString strPath){
    glGenTextures(1, &mTexID);

    wxImage CImage(strPath);
    CImage = CImage.Mirror(FALSE);
    mWidth = CImage.GetWidth();
    mHeight = CImage.GetHeight();

    unsigned char *pRGB = CImage.GetData();
    unsigned char *pAlpha = CImage.GetAlpha();

    int size = mWidth * mHeight;
    unsigned char *pTgt = new unsigned char [size * 4];

    for (int i = 0; i < size; i++){
	pTgt[i * 4] = pRGB[i*3];
	pTgt[i * 4 + 1] = pRGB[i*3 + 1];
	pTgt[i * 4 + 2] = pRGB[i*3 + 2];
	pTgt[i * 4 + 3] = pAlpha[i];
    }

    glBindTexture(GL_TEXTURE_2D, mTexID);
    glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, mWidth, mHeight, 0, 
		 GL_RGBA, GL_UNSIGNED_BYTE, pTgt);

    delete pTgt;
}

void GLButton_cls::
DrawButton(int canvasWidth, bool bState){
    glPushAttrib(GL_TEXTURE_BIT);
    
    if (mbMouseOn == TRUE){
	glDisable(GL_TEXTURE_2D);
	glColor4f(0.2f, 0.2f, 0.3f, 1.0f);
	glBegin(GL_QUADS);
	glVertex2d(canvasWidth - mOffsetX, mOffsetY);
	glVertex2d(canvasWidth - mOffsetX + mWidth, mOffsetY);
	glVertex2d(canvasWidth - mOffsetX + mWidth, mOffsetY + mHeight);
	glVertex2d(canvasWidth - mOffsetX, mOffsetY + mHeight);
	glEnd();
	glColor4f(0.3f, 0.3f, 0.5f, 1.0f);
	glBegin(GL_LINE_LOOP);
	glVertex2d(canvasWidth - mOffsetX, mOffsetY);
	glVertex2d(canvasWidth - mOffsetX + mWidth, mOffsetY);
	glVertex2d(canvasWidth - mOffsetX + mWidth, mOffsetY + mHeight);
	glVertex2d(canvasWidth - mOffsetX, mOffsetY + mHeight);
	glEnd();
    }

    glEnable(GL_TEXTURE_2D);
    glEnable(GL_BLEND);
    glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA); //At@

    glBindTexture( GL_TEXTURE_2D, mTexID);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
    glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
    glBegin(GL_QUADS);
    if (bState == FALSE)
	glColor4f(0.4f, 0.4f, 0.4f, 1.0f);
    else
	glColor4f(0.9f, 0.9f, 1.0f, 1.0f);
    switch(mOffsetType){
    case _BOTTOM_RIGHT:
	glTexCoord2f(0, 0);
	glVertex2d(canvasWidth - mOffsetX, mOffsetY);
	glTexCoord2f(1, 0);
	glVertex2d(canvasWidth - mOffsetX + mWidth, mOffsetY);
	glTexCoord2f(1, 1);
	glVertex2d(canvasWidth - mOffsetX + mWidth, mOffsetY + mHeight);
	glTexCoord2f(0, 1);
	glVertex2d(canvasWidth - mOffsetX, mOffsetY + mHeight);
    }
    
    glEnd();

    glPopAttrib();
}

bool GLButton_cls::
IsMouseOnButton(int canvasWidth, int canvasHeight,
		int mouseX, int mouseY){
    mbMouseOn = TRUE;
    switch(mOffsetType){
    case _BOTTOM_RIGHT:
	if (mouseX > canvasWidth - mOffsetX &&
	    mouseX < canvasWidth - mOffsetX + 24&&
	    mouseY > canvasHeight - mOffsetY - 24 && 
	    mouseY < canvasHeight - mOffsetY) return TRUE;
	break;
    }
    mbMouseOn = FALSE;
    return FALSE;
}
