// -*- c -*-
// "clsGLCanvasCtrl.cpp"

#ifndef _GL_CANVAS_CTRL_H_
#define _GL_CANVAS_CTRL_H_

#include <wx/wx.h>
#include <wx/glcanvas.h>
#include <wx/clrpicker.h>
#include "../MYGL/clsPositionAndDirection.h"
#include "../WIDGETCTRL/EX/clsCheckBoxEX.h"
#include "../../clsCameraPath.h"


class FrameMain_cls; 
class MainGLCanvas_cls;

class wxToggleButton; 

#define _GL_CANVAS_DISPLAY_FREE    _DIRECTION_FREE
#define _GL_CANVAS_DISPLAY_X_PLUS  _DIRECTION_X_PLUS
#define _GL_CANVAS_DISPLAY_X_MINUS _DIRECTION_X_MINUS
#define _GL_CANVAS_DISPLAY_Y_PLUS  _DIRECTION_Y_PLUS
#define _GL_CANVAS_DISPLAY_Y_MINUS _DIRECTION_Y_MINUS
#define _GL_CANVAS_DISPLAY_Z_PLUS  _DIRECTION_Z_PLUS
#define _GL_CANVAS_DISPLAY_Z_MINUS _DIRECTION_Z_MINUS
#define _GL_CANVAS_LINKED_CAM0 7

class GLCanvasCtrl_cls : public wxPanel {
 public:
    GLCanvasCtrl_cls(wxWindow *parent, wxWindowID id = wxID_ANY,
		     int* attribList = 0,
		     const wxPoint& pos = wxDefaultPosition,
		     const wxSize& size = wxDefaultSize, 
		     long style = 0,
		     const wxString& name = wxT("MainGLCanvas"),
		     const wxGLContext *contextToShare = NULL,
		     unsigned int selfIndex = 0, 
		     int displayMode = _GL_CANVAS_DISPLAY_FREE);
    ~GLCanvasCtrl_cls();
    
    MainGLCanvas_cls *mpCGLCanvas;
    wxString         mAChoiceStr[_GL_CANVAS_LINKED_CAM0 + 1 + _PATH_NUM_MAX];
    unsigned int     mSelfIndex;
    bool             mbPanelShown;

    int GetDisplayMode();

    wxComboBox       *mpCComboDirection;
    wxCheckBoxEX     *mpCBoolFlip;
    wxCheckBoxEX     *mpCFBO;
    wxToggleButton   *mpCToggleItem;
    wxToggleButton   *mpCToggleWire;
    wxToggleButton   *mpCToggleBox;
    wxToggleButton   *mpCToggleGrid;
    wxToggleButton   *mpCToggleData;
    wxMenu           *mpCPopupMenu;
    wxBoxSizer       *mpBoxSizerBar;

    bool IsPanelShown();
    void ShowPanel();
    void UpdateWindow();
    void UpdateComboBoxList(int camNum);
    
    void OnPaint(wxPaintEvent& event);
    void OnSize (wxSizeEvent& event);
    void OnKeyDown(wxKeyEvent& event);
    void OnBGColor(wxColourPickerEvent& event);
    void OnComboBox(wxCommandEvent& event);
    void OnCheckBox(wxCommandEvent& event);
    void OnToggleItem(wxCommandEvent& event);
    void OnToggleWire(wxCommandEvent& event);
    void OnToggleBox(wxCommandEvent& event);
    void OnToggleGrid(wxCommandEvent& event);
    void OnToggleData(wxCommandEvent& event);
    void OnMenuHide(wxCommandEvent& event);
    void OnMouse(wxMouseEvent& event);

    void SetParentClass(FrameMain_cls* pCParentFrame);

    void UpdateToggleButtonsAndParams();

    wxString GetPovStrCamPos();
    wxString GetPovStrCamMatrix();
    wxString GetPovStrMask(int start, int end, int height, double theta);
    void ReadStrLine(std::wistream &istream, std::wstring strLine);
    wxString SerializeConf();
    
    DECLARE_EVENT_TABLE()
};

#endif
