// "clsStructDrawInfo.h"

#include "clsStructDrawInfo.h"

#define X 0
#define Y 1
#define Z 2
#define LOOP_XYZ for (int xyz = 0; xyz < 3; xyz++)

StructDrawInfo::
StructDrawInfo(){
    mbForceNewDraw = FALSE;
}

void StructDrawInfo::
ForceNewDraw(){
    mbForceNewDraw = TRUE;
}

void StructDrawInfo::
SetBoolList(bool b0, bool b1, bool b2, bool b3, bool b4,
	    bool b5, bool b6, bool b7, bool b8){
    mABoolList[0] = b0;    mABoolList[1] = b1;    mABoolList[2] = b2;
    mABoolList[3] = b3;    mABoolList[4] = b4;    mABoolList[5] = b5;
    mABoolList[6] = b6;    mABoolList[7] = b7;    mABoolList[8] = b8;
}

void StructDrawInfo::
SetBoolPolygon(bool bPolygon[3]){
    LOOP_XYZ mABoolPolygon[xyz] = bPolygon[xyz];
}

void StructDrawInfo::
SetBoolMirror(bool bMirror[3]){
    LOOP_XYZ mABoolMirror[xyz] = bMirror[xyz];
}

void StructDrawInfo::
SetBoolCopying(bool bCopying[3]){
    LOOP_XYZ mABoolCopying[xyz] = bCopying[xyz];
}

void StructDrawInfo::
SetCopyFrom(int copyFrom[3]){
    LOOP_XYZ mACopyFrom[xyz] = copyFrom[3];
}

void StructDrawInfo::
SetBoxInfo(double boxMin[3], double boxMax[3], double boxRotate[4]){
    LOOP_XYZ mABoxMin[xyz] = boxMin[xyz];
    LOOP_XYZ mABoxMax[xyz] = boxMax[xyz];
    for (int i = 0; i < 4; i++) mABoxRotate[i] = boxRotate[i];
}

void StructDrawInfo::
SetLightInfo(int lightNum, float lightPos[][4], float lightColor[][4]){
    mLightNum = lightNum;
    for (int index = 0 ; index < mLightNum; index++)
	for (int i = 0; i < 4; i++) {
	    mALightPos[index][i] = lightPos[index][i];
	    mALightColor[index][i] = lightColor[index][i]; }
}

void StructDrawInfo::
SetClipInfo(double clipMin[3], double clipMax[3]){
    LOOP_XYZ mAClipMin[xyz] = clipMin[xyz];
    LOOP_XYZ mAClipMax[xyz] = clipMax[xyz];
}

void StructDrawInfo::
SetTransInfo(double trans[3]){
    LOOP_XYZ mATrans[xyz] = trans[xyz];
}

void StructDrawInfo::
SetClipInfoNew( std::vector < std::vector < double > > VVClipInfoMin,
		std::vector < std::vector < double > > VVClipInfoMax,
		std::vector < bool > VClipInfoActive){
    mVVClipInfoMin = VVClipInfoMin;
    mVVClipInfoMax = VVClipInfoMax;
    mVClipInfoActive = VClipInfoActive;
}

void StructDrawInfo::
SetShadeInfo(double pShadeOffset[3]){
    LOOP_XYZ mAShadeOffset[xyz] = pShadeOffset[xyz];
}

void StructDrawInfo::
SetCopyTo(int copyTo[3]){
    LOOP_XYZ mACopyTo[xyz] = copyTo[3];
}

void StructDrawInfo::
SetFilenames(std::vector < wxString > VwstrFilename){
    mVwstrFilename = VwstrFilename;
}

int StructDrawInfo::
DiffForDebug(const StructDrawInfo& CR){
    if (mbForceNewDraw == TRUE) return 999;
    if (CR.mbForceNewDraw == TRUE) return 998;
    
    if (!(mCCamPos == CR.mCCamPos)) return 1;
    if (!(mCAncPos == CR.mCAncPos)) return 2;
    if (!(mRemappedIndex == CR.mRemappedIndex)) return 3;
    if (!(mWidth == CR.mWidth)) return 4;
    if (!(mHeight == CR.mHeight)) return 5;
    if (!(mDisplayMode == CR.mDisplayMode)) return 5;
    for (int i = 0; i < 9; i++)
	if (mABoolList[i] != CR.mABoolList[i]) return 6;
    if (mVwstrFilename.size() != CR.mVwstrFilename.size()) return 7;
    unsigned int min = mVwstrFilename.size();
    if (min < CR.mVwstrFilename.size()) min = CR.mVwstrFilename.size();
    for (unsigned int i = 0; i < min; i++)
	if (mVwstrFilename[i] != CR.mVwstrFilename[i]) return 7;
    LOOP_XYZ if (mABoolPolygon[xyz] != CR.mABoolPolygon[xyz]) return 8;
    LOOP_XYZ if (mABoolMirror[xyz] != CR.mABoolMirror[xyz]) return 9;
    LOOP_XYZ if (mABoolCopying[xyz] != CR.mABoolCopying[xyz]) return 10;
    LOOP_XYZ if (mACopyFrom[xyz] != CR.mACopyFrom[xyz]) return 11;
    LOOP_XYZ if (mACopyTo[xyz] != CR.mACopyTo[xyz]) return 12;
    LOOP_XYZ if (mABoxMin[xyz] != CR.mABoxMin[xyz]) return 13;
    LOOP_XYZ if (mABoxMax[xyz] != CR.mABoxMax[xyz]) return 14;
    for (int i = 0; i < 4; i++) if (mABoxRotate[i] != CR.mABoxRotate[i]) return 15;

    if (mLightNum != CR.mLightNum)
	return 16;
    else
	for (int index = 0; index < mLightNum; index++)
	    for (int i = 0; i < 4; i++) {
		if (mALightPos[index][i] != CR.mALightPos[index][i]) return 16;
		if (mALightColor[index][i] != CR.mALightColor[index][i]) return 16;
	    }
    
    LOOP_XYZ if (mAClipMin[xyz] != CR.mAClipMin[xyz]) return 17;
    LOOP_XYZ if (mAClipMax[xyz] != CR.mAClipMax[xyz]) return 18;
    LOOP_XYZ if (mATrans[xyz] != CR.mATrans[xyz]) return 24;
    LOOP_XYZ if (mAShadeOffset[xyz] != CR.mAShadeOffset[xyz]) return 19;
    if (mVVClipInfoMin != CR.mVVClipInfoMin) return 20;
    //if (mVVClipInfoMax != CR.mVVClipInfoMax) return 21;
    //if (mVClipInfoActive != CR.mVClipInfoActive) return 22;
    LOOP_XYZ if (mAShadeOffset[xyz] != CR.mAShadeOffset[xyz]) return 23;

    return 0;
}

bool operator==(const StructDrawInfo& CL, const StructDrawInfo& CR){
    if (CL.mbForceNewDraw == TRUE || CR.mbForceNewDraw == TRUE){
	return FALSE;
    }
    bool retVal = TRUE;
    if (!(CL.mCCamPos == CR.mCCamPos)) retVal = FALSE;
    if (!(CL.mCAncPos == CR.mCAncPos)) retVal = FALSE;
    if (!(CL.mRemappedIndex == CR.mRemappedIndex)) retVal = FALSE;
    if (!(CL.mWidth == CR.mWidth)) retVal = FALSE;
    if (!(CL.mHeight == CR.mHeight)) retVal = FALSE;
    if (!(CL.mDisplayMode == CR.mDisplayMode)) retVal = FALSE;
    for (int i = 0; i < 9; i++)
	if (CL.mABoolList[i] != CR.mABoolList[i]) retVal = FALSE;
    if (CL.mVwstrFilename.size() != CR.mVwstrFilename.size()) retVal = FALSE;
    unsigned int min = CL.mVwstrFilename.size();
    if (min > CR.mVwstrFilename.size()) min = CR.mVwstrFilename.size();
    for (unsigned int i = 0; i < min; i++)
	if (CL.mVwstrFilename[i] != CR.mVwstrFilename[i]) retVal = FALSE;

    LOOP_XYZ if (CL.mABoolPolygon[xyz] != CR.mABoolPolygon[xyz]) retVal = FALSE;
    LOOP_XYZ if (CL.mABoolMirror[xyz] != CR.mABoolMirror[xyz]) retVal = FALSE;
    LOOP_XYZ if (CL.mABoolCopying[xyz] != CR.mABoolCopying[xyz]) retVal = FALSE;
    LOOP_XYZ if (CL.mACopyFrom[xyz] != CR.mACopyFrom[xyz]) retVal = FALSE;
    LOOP_XYZ if (CL.mACopyTo[xyz] != CR.mACopyTo[xyz]) retVal = FALSE;
    LOOP_XYZ if (CL.mABoxMin[xyz] != CR.mABoxMin[xyz]) retVal = FALSE;
    LOOP_XYZ if (CL.mABoxMax[xyz] != CR.mABoxMax[xyz]) retVal = FALSE;
    for (int i = 0; i < 4; i++) if (CL.mABoxRotate[i] != CR.mABoxRotate[i]) retVal = FALSE;
    
    if (CL.mLightNum != CR.mLightNum)
	retVal = FALSE;
    else
	for (int index = 0; index < CL.mLightNum; index++)
	    for (int i = 0; i < 4; i++) {
		if (CL.mALightPos[index][i] != CR.mALightPos[index][i]) 
		    retVal = FALSE;
		if (CL.mALightColor[index][i] != CR.mALightColor[index][i]) 
		    retVal = FALSE;
	    }
    
    LOOP_XYZ if (CL.mAClipMin[xyz] != CR.mAClipMin[xyz]) retVal = FALSE;
    LOOP_XYZ if (CL.mAClipMax[xyz] != CR.mAClipMax[xyz]) retVal = FALSE;
    LOOP_XYZ if (CL.mATrans[xyz] != CR.mATrans[xyz]) retVal = FALSE;
    if (CL.mVVClipInfoMin != CR.mVVClipInfoMin) retVal = FALSE;
    //if (CL.mVVClipInfoMax != CR.mVVClipInfoMax) retVal = FALSE;
    //if (CL.mVClipInfoActive != CR.mVClipInfoActive) retVal = FALSE;
    LOOP_XYZ if (CL.mAShadeOffset[xyz] != CR.mAShadeOffset[xyz]) retVal = FALSE;
    
    return retVal;
}
