// -*- c -*- 
// (setq c-basic-offset 4)
// ("GLOBJTransCube.h")

#include <math.h>

#ifdef WIN32
#include <windows.h>
#endif

#include <GL/gl.h>
#include <GL/glu.h>
#include "GLOBJTransCube.h"

#define X 0
#define Y 1
#define Z 2

namespace GLOBJ {
    /*!
      @brief ȃL[u [0:0],[+1:+1]̕`
    */
    int TransCube::DListDraw(int iMode, unsigned int opaque){

	float alpha = 0.06f * (opaque + 1);
	float vivid = 0.5f - (0.1f * opaque);

	int    listName = 0;
	if (iMode == GL_COMPILE || iMode == GL_COMPILE_AND_EXECUTE){
	    listName = glGenLists(1); // VKXg̔ԍ
	    glNewList (listName, iMode); 
	}

	glColor4f(1.f, vivid*2, vivid, alpha);
	glBegin(GL_QUADS);
	glVertex3d(0, 0, 0); glVertex3d(1, 0, 0);
	glVertex3d(1, 1, 0); glVertex3d(0, 1, 0);
	
	glVertex3d(0, 0, 1); glVertex3d(1, 0, 1);
	glVertex3d(1, 1, 1); glVertex3d(0, 1, 1);
	glEnd();
	
	glColor4f(1.f, vivid, vivid*2, alpha);
	glBegin(GL_QUADS);
	glVertex3d(0, 0, 0); glVertex3d(0, 1, 0);
	glVertex3d(0, 1, 1); glVertex3d(0, 0, 1);
	
	glVertex3d(1, 0, 0); glVertex3d(1, 1, 0);
	glVertex3d(1, 1, 1); glVertex3d(1, 0, 1);
	glEnd();
	
	glColor4f(vivid, vivid*2, 1.f, alpha);
	glBegin(GL_QUADS);
	glVertex3d(0, 0, 0); glVertex3d(1, 0, 0);
	glVertex3d(1, 0, 1); glVertex3d(0, 0, 1);
	
	glVertex3d(0, 1, 0); glVertex3d(1, 1, 0);
	glVertex3d(1, 1, 1); glVertex3d(0, 1, 1);
	glEnd();
	
	if (iMode == GL_COMPILE || iMode == GL_COMPILE_AND_EXECUTE)
	    glEndList(); 
	
	return listName;
    }

    /*!
      @brief C[{bNX [0:0],[+1:+1]̕`
    */
    int WireBox::DListDraw(int iMode, unsigned int type){
	int    listName = 0;
	if (iMode == GL_COMPILE || iMode == GL_COMPILE_AND_EXECUTE){
	    listName = glGenLists(1); // VKXg̔ԍ
	    glNewList (listName, iMode); 
	}

	switch(type){
	case 0:
	    glColor4f(1.f, 1.f, 1.f, 0.4f); break;
	case 1:
	    glColor4f(1.f, 0.5f, 0.5f, 0.6f); break;
	case 2:
	    glColor4f(1.f, 1.f, 1.f, 1.0f); break;
	case 3:
	    glColor4f(1.f, 0.5f, 0.5f, 1.0f); break;
	case 4:
	    glColor4f(1.f, 1.f, 0.2, 1.f); break;
	}

	glBegin(GL_LINE_LOOP);
	glVertex3d(0, 0, 0); glVertex3d(1, 0, 0);
	glVertex3d(1, 1, 0); glVertex3d(0, 1, 0);
	glEnd();

	glBegin(GL_LINE_LOOP);
	glVertex3d(0, 0, 1); glVertex3d(1, 0, 1);
	glVertex3d(1, 1, 1); glVertex3d(0, 1, 1);
	glEnd();

	glBegin(GL_LINES);
	glVertex3d(0, 0, 0); glVertex3d(0, 0, 1);
	glVertex3d(1, 0, 0); glVertex3d(1, 0, 1);
	glVertex3d(1, 1, 0); glVertex3d(1, 1, 1);
	glVertex3d(0, 1, 0); glVertex3d(0, 1, 1);
	glEnd();

	if (iMode == GL_COMPILE || iMode == GL_COMPILE_AND_EXECUTE)
	    glEndList(); 
	
	return listName;
    }

    void DrawWireBoxMinMax(double *min, double *max){
	glBegin(GL_LINE_LOOP);
	glVertex3d(min[X], min[Y], min[Z]);
	glVertex3d(max[X], min[Y], min[Z]);
	glVertex3d(max[X], max[Y], min[Z]);
	glVertex3d(min[X], max[Y], min[Z]);
	glEnd();
	
	glBegin(GL_LINE_LOOP);
	glVertex3d(min[X], min[Y], max[Z]);
	glVertex3d(max[X], min[Y], max[Z]);
	glVertex3d(max[X], max[Y], max[Z]);
	glVertex3d(min[X], max[Y], max[Z]);
	glEnd();
	
	glBegin(GL_LINES);
	glVertex3d(min[X], min[Y], min[Z]);
	glVertex3d(min[X], min[Y], max[Z]);
	glVertex3d(max[X], min[Y], min[Z]);
	glVertex3d(max[X], min[Y], max[Z]);
	glVertex3d(max[X], max[Y], min[Z]); 
	glVertex3d(max[X], max[Y], max[Z]);
	glVertex3d(min[X], max[Y], min[Z]); 
	glVertex3d(min[X], max[Y], max[Z]);
	glEnd();
    }

    void AdjustCoordinateMinMax(double *min, double *max){
	glTranslated(min[X], min[Y], min[Z]);
	glScaled(max[X]-min[X], max[Y]-min[Y], max[Z]-min[Z]);
    }
    
}
