
#ifndef _ISOSURFICE_MARCHINGCUBE_H_
#define _ISOSURFICE_MARCHINGCUBE_H_

#ifdef WIN32
#include <windows.h>
#endif
#include <GL/gl.h>

#include <vector>
#include <wx/thread.h>

// The main routine of this class used
// Marching Cubes Example Program 
// by Cory Bloyd (corysama@yahoo.com)
// which is publicshd as public domain 

class MarchingCube_cls;

struct GLvector{
    GLfloat fX;
    GLfloat fY;
    GLfloat fZ;     
};

/*
class VerticesVector_cls{
 public:
    std::vector < float > mVVertices;
    std::vector < float > mVNormals;
};
*/

class ThreadMarching : public wxThread {
 public:
    ThreadMarching();
    void SetParameters(MarchingCube_cls *pCParent, int selfIndex,
		       float *pTmpVertices,
		       float *pTmpNormal,
		       int *pArrayIndex,
		       unsigned char *pData,
		       unsigned int size[3], int initZ, int finZ,
		       float targetValue);

    GLfloat GetOffset(GLfloat fValue1, GLfloat fValue2, GLfloat fValueDesired);
    float GetInterpolatedValue(unsigned char *pData,
			     int lBaseIndex, float fx, float fy, float fz);
    void GetNormalPrecise
	(GLvector &rfNormal, unsigned char *pData,
	 int x, GLfloat fX, int y, GLfloat fY, int z, GLfloat fZ);

    void MarchCubeMainThread(unsigned char *pData, int x, int y, int z);
    
    virtual ExitCode Entry();

    MarchingCube_cls *mpCParent;
    int mSelfIndex;
    int *mpArrayIndex;
    float *mpTmpVertices, *mpTmpNormal;

    unsigned char *mpData;
    int mSize[3];
    int mInitZ, mFinZ;

    int mOffsetZ, mOffsetY;
    int mBaseIndex;
    float mTargetValue, mTargetValue255;

    static const GLint   VOffset[8][3];
    static const GLint   a2iEdgeConnection[12][2];
    static const GLfloat a2fEdgeDirection[12][3];

    static const GLint aiCubeEdgeFlags[256];
    static const GLint a2iTriangleConnectionTable[256][16];
};

class MarchingCube_cls{
 public:

    std::vector < float > mVVertices[8];
    std::vector < float > mVNormals[8];

    int mSizeX, mSizeY, mSizeZ;
    int mOffsetZ, mOffsetY;
    int mBaseIndex;
    
    float mTargetValue, mTargetValue255;
    
    void Clear();
    void ConstructVertices
	(unsigned char *pData, int sizeX, int sizeY, int sizeZ,
	 int threadNum);
    void GLDraw(double scale[3]);
}; 

#endif

