// -*- c -*- 
// "clsDialogEX.h"

#include "clsDialogEXKey.h"

wxDialogEXKey::
wxDialogEXKey(wxWindow* parent, wxWindowID id, const wxString& label,
	      const wxPoint& pos, const wxSize& size,
	      long style, const wxString& name) :
    wxDialog(parent, id, label, pos, size, style, name),
    mIDCloseButton(wxID_CANCEL), mpCRectPos(NULL),
    mbPreventDestroy(FALSE)
{
    SetBackgroundColour(wxColour(wxT("WHEAT")));
    Connect(id, wxEVT_KEY_DOWN,
	    wxKeyEventHandler(wxDialogEXKey::OnKeyDown));
}

wxDialogEXKey::
~wxDialogEXKey(){
    MakeModal(FALSE);
}

void wxDialogEXKey::
SetCloseButtonID(int IDCloseButton){
    mIDCloseButton = IDCloseButton;
}

void wxDialogEXKey::
SetScreenRectPos(wxRect *pCRectPos){
    mpCRectPos = pCRectPos;
}

void wxDialogEXKey::
CloseEXKey(int retCode){
    if (mpCRectPos != NULL) *mpCRectPos = GetScreenRect();
#ifdef WIN32
    if (IsModal() == TRUE)
	EndModal(retCode);
    else
	Show(FALSE);
#else
    if (IsModal() == TRUE && mbPreventDestroy == TRUE)
	EndModal(retCode);
    else
	Destroy();
#endif
}

//#include "../MYAPI/MsgBox.h"

void wxDialogEXKey::
OnKeyDown(wxKeyEvent& event){
    int code = event.GetKeyCode();
    switch(code){
    case 'W':
	if (event.GetModifiers() == wxMOD_CONTROL &&
	    mIDCloseButton != wxID_NONE){
	    wxCommandEvent event = wxCommandEvent(wxEVT_COMMAND_BUTTON_CLICKED,
						  wxID_CANCEL);
	    GetEventHandler()->AddPendingEvent(event);
	}
	break;
    }
    
    if (IsModal() == FALSE)
	wxPostEvent(GetParent()->GetEventHandler(), event);

#ifndef WIN32
    event.Skip();
#endif
}
