
/*
class FileSequence_cls : public Filename_cls {
 public:
    FileSequence_cls();
    FileSequence_cls(const wchar_t *path);
    FileSequence_cls(const std::wstring pathStr);

    void Set(const std::wstring pathStr);
    
    std::wstring::size_type SequenceFormatPos();
    
    void InitFormat();
    void SplitFormat(std::wstring::size_type pos);
    void CalcMaxOffset();

    // abc/def0000.ext
    // abc/def         msFileHead; 
    // anc/def%03d.ext msFormat;
    std::wstring msFileHead;
    std::wstring msFormat;
    std::wstring msExt;

    int         mDigit;       // AԂ̍ŏ̐
    int         mDigitLength; // AԂ̌
    int         mSeqLength;   // t@C
    std::wstring GetFormat();
    std::wstring GetModifiedStr(int index);
    std::wstring GetInfoStr();
    //void AppendDefaultSequenceTag();
};
*/



/*
FileSequence_cls::
FileSequence_cls() : Filename_cls() {
    mDigitLength = -1;
}

FileSequence_cls::
FileSequence_cls(const wchar_t *path) : Filename_cls(path) {
    InitFormat();
}

FileSequence_cls::
FileSequence_cls(const std::wstring pathStr) : Filename_cls(pathStr){
    InitFormat();
}

void FileSequence_cls::
Set(const std::wstring pathStr){
    Filename_cls::Set(pathStr);
    std::wstring::size_type formatPos = SequenceFormatPos();
    if (formatPos == std::wstring::npos) InitFormat();
    else SplitFormat(formatPos); 
}

std::wstring::size_type FileSequence_cls::
SequenceFormatPos(){
    for (int index = 1; index < 6; index++){
	wchar_t buf[12];
	swprintf(buf, 12, L"%ls0%dd", L"%", index);
	std::wstring::size_type pos = mSPath.find(buf);
	if (pos != std::wstring::npos) {
	    mDigitLength = index;
	    mDigit = 0;
	    return pos;
	}
    }
    return std::wstring::npos;
}

void FileSequence_cls::
InitFormat(){
    // %0[1-5]d甲
    for (int i = 1; i < 6; i++){
	wchar_t buf[5];
	swprintf(buf, 5, L"%ls0%dd", L"%", i);
	if (mSPath.find(buf, 0) != std::wstring::npos) {
	    mDigitLength = 1;
	    return;
	}
    }

    SplitPath_cls CPath(mSPath);
    std::wstring   strPathMinusExt = CPath.msFullPathMinusExt;
    
    std::wstring::size_type posTail = strPathMinusExt.size() - 1;
    if (posTail > 999)  return;

    while (strPathMinusExt[posTail] >= '0' && 
	   strPathMinusExt[posTail] <= '9'){
	posTail--;
	if (posTail > 999) break;
    }

    posTail++;

    if (posTail == strPathMinusExt.size()){
	mDigit = 0; mDigitLength = -1;
	msFileHead = strPathMinusExt;
	msFormat   = mSPath;
	return;
    }
    
    std::wstring strFH = CPath.msFullPathMinusExt.substr(0, posTail);
    std::wstring strDigit = CPath.msFullPathMinusExt.c_str() + posTail;

#ifdef WIN32
    mDigit       = _wtoi(strDigit.c_str());
#else
    wxString wxDigit = wxConvFile.cWC2WX(strDigit.c_str());
    mDigit       = atoi(wxDigit.ToAscii());
#endif
    mDigitLength = (int)(CPath.msFullPathMinusExt.size() - posTail);
    std::wstringstream ssLH;
    ssLH << "%0" << mDigitLength << "d";

    msFileHead = strFH;
    msFormat = strFH + ssLH.str() + CPath.msExt;
    msExt    = CPath.msExt;
}

void FileSequence_cls::
SplitFormat(std::wstring::size_type pos){
    SplitPath_cls CPath(mSPath);
    msFileHead = mSPath.substr(0, pos);
    msFormat   = mSPath;
    msExt      = CPath.msExt;
}

void FileSequence_cls::
CalcMaxOffset(){
    if (mDigitLength == -1) {
	mSeqLength = 1;
	return;
    }
    
    if (1==0) // ԕὠfBNgω鎞݂̂ɁBĂCHH
	if (msExt == L".png" || msExt == L".PNG" ||
	    msExt == L".tif" || msExt == L".TIF" ||
	    msExt == L".tiff" || msExt == L".TIFF"){
	    // 摜̘AԂ́A{PXebv̂
	    SplitPath_cls CSplit0(GetModifiedStr(0));
	    SplitPath_cls CSplit1(GetModifiedStr(1));
	    if (CSplit0.GetPathStr(_FN_DRIVE_DIR) == 
		CSplit1.GetPathStr(_FN_DRIVE_DIR)){
		mSeqLength = 1;
		return;
	    }
	}
    
    mSeqLength    = 0; 
    int increment = 1000;
    int offset    = 0;

    //std::locale::global( std::locale ("japanese"));
#ifdef WIN32
    std::wfstream ifstream(GetModifiedStr(offset).c_str(), std::ios::in);
#else
    wxString wxFileIn = wxConvFile.cWC2WX(GetModifiedStr(offset).c_str());
    std::ifstream ifstream(wxFileIn.ToAscii(), std::ios::in);
#endif

    std::wstring strMes = L"Can not open file";
    wxString wxMes = wxConvLibc.cWC2WX(strMes.c_str());

    if (ifstream.fail()) {// ȃt@C
	MsgBoxf(NULL, WCHARCONV("t@Cǂ߂܂"),
		"FileSequence_cls::CalcMaxOffset\n%ls\nFile open fails", 
		GetModifiedStr(offset).c_str() );
	return ; } 
    ifstream.close();

    bool exitFlag = FALSE;

    while (TRUE){
	do {
	    if (increment == 1){ // increment1J艺ȂI
		exitFlag = TRUE; break;
	    }
	    increment /= 10;
	
	    ifstream.clear();
#ifdef WIN32
	    ifstream.open(GetModifiedStr(offset + increment).c_str(),
			  std::ios::in);
#else
	    wxFileIn = wxConvFile.cWC2WX(GetModifiedStr(offset + increment).c_str());
	    ifstream.open(wxFileIn.ToAscii(), std::ios::in);
#endif
	    if (!ifstream.fail()) ifstream.close();
	    else
		MsgBoxf(NULL, "FileSequence_cls::CalcMaxOffset",
			"open %s fails %d", 
			GetModifiedStr(offset + increment).c_str(),
			mSeqLength);
	    
	} while (ifstream.fail()); // t@CincrementJ艺
	
	mSeqLength += increment;
	offset  += increment;
	if (exitFlag == TRUE) break;
	increment *= 10;
    }
}

// ---------------------

std::wstring FileSequence_cls::
GetFormat(){
    return msFormat;
}

std::wstring FileSequence_cls::
GetModifiedStr(int offset){
    wchar_t buf[255];
    swprintf(buf, 255, GetFormat().c_str(), mDigit + offset);
    return (std::wstring)buf;
}

std::wstring FileSequence_cls::
GetInfoStr(){
    std::wstringstream ssInfo;
    ssInfo << msFormat;
    if (mDigitLength != -1)
	ssInfo << "   (" << mDigit << "-" << mDigit + mSeqLength << ")";
    return ssInfo.str();
}

void FileSequence_cls::
AppendDefaultSequenceTag(){
    Set(mwsFileHead+wxT("%04d.")+mwsExt);
}
*/
