// -*- c -*- 
// (setq c-basic-offset 4)
// "clsMultiNumericalInputs.h"

//#include <wx/valgen.h>
#include "clsMultiNumericalInputs.h"
#include "clsAtofTextCtrl.h"
#include "clsAtoiTextCtrl.h"
#include "clsAtoiComboCtrl.h"
#include "clsAtoSTextCtrl.h"
#include "clsSliderInt.h"
#include "clsSliderFloat.h"
#include "clsCheckBoxEX.h"
#include "../../wxWidgetEnum.h"
#include "../MYAPI/MsgBox.h"

#define wxComEH wxCommandEventHandler

int alignList[4] = {
    wxEXPAND,
    wxEXPAND,
    wxALIGN_RIGHT,
    wxALIGN_RIGHT};

MultiNumericalInputsBase_cls::
MultiNumericalInputsBase_cls() :
    mpBTNAssign (NULL)
{
    mbDirty = FALSE;
    mbHideButton = TRUE;
    mSizerIndex = 0;
    mSizerCounter = 0;
    mpFuncCheck = NULL;
    
    mDefaultButton = _MN_ASSIGN_UPDATE_HIDE;
    mTextWidth = 40;
    mButtonWidth = 210;
    mComboWidth = -1;
    mMinimumWidth = 220;
}

void MultiNumericalInputsBase_cls::
CombinePointerButton(int item, wxString title, bool enabled){
    unsigned int currentIndex = (unsigned int)mVCPointers.size();

    mVCPointers.push_back(GeneralPointer_cls());
    mVCPointers[currentIndex]
	.CombinePointerButton(item, title, enabled);
    
    if (mSizerCounter > 0){
	mVCPointers[currentIndex].mbConnectSizer = TRUE;
	mVCPointers[currentIndex].mSizerIndex = mSizerIndex;
	mSizerCounter--;
    }
}

void MultiNumericalInputsBase_cls::
CombinePointer(int type, void* pPointerVal, wxString title, bool enabled,
	       unsigned int listMax, wxString *pChoiceList, unsigned int init,
	       unsigned int offset){
    unsigned int currentIndex = (unsigned int)mVCPointers.size();

    mVCPointers.push_back(GeneralPointer_cls());
    mVCPointers[currentIndex]
	.CombinePointer(type, pPointerVal, title, enabled,
			listMax, pChoiceList, init, offset);
    mVCPointers[currentIndex].mTextWidth = mTextWidth;
    
    if (mSizerCounter > 0){
	mVCPointers[currentIndex].mbConnectSizer = TRUE;
	mVCPointers[currentIndex].mSizerIndex = mSizerIndex;
	mSizerCounter--;
    }

    if (type == _GP_BOXSIZERHORIZONTAL){
	mSizerIndex = currentIndex;
	mSizerCounter = *(int*)pPointerVal;
    }
}

void MultiNumericalInputsBase_cls::
SetRange(double min, double max, int index, int scale){
    if (index == _MN_LASTITEM)
	mVCPointers[mVCPointers.size() - 1].SetRange(min, max, scale);
    else
	mVCPointers[index].SetRange(min, max, scale);
}

void MultiNumericalInputsBase_cls::
DisableHookSpace(int index){
    if (index == _MN_LASTITEM)
	mVCPointers[mVCPointers.size() - 1].DisableHookSpace();
    else
	mVCPointers[index].DisableHookSpace();
}

void MultiNumericalInputsBase_cls::
AlignRight(int index){
    if (index == _MN_LASTITEM)
	mVCPointers[mVCPointers.size() - 1].AlignRight();
    else
	mVCPointers[index].AlignRight();
}

void MultiNumericalInputsBase_cls::
SetTitle(unsigned int index, wxString title){
    assert(index < mVCPointers.size());
    mVCPointers[index].mTitle = title;
}

void MultiNumericalInputsBase_cls::
MakeGeometryBase(wxBoxSizer* pBoxSizerSrc, wxWindow* pWindow){
    
    for (unsigned int i = 0; i < mVCPointers.size(); i++){
      
	// $B;R6!$N%5%$%6!<$rMQ0U$9$k!#(B
	if (mVCPointers[i].mType == _GP_BOXSIZERHORIZONTAL){
	    mVCPointers[i].GPConnect_BoxSizer(pBoxSizerSrc, pWindow);
	    continue;
	}

	wxBoxSizer *pBSizerCurrent;
	if (mVCPointers[i].mbConnectSizer == TRUE)
	    // $B;R6!$N%5%$%6!<$K7k$S$D$1$k(B
	    pBSizerCurrent = (wxBoxSizer*)
		mVCPointers[mVCPointers[i].mSizerIndex].mpPointerCtrl;
	else
	    // $B?75,%5%$%6!<$K7k$S$D$1$k(B($B%?%$%H%kIU$-(B)
	    pBSizerCurrent = mVCPointers[i].GetPSizer(pWindow);

	switch(mVCPointers[i].mType){
	case _GP_STATIC_TEXT:
	    mVCPointers[i].GPConnect_SText(pBSizerCurrent, pWindow);
	    break; 
	case _GP_BUTTON :
	case _GP_BUTTON_HIDE_PANEL : 
	    mVCPointers[i].GPConnect_Button(pBSizerCurrent, pWindow, mButtonWidth);
	    switch (mVCPointers[i].mType){
	    case _GP_BUTTON_HIDE_PANEL:
		pWindow->Connect(mVCPointers[i].mID,
				 wxEVT_COMMAND_BUTTON_CLICKED,
				 wxCommandEventHandler(MultiNumericalInputsPanel_cls::OnHide ));
		break;
	    default: 
		ConnectButton(pWindow, mVCPointers[i].mID); break;
	    }
	    break; 
	case _GP_INTEGER:
	case _GP_UNSIGNED_INT:
	    mVCPointers[i].GPConnect_Integer(pBSizerCurrent, pWindow);
	    break;
	case _GP_UNSIGNED_INT_LIST: 
	    mVCPointers[i].GPConnect_List(pBSizerCurrent, pWindow, mComboWidth);
	    ConnectComboBox(pWindow, mVCPointers[i].mID);
	    break; 
	case _GP_INTEGER_SLIDER:
	    mVCPointers[i].GPConnect_SliderInt(pBSizerCurrent, pWindow);
	    ConnectScroll(pWindow, mVCPointers[i].mID);
	    break; 
	case _GP_FLOAT_SLIDER:
	    mVCPointers[i].GPConnect_SliderFloat(pBSizerCurrent, pWindow);
	    ConnectScroll(pWindow, mVCPointers[i].mID);
	    break;
	case _GP_FLOAT:
	    mVCPointers[i].GPConnect_Float(pBSizerCurrent, pWindow);
	    break;
	case _GP_DOUBLE:
	    mVCPointers[i].GPConnect_Double(pBSizerCurrent, pWindow);
	    break;
	case _GP_BOOL: 
	    mVCPointers[i].GPConnect_Bool(pBSizerCurrent, pWindow);
	    ConnectCheckBox(pWindow, mVCPointers[i].mID);
	    break; 
	case _GP_STRING:
	    mVCPointers[i].GPConnect_String(pBSizerCurrent, pWindow);
	    break;
	}
	
	mVCPointers[i].ApplyRange();
	
	if (mVCPointers[i].mbEnabled == FALSE)
	    mVCPointers[i].Disable();
	
	if (mVCPointers[i].mbConnectSizer == FALSE)
	    pBoxSizerSrc->Add(pBSizerCurrent, 
			      mVCPointers[i].GetSizerFlagV().Align(wxALIGN_CENTER_VERTICAL));
    }
    
    if (mDefaultButton != 0){
	wxBoxSizer *pBoxSizerButtons 
	    = new wxBoxSizer(wxHORIZONTAL);
	SetDefaultButtons(pWindow, pBoxSizerButtons);
	pBoxSizerSrc->Add(pBoxSizerButtons, 0, alignList[mDefaultButton]);
    }

    if (mType == _MN_DIALOG){
	unsigned int initIdx = SearchNextTabstop(-1, _MN_FORWARD);
	mVCPointers[initIdx].GetPCtrlWindow()->SetFocus();
    }

    pBoxSizerSrc->Add(mMinimumWidth, -1, 0, 0);
}

GeneralPointer_cls* MultiNumericalInputsBase_cls::
GetPLastVCPointer(){
    return &(mVCPointers[GetLastVCIndex()]);
}

unsigned int MultiNumericalInputsBase_cls::
GetLastVCIndex(){
    return (unsigned int)mVCPointers.size() - 1;
}

void MultiNumericalInputsBase_cls::
SetDefaultButtons(wxWindow* pC, wxBoxSizer *pSizer){
    switch(mDefaultButton){
    case _MN_ASSIGN_UPDATE_HIDE:
	mpBTNAssign = new wxButtonEX(pC, buttonCtrlAssign, wxT(" Assign"));
	mpBTNUpDate = new wxButtonEX(pC, buttonCtrl02, wxT("Update"));
	pSizer->Add(mpBTNAssign, 1, wxEXPAND);
	pSizer->Add(mpBTNUpDate, 1, wxEXPAND);
	
	if (mbHideButton == TRUE){
	    mpBTNHide   = new wxButtonEX(pC, wxID_CANCEL, wxT("Hide"), 
					 wxDefaultPosition, wxSize(40, -1));
	    pSizer->Add(mpBTNHide,   0, wxEXPAND);
	}
	break;
    case _MN_CANCEL_OK:
	mpBTNOK   = new wxButtonEX(pC, wxID_OK, wxT("OK"));
	pC->Connect(mpBTNOK->GetId(), wxEVT_COMMAND_BUTTON_CLICKED,
		    wxCommandEventHandler(MultiNumericalInputs_cls::OnOK));
	mpBTNHide = new wxButtonEX(pC, wxID_CANCEL, wxT("Cancel"));
	pSizer->Add(mpBTNHide, 0, wxALIGN_RIGHT | wxEXPAND);
	pSizer->Add(mpBTNOK,   0, wxALIGN_RIGHT | wxEXPAND);
	break;
    case _MN_OK_CANCEL:
	mpBTNOK   = new wxButtonEX(pC, wxID_OK, wxT("OK"));
	pC->Connect(mpBTNOK->GetId(), wxEVT_COMMAND_BUTTON_CLICKED,
		    wxCommandEventHandler(MultiNumericalInputs_cls::OnOK));
	mpBTNHide = new wxButtonEX(pC, wxID_CANCEL, wxT("Cancel"));
	pSizer->Add(mpBTNOK,   0, wxALIGN_RIGHT | wxEXPAND);
	pSizer->Add(mpBTNHide, 0, wxALIGN_RIGHT | wxEXPAND);
    }
}

int  MultiNumericalInputsBase_cls::
SearchNextTabstop(int index, int direction){
    int nextIndex = index;
    do {
	nextIndex += direction;
	if (nextIndex == (int)mVCPointers.size()){
	    if (index == -1) 
		return -1;
	    else            
		nextIndex = 0;
	}
	if (nextIndex < 0){
	    if (index == (int)mVCPointers.size()) 
		return -1;
	    else
		nextIndex = (int)mVCPointers.size() -1;
	}
	if (nextIndex == index) break;
    } while (mVCPointers[nextIndex].IsTabstop() == FALSE);
    
    return nextIndex;
}

void MultiNumericalInputsBase_cls::
SetTabRing(std::vector < MultiNumericalInputsBase_cls* > VpList){
    std::vector < int > VInitTabIndex, VLastTabIndex;
    std::vector < wxWindow* > VpInitTab, VpLastTab;
    for (unsigned int i = 0; i < VpList.size(); i++){
	unsigned int initIdx = 
	    VpList[i]->SearchNextTabstop(-1, _MN_FORWARD);
	unsigned int lastIdx = 
	    VpList[i]->SearchNextTabstop((int)VpList[i]->mVCPointers.size(), _MN_BACKWARD);
	VInitTabIndex.push_back(initIdx);
	VLastTabIndex.push_back(lastIdx);
	VpInitTab.push_back(VpList[i]->mVCPointers[initIdx].GetPCtrlWindow());
	VpLastTab.push_back(VpList[i]->mVCPointers[lastIdx].GetPCtrlWindow());
    }

    for (unsigned int i = 0; i < VpList.size(); i++){
	for (unsigned int j = i + 1; j < VpList.size(); j++)
	    VpList[i]->mVCPointers[VLastTabIndex[i]].PushBackNextWindow(VpInitTab[j]);
	for (unsigned int j = 0; j <= i; j++)
	    VpList[i]->mVCPointers[VLastTabIndex[i]].PushBackNextWindow(VpInitTab[j]);
	for (int j = i - 1; j >= 0; j--)
	    VpList[i]->mVCPointers[VInitTabIndex[i]].PushBackPrevWindow(VpLastTab[j]);
	for (int j = (int)VpList.size() - 1 ; j >= (int)i; j--)
	    VpList[i]->mVCPointers[VInitTabIndex[i]].PushBackPrevWindow(VpLastTab[j]);
    }
}

void MultiNumericalInputsBase_cls::
UpdateValues(int exceptionID){
    for (unsigned int i = 0; i < mVCPointers.size(); i++){
	if (mVCPointers[i].mID == exceptionID) continue;

	mVCPointers[i].UpdateLabel();
	
	switch(mVCPointers[i].mType){
	case _GP_INTEGER:
	case _GP_UNSIGNED_INT:
	    ((AtoiTextCtrl_cls*)mVCPointers[i].mpPointerCtrl)->
		SetValueInt( mVCPointers[i].GetValueInt() );
	    break;
	case _GP_UNSIGNED_INT_LIST:
	    ((AtoiComboCtrl_cls*)mVCPointers[i].mpPointerCtrl)->
		SetValueInt( mVCPointers[i].GetValueInt() );
	    break;
	case _GP_INTEGER_SLIDER:
	    ((SliderInt_cls*)mVCPointers[i].mpPointerCtrl)->
		SetValueInt( mVCPointers[i].GetValueInt() );
	    break;
	case _GP_FLOAT_SLIDER:
	    ((SliderFloat_cls*)mVCPointers[i].mpPointerCtrl)->
		SetValueFloat( mVCPointers[i].GetValueFloat() );
	    break;
	case _GP_FLOAT:
	    ((AtofTextCtrl_cls*)mVCPointers[i].mpPointerCtrl)->
		SetValueDouble(	(double)mVCPointers[i].GetValueFloat() );
	    break;
	case _GP_DOUBLE:
	    ((AtofTextCtrl_cls*)mVCPointers[i].mpPointerCtrl)->
		SetValueDouble( mVCPointers[i].GetValueDouble() );
	    break;
	case _GP_BOOL:
	    ((wxCheckBoxEX*)mVCPointers[i].mpPointerCtrl)
		->SetValue(mVCPointers[i].GetValueBool());
	    break;
	case _GP_STRING:
	    ((AtoSTextCtrl_cls*)mVCPointers[i].mpPointerCtrl)->
		SetValueStr( mVCPointers[i].GetValueStr() );
	    break;
	case _GP_STATIC_TEXT:
	    ((wxStaticText*)mVCPointers[i].mpPointerCtrl)
		->SetLabel(mVCPointers[i].mTitle);
	    break;
	}
    }
    mbDirty = FALSE;
}

bool MultiNumericalInputsBase_cls::
CheckDirty(){
    bool dirty = FALSE;
    for (unsigned int i = 0; i < mVCPointers.size(); i++){
	if (mVCPointers[i].mpPointerVal == NULL) continue;
	switch(mVCPointers[i].mType){
	case _GP_INTEGER:
	    if (*(int*)mVCPointers[i].mpPointerVal != 
		((AtoiTextCtrl_cls*)mVCPointers[i].mpPointerCtrl)->mValue)
		dirty = TRUE;
	    break;
	case _GP_UNSIGNED_INT:
	    if (*(unsigned int*)mVCPointers[i].mpPointerVal != 
		(unsigned int)
		((AtoiTextCtrl_cls*)mVCPointers[i].mpPointerCtrl)->mValue)
		dirty = TRUE;
	    break;
	case _GP_UNSIGNED_INT_LIST:
	    if (*(unsigned int*)mVCPointers[i].mpPointerVal != 
		(unsigned int)
		((AtoiComboCtrl_cls*)mVCPointers[i].mpPointerCtrl)->mValue)
		dirty = TRUE;
	    break;
	case _GP_INTEGER_SLIDER:
	    if (*(int*)mVCPointers[i].mpPointerVal != 
		((SliderInt_cls*)mVCPointers[i].mpPointerCtrl)->mValue)
		dirty = TRUE;
	    break;
	case _GP_FLOAT:
	    if (*(float*)mVCPointers[i].mpPointerVal != 
		((AtofTextCtrl_cls*)mVCPointers[i].mpPointerCtrl)->mValue)
		dirty = TRUE;
	    break;
	case _GP_DOUBLE:
	    if (*(double*)mVCPointers[i].mpPointerVal != 
		((AtofTextCtrl_cls*)mVCPointers[i].mpPointerCtrl)->mValue)
		dirty = TRUE;
	    break;
	case _GP_BOOL:
	    if (*(bool*)mVCPointers[i].mpPointerVal != 
		(((wxCheckBoxEX*)mVCPointers[i].mpPointerCtrl)->GetValue()))
		dirty = TRUE;
	    break;
	case _GP_STRING:
	    if (*(std::string*)mVCPointers[i].mpPointerVal !=
		((AtoSTextCtrl_cls*)mVCPointers[i].mpPointerCtrl)->msValue)
		dirty = TRUE;
	    break;
	}
    }
    return dirty;
}

void MultiNumericalInputsBase_cls::
UpdateFromText(unsigned int index){
    for (unsigned int i = 0; i < mVCPointers.size(); i++){
	if (index != _MN_ASSIGN_ALL) i =index;
	switch(mVCPointers[i].mType){
	case _GP_INTEGER:
	    ((AtoiTextCtrl_cls*)mVCPointers[i].mpPointerCtrl)->
		UpdateValueFromText();
	    break;
	case _GP_UNSIGNED_INT:
	    ((AtoiTextCtrl_cls*)mVCPointers[i].mpPointerCtrl)->
		UpdateValueFromText();
	    break;
	case _GP_INTEGER_SLIDER:
	    ((SliderInt_cls*)mVCPointers[i].mpPointerCtrl)->
		UpdateValueFromSlider();
	    break;
	case _GP_FLOAT_SLIDER:
	    ((SliderFloat_cls*)mVCPointers[i].mpPointerCtrl)->
		UpdateValueFromSlider();
	    break;
	case _GP_FLOAT:
	    ((AtofTextCtrl_cls*)mVCPointers[i].mpPointerCtrl)->
		UpdateValueFromText();
	    break;
	case _GP_DOUBLE:
	    ((AtofTextCtrl_cls*)mVCPointers[i].mpPointerCtrl)->
		UpdateValueFromText();
	    break;
	case _GP_BOOL:
	    break;
	case _GP_STRING:
	    ((AtoSTextCtrl_cls*)mVCPointers[i].mpPointerCtrl)->
		UpdateValueFromText();
	    break;
	default:
	    break;
	}
	if (index != _MN_ASSIGN_ALL) return;
    }
    mbDirty = FALSE;
    
}

void MultiNumericalInputsBase_cls::
AssignBase(unsigned int index){
    for (unsigned int i = 0; i < mVCPointers.size(); i++){
	if (index != _MN_ASSIGN_ALL) i =index;
	if (mVCPointers[i].mpPointerVal == NULL) continue;
	switch(mVCPointers[i].mType){
	case _GP_INTEGER:
	    *(int*)mVCPointers[i].mpPointerVal = 
		((AtoiTextCtrl_cls*)mVCPointers[i].mpPointerCtrl)->mValue;
	    break;
	case _GP_UNSIGNED_INT:
	    *(unsigned int*)mVCPointers[i].mpPointerVal = 
		((AtoiTextCtrl_cls*)mVCPointers[i].mpPointerCtrl)->mValue;
	    break;
	case _GP_UNSIGNED_INT_LIST:
	    *(unsigned int*)mVCPointers[i].mpPointerVal = 
		((AtoiComboCtrl_cls*)mVCPointers[i].mpPointerCtrl)->mValue;
	    break;
	case _GP_INTEGER_SLIDER:
	    *(int*)mVCPointers[i].mpPointerVal = 
		((SliderInt_cls*)mVCPointers[i].mpPointerCtrl)->mValue;
	    break;
	case _GP_FLOAT_SLIDER:
	    *(float*)mVCPointers[i].mpPointerVal = 
		((SliderFloat_cls*)mVCPointers[i].mpPointerCtrl)->GetValue();
	    break;
	case _GP_FLOAT:
	    *(float*)mVCPointers[i].mpPointerVal = 
		((AtofTextCtrl_cls*)mVCPointers[i].mpPointerCtrl)->mValue;
	    break;
	case _GP_DOUBLE:
	    *(double*)mVCPointers[i].mpPointerVal = 
		((AtofTextCtrl_cls*)mVCPointers[i].mpPointerCtrl)->mValue;
	    break;
	case _GP_BOOL:
	    *(bool*)mVCPointers[i].mpPointerVal = 
		(((wxCheckBoxEX*)mVCPointers[i].mpPointerCtrl)->GetValue());
	    break;
	case _GP_STRING:
	    *(std::string*)mVCPointers[i].mpPointerVal = 
		((AtoSTextCtrl_cls*)mVCPointers[i].mpPointerCtrl)->msValue;
	    break;
	default:
	    break;
	}
	if (index != _MN_ASSIGN_ALL) return;
    }
    mbDirty = FALSE;
}

void MultiNumericalInputsBase_cls::
AssignBaseById(int id){
    for (unsigned int index = 0; index < mVCPointers.size(); index++)
	if (id == mVCPointers[index].mID)
	    AssignBase(index);
}

void MultiNumericalInputsBase_cls::
SetDefaultButtonType(int type){
    mDefaultButton = type;
}

void MultiNumericalInputsBase_cls::
SetFuncCheck(void (*pFunc)(void*), void* pArg){
    mpFuncCheck = pFunc;
    mpArg = pArg;
}

// -------------

BEGIN_EVENT_TABLE(MultiNumericalInputsPanel_cls, wxPanel)
     EVT_BUTTON     (buttonCtrlAssign, MultiNumericalInputsPanel_cls::OnAssign)
     EVT_BUTTON     (wxID_CANCEL, MultiNumericalInputsPanel_cls::OnHide)
     EVT_BUTTON     (buttonCtrl02, MultiNumericalInputsPanel_cls::OnUpdate)
     // wxID_OK $B$,$&$^$/4XO"IU$1$5$l$J$+$C$?$N$G!"(BConnect$B$G<BAu(B
     EVT_SIZE       (MultiNumericalInputsPanel_cls::OnSize)
     EVT_CHILD_FOCUS(MultiNumericalInputsPanel_cls::OnChildFocusEventCustum)
     EVT_CHAR       (MultiNumericalInputsPanel_cls::OnChar)
     EVT_KEY_DOWN   (MultiNumericalInputsPanel_cls::OnKeyDown)
END_EVENT_TABLE()

MultiNumericalInputsPanel_cls::
MultiNumericalInputsPanel_cls(MultiNumericalInputsPanel_cls **ppToThis,
			       wxWindow *parent, wxWindowID id,
			       const wxPoint& pos,
			       const wxSize&  size,
			       long style,
			       const wxString& name) :
    wxPanel(parent, id, pos, size, style, name)
{
    mppToThis = ppToThis;
    mType = _MN_PANEL;
    this->SetBackgroundColour(wxColour(wxT("WHEAT")));
    SetWindowStyle(GetWindowStyle() | wxTAB_TRAVERSAL);
    mpBTNMinimize = NULL;
}

MultiNumericalInputsPanel_cls::
~MultiNumericalInputsPanel_cls(){
    *mppToThis = NULL;
}

void MultiNumericalInputsPanel_cls::
MakeGeometry(){
    wxBoxSizer *pBoxSizerSrc = new wxBoxSizer(wxVERTICAL);
    MakeGeometryBase(pBoxSizerSrc, this);
    
    this->SetSizer/*AndFit*/(pBoxSizerSrc);
}

void MultiNumericalInputsPanel_cls::
ConnectButton(wxWindow *pWindow, int id){
    pWindow->Connect(id, wxEVT_COMMAND_BUTTON_CLICKED,
		     wxComEH(MultiNumericalInputsPanel_cls::OnButton));
}

void MultiNumericalInputsPanel_cls::
ConnectComboBox(wxWindow *pWindow, int id){
    pWindow->Connect(id, wxEVT_COMMAND_COMBOBOX_SELECTED,
		     wxComEH(MultiNumericalInputsPanel_cls::OnComboBox));
}

void MultiNumericalInputsPanel_cls::
ConnectCheckBox(wxWindow *pWindow, int id){
    pWindow->Connect(id, wxEVT_COMMAND_CHECKBOX_CLICKED,
		     wxComEH(MultiNumericalInputsPanel_cls::OnCheckBox));
}

void MultiNumericalInputsPanel_cls::
ConnectScroll(wxWindow *pWindow, int id){
    pWindow->Connect(id, wxEVT_SCROLL_CHANGED,
		     wxComEH(MultiNumericalInputsPanel_cls::OnScroll));
}

void MultiNumericalInputsPanel_cls::
OnAssign(wxCommandEvent& WXUNUSED(event)){
    AssignBase(_MN_ASSIGN_ALL);
    if (mpBTNAssign != NULL)
	mpBTNAssign->SetLabel(wxT(" Assign"));
    if (mpFuncCheck != NULL){
	(*mpFuncCheck)(mpArg);
	UpdateValues();
    }
    wxPaintEvent dummyEvent;
    GetParent()->AddPendingEvent(dummyEvent);
}

void MultiNumericalInputsPanel_cls::
OnHide(wxCommandEvent& event){
    this->Show(false);
    if (mpBTNMinimize != NULL)
	if (mpBTNMinimize->IsShown() == false)  mpBTNMinimize->Show(true);
    wxSizeEvent dummyEvent;
    GetParent()->AddPendingEvent(dummyEvent);
}


void MultiNumericalInputsPanel_cls::
OnButton(wxCommandEvent& event){
    int id = event.GetId();
    for (unsigned int i = 0; i < mVCPointers.size(); i++)
	if (mVCPointers[i].mType == _GP_BUTTON && mVCPointers[i].mID   == id){
	    if (mVCPointers[i].mpPointerVal != NULL)
		((void(*)())mVCPointers[i].mpPointerVal)();
	    else{
		event.SetId(mVCPointers[i].mOffset);
		GetParent()->AddPendingEvent(event);
	    }
	}
}

void MultiNumericalInputsPanel_cls::
OnCheckBox(wxCommandEvent& event){
    wxPaintEvent dummyEvent;
    GetParent()->AddPendingEvent(dummyEvent);
    event.Skip();
}

void MultiNumericalInputsPanel_cls::
OnComboBox(wxCommandEvent& event){
    int id = event.GetId();
    for (unsigned int i = 0; i < mVCPointers.size(); i++)
	if (mVCPointers[i].mType == _GP_UNSIGNED_INT_LIST && mVCPointers[i].mID   == id)
	    AssignBase(i);
    
    event.Skip();
}

void MultiNumericalInputsPanel_cls::
OnScroll(wxCommandEvent& event){
    int id = event.GetId();
    for (unsigned int i = 0; i < mVCPointers.size(); i++)
	if ((mVCPointers[i].mType == _GP_INTEGER_SLIDER || 
	     mVCPointers[i].mType == _GP_FLOAT_SLIDER )
	    && mVCPointers[i].mID   == id)
	    AssignBase(i);
    UpdateValues(id);
    /*
    wxCommandEvent dummyEvent;
    OnAssign(dummyEvent);
    */
    event.Skip();
}

void MultiNumericalInputsPanel_cls::
OnUpdate(wxCommandEvent& WXUNUSED(event)){
    UpdateValues();
    mpBTNAssign->SetLabel(wxT("Assign"));
}

void MultiNumericalInputsPanel_cls::
OnOK(wxCommandEvent& WXUNUSED(event)){
    UpdateFromText(_MN_ASSIGN_ALL);
    wxCommandEvent dummyEvent;
    OnAssign(dummyEvent);
    OnHide(dummyEvent);
}

void MultiNumericalInputsPanel_cls::
OnChar(wxKeyEvent& event){
    if (event.GetKeyCode() == WXK_RETURN){
	AssignBaseById(event.GetId());
	UpdateValues();
	if (mpBTNAssign != NULL)
	    mpBTNAssign->SetLabel(wxT("Assign"));
	GetParent()->Refresh(FALSE);
    }
}

void MultiNumericalInputsPanel_cls::
OnKeyDown(wxKeyEvent& event){
    wxPostEvent(GetParent()->GetEventHandler(), event);
}

void MultiNumericalInputsPanel_cls::
OnChildFocusEventCustum(wxChildFocusEvent& event){
    if (mbDirty == FALSE){
	mbDirty = CheckDirty();
	if (mbDirty == TRUE){
	    if (mpBTNAssign != NULL){
		mpBTNAssign->SetLabel(wxT("*Assign"));
		mpBTNAssign->Refresh(TRUE);
	    }
	    Refresh(TRUE);
	}
    }
    event.Skip();
}

void MultiNumericalInputsPanel_cls::
OnSize(wxSizeEvent& event){
    UpdateValues();
    event.Skip();
}

void MultiNumericalInputsPanel_cls:: // $B%]%$%s%?$r;2>HEO$7$7$J$$$H$@$a(B
AssignMinimizeButtonBoth(wxButton* &pBTNMinimize, 
			 int ID, wxString title){
    pBTNMinimize = new wxButton(GetParent(), ID, title, wxDefaultPosition, wxSize(210,-1));
    mpBTNMinimize = pBTNMinimize;
    CombinePointer(_GP_BUTTON_HIDE_PANEL, NULL, title);
}

void MultiNumericalInputsPanel_cls::
RefreshBoth(bool mode){
    if (mpBTNMinimize != NULL) mpBTNMinimize->Refresh(mode);
    Refresh(mode);
}

void MultiNumericalInputsPanel_cls::
ShowPanel(bool mode){
    if (mpBTNMinimize != NULL) mpBTNMinimize->Show(!mode);
    Show(mode);
}

void MultiNumericalInputsPanel_cls::
AddToSizer(wxBoxSizer *pBoxSizer){
    wxSizerFlags sflag0(0), sflag0E(0);
    sflag0          .Border(wxALL, 2);
    sflag0E.Expand().Border(wxALL, 2);
    pBoxSizer->Add(this,          sflag0);
    if (mpBTNMinimize != NULL)
	pBoxSizer->Add(mpBTNMinimize, sflag0E);
}

int MultiNumericalInputsPanel_cls::
FinishSetting(wxBoxSizer *pBoxSizer, bool vis){
    MakeGeometry();
    ShowPanel(vis);
    AddToSizer(pBoxSizer);
    return 0;
}

// ------------------------------------------------------------------

BEGIN_EVENT_TABLE(MultiNumericalInputs_cls, wxDialog)
     EVT_BUTTON     (buttonCtrlAssign, MultiNumericalInputs_cls::OnAssign)
     EVT_BUTTON     (wxID_CANCEL, MultiNumericalInputs_cls::OnHide)
     EVT_BUTTON     (buttonCtrl02, MultiNumericalInputs_cls::OnUpdate)
     // wxID_OK $B$,$&$^$/4XO"IU$1$5$l$J$+$C$?$N$G!"(BConnect$B$G<BAu(B
     EVT_SIZE       (MultiNumericalInputs_cls::OnSize)
     EVT_CHILD_FOCUS(MultiNumericalInputs_cls::OnChildFocusEventCustum)
     EVT_CHAR       (MultiNumericalInputs_cls::OnChar)
END_EVENT_TABLE()

MultiNumericalInputs_cls::
MultiNumericalInputs_cls(MultiNumericalInputs_cls **ppToThis,
			 wxWindow *parent, wxWindowID id, wxString title,
			 const wxPoint& pos,
			 const wxSize&  size,
			 long style,
			 const wxString& name) :
    wxDialogEXKey(parent, id, title, pos, size, style, name)
{
    mppToThis = ppToThis;
    mType     = _MN_DIALOG;
    
    this->SetBackgroundColour(wxColour(wxT("WHEAT")));
    SetWindowStyle(GetWindowStyle() | (wxTAB_TRAVERSAL
				       & ~wxMINIMIZE_BOX
				       & ~wxMAXIMIZE_BOX));
    mTitle = title;
}

MultiNumericalInputs_cls::
~MultiNumericalInputs_cls(){
    //MakeModal(FALSE);
    *mppToThis = NULL;
}

void MultiNumericalInputs_cls::
MakeGeometry(){
    wxBoxSizer *pBoxSizerSrc = new wxBoxSizer(wxVERTICAL);
    MakeGeometryBase(pBoxSizerSrc, this);

    (this)->SetSizerAndFit(pBoxSizerSrc);
}

void MultiNumericalInputs_cls::
ConnectButton(wxWindow *pWindow, int id){
    pWindow->Connect(id, wxEVT_COMMAND_BUTTON_CLICKED,
		     wxComEH(MultiNumericalInputs_cls::OnButton));
}

void MultiNumericalInputs_cls::
ConnectComboBox(wxWindow *pWindow, int id){
    pWindow->Connect(id, wxEVT_COMMAND_COMBOBOX_SELECTED,
		     wxComEH(MultiNumericalInputs_cls::OnComboBox));
}

void MultiNumericalInputs_cls::
OnScroll(wxCommandEvent& event){
    int id = event.GetId();
    for (unsigned int i = 0; i < mVCPointers.size(); i++)
	if (mVCPointers[i].mType == _GP_INTEGER_SLIDER && mVCPointers[i].mID   == id)
	    AssignBase(i);
    event.Skip();
}

void MultiNumericalInputs_cls::
ConnectCheckBox(wxWindow *pWindow, int id){
    pWindow->Connect(id, wxEVT_COMMAND_CHECKBOX_CLICKED,
		     wxComEH(MultiNumericalInputs_cls::OnCheckBox));
}

void MultiNumericalInputs_cls::
ConnectScroll(wxWindow *pWindow, int id){
    pWindow->Connect(id, wxEVT_SCROLL_CHANGED,
		     wxComEH(MultiNumericalInputsPanel_cls::OnScroll));
}


void MultiNumericalInputs_cls::
OnAssign(wxCommandEvent& WXUNUSED(event)){
    AssignBase(_MN_ASSIGN_ALL);
    if (mpBTNAssign != NULL)
	mpBTNAssign->SetLabel(wxT(" Assign"));
    if (mpFuncCheck != NULL){
	(*mpFuncCheck)(mpArg);
	UpdateValues();
    }
    SetLabel(mTitle);
    wxPaintEvent dummyEvent;
    GetParent()->AddPendingEvent(dummyEvent);
}

void MultiNumericalInputs_cls::
OnHide(wxCommandEvent& WXUNUSED(event)){
    //MsgBox(this, "!!", "CLOSE");
    if (mDefaultButton == _MN_CANCEL_OK || mDefaultButton == _MN_OK_CANCEL)
	UpdateValues();
    CloseEXKey(wxID_CANCEL);
    wxPaintEvent dummyEvent;
    GetParent()->AddPendingEvent(dummyEvent);
}

void MultiNumericalInputs_cls::
OnButton(wxCommandEvent& event){
    int id = event.GetId();
    for (unsigned int i = 0; i < mVCPointers.size(); i++)
	if (mVCPointers[i].mType == _GP_BUTTON && mVCPointers[i].mID   == id){
	    if (mVCPointers[i].mpPointerVal != NULL)
		((void(*)())mVCPointers[i].mpPointerVal)();
	    else{
		event.SetId(mVCPointers[i].mOffset);
		GetParent()->AddPendingEvent(event);
	    }
	}
}

void MultiNumericalInputs_cls::
OnCheckBox(wxCommandEvent& event){
    wxPaintEvent dummyEvent;
    GetParent()->AddPendingEvent(dummyEvent);
}

void MultiNumericalInputs_cls::
OnComboBox(wxCommandEvent& event){
    int id = event.GetId();
    for (unsigned int i = 0; i < mVCPointers.size(); i++)
	if (mVCPointers[i].mType == _GP_UNSIGNED_INT_LIST && mVCPointers[i].mID   == id)
	    AssignBase(i);
    
    event.Skip();
}

void MultiNumericalInputs_cls::
OnUpdate(wxCommandEvent& WXUNUSED(event)){
    UpdateValues();
    mpBTNAssign->SetLabel(wxT(" Assign"));
    SetLabel(mTitle);
}

void MultiNumericalInputs_cls::
OnOK(wxCommandEvent& WXUNUSED(event)){
    //MsgBox(this, "!!", "OK");
    wxCommandEvent dummyEvent;
    OnAssign(dummyEvent);
    CloseEXKey(wxID_OK);
    wxSizeEvent dummyEvent2;
    GetParent()->AddPendingEvent(dummyEvent2);
}

void MultiNumericalInputs_cls::
OnChildFocusEventCustum(wxChildFocusEvent& event){
    if (mbDirty == FALSE){
	mbDirty = CheckDirty();
	if (mbDirty == TRUE && mpBTNAssign != NULL){
	    mpBTNAssign->SetLabel(wxT("*Assign"));
	    mpBTNAssign->Refresh(TRUE);
	    SetLabel(wxT("*") + mTitle);
	}
    }
    event.Skip();
}

void MultiNumericalInputs_cls::
OnSize(wxSizeEvent& event){
    UpdateValues();
    event.Skip();
}

void MultiNumericalInputs_cls::
OnChar(wxKeyEvent& event){
}

int MultiNumericalInputs_cls::
FinishSetting(bool vis, bool modal, bool bPreventDestroy){
    mbPreventDestroy = bPreventDestroy;
    MakeGeometry();
    if (modal == TRUE)
	return ShowModal();
    Show(vis);
    return 0;
}
