// (setq c-basic-offset 4)
// "clsControlPanel.h"

#include "clsControlPanel.h"
#include "../../clsFrameMain.h"
#include "../../clsMain.h"
#include "../../clsTimeCtrl.h"
#include "../../wxWidgetEnum.h"
#include "../../wxWidgetEnumMenu.h"
#include "../DF3/clsDF3Sequence.h"
#include "../DF3/clsDF3SeqCtrl.h"
#include "../DF3/clsDF3SeqGUI.h"
#include "../POVRAY/clsPovIsosurface.h"

#include "../WIDGETCTRL/EX/clsButtonEX.h"
#include "../WIDGETCTRL/EX/clsCheckBoxEX.h"
#include "../WIDGETCTRL/EX/clsSliderEX.h"
#include <wx/tglbtn.h>

// ÓIɃCxgт
BEGIN_EVENT_TABLE(ControlPanel_cls, wxPanel)
     EVT_PAINT(ControlPanel_cls::OnPaint)
     EVT_CHECKBOX(checkBoxPrefetch,  ControlPanel_cls::OnCheckBoxPrefetch)
     EVT_CHECKBOX(checkBoxQuickShow, ControlPanel_cls::OnCheckBoxQuickShow)
     EVT_BUTTON(buttonSetKeyPos,     ControlPanel_cls::OnButtonSetKeyPos)
     EVT_BUTTON(buttonSetKeyAnc,     ControlPanel_cls::OnButtonSetKeyAnc)
     EVT_BUTTON(buttonCtrlStepBCK2,  ControlPanel_cls::OnButtonStepBCK2)
     EVT_BUTTON(buttonCtrlPlayBCK1,  ControlPanel_cls::OnButtonPlayBCK1)
     EVT_BUTTON(buttonCtrlStepBCK1,  ControlPanel_cls::OnButtonStepBCK1)
     EVT_BUTTON(buttonCtrlStepFWD1,  ControlPanel_cls::OnButtonStepFWD1)
     EVT_BUTTON(buttonCtrlPlayFWD1,  ControlPanel_cls::OnButtonPlayFWD1)
     EVT_BUTTON(buttonCtrlStepFWD2,  ControlPanel_cls::OnButtonStepFWD2)
     EVT_TOGGLEBUTTON(buttonRepeat,  ControlPanel_cls::OnToggleRepeat)
//     EVT_BUTTON(buttonReTexture,     ControlPanel_cls::OnButtonReTexture)
//     EVT_BUTTON(buttonReload,        ControlPanel_cls::OnButtonReload)

     EVT_KEY_DOWN(ControlPanel_cls::OnKeyDown)
END_EVENT_TABLE()

ControlPanel_cls::
ControlPanel_cls(wxWindow *pC, FrameMain_cls *pCFrame, 
		 DF3SeqCtrl_cls *pCDF3SeqCtrl) : 
wxPanel(pC, wxID_ANY, wxDefaultPosition, wxDefaultSize, wxWANTS_CHARS)
{
    mpCParentFrame = pCFrame;
    mpCDF3SeqCtrl = pCDF3SeqCtrl;
    mpCTimeCtrlLink = mpCParentFrame->mpCParent->mpCTime;

    int flags = wxEXPAND | wxALIGN_CENTER_VERTICAL;

    wxBoxSizer  *pBoxSizerSrc = new wxBoxSizer(wxVERTICAL);
    
    // i
    //wxBoxSizer *pBoxSizerButtons1 = new wxBoxSizer(wxHORIZONTAL);
    mpCCheckBoxPrefetch = new wxCheckBoxEX(this, checkBoxPrefetch, wxT("Prefetch"));
    mpCCheckBoxPrefetch->SetValue(FALSE);
    mpCCheckBoxQuickShow = new wxCheckBoxEX(this, checkBoxQuickShow, wxT("QuickShow"));
    mpCCheckBoxQuickShow->SetValue(FALSE);

    //i
    wxBoxSizer *pBoxSizerButtons2 = new wxBoxSizer(wxHORIZONTAL);

    mpCButtonSetKeyPos  = 
	new wxButtonEX(this, buttonSetKeyPos,
		       wxString::Format(_T("%s [POS]"),	_("Set Key")),
		       wxDefaultPosition, wxSize(120, -1));
    mpCButtonSetKeyAnc  =
	new wxButtonEX(this, buttonSetKeyAnc,
		       wxString::Format(_T("%s [ANC]"), _("Set Key")),
		       wxDefaultPosition, wxSize(120, -1));

    mpCButtonStepBCK2 =
	new wxButtonEX(this, buttonCtrlStepBCK2, wxT("|<|"), 
		       wxDefaultPosition, wxSize(40, -1));
    mpCButtonPlayBCK1 =
	new wxButtonEX(this, buttonCtrlPlayBCK1, wxT("<-|"),
		       wxDefaultPosition, wxSize(40, -1));
    mpCButtonStepBCK1 =
	new wxButtonEX(this, buttonCtrlStepBCK1, wxT("<||"),
		       wxDefaultPosition, wxSize(40, -1));
    mpCButtonStepFWD1 =
	new wxButtonEX(this, buttonCtrlStepFWD1, wxT("||>"),
		       wxDefaultPosition, wxSize(40, -1));
    mpCButtonPlayFWD1 =
	new wxButtonEX(this, buttonCtrlPlayFWD1, wxT("|->"),
		       wxDefaultPosition, wxSize(40, -1));
    mpCButtonStepFWD2 =
	new wxButtonEX(this, buttonCtrlStepFWD2, wxT("|>|"),
		       wxDefaultPosition, wxSize(40, -1));

    mpCToggleRepeat    =
	new wxToggleButton(this, buttonRepeat, wxT("Repeat"),
			   wxDefaultPosition, wxSize(70, -1));
    
    pBoxSizerButtons2->Add(mpCButtonSetKeyAnc,  0, flags);
    pBoxSizerButtons2->Add(mpCButtonSetKeyPos,  0, flags);
    pBoxSizerButtons2->Add(10, -1);
    pBoxSizerButtons2->Add(mpCButtonStepBCK2,   0, flags);
    pBoxSizerButtons2->Add(mpCButtonPlayBCK1,   0, flags);
    pBoxSizerButtons2->Add(mpCButtonStepBCK1,   0, flags);
    pBoxSizerButtons2->Add(mpCButtonStepFWD1,   0, flags);
    pBoxSizerButtons2->Add(mpCButtonPlayFWD1,   0, flags);
    pBoxSizerButtons2->Add(mpCButtonStepFWD2,   0, flags);
    pBoxSizerButtons2->Add(20, -1);
    pBoxSizerButtons2->Add(mpCToggleRepeat,     0, flags);
    pBoxSizerButtons2->Add(10, -1);
    pBoxSizerButtons2->Add(mpCCheckBoxQuickShow, 0, wxEXPAND);
    pBoxSizerButtons2->Add(10, -1);
    pBoxSizerButtons2->Add(mpCCheckBoxPrefetch , 0, wxEXPAND);
    
    pBoxSizerSrc->Add(pBoxSizerButtons2, 0, flags);

    this->SetSizer(pBoxSizerSrc);
}

void ControlPanel_cls::
UpdateButtonColor(){
    if (mpCTimeCtrlLink->mbPlayTex == TRUE){
	if (mpCTimeCtrlLink->mPlayDirection == +1){
	    mpCButtonPlayFWD1->SetBackgroundColour(wxT("LIGHT BLUE"));
	    mpCButtonPlayBCK1->SetBackgroundColour(wxNullColour); 
	}
	else if (mpCTimeCtrlLink->mPlayDirection == -1){
	    mpCButtonPlayBCK1->SetBackgroundColour(wxT("LIGHT BLUE"));
	    mpCButtonPlayFWD1->SetBackgroundColour(wxNullColour); 
	}
    }
    else{
	mpCButtonPlayFWD1->SetBackgroundColour(wxNullColour);
	mpCButtonPlayBCK1->SetBackgroundColour(wxNullColour);
    }
}

void ControlPanel_cls::
OnPaint(wxPaintEvent& event){
    UpdateButtonColor();
    event.Skip();
}

void ControlPanel_cls::
OnCheckBoxPrefetch(wxCommandEvent& event){
    mpCDF3SeqCtrl->mbPreFetch = mpCCheckBoxPrefetch->GetValue();
    if (mpCDF3SeqCtrl->mbPreFetch == TRUE){
	if (mpCTimeCtrlLink->mbPlayTex == TRUE){
	    mpCTimeCtrlLink->mbPlayTex = FALSE;
	    wxCommandEvent cmd(wxEVT_COMMAND_MENU_SELECTED, menuItemPlayStop);
	    wxGetTopLevelParent(this)->AddPendingEvent(cmd);
	}
    }
}

void ControlPanel_cls::
OnCheckBoxQuickShow(wxCommandEvent& event){
    mpCDF3SeqCtrl->mbQuickShow = mpCCheckBoxQuickShow->GetValue();
}

void ControlPanel_cls::
OnButtonSetKeyPos(wxCommandEvent &event){
    mpCParentFrame->SetKeyPath(0);
}

void ControlPanel_cls::
OnButtonSetKeyAnc(wxCommandEvent &event){
    mpCParentFrame->SetKeyPath(1);
}

void ControlPanel_cls::
OnButtonStepBCK2(wxCommandEvent& event){
    mpCTimeCtrlLink->FrameMoveL(-1);
    //mpCDF3SeqCtrl->mpCGUI->mpCSlider->SetValue(mpCTimeCtrlLink->mFrame);
    mpCTimeCtrlLink->UpdateDF3SeqGUI(TRUE);
}

void ControlPanel_cls::
OnButtonPlayBCK1(wxCommandEvent& event){
    mpCTimeCtrlLink->mbPlayTex = ! mpCTimeCtrlLink->mbPlayTex;
    if (mpCTimeCtrlLink->mbPlayTex == TRUE){
	//mpCDF3SeqCtrl->mbPreFetch = FALSE;
	if (mpCDF3SeqCtrl->IsPlayTexConditionSatisfied(mpCTimeCtrlLink->CalcNextStep(-1)) == FALSE){
	    OnButtonStepBCK1(event);
	    return;
	}
    }
    else{
	wxCommandEvent cmd(wxEVT_COMMAND_MENU_SELECTED, menuItemPlayStop);
	wxGetTopLevelParent(this)->AddPendingEvent(cmd);
    }
    mpCTimeCtrlLink->mPlayDirection = -1;
    mpCTimeCtrlLink->UpdateDF3SeqGUI(TRUE);

    UpdateButtonColor();
}

void ControlPanel_cls::
OnButtonStepBCK1(wxCommandEvent& event){
    mpCTimeCtrlLink->FrameStep(-1, (event.GetId() != buttonCtrlStepBCK1));
}

void ControlPanel_cls::
OnButtonStepFWD1(wxCommandEvent& event){
    mpCTimeCtrlLink->FrameStep(+1, (event.GetId() != buttonCtrlStepFWD1));
}

void ControlPanel_cls::
OnButtonPlayFWD1(wxCommandEvent& event){
    mpCTimeCtrlLink->mbPlayTex = ! mpCTimeCtrlLink->mbPlayTex;
    if (mpCTimeCtrlLink->mbPlayTex == TRUE){
	if (mpCDF3SeqCtrl->IsPlayTexConditionSatisfied(mpCTimeCtrlLink->CalcNextStep(+1)) == FALSE){
	    OnButtonStepFWD1(event);
	    return;
	}
	mpCParentFrame->mCSWMain.Start();
    }
    else{
	mpCParentFrame->mCSWMain.Pause();
	wxCommandEvent cmd(wxEVT_COMMAND_MENU_SELECTED, menuItemPlayStop);
	wxGetTopLevelParent(this)->AddPendingEvent(cmd);
    }
    mpCTimeCtrlLink->mPlayDirection = +1;
    mpCTimeCtrlLink->UpdateDF3SeqGUI(TRUE);

    UpdateButtonColor();
}

void ControlPanel_cls::
OnButtonStepFWD2(wxCommandEvent& event){
    mpCTimeCtrlLink->FrameMoveL(+1);
    //mpCDF3SeqCtrl->mpCGUI->mpCSlider->SetValue(mpCTimeCtrlLink->mFrame);
    mpCTimeCtrlLink->UpdateDF3SeqGUI(TRUE);
}

void ControlPanel_cls::
OnToggleRepeat(wxCommandEvent& event){
    mpCTimeCtrlLink->mCbRepeat.mbBody = mpCToggleRepeat->GetValue();
}

/*
void ControlPanel_cls::
OnButtonReload(wxCommandEvent& event){
    mpCDF3SeqCtrl->ReleaseAllDF3Seq();
    mpCTimeCtrlLink->UpdateDF3SeqGUI(TRUE);
}

void ControlPanel_cls::
OnButtonReTexture(wxCommandEvent& event){
    wxCommandEvent cmd(wxEVT_COMMAND_MENU_SELECTED, menuItemReTexture);
    wxGetTopLevelParent(this)->AddPendingEvent(cmd);
}
*/

void ControlPanel_cls::
OnKeyDown(wxKeyEvent& event){
    //GetParent()->AddPendingEvent(event);
    mpCDF3SeqCtrl->mpCGUI->AddPendingEvent(event); // DF3ɃL[n
    event.Skip();
}
