
#ifndef _CONTROL_PANEL_H_
#define _CONTROL_PANEL_H_

#include <wx/wx.h>

class FrameMain_cls;
class DF3Sequence_cls;
class DF3SeqCtrl_cls;
class TimeCtrl_cls;

class wxCheckBoxEX;
class wxButtonEX;
class wxToggleButton; 

class ControlPanel_cls : public wxPanel {
 public:
    ControlPanel_cls(wxWindow *pC, 
		     FrameMain_cls *pCFrame, 
		     DF3SeqCtrl_cls *pCDF3SeqCtrl);
    //~ControlPanel_cls();
    
    FrameMain_cls *mpCParentFrame;
    DF3SeqCtrl_cls *mpCDF3SeqCtrl;
    TimeCtrl_cls *mpCTimeCtrlLink;

    wxCheckBoxEX *mpCCheckBoxPrefetch;
    wxCheckBoxEX *mpCCheckBoxQuickShow;

    wxButtonEX   *mpCButtonSetKeyAnc;
    wxButtonEX   *mpCButtonSetKeyPos;

    wxButtonEX   *mpCButtonStepBCK2;
    wxButtonEX   *mpCButtonPlayBCK1;
    wxButtonEX   *mpCButtonStepBCK1;
    wxButtonEX   *mpCButtonStepFWD1;
    wxButtonEX   *mpCButtonPlayFWD1;
    wxButtonEX   *mpCButtonStepFWD2;

    wxToggleButton *mpCToggleRepeat;

    void UpdateButtonColor();
    void OnPaint(wxPaintEvent& event);

    void OnCheckBoxPrefetch(wxCommandEvent &event);
    void OnCheckBoxQuickShow(wxCommandEvent &event);
    void OnCheckBoxDF3QuickShow(wxCommandEvent &event);
    void OnButtonSetKeyPos(wxCommandEvent &event);
    void OnButtonSetKeyAnc(wxCommandEvent &event);
    void OnButtonStepBCK2(wxCommandEvent &event);
    void OnButtonPlayBCK1(wxCommandEvent &event);
    void OnButtonStepBCK1(wxCommandEvent &event);
    void OnButtonStepFWD1(wxCommandEvent &event);
    void OnButtonPlayFWD1(wxCommandEvent &event);
    void OnButtonStepFWD2(wxCommandEvent &event);
    void OnToggleRepeat(wxCommandEvent &event);
    //void OnButtonReload(wxCommandEvent &event);
    //void OnButtonReTexture(wxCommandEvent &event);
    
    void OnKeyDown(wxKeyEvent &event);

 private:
    // any class wishing to process wxWidgets events must use this macro
    DECLARE_EVENT_TABLE()
};

#endif
