// -*- c++ -*-
// (setq c-basic-offset 4)

#ifndef _FILTER_PANELS_H_
#define _FILTER_PANELS_H_

#include <wx/wx.h>
#include <wx/splitter.h>
#include <list>

class FrameMain_cls;
class FilterCtrl_cls;
class FilterPanelPain_cls;

#define _FILTER_PANEL_OFFSET 0

class ItemIntAndPointer_cls {    
 public:
    ItemIntAndPointer_cls();
    ItemIntAndPointer_cls(void *pObjectForShow, void *pObjectForDelete, void *pPointer);
    
    void *mpObjectForShow;
    void *mpObjectForDelete;
    void *mpPointer;
};

class FilterPanels_cls : public wxPanel {
public:
    FilterPanels_cls(/*FilterPanelPain_cls*/wxWindow *pC, 
		     FrameMain_cls *pCFrame);
    ~FilterPanels_cls();

    //FilterPanelPain_cls *mpCParentPreviewWindow;
    FrameMain_cls *mspCParentFrame;
    FilterCtrl_cls *mpCFilterCtrlLink;

    wxMenu *mpCPopupMenu;

    void SetFilterCtrlLink(FilterCtrl_cls *pCFilterCtrl);

    std::list < ItemIntAndPointer_cls > mPanelListItem;
    std::list<ItemIntAndPointer_cls>::iterator GetIterator(int index);

    void PopUpFilterMenu();
    void RefreshPanels();
    void UpdateSizer();
    void UpdatePanelLayout();
    void PanelsTotalSizeChanged();

    bool IsItemExist(void *pPointer);
    void AddItemList(void *pObjectForShow, void *pObjectForDelete, 
		     void* pPointer);
    void RemoveItemList(void *pPointer);
    void SwapItemList(int index, int direction);

    void OnCheckBoxValid(wxCommandEvent &event);
    void OnButtonShowItem(wxCommandEvent &event);
    void OnButtonDelete(wxCommandEvent &event);
    void OnButtonCustomA(wxCommandEvent &event);
    void OnButtonCustomB(wxCommandEvent &event);
    void OnButtonCustomC(wxCommandEvent &event);
    void OnMouse(wxMouseEvent& event);
    void OnMenuSwap(wxCommandEvent& event);
    void OnMenuAdvanced(wxCommandEvent& event);
    void OnMenuName(wxCommandEvent& event);
    void OnMenuDelete(wxCommandEvent& event);
    
    void OnKeyDown(wxKeyEvent &event);

    /*
    std::vector < WXTYPE > mVEventType;
    std::vector < int > mVEventId;
    std::vector < wxObject* > mVpEventObj;
    */
    std::vector < wxEvent* > mVpCEvent;
    bool CheckThreadLocking(wxCommandEvent &event);
    void PushEventOnStack(wxCommandEvent &event);
    void ProcessEventOnStack();

private:
    // any class wishing to process wxWidgets events must use this macro
    DECLARE_EVENT_TABLE()
};

#endif

