
// -*- c++ -*- 
// "clsFrameMainInitializer.h"

#include "clsFrameMainInitializer.h"

#include "clsControlPanel.h"
#include "clsDragAndDrop.h"

#include "../MYAPI/MsgBox.h"
#include "../WIDGETCTRL/EX/clsColourDialogEX.h"
#include "../WIDGETCTRL/EX/clsFileDialogEX.h"

#include "../POVRAY/clsPovRay.h"
#include "../POVRAY/clsStereoGram.h"

#include "../../clsFrameMain.h"
#include "../../clsMain.h"
#include "../../clsTimeCtrl.h"

extern wxColourDialogEX* GpCClrDialog;
extern wxFileDialogEX*   GpCFileDialog;

#include "../../wxWidgetEnumMenu.h"

FrameMainInitializer01_cls::
FrameMainInitializer01_cls(wxThreadKind kind, FrameMain_cls* pCParent)
    : MultiThreadThread_cls(kind)
{
    mpCParent = pCParent;
}

void FrameMainInitializer01_cls::
SetParameters(){
    if ( Create() != wxTHREAD_NO_ERROR) 
	MsgBoxExit(NULL, "Error!", "Can't create thread");
}

wxThread::ExitCode FrameMainInitializer01_cls::
Entry(){
    mpCParent->SetBackgroundColour(wxColour(wxT("WHEAT")));

    GpCClrDialog  = new wxColourDialogEX(mpCParent, wxColour(wxT("BLACK")), TRUE);
    GpCFileDialog = new wxFileDialogEX  (mpCParent);

    mpCParent->mpBitmapPovray = 
	new wxBitmap(wxT("ICONS/Pov.png"), wxBITMAP_TYPE_PNG);
    mpCParent->mpBitmapPreference = 
	new wxBitmap(wxT("ICONS/Preference.png"), wxBITMAP_TYPE_PNG);
    mpCParent->mpBitmapScene = 
	new wxBitmap(wxT("ICONS/Scene.png"), wxBITMAP_TYPE_PNG);
    mpCParent->mpBitmapTree = 
	new wxBitmap(wxT("ICONS/Tree.png"), wxBITMAP_TYPE_PNG);
    mpCParent->mpBitmapQuit = 
	new wxBitmap(wxT("ICONS/Quit.png"), wxBITMAP_TYPE_PNG);
    
    return 0;
}

FrameMainInitializer02_cls::
FrameMainInitializer02_cls(wxThreadKind kind, FrameMain_cls* pCParent)
    : MultiThreadThread_cls(kind)
{
    mpCParent = pCParent;
}

void FrameMainInitializer02_cls::
SetParameters(){
    if ( Create() != wxTHREAD_NO_ERROR) 
	MsgBoxExit(NULL, "Error!", "Can't create thread");
}

wxThread::ExitCode FrameMainInitializer02_cls::
Entry(){
    // --menuFile--

    wxMenu *pCMenuFile = new wxMenu;
    pCMenuFile->Append(menuItemProjectOpen,
		     wxString::Format(_T("%s(&O)\tCtrl-O"), _("Open project file")),
		     _("Open project file"));
    pCMenuFile->Append(menuItemProjectSave,
		     wxString::Format(_T("%s(&S)\tCtrl-S"), _("Save project file")),
		     _("Save project file"));
    pCMenuFile->Append(menuItemProjectSaveAs,
		     wxString::Format(_T("%s\tCtrl-Alt-S"),
				      _("Save project file as...")),
		     _("Save project file as..."));
    
    pCMenuFile->AppendSeparator();
    pCMenuFile->Append(menuItemFileOpen, 
		     wxString::Format(_T("%s\tCtrl-Alt-O"), _("Open Data file")),
		     _("Open Data file"));
    pCMenuFile->Append(menuItemFileAdd,
		     wxString::Format(_T("%s\tCtrl-Alt-Shift-O"),
				      _("Append Data file")),
		     _("Append Data file"));
    
    pCMenuFile->AppendSeparator();
    pCMenuFile->Append(menuItemFileOpenEdit, 
		     wxString::Format(_T("%s(&E)\tCtrl-Alt-E"),
				      _("Open Data by name")),
		     _("Open DF3 by name 2"));

    pCMenuFile->Append(menuItemFileAddEdit, 
		     wxString::Format(_T("%s\tCtrl-Alt-Shift-E"),
				      _("Append Data by name")),
		     _("Append DF3 by name 2"));
    
    pCMenuFile->AppendSeparator();
    wxMenu *pCMenuFileImport = new wxMenu;
    pCMenuFileImport->Append(menuItemImportPath, 
			     _("Import camera path"), _("Import camera path 2"));
    pCMenuFileImport->Append(menuItemImportRenderParam, 
			     _("Import render-param path"), _("Import render-param path 2"));
    pCMenuFile->Append(menuItemImport, _("Import"),
		     pCMenuFileImport, _("Import"));
    
    wxMenu *fileExport = new wxMenu;
    fileExport->Append(menuItemExportDF3,
		       _("Export a DF3 file"), _("Export a DF3 file 2"));
    fileExport->Append(menuItemExportDF3Seq,
		       _("Export DF3 file sequence"), _("Export DF3 file sequence 2"));
    fileExport->Append(menuItemExportImgSeq,
		       _("Export image Sequence for a snap"),
		       _("Export image Sequence for a snap 2"));
    fileExport->AppendSeparator();
    fileExport->Append(menuItemExportIsosurfOBJ,
		       wxString::Format(_T("%s(.obj)"), _("Export Isosurface")),
		       _("Export Isosurface"));
    fileExport->Append(menuItemExportIsosurfPOV,
		       wxString::Format(_T("%s(.pov)"), _("Export Isosurface")),
		       _("Export Isosurface"));
    pCMenuFile->Append(menuItemExport, _("Export"),
		     fileExport, _("Export"));

    pCMenuFile->AppendSeparator();
    pCMenuFile->Append(menuItemSaveImage,
		     wxString::Format(_T("%s\tF7"), _("Save Image")),
		     _("Save a preview Image"));
    pCMenuFile->Append(menuItemSaveImageSeq,
		     wxString::Format(_T("%s\tF8"), _("Save Image Sequence")),
		     _("Save a preview Image Sequence"));
    
    pCMenuFile->AppendSeparator();
    pCMenuFile->Append(menuItemCloseData,
		       wxString::Format(_T("%s\tCtrl-W"),
					_("Close Data")),
		       _("Close data of active slot"));
    mpCParent->AddBitmapMenu
	(pCMenuFile, wxID_EXIT, wxString::Format(_T("%s(&Q)\tQ"), _("Quit")),
	 _("Quit this application"), mpCParent->mpBitmapQuit);
    /*
    pCMenuFile->Append(wxID_EXIT,
		     wxString::Format(_T("%s(&Q)\tQ"),
				      _("Quit")),
		     _("Quit this application"));
    */

    // --menuEdit--
    mpCParent->mpCMenuEdit = new wxMenu;
    wxMenu *pCMenuEdit = mpCParent->mpCMenuEdit;
    
    pCMenuEdit->Append(menuItemUndo,
			_T("Undo(&U)\tCtrl-Z"), _T("Undo"));
    pCMenuEdit->Append(menuItemRedo,
			_T("Redo(&R)\tCtrl-Y"), _T("Redo"));
    
    pCMenuEdit->AppendSeparator();
    pCMenuEdit->Append(menuItemGoFrame,
			wxString::Format(_T("%s(&G)\tCtrl-G"),
					 _("Move Frame")),
			_("Move Frame"));

    pCMenuEdit->AppendSeparator();
    pCMenuEdit->Append(menuItemAutoRescale, _("Auto Rescale"));

    pCMenuEdit->AppendSeparator();
    wxMenu *pCMenuRemoveCache = new wxMenu;
    pCMenuEdit->Append(menuItemRemoveCache, 
		       wxString::Format(_T("%s(&D)"),_("Remove Cache")),
		       pCMenuRemoveCache, _("Remove Cache"));
    pCMenuRemoveCache->Append(menuItemRemoveCacheSnap,
			      wxString::Format(_T("%s\tF5"),
					       _("Snapshot")));
    pCMenuRemoveCache->Append(menuItemReTexture,
			      wxString::Format(_T("%s\tCtrl-F5"),
					       _("All Texture Memory")));
    pCMenuRemoveCache->Append(menuItemRemoveCacheMain,
			      wxString::Format(_T("%s\tCtrl-Alt-F5"),
					       _("All Main Memory")));
    
    pCMenuEdit->AppendSeparator();
    mpCParent->AddBitmapMenu(pCMenuEdit, menuItemScene,
			     wxString::Format(_T("%s(&S)\tCtrl-K"), _("Scene Setting")),
			     _("Scene Setting"), mpCParent->mpBitmapScene);

    mpCParent->AddBitmapMenu(pCMenuEdit, menuItemPreference,
			     wxString::Format(_T("%s(&P)\tCtrl-Alt-P"), _("Preference")),
			     _("Preference"), mpCParent->mpBitmapPreference);
    
    pCMenuEdit->AppendSeparator();
    pCMenuEdit->AppendCheckItem(menuItemTimeRemap, 
				 wxString::Format(_T("%s"), _("Use time-remap")),
				 _("Use time-remap 2"));

    pCMenuEdit->Check(menuItemTimeRemap, mpCParent->mpCParent->mpCTime->mCbUseTimeRemap.mbBody);

    // --MenuFilter--
    mpCParent->mpCMenuFilter = new wxMenu;
    wxMenu *pCMenuFilter = mpCParent->mpCMenuFilter;
    wxMenu *pCMenuFilterObject = new wxMenu;
    pCMenuFilter->Append(menuItemObjectFilter, _("Object Filter"),
			  pCMenuFilterObject, _("Object Filter"));
    
    pCMenuFilterObject->Append(menuItemVolume,
			       _("Volume"), _("Add Volume"));
    pCMenuFilterObject->Append(menuItemIsosurface,
			       _("Isosurface"), _("Add Isosurface"));
    pCMenuFilterObject->Append(menuItemCrossSection,
			       _("Cross-section"), _("Add Cross-section"));
    pCMenuFilterObject->Append(menuItemPovThreeView,
			       _("Three-view"), _("Add Three-View"));
    pCMenuFilterObject->Append(menuItemFog,
			       _("Fog"), _("Add Fog"));
    pCMenuFilterObject->Append(menuItemPovDiffObj,
			       _("Diff Object"), _("Add Diff Object"));

    mpCParent->mpCMenuFilterPrimitive = new wxMenu;
    wxMenu *pCMenuFilterPrimitive = mpCParent->mpCMenuFilterPrimitive;
    pCMenuFilter->Append(menuItemPrimitiveFilter, _("Add Primitive"),
			 pCMenuFilterPrimitive, _("Add Primitive"));
    pCMenuFilterPrimitive->Append(menuItemPovObjPlane,
				   _("Plane"), wxT("Add Plane"));
    pCMenuFilterPrimitive->Append(menuItemPovObjBox,
				   _("Box"), wxT("Add Box"));
    pCMenuFilterPrimitive->Append(menuItemPovObjWiredBox,
				   _("Wired Box"), wxT("Add Wired Box"));
    pCMenuFilterPrimitive->Append(menuItemPovObjSphere,
				   _("Sphere"), wxT("Add Sphere"));
    pCMenuFilterPrimitive->Append(menuItemPovObjCone,
				   _("Cylinder/Cone"), wxT("Add Cylinder/Cone"));
    pCMenuFilterPrimitive->Append(menuItemPovObjArrow,
				   _("Arrow"), wxT("Add Arrow"));
    pCMenuFilterPrimitive->Append(menuItemPovObjText,
				   _("Text"), wxT("Add Text"));
    pCMenuFilterPrimitive->Append(menuItemPovObjMesh,
				   wxT("Mesh"), wxT("Add Mesh"));
    pCMenuFilterPrimitive->Append(menuItemPovObjPlugin,
				   wxT("Plugin"), wxT("Add Plugin"));
       
    wxMenu *pCMenuFilterBox = new wxMenu;
    pCMenuFilter->Append(menuItemBoxFilter, _("Box Filter"),
			 pCMenuFilterBox, _("Box Filter"));
    
    pCMenuFilterBox->Append(menuItemBoxCopy,
			    _("Box Copy"), _("Add Box Copy"));
    pCMenuFilterBox->Append(menuItemClipping,
			    _("Clipping"), _("Add Clipping"));
    pCMenuFilterBox->Append(menuItemFixPosition,
			    _("FixPosition"), _("FixPosition"));
    
    wxMenu *pCMenuFilterData = new wxMenu;
    pCMenuFilter->Append(menuItemDataFilter, _("Data Filter"),
			  pCMenuFilterData, _("Data Filter"));
    
    pCMenuFilterData->Append(menuItemLevelAndGamma,
			     _("Level and Gamma"), _("Add Level and Gamma"));    
    pCMenuFilterData->Append(menuItemBlurGauss,
			     _("Gauss Blur"), _("Add Gauss Blur"));
    pCMenuFilterData->Append(menuItemInvDiffuse,
			     _("Inverse Diffuse"), _("Add Inverse Diffuse"));
    pCMenuFilterData->Append(menuItemDataRotate,
			     _("Data Rotate"), _("Add Data Rotate"));
    pCMenuFilterData->Append(menuItemLayerColorCurve,
			     _("Density Curve"), _("Composite Density Curve"));

    wxMenu *pCMenuFilterVelocity = new wxMenu;
    pCMenuFilter->Append(menuItemPovVelocity, _("Velocity Field"),
			  pCMenuFilterVelocity, _("Velocity Field"));
    pCMenuFilterVelocity->Append(menuItemPovStreamLine,
				 _("Stream Line"), _("Stream Line"));
    pCMenuFilterVelocity->Append(menuItemPovVelocityField,
				 _("Velocity Field"), _("Velocity Field"));

    wxMenu *pCMenuFilterAnalyze = new wxMenu;
    pCMenuFilter->Append(menuItemAnalyzeFilter, _("Analizer"),
			  pCMenuFilterAnalyze, _("Analizer"));
    pCMenuFilterAnalyze->Append(menuItemAnalyzeCenterOfMass,
				_("CenterOfMass"), _("CenterOfMass"));
    pCMenuFilterAnalyze->Append(menuItemAnalyzeMorphOpenClose,
				_("Morphological Filter"), _("Morphological Filter"));
    
    pCMenuFilter->Append(menuItemFilterAdvanced,
			 wxString::Format(_T("%s(&F)\tCtrl-F"), _("Property of Active Filter")), 
			 _("Morphological Filter"));

    // --menuPovRay--
    mpCParent->mpCMenuPovRay = new wxMenu;
    wxMenu *pCMenuPovRay = mpCParent->mpCMenuPovRay;
    mpCParent->AddBitmapMenu(pCMenuPovRay, menuItemConfPovRay,
			     wxString::Format(_T("%s(&R)\tCtrl-R"), _("Rendering preference")),
			     _("Rendering preference"), mpCParent->mpBitmapPovray);
    pCMenuPovRay->Append(menuItemConfPovRayAdvanced, 
			 _("Advanced PovRay setting"), _("Advanced PovRay setting"));
    
    pCMenuPovRay->AppendSeparator();
    
    pCMenuPovRay->Append
	(menuItemPovSnap, wxString::Format(_T("%s (%s)"),
					   _("PovRay Export"), _("Snap")),
	 _("PovRay Export 2"));
    
    pCMenuPovRay->Append(menuItemPovAnim, 
			 wxString::Format(_T("%s (%s)"),
					  _("PovRay Export"), _("Animation")),
			 _("PovRay Export 2"));
    
    pCMenuPovRay->AppendSeparator();

    pCMenuPovRay->Append(menuItemRenderSnap, 
			 wxString::Format(_T("%s (%s)"),
					  _("Export and Render"), _("Snap")),
			 _("Export and Render 2"));

    pCMenuPovRay->Append(menuItemRenderAnim,
			 wxString::Format(_T("%s (%s)"),
					  _("Export and Render"), _("Animation")),
			 _("Export and Render 2"));
#ifndef WIN32
    //pCMenuPovRay->AppendSeparator();
    //pCMenuPovRay->AppendCheckItem(menuItemPovWine, wxT("Wine mode (add z: to path)"));
    //pCMenuPovRay->Check(menuItemPovWine, mpCParent->mpCPovRay->mCbWinePov.mbBody);
#endif

    // --menuPovRay--
    mpCParent->mpCMenuPanel = new wxMenu;
    wxMenu *pCMenuPanel = mpCParent->mpCMenuPanel;
    pCMenuPanel->Append(menuItemViewMainPanelType1, 
			wxString::Format(_T("%s\tAlt-1"), _("1 panel")),
			_("1 panel"));
    mpCParent->AddBitmapMenu(pCMenuPanel, menuItemViewMainPanelType2,
			     wxString::Format(_T("%s\tAlt-2"), _("2 panels (vertical)")),
			     wxString::Format(_T("%s"), _("2 panels (vertical)")),
			     wxT("ICONS/splitV.png"));
    mpCParent->AddBitmapMenu(pCMenuPanel, menuItemViewMainPanelType3,
			     wxString::Format(_T("%s\tAlt-3"), _("2 panels (horizontal)")),
			     wxString::Format(_T("%s"), _("2 panels (Horizontal)")),
			     wxT("ICONS/splitH.png"));
    mpCParent->AddBitmapMenu(pCMenuPanel, menuItemViewMainPanelType4,
			     wxString::Format(_T("%s A\tAlt-4"), _("4 panels")),
			     wxString::Format(_T("%s"), _("4 panels")),
			     wxT("ICONS/split4.png"));
    mpCParent->AddBitmapMenu(pCMenuPanel, menuItemViewMainPanelType5,
			     wxString::Format(_T("%s B\tAlt-5"), _("4 panels")),
			     wxString::Format(_T("%s"), _("4 panels")),
			     wxT("ICONS/split4.png"));

    // --menuDialog--
    mpCParent->mpCMenuDialog = new wxMenu;
    wxMenu *pCMenuDialog = mpCParent->mpCMenuDialog;
    mpCParent->AddBitmapMenu(pCMenuDialog, menuItemPreviewConfig,
			     wxString::Format(_T("%s(&P)\tCtrl-P"), _("Preview Property")),
			     _("Preview Property"), mpCParent->mpBitmapPreviewConfig);
    mpCParent->AddBitmapMenu(pCMenuDialog, menuItemConfCameraPath,
			     wxString::Format(_T("%s(&U)\tCtrl-U"),_("View and Camera Configure")),
			     _("View and Camera Configure"), mpCParent->mpBitmapCameraConfig);
    mpCParent->AddBitmapMenu(pCMenuDialog, menuItemConfStereogram,
			     wxString::Format(_T("%s(&M)\tCtrl-M"), _("Stereogram preference")),
			     _("Stereogram preference"), mpCParent->mpBitmapStereo);
    mpCParent->AddBitmapMenu(pCMenuDialog, menuItemTextureDLG,
			     wxString::Format(_T("%s(&T)\tCtrl-T"), _("Texture")),
			     _("Custom Color"), mpCParent->mpBitmapTexture);
    mpCParent->AddBitmapMenu(pCMenuDialog, menuItemCustomColor,
			     wxString::Format(_T("%s(&H)\tCtrl-J"), _("Custom Color")),
			     _("Custom Color"), mpCParent->mpCParent->mpBitmapColor);
    mpCParent->AddBitmapMenu(pCMenuDialog, menuItemConfLightSource,
			     wxString::Format(_T("%s(&L)\tCtrl-L"), _("Light preference")),
			     _("Preference for light source"), mpCParent->mpCParent->mpBitmapLight);

    pCMenuDialog->AppendSeparator();

    mpCParent->AddBitmapMenu(pCMenuDialog, menuItemConfTree,
			     wxString::Format(_T("%s(&R)\tCtrl-Alt-T"), _("Tree preference")),
			     _("Tree preference"), mpCParent->mpBitmapTree);
    
    pCMenuDialog->Append(menuItemConfHotSpot,
			 wxString::Format(_T("%s(&H)\tCtrl-H"),_("Hotspot preference")),
			 _("Hotspot preference"));

    // --menuHelp--
    mpCParent->mpCMenuHelp = new wxMenu;
    wxMenu *pCMenuHelp = mpCParent->mpCMenuHelp;
    pCMenuHelp->Append(/*Minimal_About*/wxID_ABOUT, wxT("&About...\tF1"), wxT("Show about dialog"));
    pCMenuHelp->AppendCheckItem(menuItemToolTip, _("ToolTip"));

    // --menuBar--
    mpCParent->mpCMenuBar = new wxMenuBar;
    mpCParent->mpCMenuBar->Append(pCMenuFile, _("File(&F)"));
    mpCParent->mpCMenuBar->Append(mpCParent->mpCMenuEdit, _("Edit(&E)"));
    mpCParent->mpCMenuBar->Append(mpCParent->mpCMenuFilter, _("Filter(&L)"));
    mpCParent->mpCMenuBar->Append(mpCParent->mpCMenuPovRay, _("Pov-Ray(&P)"));
    mpCParent->mpCMenuBar->Append(mpCParent->mpCMenuPanel, _("Panel(&D)"));
    mpCParent->mpCMenuBar->Append(mpCParent->mpCMenuDialog, _("Dialog(&D)"));
    mpCParent->mpCMenuBar->Append(mpCParent->mpCMenuHelp, _("Help(&H)"));

    // ---
    mpCParent->mCLastOpenedFileDF3.SetItem(L"MainLastOpenedFileDF3=", L"");
    mpCParent->mCLastOpenedFileOSP.SetItem(L"MainLastOpenedFileOSP=", L"");
    mpCParent->mCLastOpenedFileIMG.SetItem(L"MainLastOpenedFileIMG=", L"");
    mpCParent->mCLastExportedFileDF3.SetItem(L"MainLastExportFileDF3=", L"");
    mpCParent->mCLastExportedFileIMG.SetItem(L"MainLastExportFileIMG=", L"");
    mpCParent->mCPreviewPanelType.SetItem(L"MainPreviewPanelType=", L"0");
    
    return 0;
}
    
