// (setq c-basic-offset 4)
// "clsPreference.h"

#include "clsPreference.h"

#include <GL/gl.h>
#include <wx/valgen.h>
#include <wx/notebook.h>

#include "../DF3/clsDF3SeqCtrl.h"
#include "../DF3/clsDF3Sequence.h"
#include "../DF3/FILEIO/clsReadBodyImgSeq.h"
#include "../FILTER/clsFilterCtrl.h"
#include "../GLCANVAS/clsMainGLCanvas.h"
#include "../MYGL/clsFBO.h"
#include "../MYGL/clsGLInfo.h"
#include "../WIDGETCTRL/EX/clsButtonEX.h"
#include "../WIDGETCTRL/EX/clsCheckBoxEX.h"
#include "../WIDGETCTRL/clsGraphPanel.h"
#include "../WIDGETCTRL/clsAtoiTextCtrl.h"
#include "../PARAMETER/clsTimeLinePanel.h"

#include "../../wxWidgetEnum.h"
#include "../../wxWidgetEnumMenu.h"

#include "../GRAPHIC/clsImageIO.h"
extern ImageIO_cls GCImgIO;

// ----

// ÓIɃCxgт
BEGIN_EVENT_TABLE(PreferenceGUI_cls, wxDialog)
     EVT_BUTTON(wxID_CANCEL   ,  PreferenceGUI_cls::OnButtonClose)
END_EVENT_TABLE()

PreferenceGUI_cls::
PreferenceGUI_cls(Preference_cls* pCParent, wxWindow *pC,
		  wxPoint pos, wxSize size) :
    wxDialogEXKey(pC, wxID_ANY, _("Preference"), 
		  pos, size, pCParent->mpBitmapLink) {
       
    mpCParent = pCParent;
    //SetCloseButtonID(buttonCtrlPovClose);
    SetScreenRectPos(&pCParent->mCScreenRect);

    mTemplateSetting = 0;

    /*
#ifdef WIN32
    wxIcon icon(wxT("ICONS/Preference.ico"), wxBITMAP_TYPE_ICO);
#else
    wxIcon icon(wxT("ICONS/Preference.png"), wxBITMAP_TYPE_PNG);
#endif
    SetIcon(icon);
    */

    // TCU[
    wxBoxSizer    *pBoxSizerSrc  = new wxBoxSizer(wxVERTICAL);
    wxBoxSizer    *pBoxSizerBTM  = new wxBoxSizer(wxHORIZONTAL);

    mpCBook = new wxNotebook(this, ID_BOOK_PREFERENCE);

    mpBoxSizerBookMouse = new wxBoxSizer(wxVERTICAL);
    SetMNumMouseParam(mpBoxSizerBookMouse);
    mpCBook->AddPage(mpCMNumMouseParam, _("Mouse"));
    mpCBook->SetSizer(mpBoxSizerBookMouse);

    mpBoxSizerBookTL    = new wxBoxSizer(wxVERTICAL);
    SetMNumTLParam(mpBoxSizerBookTL);
    mpCBook->AddPage(mpCMNumTLParam, _("Time Line"));
    mpCBook->SetSizer(mpBoxSizerBookTL);

    mpBoxSizerBookMem    = new wxBoxSizer(wxVERTICAL);
    SetMNumMemParam(mpBoxSizerBookMem);
    mpCBook->AddPage(mpCMNumMemParam, _("Memory"));
    mpCBook->SetSizer(mpBoxSizerBookMem);

    mpBoxSizerBookPerformance = new wxBoxSizer(wxVERTICAL);
    SetMNumPerformanceParam(mpBoxSizerBookPerformance);
    mpCBook->AddPage(mpCMNumPerformanceParam, _("Performance"));
    mpCBook->SetSizer(mpBoxSizerBookPerformance);

    pBoxSizerSrc->Add( mpCBook, 0, wxEXPAND);
    //pBoxSizerSrc->Add(mpCMNumMouseParam);
    
    wxButtonEX *pCButtonClose = new wxButtonEX (this, wxID_CANCEL,
						wxT("Close"));

    pBoxSizerBTM->Add( -1, -1, 1, wxEXPAND);

    pBoxSizerBTM->Add( pCButtonClose,  0, wxEXPAND);

    pBoxSizerSrc->Add( pBoxSizerBTM, 0, wxEXPAND);

    SetSizerAndFit(pBoxSizerSrc);

    //pCButtonClose->SetFocus();
}

#include "../MYAPI/MsgBox.h"

void PreferenceGUI_cls::
SetMNumMouseParam(wxBoxSizer *pBoxSizer){
    MultiNumericalInputsPanel_cls* pCurr = 
	InitializeMNumPanel(&mpCMNumMouseParam, mpCBook);
    int boxWidth = 4;
    
    pCurr->mTextWidth     = 100;
#ifdef WIN32
    pCurr->mCheckBoxWidth = 50;
#else
    pCurr->mCheckBoxWidth = 55;
#endif

    wxString strList[4] = {
	_("Left Mouse BTN"), _("Middle Mouse BTN"), _("Right Mouse BTN"), _("Not Assigned")};
    wxString strListB[4] = { _("Left BTN + Shift"), _("Left BTN + Ctrl"), _("Left BTN + Alt"), _("Not Assigned")};
    wxString strListC[2] = { _("Defalut"), _("Blender Like")};
    
    pCurr->CombinePointer(_GP_BOXSIZERHORIZONTAL, &boxWidth, _("Gyration"));
    pCurr->CombinePointer(_GP_UNSIGNED_INT_LIST, &mpCParent->mCGyrationMouse.mBody,
			  wxT(""), TRUE, 4, strList, 0);
    pCurr->CombinePointer(_GP_BOOL, &mpCParent->mCbGyrationMod.mpbBody[0],
			  wxT("Shift"));
    pCurr->CombinePointer(_GP_BOOL, &mpCParent->mCbGyrationMod.mpbBody[1],
			  wxT("Ctrl"));
    pCurr->CombinePointer(_GP_BOOL, &mpCParent->mCbGyrationMod.mpbBody[2],
			  wxT("Alt"));

    pCurr->CombinePointer(_GP_BOXSIZERHORIZONTAL, &boxWidth, _("Zoom"));
    pCurr->CombinePointer(_GP_UNSIGNED_INT_LIST, &mpCParent->mCZoomMouse.mBody,
			  wxT(""), TRUE, 4, strList, 1);
    pCurr->CombinePointer(_GP_BOOL, &mpCParent->mCbZoomMod.mpbBody[0], 
			  wxT("Shift"));
    pCurr->CombinePointer(_GP_BOOL, &mpCParent->mCbZoomMod.mpbBody[1],
			  wxT("Ctrl"));
    pCurr->CombinePointer(_GP_BOOL, &mpCParent->mCbZoomMod.mpbBody[2],
			  wxT("Alt"));

    pCurr->CombinePointer(_GP_BOXSIZERHORIZONTAL, &boxWidth, _("Move Center"));
    pCurr->CombinePointer(_GP_UNSIGNED_INT_LIST, &mpCParent->mCCenterMouse.mBody,
			  wxT(""), TRUE, 4, strList, 1);
    pCurr->CombinePointer(_GP_BOOL, &mpCParent->mCbCenterMod.mpbBody[0], 
			  wxT("Shift"));
    pCurr->CombinePointer(_GP_BOOL, &mpCParent->mCbCenterMod.mpbBody[1],
			  wxT("Ctrl"));
    pCurr->CombinePointer(_GP_BOOL, &mpCParent->mCbCenterMod.mpbBody[2],
			  wxT("Alt"));

    pCurr->CombinePointer(_GP_BOXSIZERHORIZONTAL, &boxWidth, _("Move Item"));
    pCurr->CombinePointer(_GP_UNSIGNED_INT_LIST, &mpCParent->mCItemMouse.mBody,
			  wxT(""), TRUE, 4, strList, 1);
    pCurr->CombinePointer(_GP_BOOL, &mpCParent->mCbItemMod.mpbBody[0], 
			  wxT("Shift"));
    pCurr->CombinePointer(_GP_BOOL, &mpCParent->mCbItemMod.mpbBody[1],
			  wxT("Ctrl"));
    pCurr->CombinePointer(_GP_BOOL, &mpCParent->mCbItemMod.mpbBody[2],
			  wxT("Alt"));

    pCurr->CombinePointer(_GP_BOXSIZERHORIZONTAL, &boxWidth, _("Menu"));
    pCurr->CombinePointer(_GP_UNSIGNED_INT_LIST, &mpCParent->mCMenuMouse.mBody,
			  wxT(""), TRUE, 4, strList, 1);
    pCurr->CombinePointer(_GP_BOOL, &mpCParent->mCbMenuMod.mpbBody[0], 
			  wxT("Shift"));
    pCurr->CombinePointer(_GP_BOOL, &mpCParent->mCbMenuMod.mpbBody[1],
			  wxT("Ctrl"));
    pCurr->CombinePointer(_GP_BOOL, &mpCParent->mCbMenuMod.mpbBody[2],
			  wxT("Alt"));
    
    pCurr->CombinePointer(_GP_BOXSIZERHORIZONTAL, &boxWidth, _("Item Selection"));
    pCurr->CombinePointer(_GP_UNSIGNED_INT_LIST, &mpCParent->mCHitTestMouse.mBody,
			  wxT(""), TRUE, 4, strList, 1);
    pCurr->CombinePointer(_GP_BOOL, &mpCParent->mCbHitTestMod.mpbBody[0], 
			  wxT("Shift"));
    pCurr->CombinePointer(_GP_BOOL, &mpCParent->mCbHitTestMod.mpbBody[1],
			  wxT("Ctrl"));
    pCurr->CombinePointer(_GP_BOOL, &mpCParent->mCbHitTestMod.mpbBody[2],
			  wxT("Alt"));
    
    int comboIndexMButton = pCurr->CombinePointer
	(_GP_UNSIGNED_INT_LIST, &mpCParent->mCMButtonEmulate.mBody,
	 _("MButton Emulate"), TRUE, 4, strListB, 3);

    boxWidth = 2;
    pCurr->mCheckBoxWidth = 70;
    pCurr->CombinePointer(_GP_BOXSIZERHORIZONTAL, &boxWidth, _("Invert"));
    pCurr->CombinePointer(_GP_BOOL, &mpCParent->mCbZoomInvert.mbBody,
			  _("Zoom"));
    pCurr->CombinePointer(_GP_BOOL, &mpCParent->mCbGyrationInvert.mbBody,
			  _("Gyration"));

    int comboIndex = pCurr->CombinePointer
	(_GP_UNSIGNED_INT_LIST, &mTemplateSetting,
	 _("Template"), TRUE, 2, strListC, 0);
    
    pCurr->FinishSetting(pBoxSizer, TRUE);

    Connect(pCurr->mVCPointers[comboIndex].mID, wxEVT_COMMAND_COMBOBOX_SELECTED,
	    wxCommandEventHandler(PreferenceGUI_cls::OnCommandEventTemplate));
    Connect(pCurr->mVCPointers[comboIndexMButton].mID,
	    wxEVT_COMMAND_COMBOBOX_SELECTED,
	    wxCommandEventHandler(PreferenceGUI_cls::OnCommandEventGrayOut));
}

PreferenceGUI_cls::
~PreferenceGUI_cls(){
    MakeModal(FALSE);
}

void PreferenceGUI_cls::
SetMNumPerformanceParam(wxBoxSizer *pBoxSizer){
    MultiNumericalInputsPanel_cls* pCurr = 
	InitializeMNumPanel(&mpCMNumPerformanceParam, mpCBook);
    pCurr->mTextWidth = 120;
    
    int boxWidth = 2;
    pCurr->CombinePointer(_GP_BOXSIZERHORIZONTAL, &boxWidth, 
			  _("Read Image Seq."));
    pCurr->CombinePointer(_GP_BOOL, 
			  &mpCParent->mCbMultiThreadImgRead.mbBody,
			  _("Multi Thread"));
    pCurr->CombinePointer(_GP_UINT_SPIN, 
			  &mpCParent->mCThreadNumImgRead.mBody);
    pCurr->SetRange(1, 3);

    boxWidth = 3;
    pCurr->CombinePointer(_GP_BOXSIZERHORIZONTAL, &boxWidth, 
			  _("Filter Process"));
    pCurr->CombinePointer(_GP_BOOL, 
			  &mpCParent->mCbSSEFilter.mbBody,
			  _("SSE"));
    pCurr->CombinePointer(_GP_BOOL, 
			  &mpCParent->mCbMultiThreadFilter.mbBody,
			  _("Multi Thread"));
    pCurr->CombinePointer(_GP_UINT_SPIN, 
			  &mpCParent->mCThreadNumFilter.mBody);
    pCurr->SetRange(1, 12);

    boxWidth = 2;
    pCurr->CombinePointer(_GP_UINT_SPIN, 
			  &mpCParent->mCThreadIsosurfaceLayer.mBody,
			  _("Isosurface: layers for a thread"));
    pCurr->SetRange(1, 32);
       
    pCurr->CombinePointer(_GP_BOXSIZERHORIZONTAL, &boxWidth, 
			  _("jpeg quality"));
    pCurr->CombinePointer(_GP_INTEGER_SLIDER, &GCImgIO.mJPEGQuality);
    pCurr->SetRange(2, 100);

    pCurr->CombinePointer(_GP_INTEGER_SPIN, &GCImgIO.mJPEGQuality);
    pCurr->SetRange(2, 100);

    wxString strList[2] = {wxT("Not compress"), wxT("Compress (Slow)")};
    if (mpCParent->mpCParentFrame->mpCGLInfo->mMajorVersion == 1 && 
	mpCParent->mpCParentFrame->mpCGLInfo->mMajorVersion < 2) // 1.3ȏ
	pCurr->CombinePointer(_GP_UNSIGNED_INT_LIST, &mpCParent->mCTexCompress.mBody,
			      wxT("Compress Texture Data"), FALSE, 1, strList);
    else
	pCurr->CombinePointer(_GP_UNSIGNED_INT_LIST, &mpCParent->mCTexCompress.mBody,
			      wxT("Compress Texture Data"), TRUE, 2, strList);
    
    pCurr->FinishSetting(pBoxSizer, TRUE);
}

void PreferenceGUI_cls::
SetMNumTLParam(wxBoxSizer *pBoxSizer){
    MultiNumericalInputsPanel_cls* pCurr = 
	InitializeMNumPanel(&mpCMNumTLParam, mpCBook);
    pCurr->mTextWidth = 170;
    
    pCurr->CombinePointer(_GP_BOOL, &TimeLinePanel_cls::msbShowParameter, _("Show Numerical Values"));

    wxString listAppendType[2] = {_("Do not Remap Key Frame"), _("Remap Key Frame")};
    pCurr->CombinePointer(_GP_UNSIGNED_INT_LIST, &mpCParent->mpCParentFrame->mpCDF3SeqCtrl->mCAppendType.mBody,
			  _("When Appending Data"), TRUE, 2, listAppendType);
    
    pCurr->FinishSetting(pBoxSizer, TRUE);

    Connect(pCurr->mVCPointers[0].mID, wxEVT_COMMAND_CHECKBOX_CLICKED,
	    wxCommandEventHandler(PreferenceGUI_cls::OnCommandEventRefresh));

    pCurr->mVCPointers[1].GetPCtrlWindow()->
	SetToolTip(_("Remap in Adding Tip"));
}

void PreferenceGUI_cls::
SetMNumMemParam(wxBoxSizer *pBoxSizer){
    MultiNumericalInputsPanel_cls* pCurr = 
	InitializeMNumPanel(&mpCMNumMemParam, mpCBook);
    pCurr->mTextWidth = 170;

    int boxWidth = 2;
    pCurr->CombinePointer(_GP_BOXSIZERHORIZONTAL, &boxWidth, wxT("Tex(MB)"));
    pCurr->CombinePointer(_GP_UNSIGNED_INT, 
			  &mpCParent->mpCParentFrame->mpCDF3SeqCtrl->mCCritTexMemoryMB.mBody,
			  wxT("Tex Crit"));
    pCurr->CombinePointer(_GP_UNSIGNED_INT, 
			  &mpCParent->mpCParentFrame->mpCDF3SeqCtrl->mTexMemoryMB,
			  wxT("Tex Memory MB"), FALSE);
    
    pCurr->CombinePointer(_GP_BOXSIZERHORIZONTAL, &boxWidth, wxT("XY(MB)"));
    pCurr->CombinePointer(_GP_UNSIGNED_INT, 
			  &mpCParent->mpCParentFrame->mpCDF3SeqCtrl->mCCritXYMemoryMB.mBody,
			  wxT("XY Crit"));
    pCurr->CombinePointer(_GP_UNSIGNED_INT, 
			  &mpCParent->mpCParentFrame->mpCDF3SeqCtrl->mXYMemoryMB,
			  wxT("XY Memory MB"), FALSE);
    
    pCurr->CombinePointer(_GP_BOXSIZERHORIZONTAL, &boxWidth, wxT("XY+Z(MB)"));
    pCurr->CombinePointer(_GP_UNSIGNED_INT, 
			  &mpCParent->mpCParentFrame->mpCDF3SeqCtrl->mCCritXYZMemoryMB.mBody,
			  wxT("XYZ Crit"));
    pCurr->CombinePointer(_GP_UNSIGNED_INT, 
			  &mpCParent->mpCParentFrame->mpCDF3SeqCtrl->mXYZMemoryMB,
			  wxT("XYZ Memory MB"), FALSE);

    pCurr->FinishSetting(pBoxSizer, TRUE);
}

void PreferenceGUI_cls::
GrayOutItems(){
    MultiNumericalInputsPanel_cls* pCurr = mpCMNumMouseParam;
    for (int i =  2; i <=  4; i++) pCurr->mVCPointers[i].Enable();
    for (int i =  7; i <=  9; i++) pCurr->mVCPointers[i].Enable();
    for (int i = 12; i <= 14; i++) pCurr->mVCPointers[i].Enable();
    for (int i = 17; i <= 19; i++) pCurr->mVCPointers[i].Enable();
    for (int i = 22; i <= 24; i++) pCurr->mVCPointers[i].Enable();
    for (int i = 27; i <= 29; i++) pCurr->mVCPointers[i].Enable();

    if (mpCParent->mCMButtonEmulate.mBody == 2){
	pCurr->mVCPointers[4].Disable();
	pCurr->mVCPointers[9].Disable();
	pCurr->mVCPointers[14].Disable();
	pCurr->mVCPointers[19].Disable();
	pCurr->mVCPointers[24].Disable();
	pCurr->mVCPointers[29].Disable();
    }
    if (mpCParent->mCMButtonEmulate.mBody == 1){
	pCurr->mVCPointers[3].Disable();
	pCurr->mVCPointers[8].Disable();
	pCurr->mVCPointers[13].Disable();
	pCurr->mVCPointers[18].Disable();
	pCurr->mVCPointers[23].Disable();
	pCurr->mVCPointers[28].Disable();
    }
    if (mpCParent->mCMButtonEmulate.mBody == 0){
	pCurr->mVCPointers[2].Disable();
	pCurr->mVCPointers[7].Disable();
	pCurr->mVCPointers[12].Disable();
	pCurr->mVCPointers[17].Disable();
	pCurr->mVCPointers[22].Disable();
	pCurr->mVCPointers[27].Disable();
    }
}

void PreferenceGUI_cls::
OnCommandEventTemplate(wxCommandEvent &event){
    mpCParent->SetToDefaultGUI(mTemplateSetting);
    mpCMNumMouseParam->UpdateValues();
    GrayOutItems();
}

void PreferenceGUI_cls::
OnCommandEventGrayOut(wxCommandEvent &event){
    GrayOutItems();
}

void PreferenceGUI_cls::
OnCommandEventRefresh(wxCommandEvent &event){
    GrayOutItems();
    wxCommandEvent dummy(wxEVT_COMMAND_MENU_SELECTED, menuItemRefresh);
    mpCParent->mpCParentFrame->AddPendingEvent(dummy);
}

void PreferenceGUI_cls::
OnButtonClose(wxCommandEvent &event){
    //UpdateValues();
    CloseEXKey();
    
}

// -------------------------------------------

Preference_cls::
~Preference_cls(){
    if (mpCGUI != NULL) delete mpCGUI;
}
 
Preference_cls::
Preference_cls(FrameMain_cls *pC) 
{
    mpCParentFrame = pC;
    mpBitmapLink = mpCParentFrame->mpBitmapPreference;
    mpCGUI  = NULL;
    SetToDefaultGUI(0);
    
    mCConfListPerformance.Clear();
    mCConfListPerformance.Add(&mCbMultiThreadImgRead,wxT("MultiThreadImgRead="), L"0");
    mCConfListPerformance.Add(&mCThreadNumImgRead, wxT("ThreadNumImgRead="), L"1");
    mCConfListPerformance.Add(&mCbSSEFilter, wxT("SSEFilter="), L"0");
    mCConfListPerformance.Add(&mCbMultiThreadFilter, wxT("MultiThreadFilter="), L"0");
    mCConfListPerformance.Add(&mCThreadNumFilter, wxT("ThreadNumFilter="), L"1");
    mCConfListPerformance.Add(&mCThreadIsosurfaceLayer, wxT("ThreadIsosurfaceLayer="), L"8");
    mCConfListPerformance.Add(&mCTexCompress, wxT("CompressTexture="), L"0");
    
    InitGUI(pC); // GUI ̃CX^X
}

void Preference_cls::
UpdateItems(bool bForce){
    mpCGUI->mpCMNumMouseParam->UpdateValuesAll(bForce);
    mpCGUI->mpCMNumPerformanceParam->UpdateValuesAll(bForce);
    mpCGUI->mpCMNumTLParam->UpdateValuesAll(bForce);
    mpCGUI->mpCMNumMemParam->UpdateValuesAll(bForce);
}

void Preference_cls::
OpenWindow(wxWindow *pC){
    DialogControl_cls::OpenWindow(pC);
    UpdateItems(TRUE);
    mpCGUI->GrayOutItems();
}

void Preference_cls::
SetToDefaultGUI(int type){
    mCConfListGUI.Clear();
    switch(type){
    case 0:
	mCConfListGUI.Add(&mCGyrationMouse, wxT("GUI_GYRATION="), L"0");
	mCConfListGUI.Add(&mCbGyrationMod,  wxT("GUI_GYRATION_MOD="), wxT("0 0 0"));
	mCConfListGUI.Add(&mCbGyrationInvert, wxT("GUI_GYRATION_INVERT="), L"0");
	mCConfListGUI.Add(&mCZoomMouse, wxT("GUI_ZOOM="), L"1");
	mCConfListGUI.Add(&mCbZoomMod, wxT("GUI_ZOOM_MOD="), L"0 0 0");
	mCConfListGUI.Add(&mCbZoomInvert, wxT("GUI_ZOOM_INVERT="), L"0");
	mCConfListGUI.Add(&mCCenterMouse, wxT("GUI_CENTER="), L"0");
	mCConfListGUI.Add(&mCbCenterMod, wxT("GUI_CENTER_MOD="), L"1 1 0");
	mCConfListGUI.Add(&mCItemMouse, wxT("GUI_ITEM="), L"0");
	mCConfListGUI.Add(&mCbItemMod, wxT("GUI_ITEM_MOD="), L"1 0 0");
	mCConfListGUI.Add(&mCMenuMouse, wxT("GUI_MENU="), L"2");
	mCConfListGUI.Add(&mCbMenuMod, wxT("GUI_MENU_MOD="), L"0 0 0");
	mCConfListGUI.Add(&mCHitTestMouse, wxT("GUI_HITTEST="), L"2");
	mCConfListGUI.Add(&mCbHitTestMod, wxT("GUI_HITTEST_MOD="), L"1 0 0");
	mCConfListGUI.Add(&mCMButtonEmulate, wxT("GUI_MBUTTON_EMULATE="), L"2");
	break;
    case 1:
	mCConfListGUI.Add(&mCGyrationMouse, wxT("GUI_GYRATION="), L"1");
	mCConfListGUI.Add(&mCbGyrationMod, wxT("GUI_GYRATION_MOD="), L"0 0 0");
	mCConfListGUI.Add(&mCbGyrationInvert, wxT("GUI_GYRATION_INVERT="), L"0");
	mCConfListGUI.Add(&mCZoomMouse, wxT("GUI_ZOOM="), L"1");
	mCConfListGUI.Add(&mCbZoomMod, wxT("GUI_ZOOM_MOD="), L"0 1 0");
	mCConfListGUI.Add(&mCbZoomInvert, wxT("GUI_ZOOM_INVERT="), L"0");
	mCConfListGUI.Add(&mCCenterMouse, wxT("GUI_CENTER="), L"1");
	mCConfListGUI.Add(&mCbCenterMod, wxT("GUI_CENTER_MOD="), L"1 0 0");
	mCConfListGUI.Add(&mCItemMouse, wxT("GUI_ITEM="), L"0");
	mCConfListGUI.Add(&mCbItemMod, wxT("GUI_ITEM_MOD="), L"0 0 0");
	mCConfListGUI.Add(&mCMenuMouse, wxT("GUI_MENU="), L"2");
	mCConfListGUI.Add(&mCbMenuMod, wxT("GUI_MENU_MOD="), L"1 0 0");
	mCConfListGUI.Add(&mCHitTestMouse, wxT("GUI_HITTEST="), L"2");
	mCConfListGUI.Add(&mCbHitTestMod, wxT("GUI_HITTEST_MOD="), L"0 0 0");
	mCConfListGUI.Add(&mCMButtonEmulate, wxT("GUI_MBUTTON_EMULATE="), L"2");
	break;
    }
}

void Preference_cls::
InitGUI(wxWindow *pC){
    mpCGUI = new PreferenceGUI_cls(this, pC,
				   mCScreenRect.GetPosition(),
				   mCScreenRect.GetSize());
    SetPDialog(mpCGUI);
}

void Preference_cls::
ModulateBTN(bool bAModifier[4], bool bAMouseBTN[4]){
    if (bAMouseBTN[0] == TRUE)
	if (bAModifier[mCMButtonEmulate.mBody] == TRUE){
	    bAMouseBTN[0] = FALSE;
	    bAMouseBTN[1] = TRUE;
	}
    bAModifier[mCMButtonEmulate.mBody] = FALSE;
}

bool Preference_cls::
IsGyration(bool bAModifier[4], bool bAMouseBTN[4]){
    if (bAMouseBTN[mCGyrationMouse.mBody] == FALSE) return FALSE;
    for (unsigned int i = 0; i < 3; i++){
	bool condition = mCbGyrationMod.mpbBody[i];
	if (i == mCMButtonEmulate.mBody) condition = FALSE;
	if (bAModifier[i] != condition) return FALSE;
    }
    return TRUE;
}

bool Preference_cls::
IsZoom(bool bAModifier[4], bool bAMouseBTN[4]){
    if (bAMouseBTN[mCZoomMouse.mBody] == FALSE) return FALSE;
    for (unsigned int i = 0; i < 3; i++)
	if (bAModifier[i] != mCbZoomMod.mpbBody[i]) return FALSE;
    return TRUE;
}

bool Preference_cls::
IsMoveCenter(bool bAModifier[4], bool bAMouseBTN[4]){
    if (bAMouseBTN[mCCenterMouse.mBody] == FALSE) return FALSE;
    for (unsigned int i = 0; i < 3; i++){
	bool condition = mCbCenterMod.mpbBody[i];
	if (i == mCMButtonEmulate.mBody) condition = FALSE;
	if (bAModifier[i] != condition) return FALSE;
    }
    return TRUE;
}

bool Preference_cls::
IsMoveItem(bool bAModifier[4], bool bAMouseBTN[4]){
    if (bAMouseBTN[mCItemMouse.mBody] == FALSE) return FALSE;
    for (unsigned int i = 0; i < 3; i++){
	bool condition = mCbItemMod.mpbBody[i];
	if (i == mCMButtonEmulate.mBody) condition = FALSE;
	if (bAModifier[i] != condition) return FALSE;
    }
    return TRUE;
}

bool Preference_cls::
IsHitTest(bool bAModifier[4], bool bAMouseBTN[4]){
    if (bAMouseBTN[mCHitTestMouse.mBody] == FALSE) return FALSE;
    for (unsigned int i = 0; i < 3; i++){
	bool condition = mCbHitTestMod.mpbBody[i];
	if (i == mCMButtonEmulate.mBody) condition = FALSE;
	if (bAModifier[i] != condition) return FALSE;
    }
    return TRUE;
}

unsigned int Preference_cls::
GetThreadNumFilter(){
    if (mCbMultiThreadFilter.mbBody == FALSE) return 1;
    return mCThreadNumFilter.mBody;
}

void Preference_cls::
ReadStrLine(std::wstring strLine){
    mCConfListGUI.ReadStrLineAll(strLine);
    mCConfListPerformance.ReadStrLineAll(strLine);
}

wxString Preference_cls::
Serialize(){
    return 
	mCConfListGUI.SerializeAll() + mCConfListPerformance.SerializeAll();
}
