// (setq c-basic-offset 4)
// "clsPreviewPanel.h"

#include "../../clsFrameMain.h"
#include "../../wxWidgetEnum.h"
#include "../FILTER/clsFilterCtrl.h"
#include "../GLCANVAS/clsGLCanvasCtrl.h"
#include "../GLCANVAS/clsMainGLCanvas.h"
#include "clsPreviewPanel.h"
#include "clsFilterPanelPain.h"

#include "../MYAPI/MsgBox.h"

// ÓIɃCxgт
BEGIN_EVENT_TABLE(PreviewPanel_cls, wxPanel)
       EVT_MOUSE_EVENTS(PreviewPanel_cls::OnMouse)
//     EVT_KEY_DOWN(PreviewPanel_cls::OnKeyDown)
END_EVENT_TABLE()

PreviewPanel_cls::
PreviewPanel_cls(wxWindow *pC, FrameMain_cls *pCFrame) : 
wxPanel(pC, wxID_ANY, wxDefaultPosition, wxDefaultSize)
{
    mpCParentFrame = pCFrame;

    wxBoxSizer  *mpBoxSizerTop = new wxBoxSizer(wxHORIZONTAL);

    mpCSplitterMain = new
	wxSplitterWindow(this, wxID_ANY, 
			 wxDefaultPosition, wxDefaultSize, wxSP_BORDER | wxSP_3DSASH );
    mpCSplitterChildA = new
	wxSplitterWindow(mpCSplitterMain, wxID_ANY, 
			 wxDefaultPosition, wxDefaultSize, wxSP_NOBORDER | wxSP_3DSASH );
    mpCSplitterChildB = new
	wxSplitterWindow(mpCSplitterMain, wxID_ANY, 
			 wxDefaultPosition, wxDefaultSize, wxSP_NOBORDER | wxSP_3DSASH );
    mpCSplitterChildA->SetSashGravity(0.5);
    mpCSplitterChildB->SetSashGravity(0.5);
    mpCSplitterMain->SetSashGravity(0.5);

    // ̃TCU[
    wxBoxSizer  *pBoxSizerLFT = new wxBoxSizer(wxVERTICAL);

    int attribList[5] = {WX_GL_DOUBLEBUFFER, 1, WX_GL_STENCIL_SIZE, 1, 0};
    mpCParentFrame->mpCCanvas[0] = 
	new GLCanvasCtrl_cls(mpCSplitterChildA, wxID_ANY, attribList, wxDefaultPosition, wxDefaultSize,
			     wxWANTS_CHARS,
			     wxT("MainGLCanvas 0"), NULL, 0, 
			     _GL_CANVAS_DISPLAY_FREE);
    mpCParentFrame->mpCCanvas[1] =
	new GLCanvasCtrl_cls(mpCSplitterChildA, wxID_ANY, attribList, wxDefaultPosition, wxDefaultSize,
			     wxWANTS_CHARS,
			     wxT("MainGLCanvas 1"), mpCParentFrame->mpCCanvas[0]->mpCGLCanvas->mpCGLContext, 1,
			     _GL_CANVAS_DISPLAY_Z_MINUS);
    mpCParentFrame->mpCCanvas[2] =
	new GLCanvasCtrl_cls(mpCSplitterChildB, wxID_ANY, attribList, wxDefaultPosition, wxDefaultSize,
			     wxWANTS_CHARS,    
			     wxT("MainGLCanvas 2"), mpCParentFrame->mpCCanvas[0]->mpCGLCanvas->mpCGLContext, 2,
			     _GL_CANVAS_DISPLAY_X_PLUS);
    mpCParentFrame->mpCCanvas[3] = 
	new GLCanvasCtrl_cls(mpCSplitterChildB, wxID_ANY, attribList, wxDefaultPosition, wxDefaultSize, 
			     wxWANTS_CHARS | wxCLIP_CHILDREN | wxBORDER_NONE, 
			     wxT("MainGLCanvas 3"), mpCParentFrame->mpCCanvas[0]->mpCGLCanvas->mpCGLContext, 3, 
			     _GL_CANVAS_DISPLAY_Y_PLUS);

    mpCSplitterMain->SplitHorizontally(mpCSplitterChildA, mpCSplitterChildB, 0);
    mpCSplitterChildA->SplitVertically(mpCParentFrame->mpCCanvas[0],
				       mpCParentFrame->mpCCanvas[1]);
    mpCSplitterChildB->SplitVertically(mpCParentFrame->mpCCanvas[2],
				       mpCParentFrame->mpCCanvas[3]);
    mpCSplitterChildA->Unsplit();
    mpCSplitterChildB->Unsplit();
    mpCSplitterMain->Unsplit();

    pBoxSizerLFT->Add( mpCSplitterMain, 1, wxEXPAND);
    
    // ẼTCU[
    wxBoxSizer *pCBoxSizerRGT = new wxBoxSizer(wxVERTICAL);
    pCBoxSizerRGT->Add(220 + 8, 0, 0); // _
    
    pCFrame->mpCFilterPain = new FilterPanelPain_cls(this, pCFrame);
    
    pCBoxSizerRGT->Add(pCFrame->mpCFilterPain, 1, wxEXPAND);

    mpBoxSizerTop->Add( pBoxSizerLFT, 1, wxEXPAND);
    mpBoxSizerTop->Add( pCBoxSizerRGT, 0, wxEXPAND);
    this->SetSizer(mpBoxSizerTop);
}

void PreviewPanel_cls::
SplitPanel(unsigned int type){
    switch (type){
    case 0:
	mpCSplitterMain->Unsplit();
	mpCSplitterChildA->Unsplit(mpCParentFrame->mpCCanvas[1]);
	break;
    case 1:
	mpCSplitterChildA->Unsplit();
	mpCSplitterMain->Unsplit(mpCSplitterChildB);
	mpCSplitterChildA->SplitHorizontally(mpCParentFrame->mpCCanvas[0],
					     mpCParentFrame->mpCCanvas[1]);
	break;
    case 2:
	mpCSplitterChildA->Unsplit();
	mpCSplitterMain->Unsplit();
	mpCSplitterChildA->SplitVertically(mpCParentFrame->mpCCanvas[0],
					   mpCParentFrame->mpCCanvas[1]);
	break;
    case 3:
	mpCSplitterChildA->Unsplit();
	mpCSplitterChildB->Unsplit();
	mpCSplitterMain->Unsplit();
	mpCSplitterMain->SplitHorizontally(mpCSplitterChildA, mpCSplitterChildB, 0);
	mpCSplitterChildA->SplitVertically(mpCParentFrame->mpCCanvas[0],
					   mpCParentFrame->mpCCanvas[1]);
	mpCSplitterChildB->SplitVertically(mpCParentFrame->mpCCanvas[2],
					   mpCParentFrame->mpCCanvas[3]);
	break;
    case 4:
	mpCSplitterChildA->Unsplit();
	mpCSplitterChildB->Unsplit();
	mpCSplitterMain->Unsplit();
	mpCSplitterMain->SplitVertically(mpCSplitterChildA, mpCSplitterChildB, 0);
	mpCSplitterChildA->SplitHorizontally(mpCParentFrame->mpCCanvas[0],
					     mpCParentFrame->mpCCanvas[1]);
	mpCSplitterChildB->SplitHorizontally(mpCParentFrame->mpCCanvas[2],
					     mpCParentFrame->mpCCanvas[3]);
	break;
    }
}

void PreviewPanel_cls::
OnMouse(wxMouseEvent& event){
    if (event.RightDown() == TRUE){
	/*
	for (std::list<FilterBase_cls*>::iterator itr = mpCParentFrame->mpCFilterCtrl->mVpCFilter.begin(); 
	     itr != mpCParentFrame->mpCFilterCtrl->mVpCFilter.end(); itr++)
	    if (event.GetId() == (*itr)->mpCGUIPanel->mpBTNShow->GetId()){
		PopupMenu(FilterGUI_cls::mspoPpupMenu, wxDefaultPosition);
		return;
	    }
	*/
    
	if (event.GetId() == GetId()){
	    mpCParentFrame->PopupMenu(mpCParentFrame->mpCMenuFilter, wxDefaultPosition);
	}
    }
}

/*
void PreviewPanel_cls::
OnKeyDown(wxKeyEvent& event){
    if (event.GetKeyCode() == WXK_DELETE)
	mpCParentFrame->mpCFilterCtrl->DeleteSelectedItem();
}
*/

PreviewPanel_cls::
~PreviewPanel_cls(){
    delete mpCSplitterChildA;
    delete mpCSplitterChildB;
    delete mpCSplitterMain;
}
