// -*- c -*-
// "clsParametersPanel.cpp"
// (setq c-basic-offset 4)

#ifndef _PARAMETERS_PANEL_H
#define _PARAMETERS_PANEL_H

#include <wx/wx.h>
#include <wx/image.h>

class Parameters_cls; 
class DF3SeqGUI_cls; 
class TimeLinePanel_cls; 
class TimeCtrl_cls;
class BitmapPanel_cls; 

class ParametersPanel_cls : public wxPanel {
 public:
    ParametersPanel_cls(Parameters_cls *pCParam, wxWindow *parent, /*wxString strTitle = wxT("Title"),*/ wxString strCustomName = wxT("CustomName"), bool bShow = TRUE, wxPoint pos = wxDefaultPosition, wxSize size = wxDefaultSize, wxWindowID id = wxID_ANY);
    Parameters_cls *mpCParam;
    void LinkParameter(Parameters_cls *pCParam);
    void UpdatePanelBitmapState();
    
    static double msCurrentDoubleIndex;
    static double msDoubleIndexWAMin, msDoubleIndexWAMax;
    static double msDoubleIndexAAMin, msDoubleIndexAAMax;
    static int msMaxFrame, msAAMin, msAAMax;
    static void SetDoubleIndex
	(int maxFrame, int AAMin, int AAMax, double doubleIndex,
	 double doubleIndexAAMin, double doubleIndexAAMax,
	 double doubleIndexWAMin, double doubleIndexWAMax);

    static DF3SeqGUI_cls* mspCDF3SeqGUILink;
    static TimeCtrl_cls*  mspCTimeLink;
    static wxBitmap msCBitmapTimeDependent;
    static wxBitmap msCBitmapConstant;
    static wxBitmap msCBitmapTimeDisable;
    static wxBitmap msCBitmapVisible;
    static wxBitmap msCBitmapInvisible;
    static bool   mbInitialized;

    TimeLinePanel_cls *mpCTimeLine;
    BitmapPanel_cls *mpCBPanelTime;
    BitmapPanel_cls *mpCBPanelVisible;
    BitmapPanel_cls *mpCBPanelTimeDisable;
    wxButton *mpButtonLFT;
    wxButton *mpButtonRGT;
    wxCheckBox *mpCheckBoxKey;
    
    void HidePanel();
    
    void OnButtonToggleTime(wxCommandEvent& event);

    void OnButtonKeyLFT(wxCommandEvent& event);
    void OnButtonKeyRGT(wxCommandEvent& event);
    void OnCheckBoxKey(wxCommandEvent& event);
    void EmuCheckBox();

    void UpdateDisplay();

    bool IsKeyFrame(double doubleIndex);    

    void SetMemberSize(wxSize size);
    int  GetDeviceX(float x);

    int  mWidth, mHeight;
    int  mOffset;

    void OnPaint(wxPaintEvent& event);
    void OnKeyDown(wxKeyEvent& event);
    void OnMouseL(wxMouseEvent& event);
    void OnMouseR(wxMouseEvent& event);

    DECLARE_EVENT_TABLE()
};

#endif
