// "clsMarchingCube.cpp"
// (setq c-basic-offset 4)

#ifndef _ISOSURFACE_MARCHINGCUBE_H_
#define _ISOSURFACE_MARCHINGCUBE_H_

#include "../../MYGL/clsTextureProperty.h"
#include "../../MYGL/clsTextureMapping.h"

#ifdef WIN32
#include <windows.h>
#include <GL/glu.h>
#include <GL/glext.h>
#else
#define GL_GLEXT_PROTOTYPES 
#include <GL/glu.h>
#endif

#include <vector>
#include <wx/wx.h>
#include <wx/thread.h>

class ThreadExportMesh2PovSub : public wxThread {
 public:
    ThreadExportMesh2PovSub
	(wxString *pstrOut, unsigned int indexSize,
	 unsigned int polygonNumber,
	 std::vector < std::vector < unsigned int > > *pVVVertexIndicesOptFull,
	 std::vector < unsigned int > *pVvertexOffset);
    
    wxString *mpStrOut;
    unsigned int mIndexSize;
    unsigned int mPolygonNumber;
    std::vector < std::vector < unsigned int > > *mpVVVertexIndicesOptFull;
    std::vector < unsigned int > *mpVvertexOffset;

    virtual ExitCode Entry();
};

class MarchingCube_cls : public TextureMapping_cls {
 public:
    MarchingCube_cls();
    ~MarchingCube_cls();

    // f̃|Sf[^
    std::vector < float* > mVpVertices;
    std::vector < float* > mVpNormals;
    std::vector < bool > mVbOptimized;
    std::vector < int > mVAllocSize;
    std::vector < int > mVAllocSizeOrg;

    // yx̍œKꂽ|Sf[^
    std::vector < std::vector < float > > mVVVerticesOpt;
    std::vector < std::vector < float > > mVVNormalsOpt;
    std::vector < std::vector < float > > mVVUV1DOpt;
    std::vector < std::vector < unsigned int > > mVVVertexIndicesOpt;
    std::vector < bool > mVbOptimizedFull;
    std::vector < unsigned int > mVOptVertexNumOrg;
    bool mbMemoryReadyOpt;

    // tɍœKꂽ|Sf[^
    std::vector < std::vector < float > > mVVVerticesOptFull;
    std::vector < std::vector < float > > mVVNormalsOptFull;
    std::vector < std::vector < float > > mVVUV1DOptFull;
    std::vector < std::vector < unsigned int > > mVVVertexIndicesOptFull;
    bool mbMemoryReadyOptFull;

    int mSize[3];
    int mVerticesIndex;

    float mTargetValue, mTargetValue255;
    
    void Clear(int sizeZ);
    void ClearOpt();
    void ClearOptFull();
    unsigned int GetVertexNumber();
    unsigned int GetVertexNumberOpt();
    int   GetVertexNumberOptFull();
    float GetVertexDensity();
    float GetMaxVertexDensity(int layerFactor);

    bool ThreadControlMain(unsigned char *pData, int *pSkip,
			   int xLayerBase, int zLayerBase,
			   bool bUseSSE, int threadNum, const int layerFactor,
			   bool bOptimize, bool bPrecise);
    void ConstructVertices
	(unsigned char *pData, int sizeX, int sizeY, int sizeZ,
	 double zMin, double zMax,
	 bool bUseSSE, int threadNum, const int layerFactor,
	 bool bOptimize, bool bTrimEdge, bool bPrecise);

    void OptimizeVerticesMainBlock(int threadNum);
    void OptimizeVerticesMainBlockFull(int threadNum);
    void OptimizeVertices(int threadNum);
    void OptimizeVerticesFull(int threadNum);

    void MakeUV1D(float pos[3], float mapscale,
		  double offset[3], double scale[3]);

    void GLDraw(double center[3], double scale[3], bool bCullFace, 
		GLuint showType,
		TexProperty_cls *pCTexProp, int colorType);

    void GetStrWaveFrontObj(wxString *pstrOut, bool bOffset, bool bNormal);
    void GetStrPovMesh2(wxString *pstrOut, wxString strID, wxString strTag,
			bool bNormal);
}; 

#endif

