// -*- c -*- 
// (setq c-basic-offset 4)
// "clsPovPhotons.h"

#include "clsPovPhotons.h"

#include "../clsPovRay.h"
#include "../../../wxWidgetEnum.h"
#include "../../WIDGETCTRL/clsDialogEXKey.h"

#define ENDLWX wxT("\n")

void PovPhotons_cls::
SetToDefault(){
    mCConfList.Clear();
    mCConfList.Add(&mCType, wxT("PovPhotonsType="), L"0");
    mCConfList.Add(&mCCount, wxT("PovPhotonsCount="), L"20");
    mCConfList.Add(&mCMaxTrace, wxT("PovPhotonsMaxTrace="), L"5");
}

void PovPhotons_cls::
SetMNumPhotons(wxBoxSizer *pBoxSizer, wxWindow* pCParentPanel,
		      wxString *psWorkingDir){
    MultiNumericalInputsPanel_cls* pCurr = 
	wxDialogEXKey::InitializeMNumPanel(&mpCMNumPhotons, pCParentPanel);
    pCurr->AssignMinimizeButtonBoth(mpCBTNPhotons, btnPovPhotons,
				    _("[+]Photons Settings"));

    pCurr->mTextWidth     = -1;
    pCurr->mComboWidth = 108;

    wxString photonsType[2] =
	{_("No Photons"), _("Use Photons") };
    mIndexType = pCurr->CombinePointer
	(_GP_UNSIGNED_INT_LIST, &mCType.mBody,
	 _("Photon Mapping"), TRUE, 2, photonsType);

    int boxWidth = 2;
    mIndexCount = pCurr->CombinePointer
	(_GP_BOXSIZERHORIZONTAL, &boxWidth, _("photon (x1000)"));
    pCurr->CombinePointer(_GP_INTEGER_SLIDER, &mCCount.mBody);
    pCurr->SetRange(2, 2500);
    pCurr->CombinePointer(_GP_INTEGER_SPIN, &mCCount.mBody);
    pCurr->SetRange(2, 2500);

    mIndexMaxTrace = pCurr->CombinePointer
	(_GP_BOXSIZERHORIZONTAL, &boxWidth, wxT("max_trace_level"));
    pCurr->CombinePointer(_GP_INTEGER_SLIDER, &mCMaxTrace.mBody);
    pCurr->SetRange(2, 10);
    pCurr->CombinePointer(_GP_INTEGER_SPIN, &mCMaxTrace.mBody);
    pCurr->SetRange(2, 10);
    
#ifdef WIN32
    pCurr->mMinimumWidth = 320;
#else
    pCurr->mMinimumWidth = 340;
#endif
    pCurr->FinishSetting(pBoxSizer, FALSE);

    pCurr->SetFuncHook(&PovRay_cls::HookPhotons, _MN_HOOK_COMBOBOX);

    HideAndShow();
}

void PovPhotons_cls::
HideAndShow(){
    MultiNumericalInputsPanel_cls *pCurr = mpCMNumPhotons;
    bool bShow = (mCType.mBody > _POV_PHOTONS_NOUSE);

    pCurr->ShowItems(mIndexCount, 3, bShow);
    pCurr->ShowItems(mIndexMaxTrace, 3, bShow);
}

wxString PovPhotons_cls::
GetPovStrGlobal(){
    if (mCType.mBody == _POV_PHOTONS_NOUSE) return wxT("");
    wxString strPov;

    strPov << wxT("\tphotons {") << ENDLWX;
    strPov << wxT("\t\tcount ") << mCCount.mBody * 1000;
    strPov << wxT("\t\tautostop ") << 0;
    strPov << wxT("\t\tjitter ") << .4;
    strPov << wxT("\t\tmax_trace_level ") << mCMaxTrace.mBody;

    strPov << wxT("\t}") << ENDLWX;

    return strPov;
}

wxString PovPhotons_cls::
GetPovStrIni(){
    wxString strIni;
    return strIni;
}

wxString PovPhotons_cls::
GetPovStrPhotonSetting(double alpha, double reflectMin, double reflectMax,
		       bool bKillTarget){
    wxString strPhoton;
    if (mCType.mBody == _POV_PHOTONS_NOUSE) return strPhoton;
    wxString strTarget = wxT("target ");
    wxString strReflection = wxT("reflection ");
    wxString strRefraction = wxT("refraction ");
    wxString strCollect = wxT("collect ");

    if (alpha > 0.8) strRefraction << wxT("off ");
    else             strRefraction << wxT("on ");

    if (reflectMin < 0.1 && reflectMax < 0.2) strReflection << wxT("off ");
    else                                      strReflection << wxT("on ");

    if (bKillTarget) strTarget << wxT("off ");
    else {
	if (strRefraction == wxT("refraction off ") && 
	    strReflection == wxT("reflection off "))
	    strTarget << wxT("off ");
	else
	    strTarget << wxT("on ");
    }
    if (alpha < 0.1) strCollect << wxT("off ");
    else             strCollect << wxT("on ");

    strPhoton << wxT("\tphotons{ ") << strTarget << strReflection << strRefraction << strCollect << wxT("}") << ENDLWX;

    /*
    if (alpha > 0.8) // 0.8 ȏł͕sȂ̂targetɂȂ
	strPhoton << wxT("\tphotons{ reflection on refraction}") << ENDLWX;
    else if (alpha < 0.1) // 0.1 ȉłcollectȂ
	strPhoton << wxT("\tphotons{ target reflection on refraction on collect off}") << ENDLWX;
    else
	strPhoton << wxT("\tphotons{ target reflection on refraction on collect on}") << ENDLWX;
    */

    return strPhoton;
}

void PovPhotons_cls::
ReadStrLine(std::wstring strLine){
    mCConfList.ReadStrLineAll(strLine);
}

wxString PovPhotons_cls::
SerializeConf(){
    return mCConfList.SerializeAll();
}

