// -*- c -*- 
// (setq c-basic-offset 4)
// "clsPovRadiosity.h"

#include "clsPovRadiosity.h"

#include "../clsPovRay.h"
#include "../../../wxWidgetEnum.h"
#include "../../WIDGETCTRL/clsDialogEXKey.h"

#define ENDLWX wxT("\n")

PovRadiosity_cls::
PovRadiosity_cls(PovRay_cls *pCParent){
    mpCParent = pCParent;
    mstrListOnOff[0] = wxT("off");
    mstrListOnOff[1] = wxT("on");
}

void PovRadiosity_cls::
SetToDefault(){
    mCConfList.Clear();
    mCConfList.Add(&mCType, wxT("PovRadiosityType="), L"0");
    mCConfList.Add(&mCReuse, wxT("PovRadiosityReuse="), L"0");
    mCConfList.Add(&mCPathStr, wxT("PovRadiosityPathDir="), L"");
    mCConfList.Add(&mCRayCount, wxT("PovRadiosityCount="), L"35");
    mCConfList.Add(&mCError, wxT("PovRadiosityError="), L"1.8");
    mCConfList.Add(&mCMinimumReuse, wxT("PovRadiosityMinimumReuse="), L"0.015");
    mCConfList.Add(&mCRecursionLimit, wxT("PovRadiosityRecursionLimit="), L"3");
    mCConfList.Add(&mCNearestCount, wxT("PovRadiosityNearestCount="), L"5");
    mCConfList.Add(&mCTraceStart, wxT("PovRadiosityTraceStrat="), L"0.08");
    mCConfList.Add(&mCTraceEnd, wxT("PovRadiosityTraceEnd="), L"0.04");
    mCConfList.Add(&mCbZeroAmbient, wxT("PovRadiosityZeroAmbient="), L"1");
    mCConfList.Add(&mCbMedia, wxT("PovRadiosityMedia="), L"0");
    mCConfList.Add(&mCbNormal, wxT("PovRadiosityNormal="), L"1");
    mCConfList.Add(&mCHighReproducibility, wxT("PovRadHighReproduce="), L"0");
}

void PovRadiosity_cls::
SetMNumRadiosity(wxBoxSizer *pBoxSizer, wxWindow* pCParentPanel,
		      wxString *psWorkingDir){
    MultiNumericalInputsPanel_cls* pCurr = 
	wxDialogEXKey::InitializeMNumPanel(&mpCMNumRadiosity, pCParentPanel);
    pCurr->AssignMinimizeButtonBoth(mpCBTNRadiosity, btnPovRadiosity,
				    _("[+]Radiosity Settings"));

    pCurr->mTextWidth     = -1;
    pCurr->mComboWidth = 108;

    wxString radiosityType[3] =
	{_("No Radiosity (fast)"), _("Pretrace Only"),
	 _("Fully Trace")};
    mIndexType = pCurr->CombinePointer
	(_GP_UNSIGNED_INT_LIST, &mCType.mBody,
	 _("radiosity"), TRUE, 3, radiosityType);

    int boxWidth = 2;
    mIndexRecursionLimit = pCurr->CombinePointer
	(_GP_BOXSIZERHORIZONTAL, &boxWidth, wxT("recursion_limit"));
    pCurr->CombinePointer(_GP_INTEGER_SLIDER, &mCRecursionLimit.mBody);
    pCurr->SetRange(1, 20);
    pCurr->CombinePointer(_GP_INTEGER_SPIN, &mCRecursionLimit.mBody);
    pCurr->SetRange(1, 20);

    mIndexCount = pCurr->CombinePointer
	(_GP_BOXSIZERHORIZONTAL, &boxWidth, _("ray count"));
    pCurr->CombinePointer(_GP_INTEGER_SLIDER, &mCRayCount.mBody);
    pCurr->SetRange(35, 3200);
    pCurr->CombinePointer(_GP_INTEGER_SPIN, &mCRayCount.mBody);
    pCurr->SetRange(35, 3200);

    mIndexError = pCurr->CombinePointer
	(_GP_BOXSIZERHORIZONTAL, &boxWidth, _("error bound"));
    pCurr->CombinePointer(_GP_FLOAT_SLIDER, &mCError.mBody);
    pCurr->SetRange(1, 200, _MN_LASTITEM, 100);
    pCurr->CombinePointer(_GP_FLOAT, &mCError.mBody);

    mIndexMinReuse = pCurr->CombinePointer
	(_GP_BOXSIZERHORIZONTAL, &boxWidth, wxT("minimum_reuse"));
    pCurr->CombinePointer(_GP_FLOAT_SLIDER, &mCMinimumReuse.mBody);
    pCurr->SetRange(1, 30, _MN_LASTITEM, 1000);
    pCurr->CombinePointer(_GP_FLOAT, &mCMinimumReuse.mBody);

    mIndexNearestCount = pCurr->CombinePointer
	(_GP_BOXSIZERHORIZONTAL, &boxWidth, wxT("nearest_count"));
    pCurr->CombinePointer(_GP_INTEGER_SLIDER, &mCNearestCount.mBody);
    pCurr->SetRange(3, 20);
    pCurr->CombinePointer(_GP_INTEGER_SPIN, &mCNearestCount.mBody);
    pCurr->SetRange(3, 20);
    
    mIndexReproducibility = pCurr->CombinePointer
	(_GP_UNSIGNED_INT_LIST, &mCHighReproducibility.mBody,
	 wxT("High Reproducibility"), TRUE, 2, mstrListOnOff);

    mIndexTraceStartEnd = pCurr->CombinePointer
	(_GP_BOXSIZERHORIZONTAL, &boxWidth, _("Trace Start/End"));
    pCurr->CombinePointer(_GP_FLOAT, &mCTraceStart.mBody);
    pCurr->CombinePointer(_GP_FLOAT, &mCTraceEnd.mBody);
	
    boxWidth = 3;
    mIndexBoolOptions = pCurr->CombinePointer
	(_GP_BOXSIZERHORIZONTAL, &boxWidth, wxT(""));
    pCurr->CombinePointer
	(_GP_BOOL, &mCbZeroAmbient.mbBody, wxT("ambient off"));
    pCurr->CombinePointer
	(_GP_BOOL, &mCbMedia.mbBody, wxT("media on"));
    pCurr->CombinePointer
	(_GP_BOOL, &mCbNormal.mbBody, wxT("normal on"));

    wxString radiosityReuse[3] =
	{_("Not reuse pretrace"), _("Save Pretrace"),
	 _("Load Pretrace")};
    mIndexReuse = pCurr->CombinePointer
	(_GP_UNSIGNED_INT_LIST, &mCReuse.mBody,
	 _("reuse pretrace"), TRUE, 3, radiosityReuse);
    mIndexPath = pCurr->CombinePointer
	(_GP_WXSTRING_PATH, &mCPathStr.msBody, _("Cache File"), TRUE);
    
#ifdef WIN32
    pCurr->mMinimumWidth = 320;
#else
    pCurr->mMinimumWidth = 340;
#endif
    //pCurr->mProportion = 1;
    pCurr->FinishSetting(pBoxSizer, FALSE);

    pCurr->SetFuncHook(&PovRay_cls::HookRadiocity, _MN_HOOK_COMBOBOX);

    AtoWXSTextPathCtrl_cls* pSelector = (AtoWXSTextPathCtrl_cls*)pCurr->mVCPointers[mIndexPath].mpPointerCtrl;
    
    pSelector->mpstrDefaultDirLink = psWorkingDir;
    pSelector->mstrFilter = wxT("radiosity cache file(*.txt)|*.txt|all|*");
    pSelector->mstrDefaultFileName = wxT("radiosity.txt");
    pSelector->mStyle = wxFD_SAVE;
    HideAndShow();
}

void PovRadiosity_cls::
HideAndShow(){
    MultiNumericalInputsPanel_cls *pCurr = mpCMNumRadiosity;
    bool bShow = (mCType.mBody > _POV_RADIOSITY_NOUSE);

    pCurr->ShowItems(mIndexRecursionLimit, 3, bShow);
    pCurr->ShowItems(mIndexCount, 3, bShow);
    pCurr->ShowItems(mIndexError, 3, bShow);
    // Ƃ肠܂ׂݒ͉BĂ
    bool bTweak = (mpCParent->mCShowTweaks.mBody == 1);
    pCurr->ShowItems(mIndexMinReuse, 3, bTweak & bShow);
    pCurr->ShowItems(mIndexNearestCount, 3, bTweak & bShow);
    pCurr->ShowItems(mIndexReproducibility, 1, bTweak & bShow);
    
    pCurr->ShowItems(mIndexTraceStartEnd, 3, bShow);
    pCurr->ShowItems(mIndexBoolOptions, 4, bShow);
    pCurr->ShowItems(mIndexReuse, 1, bShow);

    bool bReuse = (mCReuse.mBody != 0);
    pCurr->ShowItems(mIndexPath, 1, bShow & bReuse);
}

bool PovRadiosity_cls::
IsRadiosityFormatOK(){
    if (mCType.mBody == 0) return TRUE;
    if (mCReuse.mBody == 0) return TRUE;
    
    if (mCPathStr.msBody == wxT("NONE")) return FALSE;

    switch (mCReuse.mBody){
    case 1: {
	SplitPathWX_cls CSplit(mCPathStr.msBody);
	wxFileName CTmpDir(CSplit.GetPathWXStr(_FN_DRIVE_DIR));
	printf("PathCheck= %ls\n", CSplit.GetPathWXStr(_FN_DRIVE_DIR).c_str());
	if (CTmpDir.IsDirWritable() == FALSE)
	    return FALSE; }
	break;
    case 2: {
	wxFileName CTmpFile(mCPathStr.msBody);
	if (CTmpFile.IsFileReadable() == FALSE)
	    return FALSE; }
	break;
    }
    return TRUE;
}

wxString PovRadiosity_cls::
GetPovStrGloabal(){
    if (mCType.mBody == 0) return wxT("");
    wxString strPov;

    strPov << wxT("\tradiosity {") << ENDLWX;
    if (mCType.mBody == 1)
	strPov << wxT("\t\talways_sample off") << ENDLWX;
    if (mCType.mBody == 2)
	strPov << wxT("\t\talways_sample on") << ENDLWX;
    
    strPov 
	<< wxT("\t\tpretrace_start ") << mCTraceStart.mBody << ENDLWX
	<< wxT("\t\tpretrace_end ") << mCTraceEnd.mBody << ENDLWX
	<< wxT("\t\tcount ") << mCRayCount.mBody << ENDLWX
	<< wxT("\t\tnearest_count ") << mCNearestCount.mBody << ENDLWX
	<< wxT("\t\terror_bound ") << mCError.mBody << ENDLWX
	<< wxT("\t\tminimum_reuse ") << mCMinimumReuse.mBody << ENDLWX
	<< wxT("\t\trecursion_limit ") << mCRecursionLimit.mBody << ENDLWX;
    
    if (mCbMedia.mbBody == TRUE)
	strPov << wxT("\t\tmedia on") << ENDLWX;
    if (mCbNormal.mbBody == TRUE)
	strPov << wxT("\t\tnormal on") << ENDLWX;

    /*
    if (mCReuse.mBody == 1)
	strPov << wxT("\t\tsave_file \"") << mCPathStr.msBody << wxT("\"") << ENDLWX;
    if (mCReuse.mBody == 2)
	strPov << wxT("\t\tload_file \"") << mCPathStr.msBody << wxT("\"") << ENDLWX;
    */
    
    strPov << wxT("\t}") << ENDLWX;
    if (mCbZeroAmbient.mbBody == TRUE)
	strPov << wxT("\tambient_light 0") << ENDLWX;

    return strPov;
}

wxString PovRadiosity_cls::
GetPovStrIni(){
    if (mCType.mBody == 0) return wxT("");
    wxString strIni;
    
    wxString strWorkingDir = mpCParent->GetWorkingDirWithSep(TRUE);
    wxString strPath = mCPathStr.msBody;
    if (mpCParent->mCbConfAbsolutePath.mbBody == FALSE)
	strPath.Replace(strWorkingDir, wxT("./"));
    
    if (mCReuse.mBody != 0 &&
	IsRadiosityFormatOK() == TRUE)
	strIni << wxT("Radiosity_File_Name=\"") << strPath << wxT("\"") << ENDLWX;
    if (mCReuse.mBody == 1)
	strIni << wxT("Radiosity_To_File=on") << ENDLWX;
    if (mCReuse.mBody == 2)
	strIni << wxT("Radiosity_From_File=on") << ENDLWX;

    if (mCType.mBody != 0)
	strIni << wxT("Radiosity_Vain_Pretrace=off") << ENDLWX
	       << wxT("High_Reproducibility=") << mstrListOnOff[mCHighReproducibility.mBody] << ENDLWX; 
    
    return strIni;
}

void PovRadiosity_cls::
ReadStrLine(std::wstring strLine){
    mCConfList.ReadStrLineAll(strLine);
}

wxString PovRadiosity_cls::
SerializeConf(){
    return mCConfList.SerializeAll();
}
