
#ifndef _POV_RADIOSITY_H_
#define _POV_RADIOSITY_H_

#include "../../COMMON/clsFilename.h"
#include "../../CONFITEM/clsConfItem.h"
#include "../../WIDGETCTRL/clsMultiNumericalInputs.h"
#include "../../WIDGETCTRL/EX/clsButtonEX.h"
#include "../../WIDGETCTRL/clsAtoWXSTextCtrl.h"

#include <wx/filename.h>

#define _POV_RADIOSITY_NOUSE 0
#define _POV_RADIOSITY_PRETRACE 1
#define _POV_RADIOSITY_FULL 2

class PovRay_cls;

class PovRadiosity_cls{
 public:
    PovRadiosity_cls(PovRay_cls *pCParent);

    void SetToDefault();

    PovRay_cls *mpCParent;

    wxButtonEX *mpCBTNRadiosity;
    MultiNumericalInputsPanel_cls* mpCMNumRadiosity;
    void SetMNumRadiosity(wxBoxSizer *pBoxSizer, wxWindow *pCParentPanel,
			  wxString *pstrWorkingDir);

    void HideAndShow();

    wxString mstrListOnOff[2];
    int  mIndexType, mIndexCount, mIndexError;
    int  mIndexMinReuse, mIndexNearestCount;
    int  mIndexRecursionLimit;
    int  mIndexBoolOptions; 
    int  mIndexReuse, mIndexPath;
    int  mIndexTraceStartEnd;
    int  mIndexReproducibility;

    bool IsRadiosityFormatOK();
    wxString GetPovStrGloabal();
    wxString GetPovStrIni();

    ConfItemList_cls      mCConfList;
    ConfItemUINT_cls      mCType, mCReuse;
    ConfItemSTR_cls       mCPathStr;
    ConfItemINT_cls       mCRayCount, mCNearestCount, mCRecursionLimit;
    ConfItemFLOAT_cls     mCError, mCTraceStart, mCTraceEnd;
    ConfItemFLOAT_cls     mCMinimumReuse;
    ConfItemBOOL_cls      mCbZeroAmbient, mCbMedia, mCbNormal;
    ConfItemUINT_cls      mCHighReproducibility;

    void ReadStrLine(std::wstring strLine);
    wxString SerializeConf();
};

#endif
