// "clsPovObjectWavefront.h"
// (setq c-basic-offset 4)

#include "clsPovObjectWavefront.h"

#include "../../../wxWidgetString.h"

#define X 0
#define Y 1
#define Z 2

#define ENDLWX wxT("\n")

wxString Wavefront_cls::
GetMesh2Format(wxString strTag, bool bNormal, 
	       std::vector < float > *pVVertices,
	       std::vector < float > *pVNormals,
	       std::vector < unsigned int > *pVIndices){
    wxString strMesh2;
    
    strMesh2 << wxT("//Mesh2file generated by ") << _FRAME_MAIN_APPNAME << ENDLWX;
    strMesh2 << wxT("//normal_start_at=");
    int posNormalTag = strMesh2.Len();
    strMesh2 << wxT("##########") << ENDLWX;

    strMesh2 << wxT("//index_start_at=");
    int posIndexTag = strMesh2.Len();
    strMesh2 << wxT("##########") << ENDLWX;

    int verticesSize = pVVertices->size();
    int verticesNum = verticesSize / 3;

    strMesh2 << wxT("#declare ") << wxT("MESH2OBJ_") << strTag << wxT("=mesh2{") << ENDLWX
	     << wxT("\tvertex_vectors{") << ENDLWX
	     << wxT("\t\t") << verticesNum << wxT (",") << ENDLWX;
    float *pVertex = &((*pVVertices)[0]);
    for (size_t v = 0; v < verticesNum; v++){
	char buf [64];
	if (v % 3 == 0 && v == verticesNum - 1)
	    sprintf(buf, "\t\t<%0.5f,%0.5f,%0.5f>,\n",
		    *(pVertex + v*3 + X),
		    *(pVertex + v*3 + Y),
		    *(pVertex + v*3 + Z));
	else if (v % 3 == 2)
	    sprintf(buf, "<%0.5f,%0.5f,%0.5f>,\n",
		    *(pVertex + v*3 + X),
		    *(pVertex + v*3 + Y),
		    *(pVertex + v*3 + Z));
	else if (v % 3 == 0)
	    sprintf(buf, "\t\t<%0.5f,%0.5f,%0.5f>,",
		    *(pVertex + v*3 + X),
		    *(pVertex + v*3 + Y),
		    *(pVertex + v*3 + Z));
	else
	    sprintf(buf, "<%0.5f,%0.5f,%0.5f>,",
		    *(pVertex + v*3 + X),
		    *(pVertex + v*3 + Y),
		    *(pVertex + v*3 + Z));
	/*
	strMesh2 << 
	    wxString::Format(wxT("\t\t<%0.5f,%0.5f,%0.5f>,"),
			     *(pVertex + v + X),
			     *(pVertex + v + Y),
			     *(pVertex + v + Z)) << ENDLWX;
			     */
	strMesh2 << wxString::From8BitData(buf);
    }
    strMesh2 << wxT("\t}") << ENDLWX;

    if (bNormal == TRUE){
	int normalSize = pVNormals->size();
	int normalNum = normalSize / 3;
	strMesh2 << wxT("\tnormal_vectors{") << ENDLWX
		 << wxT("\t\t") << normalNum << wxT (",") 
		 << ENDLWX;
	float *pNormal = &((*pVNormals)[0]);
	for (size_t n = 0; n < normalNum; n++){
	    char buf[64];
	    if (n % 3 == 0 && n == normalNum - 1)
		sprintf(buf, "\t\t<%0.3f,%0.3f,%0.3f>,\n",
			*(pNormal + n*3 + X),
			*(pNormal + n*3 + Y),
			*(pNormal + n*3 + Z));
	    else if (n % 3 == 2)
		sprintf(buf, "<%0.3f,%0.3f,%0.3f>,\n",
			*(pNormal + n*3 + X),
			*(pNormal + n*3 + Y),
			*(pNormal + n*3 + Z));
	    else if (n % 3 == 0)
		sprintf(buf, "\t\t<%0.3f,%0.3f,%0.3f>,",
			*(pNormal + n*3 + X),
			*(pNormal + n*3 + Y),
			*(pNormal + n*3 + Z));
	    else
		sprintf(buf, "<%0.3f,%0.3f,%0.3f>,",
			*(pNormal + n*3 + X),
			*(pNormal + n*3 + Y),
			*(pNormal + n*3 + Z));
	    /*
	    strMesh2 << 
		wxString::Format(wxT("\t\t<%0.3f,%0.3f,%0.3f>,"),
				 *(pNormal + n + X),
				 *(pNormal + n + Y),
				 *(pNormal + n + Z)) << ENDLWX;
				 */
	    strMesh2 << wxString::From8BitData(buf);
	}
	strMesh2 << wxT("\t}") << ENDLWX;
    }

    int faceSize = pVIndices->size();
    int faceNum = faceSize / 3;
    strMesh2 << wxT("\tface_indices{") << ENDLWX
	     << wxT("\t\t") << faceSize / 3 << wxT (",") 
	     << ENDLWX;
    unsigned *pFace = &((*pVIndices)[0]);
    for (size_t i = 0; i < faceNum; i++){
	if (i % 4 == 0) strMesh2 << wxT("\t\t");
	strMesh2 << wxT("<")
		 << *(pFace + i*3 + X) << wxT(",")
		 << *(pFace + i*3 + Y) << wxT(",")
		 << *(pFace + i*3 + Z) << wxT(">")
		 << wxT(",");
	if (i % 4 == 3 || i == faceNum-1) strMesh2 << ENDLWX;
    }
    strMesh2 << wxT("\t}") << ENDLWX
	     << wxT("}") << ENDLWX;
    
    
    return strMesh2;
}
