
#include "clsHexagon.h"

#define X 0
#define Y 1
#define Z 2

#include <math.h>

double Hexagon_cls::
GetSimpleCasePattern(int iz){
    if (iz < 0) iz+=6;
    switch(iz){
    case 0:         return 0.01;
    case 1: case 2: return 0.5;
    case 3: case 4: return 0.99;
    case 5:         return 0.01;
    }
    return 0;
}

double Hexagon_cls::
GetComplicatePattern(int iz, double lx, double lz){
    if (iz < 0) iz+=6;
    if (lx < 0) lx+=1;
    if (lz < 0) lz+=1;
    switch(iz){
    case 0: return (lx < 1.0 - lz) ? 0.01 : 0.99;
    case 1: return (lx < lz) ? 0.5 : 0.99;
    case 2: return (lx < 1.0 - lz) ? 0.5 : 0.01;
    case 3: return (lx < lz) ? 0.99 : 0.01;
    case 4: return (lx < 1.0 - lz) ? 0.99 : 0.5;
    case 5: return (lx < lz) ? 0.01 : 0.5;
    }
    return 0;
}

double Hexagon_cls::
GetPattern(double pos[3]){
    double x = pos[X];
    double z = pos[Z];
    
    // Ŋe_iq̏ɂ̂Ĉ₷ȂB
    x *= 2;
    z /= 0.866025404; 
    
    x = fabs(x); // xΏ̂ɂ

    int ix = (int)floor(x) % 6;
    switch (ix){
    case 0: case 5: {
	int iz = (int)floor(z) % 6;
	return GetSimpleCasePattern(iz); }
    case 2: case 3: {
	int iz = ( (int)floor(z) + 3 ) % 6;
	return GetSimpleCasePattern(iz); }
    case 1: {
	int iz = (int)floor(z) % 6;
	return GetComplicatePattern(iz, fmod(x, 1), fmod(z, 1)); }
    case 4: {
	int iz = ( (int)floor(z) + 3 ) % 6;
	return GetComplicatePattern(iz, fmod(x, 1), fmod(z, 1)); }
    }
}
		    
		    
