//(setq c-basic-offset 4)

#include "pattern.h"
#include "texture.h"

#include <math.h>

#define X 0
#define Y 1
#define Z 2 

DBL agate_pattern_MOD (const VECTOR EPoint, const TURB *Turb, int noise_generator){
    register DBL noise, turb_val;
    //const TURB* Turb;
    //Turb=Search_For_Turb(TPat->Warps);
    
    //turb_val = TPat->Vals.Agate_Turb_Scale * Turbulence(EPoint,Turb,noise_generator);
    turb_val = Turb->Turbulence[X] * Turbulence(EPoint,Turb,noise_generator);
    
    noise = 0.5 * (cycloidal(1.3 * turb_val + 1.1 * EPoint[Z]) + 1.0);
    
    if (noise < 0.0) noise = 0.0; 
    else {	
	noise = min(0.996, noise);
	noise = pow(noise, 0.77);
    }
    
    return(noise);
}

DBL granite_pattern (const VECTOR EPoint, int noise_generator)
{
    register int i;
    register DBL temp, noise = 0.0, freq = 1.0;
    VECTOR tv1,tv2;

    VScale(tv1,EPoint,4.0);

    for (i = 0; i < 6 ; freq *= 2.0, i++) {
	    VScale(tv2,tv1,freq);
	    if(noise_generator==1) {
		    temp = 0.5 - Noise (tv2, noise_generator);
		    temp = fabs(temp);
		}
	    else {
		    temp = 1.0 - 2.0 * Noise (tv2, noise_generator);
		    temp = fabs(temp);
		    if (temp>0.5) temp=0.5;
		}

	    noise += temp / freq;
	}

    return(noise);
}
