
#ifndef _POV_STREAM_LINE_H_
#define _POV_STREAM_LINE_H_

#include "../clsPovSerialize.h"
#include "../../COMMON/clsMultiThreadCtrl.h"
#include "../../CONFITEM/clsConfItem.h"
#include "../../DF3/clsDF3SeqCtrl.h"
#include "../../DF3/clsDF3Sequence.h"
#include "../../DF3/GL/clsColoring.h"
#include "../../FILTER/clsFilterBase.h"
#include "../../FILTER/clsFilterWithParameter.h"
#include "../../FILTER/clsFilterWithTexture.h"
#include "../../MYGL/clsTextureMapping.h"

#include "clsPovVelocityCommon.h"

class PovStreamLine_cls;
class DrawingBlock_cls;

#include <fstream>
#include <string.h>

class ThreadPovoutStream : public MultiThreadThread_cls, public PovSerialize_cls{
 public:
    ThreadPovoutStream(wxThreadKind kind, PovStreamLine_cls *pCParent);
    void SetParameters(int currentFrame, int currMaxFrame,
		       int clrType, double *pScale,
		       int lineNumber, unsigned int *pIndexForDraw,
		       float **ppPos, float *pColorCurvePov, float width,
		       bool bInside, wxString *pstrTarget);
    
    PovStreamLine_cls *mpCParent;
    int mCurrentFrame, mCurrMaxFrame;
    int mClrType, mLineNumber;
    double *mpScale;
    unsigned int *mpIndexForDraw;
    float **mppPos;
    float *mpColorCurvePov;
    float mWidth;
    bool mbInside;
    wxString *mpstrTarget;
    
    void PushBackStreamLineElements0
	(wxString *pstrTgt, 
	 float *pPos0, float *pPos1, wxString strWidth, bool bFinish = FALSE);
    void PushBackStreamLineElements0Intersect
	(wxString *pstrTgt, 
	 float *pPos0, float *pPos1, wxString strWidth, bool bFinish = FALSE);
    void PushBackStreamLineElements1
	(wxString *pstrTgt,
	 float *pPos0, float *pPos1, float *pClr, wxString strWidth, 
	 bool bFinish = FALSE);
    void PushBackStreamLineElements1Intersect
	(wxString *pstrTgt,
	 float *pPos0, float *pPos1, float *pClr, wxString strWidth,
	 wxString strScaleBox, bool bFinish = FALSE);

    int  CheckWithinBox(float pos0[3], float pos1[3],
			float width, float oneMinusWidth, float onePlusWidth);
    void PushBackSingleStreamLine
	(wxString *pstrTgt,
	 float *pPos, float *pClr, int clrType, float width,
	 int currentFrame, double scale[3]);

    virtual ExitCode Entry();
};

class ThreadPovoutPoint : public MultiThreadThread_cls, public PovSerialize_cls{
 public:
    ThreadPovoutPoint(wxThreadKind kind, PovStreamLine_cls *pCParent);
    void SetParameters(int currentFrame, int currMaxFrame,
		       int lineNumber, int lineIni, double *pScale,
		       float **ppPos, unsigned char *pDensity,
		       int sizeX, int sizeY, int sizeZ,
		       float pointSize, double *pCamPosLocal,
		       wxString *pstrTarget);

    PovStreamLine_cls *mpCParent;
    int mCurrentFrame, mCurrMaxFrame;
    int mLineNumber, mLineIni;
    double *mpScale;
    float **mppPos;
    double *mpCamPos;
    unsigned char *mpDensity;
    int mSizeX, mSizeY, mSizeZ;
    float mPointSize;
    wxString *mpstrTarget;
    
    bool CheckWithinBoxPoint(float pos[3]);
    virtual ExitCode Entry();
};

class ThreadConstructStream : public MultiThreadThread_cls, public PovVelocityCommonInterp_cls {
 public:
    ThreadConstructStream(wxThreadKind kind, PovStreamLine_cls *pCParent);

    void SetParameters
	(int initIndex, int finIndex,
	 unsigned char *pFieldX, unsigned char *pFieldY, unsigned char *pFieldZ,
	 float *pInitPosX, float *pInitPosY, float *pInitPosZ,
	 std::vector < float* > VpStreamPos);
    
    /*
    float GetInterpolatedValue(const unsigned char *pData,
			       const int lBaseIndex,
			       const float fx, const float fy, const float fz);
    */
    void FollowField(float initX, float initY, float initZ,
		     float *pStream, 
		     unsigned char *pX, unsigned char *pY, unsigned char *pZ);
    //void FollowFieldCtrl();

    virtual ExitCode Entry();

    int mInitIndex, mFinIndex;
    unsigned char *mpFieldX, *mpFieldY, *mpFieldZ;
    float *mpInitPosX, *mpInitPosY, *mpInitPosZ;
    //float *mpRandTable;
    //float **mppStreamPos;
    std::vector < float* > mVpStreamPos;
    int mSizeX, mSizeY, mSizeZ;
    //int mOffsetZ, mOffsetY;
    float mStepFactorX, mStepFactorY, mStepFactorZ;
    int mCurrMaxFrame;
};

class PovStreamLineGUI_cls : public PovVelocityGUICommon_cls, public FilterWithTextureGUI_cls {
    MACRO_DefGUIMainSettings(PovStreamLine);
    MACRO_DefVirtualCustmFunctions;

    void ConstructStreamLine();
    void SelectColor();
    void SetVxVyVz();
    
    int mIndexPointNum, mIndexPointColor;
    int mIndexLength, mIndexStepFactor;
    wxString mListType[_CLR_CUSTOM];

    static void  FuncHookHideItem(void *pArg, void *pEvent);
};

class PovStreamLineData_cls : public PovVelocityDataCommon_cls, public FilterWithParameterData_cls, public FilterWithTextureData_cls {
 public:
    PovStreamLineData_cls(FilterCtrl_cls* pCCtrl,
			  bool bConnectToStaticParam = TRUE);

    // |C^ĊmۂňړȂ悤ɂB(UNDO݂ł܂)
    // *todo _MAX_ITEM_NUMBERɂ鏈
    static std::vector < Parameters_cls > msVCParam[_DF3_MAX_SLOT];
    static std::vector < bool > msVbParamUsed[_DF3_MAX_SLOT];
    static void InitializeStaticMember(int df3index);
    Parameters_cls* GetPParamActive();

    // UndoŁẢ\Parameter̊mۂSɕKvȂȂJB
    // !! Complete Me !!
    static void GarbageCollect();
    
    void ReDefineList();
    
    ConfItemFLOAT_cls mCPointSize;
    ConfItemFLOAT_cls mCLineWidthIn;//, mCLineWidthOut;
    ConfItemBOOL_cls mCbShowPoints;
    ConfItemINT_cls  mCPointNumber, mCClrStep;
    ConfItemFLOATARRAY_cls mCPointColor;
    ConfItemUINT_cls mCLineIntensityIn;//, mCLineIntensityOut;
    ConfItemUINT_cls mCRandom, mCAnimation, mCPointType;
    ConfItemINT_cls mCLength, mCSkip, mCInitAnim;
    ConfItemFLOAT_cls mCStepFactor;
    ConfItemINTARRAY_cls mCLineNumber;

    void MakeFilterInstanceAndAddToList
	(int index, FilterCtrl_cls *pCParentCtrl);
    wxString SerializeConfPolymorph();
    void ReadStrLinePolymorph(std::wistream &istream, std::wstring strLine);
};

class PovStreamLine_cls : public PovVelocityCommon_cls, public FilterWithParameter_cls, public TextureMapping_cls, public MultiThreadCtrl_cls {
 public:
    PovStreamLine_cls(FilterCtrl_cls *pCParentCtrl,
		      PovStreamLineData_cls* pCInitData = NULL);
    ~PovStreamLine_cls();
    
    // ---
    virtual void AddFilterItemPolymorph(wxBoxSizer *pBoxSizer, FilterPanels_cls *pCFilterPanels, unsigned int index);
    static void InitializeStaticMember(int df3index);
    PovStreamLineData_cls* GetPCData();
    // ----

    void SetMNumAdvanced(wxWindow *pCParentWindow);
    void AdvancedSetting();
    void UpdateColors();

    //static double msAlpha;
    //int mSizeX, mSizeY, mSizeZ;
    int mOffsetY, mOffsetZ;
    int mLineSkipIn, mLineSkipInPrev;
    bool mbNewStream;
    double mMinRootPrev[3], mMaxRootPrev[3];
    std::vector < float* > mVpPosition;
    std::vector < unsigned int > mVIndexForDrawIn;
    float *mpColorCurve, *mpColorCurvePov;
    float *mpInitPosX, *mpInitPosY, *mpInitPosZ;
    float *mpRandTable;
    bool mbColorCurveAllocated;
    void Allocate(int maxFrame, int linePerAxis[3], int clrStep);
    int  mCurrMaxFrame, mCurrLineNumber, mCurrClrStep;
    int  mCurrLinePerAxis[3];
    static int  msAIndexList[_DF3_SEQ_MAX];
    
    void ConstructInitPosition();
    void ConstructStreamLine();

    void MakeIndexForDraw(double min[3], double max[3]);
    void DrawLinesMonoColorA(int maxFrame);
    void DrawLinesColorCurveA(int currentFrame, int maxFrame);
    void DrawBox(int currentFrame);
    bool DoesUseMapping();
    void MakeUV1D(TexProperty_cls *pCTexProp,
		  double offset[3], double scale[3]); 

    // --

    //wxString GetPovStrPeriodicOffset();
    wxString GetPovStrStreamLineTex(wxString strTag);

    void MakeColorCurvePov(int clrType, int currentFrame);
    void GetPovStrStreamLines
	(std::wfstream &ofstream,
	 wxString strTag, wxString strGeometry, 
	 int currentFrame, DrawingBlock_cls *pCDrawingBlock);

    // -- 

    wxString GetFilterStatusStr();
    wxString SerializeConf();
    static PovStreamLineData_cls*
	GetNewPReadDataBlock(FilterCtrl_cls* pCCtrl,
			     std::wistream &istream);
};

#endif
