// "clsPovStreamLine.h"
// (setq c-basic-offset 4)

#include "clsPovVelocityCommon.h"

#include "../../WIDGETCTRL/clsMultiNumericalInputs.h"

#define ENDLWX wxT("\n")
#define ENDL L"\n"

float PovVelocityCommonInterp_cls::
GetInterpolatedValue(const unsigned char *pData,
		     const int lBaseIndex,
		     const float fx, const float fy, const float fz){
    register const unsigned int lOffsetZ(mOffsetZ);
    register const unsigned int lOffsetY(mOffsetY);
    
    const float P000(pData[lBaseIndex]);
    const float P001(pData[lBaseIndex+1]);
    const float P010(pData[lBaseIndex+lOffsetY]);
    const float P011(pData[lBaseIndex+lOffsetY+1]);
    const float P100(pData[lBaseIndex+lOffsetZ]); 
    const float P101(pData[lBaseIndex+lOffsetZ+1]);
    const float P110(pData[lBaseIndex+lOffsetZ+lOffsetY]);
    const float P111(pData[lBaseIndex+lOffsetZ+lOffsetY+1]);
    
    return  
	(1.0f-fz) * ( (1.0f-fy) * ((1.0f-fx)*P000 + fx*P001)  +
		      fy        * ((1.0f-fx)*P010 + fx*P011)) +
	fz        * ( (1.0f-fy) * ((1.0f-fx)*P100 + fx*P101)  +
		      fy        * ((1.0f-fx)*P110 + fx*P111));
}

// -----

PovVelocityGUICommon_cls::
PovVelocityGUICommon_cls(){
    mpCDataCommon = NULL; // pŃZbgB
    mpCMNumCustomA = NULL;
}

void PovVelocityGUICommon_cls::
SetMNumCustomA(wxWindow *pCParentWindow){
    mpCMNumCustomA = new MultiNumericalInputs_cls
	(&mpCMNumCustomA, pCParentWindow, wxID_ANY, wxT("VxVyVz Setting"),
	 wxDefaultPosition, wxDefaultSize);

    MultiNumericalInputs_cls* pCurr = mpCMNumCustomA;
    pCurr->SetDefaultButtonType(_MN_OK_CANCEL_DEFAULT);
    pCurr->mTextWidth = -1;

    wxString dataList[4] = { _("DataSlot0"), _("DataSlot1"), _("DataSlot2"), _("DataSlot3")};
    
    pCurr->CombinePointer(_GP_UNSIGNED_INT_LIST, &mpCDataCommon->mCCompX.mBody,
			  _("Comp X"), TRUE, 4, dataList);
    pCurr->CombinePointer(_GP_UNSIGNED_INT_LIST, &mpCDataCommon->mCCompY.mBody,
			  _("Comp Y"), TRUE, 4, dataList);
    pCurr->CombinePointer(_GP_UNSIGNED_INT_LIST, &mpCDataCommon->mCCompZ.mBody,
			  _("Comp Z"), TRUE, 4, dataList);
    
    pCurr->FinishSettingDLG(FALSE);
    pCurr->SetScreenRectPos(&mCRectMNumCustomA);
}

// ----

wxString PovVelocityCommon_cls::
GetPovStrPeriodicOffset(){
    // E炭 1boxel̍ŴAŏIIɂǂc
    wxString strOffset;
    strOffset << wxConvFile.cWX2WC
	(PovOut3(wxT("\tscale"), 
		 (float)mSizeX/(mSizeX-1),
		 (float)mSizeY/(mSizeY-1),
		 (float)mSizeZ/(mSizeZ-1))) << ENDLWX;
    return strOffset;
}
