
#ifndef _POV_VELOCITY_FIELD_H_
#define _POV_VELOCITY_FIELD_H_

#include "../clsPovSerialize.h"
#include "../../CONFITEM/clsConfItem.h"
#include "../../DF3/clsDF3SeqCtrl.h"
#include "../../DF3/clsDF3Sequence.h"
#include "../../DF3/GL/clsColoring.h"
#include "../../FILTER/clsFilterBase.h"
#include "../../FILTER/clsFilterWithParameter.h"
#include "../../FILTER/clsFilterWithTexture.h"
#include "../../MYGL/clsTextureMapping.h"

#include "clsPovVelocityCommon.h"

class PovVelField_cls;
class DrawingBlock_cls;

#include <fstream>
#include <string.h>

class PovVelFieldGUI_cls : public PovVelocityGUICommon_cls, public FilterWithTextureGUI_cls {
    MACRO_DefGUIMainSettings(PovVelField);
    MACRO_DefVirtualCustmFunctions;

    void SelectColor();
    void SetVxVyVz();

    static void  FuncHookHideItem(void *pArg, void *pEvent);
};

class PovVelFieldData_cls : public PovVelocityDataCommon_cls, public FilterWithParameterData_cls, public FilterWithTextureData_cls {
 public:
    PovVelFieldData_cls(FilterCtrl_cls* pCCtrl,
			     bool bConnectToStaticParam = TRUE);

    // |C^ĊmۂňړȂ悤ɂB(UNDO݂ł܂)
    // *todo _MAX_ITEM_NUMBERɂ鏈
    static std::vector < Parameters_cls > msVCParam[_DF3_MAX_SLOT];
    static std::vector < bool > msVbParamUsed[_DF3_MAX_SLOT];
    static void InitializeStaticMember(int df3index);
    Parameters_cls* GetPParamActive();

    // UndoŁẢ\Parameter̊mۂSɕKvȂȂJB
    // !! Complete Me !!
    static void GarbageCollect();
    
    void ReDefineList();
    
    ConfItemFLOAT_cls mCArrowWidth, mCArrowLength, mCArrowHeadSize;
    ConfItemINTARRAY_cls mCArrowNumber;

    void MakeFilterInstanceAndAddToList
	(int index, FilterCtrl_cls *pCParentCtrl);
    wxString SerializeConfPolymorph();
    void ReadStrLinePolymorph(std::wistream &istream, std::wstring strLine);
};

class PovVelField_cls : public FilterWithParameter_cls, public TextureMapping_cls, public PovVelocityCommon_cls, public PovVelocityCommonInterp_cls {
 public:
    PovVelField_cls(FilterCtrl_cls *pCParentCtrl,
			 PovVelFieldData_cls* pCInitData = NULL);
    ~PovVelField_cls();

    // ---
    virtual void AddFilterItemPolymorph(wxBoxSizer *pBoxSizer, FilterPanels_cls *pCFilterPanels, unsigned int index);
    static void InitializeStaticMember(int df3index);
    PovVelFieldData_cls* GetPCData();
    // ----

    void SetMNumAdvanced(wxWindow *pCParentWindow);
    void AdvancedSetting();
    void UpdateColors();

    int mSize[3];

    bool DoesUseMapping();
    void MakeUV1D(TexProperty_cls *pCTexProp,
		  double offset[3], double scale[3]); 

    // --
    wxString GetPovStrVelFieldTex(wxString strTag);
    void     GetPovStrVelocityField
	(std::wfstream &ofstream,
	 wxString strTag, wxString strGeometry, 
	 int currentFrame, DrawingBlock_cls *pCDrawingBlock);

    void DrawArrows();
    void DrawBox();

    // -- 

    wxString GetFilterStatusStr();
    wxString SerializeConf();
    static PovVelFieldData_cls*
	GetNewPReadDataBlock(FilterCtrl_cls* pCCtrl,
			     std::wistream &istream);
};

#endif
