// -*- c -*-
// "clsCheckTreeFile.h"

#include "clsCheckTreeFile.h"
#include "../../GlobalConstants.h"

#include <stdlib.h>
#include <wx/wx.h>

#ifndef TRUE
#define TRUE true
#define FALSE false
#endif

//#include "SRC/MYAPI/MsgBox.h"

FileItem_cls::
FileItem_cls() :
    mDepth(0),
    mpChilds(NULL),
    mVstrFilePath(_DF3_MAX_SLOT)
{
    mIsFileExist = _FILE_UNCHECKED;
}

FileItem_cls::
~FileItem_cls(){
    if (mpChilds != NULL) delete [] mpChilds;
    mpChilds = NULL;
}

void FileItem_cls::
MakeChilds(){
    mpChilds = new FileItem_cls[8];
    for (int i = 0; i < 8; i++)
	mpChilds[i].mDepth = mDepth + 1;
}

bool FileItem_cls::
IsFileExist(std::vector < wxString > VstrFile, 
	    std::wstring strTreePath, wxString strDataSlot){
    //MsgBoxf(NULL, "!!", "%s\n%s", strFile.c_str(), strTreePath.c_str());
    
    // $B?F$N;~(B "0"
    if (strTreePath.size() == 1){
	for (int df3index = 0; df3index < _DF3_MAX_SLOT; df3index++){
	    if (VstrFile[df3index] != mVstrFilePath[df3index]) mIsFileExist = _FILE_UNCHECKED;
	}
	
	if (mIsFileExist == _FILE_EXIST) return TRUE;
	if (mIsFileExist == _FILE_NOTEXIST) return FALSE;

	bool bAllFileExist = TRUE;
	
	for (int df3index = 0; df3index < _DF3_MAX_SLOT; df3index++){
	    if (VstrFile[df3index] == wxT("")) continue;
	    wxString strIndex; strIndex << df3index;
	    if (strDataSlot.Matches(strIndex) == FALSE) continue;
#ifdef WIN32
	    //FILE *fp = _wfopen(strFile.c_str(), L"rb");
	    FILE *fp = _wfopen(VstrFile[df3index].c_str(), L"rb");
#else
	    //wxString wxFile = wxConvFile.cWC2WX(strFile.c_str());
	    //FILE *fp = fopen(wxFile.ToAscii(), "rb");
	    FILE *fp = fopen(VstrFile[df3index].ToAscii(), "rb");
#endif
	
	    if (fp == NULL) 
		//mIsFileExist = _FILE_NOTEXIST;
		bAllFileExist = FALSE;
	    /*
	    else
		mIsFileExist = _FILE_EXIST;
	    */
	    if (fp != NULL) fclose(fp);

	    mVstrFilePath[df3index] = VstrFile[df3index];
	}
	
	if (bAllFileExist == FALSE)
	    mIsFileExist = _FILE_NOTEXIST;
	else
	    mIsFileExist = _FILE_EXIST;
	
	if (mIsFileExist == _FILE_EXIST) return TRUE;
	return FALSE;
    }

#ifdef WIN32
    unsigned int childIndex = _wtoi(strTreePath.substr(1, 1).c_str());
#else
    wxString wxChildIndex = wxConvFile.cWC2WX(strTreePath.substr(1, 1).c_str());
    unsigned int childIndex = atoi(wxChildIndex.ToAscii());
#endif
    if (mpChilds == NULL) MakeChilds();
    return mpChilds[childIndex].IsFileExist(VstrFile, strTreePath.substr(1), strDataSlot);
}

//----

CheckTreeFile_cls::
CheckTreeFile_cls() : 
mpCRoot(NULL){
}

CheckTreeFile_cls::
~CheckTreeFile_cls(){
    ClearTree();
}

void CheckTreeFile_cls::
ClearTree(){
    if (mpCRoot != NULL) delete mpCRoot;
    mpCRoot = NULL;
}

bool CheckTreeFile_cls::
IsFileExist(std::vector < wxString > VstrFilePath, std::wstring strTreePath,
	    wxString strDataSlot){
    if (mpCRoot == NULL) mpCRoot = new FileItem_cls;
    return mpCRoot->IsFileExist(VstrFilePath, strTreePath, strDataSlot);
}
