// "clsPovCrossSection.h"
// (setq c-basic-offset 4)

#include "clsPovCrossSection.h"

#include "clsPovRay.h"

#include "../DF3/clsDF3SeqGUI.h"
#include "../DF3/clsDF3SeqCtrl.h"
#include "../DF3/clsDF3Sequence.h"
#include "../DF3/GL/clsPreviewProperty.h"
#include "../DF3/GL/clsColoring.h"
extern Coloring_cls GCColoring;
#include "../FILTER/clsFilterCtrl.h"
#include "../FILTER/clsClipping.h"
#include "../GLOBJ/GLOBJTransCube.h"
#include "../GRAPHIC/clsImageIO.h"
extern ImageIO_cls GCImgIO;
#include "../MAINCANVAS/clsPreference.h"
#include "../MAINCANVAS/clsPreviewPanel.h"
#include "../MYAPI/MsgBox.h"
#include "../WIDGETCTRL/clsMultiNumericalInputs.h"
#include "../WIDGETCTRL/clsAtoiComboCtrl.h"
#include "../WIDGETCTRL/EX/clsCheckBoxEX.h"
#include "../WIDGETCTRL/EX/clsStaticTextEX.h"
#include "../../wxWidgetEnum.h"

#include <wx/wx.h>
#include <wx/file.h>

#include <GL/glu.h>
#include <wx/colordlg.h>
#include <wx/stopwatch.h>

#include <sstream>

extern int GTestVariableInt;
extern bool GbGLLockForMultithread;

#define X 0
#define Y 1
#define Z 2
#define LOOP_XYZ for (int xyz = 0; xyz < 3; xyz++)
#define R 0
#define G 1
#define B 2
#define A 3
#define LOOP_RGB for (int rgb = 0; rgb < 3; rgb++)
#define LOOP_RGBA for (int rgba = 0; rgba < 4; rgba++)
#define ENDLWX wxT("\n")

#ifdef _DEBUG
#include <stdlib.h>
#include <crtdbg.h>
#define new new(_NORMAL_BLOCK, __FILE__, __LINE__)
#endif

PovCrossSectionGUI_cls::
PovCrossSectionGUI_cls(PovCrossSection_cls *pCParent) : 
    FilterWithTextureGUI_cls(pCParent) 
{
    mpCParent = pCParent;
    mFilterType = pCParent->mFilterType;
}

void PovCrossSectionGUI_cls::
SetMNumPanel(wxBoxSizer *pBoxSizer, wxWindow *pCParentWindow, 
	     unsigned int index){
    PovCrossSectionData_cls *pCData = mpCParent->GetPCData();
    MultiNumericalInputsPanel_cls* pCurr = InitializeMNumPanel(pCParentWindow);
    
    pCurr->mTextWidth = 65;
    int boxWidth = 2;

     pCurr->mItemWidth = -1;
#ifdef WIN32
     //pCurr->mComboWidth = 108;
#else
    pCurr->mComboWidth = 98;
#endif
   
    pCurr->CombinePointer(_GP_BOXSIZERHORIZONTAL, &boxWidth, wxT(""));
    
    wxString listColor[1] = { wxT("Use Texture") };
    mIndexColorType = pCurr->CombinePointer
	(_GP_UNSIGNED_INT_LIST, &pCData->mCTexProperty.mCColorType.mBody,
	 wxT(""), TRUE, 1, listColor);
    
    InitializeColorPanel(pCurr, this, &GetColorR, &GetColorG, &GetColorB,
			 _("Texture"));
    mIndexColorBar = pCurr->CombinePointer(_GP_WXPANEL, mpCPanelColorBar);

    // lݒ肵Ă
    pCData->GetPInterpolated()[_C_SECTION_LAYER] = 0.5;
    pCData->GetPInterpolated()[_C_SECTION_ALPHA] = 1;
    pCData->GetPInterpolated()[_C_SECTION_CRIT] = 0;

#ifdef WIN32
    //pCurr->mComboWidth = 65;
#else
    pCurr->mComboWidth = 55;
#endif

    boxWidth = 3;
    pCurr->CombinePointer(_GP_BOXSIZERHORIZONTAL, &boxWidth, wxT(""));
    wxString listAxis[3] = { wxT("x axis"), wxT("y aixs"), wxT("z axis") };
    pCurr->CombinePointer(_GP_UNSIGNED_INT_LIST, &pCData->mCAxis.mBody,
			  wxT("Axis"), TRUE, 3, listAxis);
    mIndexLayer = pCurr->CombinePointer
	(_GP_DOUBLE_SLIDER, &pCData->GetPInterpolated()[_C_SECTION_LAYER]);
    pCurr->SetRange(0, 100, _MN_LASTITEM, 1);
    pCurr->CombinePointer(_GP_DOUBLE, 
			  &pCData->GetPInterpolated()[_C_SECTION_LAYER]);
    pCurr->SetRange(0, 100, _MN_LASTITEM, 1);

    boxWidth = 2;
    pCurr->CombinePointer(_GP_BOXSIZERHORIZONTAL, &boxWidth, 
			  _("Emboss"));
    pCurr->CombinePointer(_GP_DOUBLE_SLIDER, 
			  &pCData->GetPInterpolated()[_C_SECTION_EMBOSS]);
    pCurr->SetRange(-400, 400, _MN_LASTITEM, 100);
    pCurr->CombinePointer(_GP_DOUBLE, &pCData->GetPInterpolated()[_C_SECTION_EMBOSS]);
    pCurr->SetRange(-400, 400, _MN_LASTITEM, 100);

    mIndexCrit = pCurr->CombinePointer(_GP_BOXSIZERHORIZONTAL, &boxWidth, 
				       _("ClipBy Val."));
    pCurr->CombinePointer(_GP_DOUBLE_SLIDER, 
			  &pCData->GetPInterpolated()[_C_SECTION_CRIT]);
    pCurr->SetRange(0, 100, _MN_LASTITEM, 100);
    pCurr->CombinePointer(_GP_DOUBLE, &pCData->GetPInterpolated()[_C_SECTION_CRIT]);
    
    wxString listClip[3] = { wxT("No Clip"), wxT("Clipping +"), wxT("Clipping -") };
    pCurr->CombinePointer(_GP_UNSIGNED_INT_LIST, &pCData->mCCliping.mBody,
			  wxT("Clipping"), TRUE, 3, listClip);
    
    pCurr->mItemWidth = -1;

    pCurr->FinishSetting(pBoxSizer, FALSE, index);
   
    UpdateColorList();
    pCurr->SetFuncHook(&FilterCtrl_cls::FuncHookAssign, _MN_HOOK_ASSIGN);
    pCurr->SetFuncHook(&FilterCtrl_cls::FuncHookRefreshTop, _MN_HOOK_ASSIGN);
    pCurr->SetFuncHook(&FilterWithTextureGUI_cls::FuncHookUpdateTextureDLG,
		       _MN_HOOK_COMBOBOX_CHANGE);
    pCurr->SetFuncHook(&FuncHookOpenTextureDLG, _MN_HOOK_PANELCLICK);
    pCurr->SetFuncHook(&FilterCtrl_cls::FuncHookChanged, _MN_HOOK_CHANGE);

    HideAndShowItems();
}

MACRO_SetCustomFunctions(PovCrossSectionGUI_cls,,,);

void PovCrossSectionGUI_cls::
HideAndShowItems(){
    mpCMNumPanel->ShowItems(mIndexCrit, 3, mpCParent->GetPCData()->mCbTransNullRegion.mbBody);

    mpCParent->mpCParentCtrl->mpCFilterPanelsLink->UpdatePanelLayout();
}

void PovCrossSectionGUI_cls::
SetLayerIndexRange(int max){
    MultiNumericalInputsPanel_cls* pCurr = mpCMNumPanel;

    pCurr->SetRange(0, max-1, mIndexLayer, 1);
    pCurr->SetRange(0, max-1, mIndexLayer+1, 1);
    pCurr->mVCPointers[mIndexLayer].ApplyRange();
    pCurr->mVCPointers[mIndexLayer+1].ApplyRange();
}

// ----------

PovCrossSectionData_cls::
PovCrossSectionData_cls(FilterCtrl_cls* pCCtrl,
			bool bConnectToStaticParam) :
FilterWithParameterData_cls(pCCtrl)
{
    ReDefineList();
    mCConfList.mbSetWithInitValue = FALSE;
    
    double initParam[4] = {0, 1, 1, 0};    
    Parameters_cls CParam(sizeof(initParam)/sizeof(double), L"CrossSection");
    CParam.ExecCommandInitSet(initParam);
    
    // !! todo !! _MAX_PARAMETER_NUMBER 𒴂̏
    if (bConnectToStaticParam == TRUE){
	mParamNumber = -1;
	for (size_t i = 0; i < msVbParamUsed[mpCCtrl->mSelfDF3Index].size(); i++)
	    if (msVbParamUsed[mpCCtrl->mSelfDF3Index][i] == FALSE){
		mParamNumber = (int)i;
		msVCParam[mpCCtrl->mSelfDF3Index][mParamNumber].CopyFromP(&CParam);
		msVbParamUsed[mpCCtrl->mSelfDF3Index][mParamNumber] = TRUE;
		i = _MAX_PARAMETER_NUMBER;
	    }
	if (mParamNumber == -1){
	    mParamNumber = (int)msVbParamUsed[mpCCtrl->mSelfDF3Index].size();
	    msVCParam[mpCCtrl->mSelfDF3Index].push_back(CParam);
	    msVbParamUsed[mpCCtrl->mSelfDF3Index].push_back(TRUE);
	}
    }
}

void PovCrossSectionData_cls::
ReDefineList(){
    FilterData_cls::ReDefineListBase();
    mCConfList.Add(&mCAxis,        wxT("CrossSectionAxis="),  L"2");
    mCConfList.Add(&mCCliping,     wxT("CrossSectionClipping="), L"0");
    mCConfList.Add(&mCbShade,      wxT("CrossSectionShade="), L"1");
    mCConfList.Add(&mCbTransNullRegion, wxT("CrossSectionTransNull="), L"0");
    mCConfList.Add(&mCbSmooth,     wxT("CrossSectionSmooth="), L"1");
    mCConfList.Add(&mCbPostSceneCommand, wxT("CrossSectionPostScene="), L"1");
    mCConfList.Add(&mCbDrawFrame,  wxT("CrossSectionDrawFrame="), L"1");
    
    mCTexProperty.mCConfList.mbSetWithInitValue = mCConfList.mbSetWithInitValue;
    mCTexProperty.ReDefineList();
}

MACRO_MakeInstanceAndAddToList(PovCrossSection)

wxString PovCrossSectionData_cls::
SerializeConfPolymorph(){
    return mCTexProperty.Serialize() + msVCParam[mpCCtrl->mSelfDF3Index][mParamNumber].Serialize();
}

void PovCrossSectionData_cls::
ReadStrLinePolymorph(std::wistream &istream, std::wstring strLine){
    mCTexProperty.ReadStrLine(strLine);
    msVCParam[mpCCtrl->mSelfDF3Index][mParamNumber].ReadStrLine(istream, strLine);
}

void PovCrossSectionData_cls::
InitializeStaticMember(int df3index){
    msVCParam[df3index].reserve(_MAX_PARAMETER_NUMBER);
    msVbParamUsed[df3index].reserve(_MAX_PARAMETER_NUMBER);
}

Parameters_cls* PovCrossSectionData_cls::
GetPParamActive(){
    return &msVCParam[mpCCtrl->mSelfDF3Index][mParamNumber];
}

std::vector < Parameters_cls > PovCrossSectionData_cls::msVCParam[_DF3_MAX_SLOT];
std::vector < bool > PovCrossSectionData_cls::msVbParamUsed[_DF3_MAX_SLOT];

// ----------

#include "../MYAPI/MsgBox.h"

PovCrossSection_cls::
PovCrossSection_cls(FilterCtrl_cls *pCParentCtrl, PovCrossSectionData_cls *pCInitData) :
    PovCrossSectionCommon_cls(pCParentCtrl)
{
    mpCData = new PovCrossSectionData_cls(pCParentCtrl, (pCInitData == NULL));
    if (pCInitData != NULL) *(PovCrossSectionData_cls*)mpCData = *pCInitData;

    TexProperty_cls *pCTexProp = &GetPCData()->mCTexProperty;
    if (msbConstructedFromMenu == TRUE){
	if (GCColoring.mpCCustomColor->mCItemNum.mBody > 0)
	    pCTexProp->mCColorType.mBody = 1;
    }
    
    pCTexProp->LinkFilterParameter(this, _C_SECTION_ALPHA);
    
    ConstructorCommon(pCParentCtrl, _("Cross-section"), _FILTER_CROSS_SECTION);

    mpCGUIPanel = new PovCrossSectionGUI_cls(this);
    //mTimeIndex = -1;
    mAllocU = mAllocV = -1;
    mAllocArrayV = mAllocArrayUm = -1;
    mTexId = -1;
    mColorRefreshId = -1;
}

PovCrossSection_cls::
~PovCrossSection_cls(){
    if (FilterWithTextureGUI_cls::mspCLinkTexpropertyCtrl->mpCConnected == &((PovCrossSectionData_cls*)mpCData)->mCTexProperty)
	FilterWithTextureGUI_cls::mspCLinkTexpropertyCtrl->ConnectProperty(NULL, wxT("No Item is Linked"));
    if (mspCDF3SeqGUI != NULL)
	mspCDF3SeqGUI->mpCPanelList->Remove(mstrLabel);

    if (mTexId != -1)
	glDeleteTextures(1, &mTexId);

    if (mAllocArrayV != -1 || mAllocArrayUm != -1){
	delete [] mpTexture;
	delete [] mpNormals;
	delete [] mpVertices;
	delete [] mpPolyIndices;
    }
}

MACRO_AddFilterItemPolymorphP(PovCrossSection,RefreshTop());
MACRO_InitializeStaticMemberP(PovCrossSection);
MACRO_GetPCData(PovCrossSection);

//--

void PovCrossSection_cls::
SetMNumAdvanced(wxWindow *pCParentWindow){
    MultiNumericalInputs_cls* pDLG = 
	wxDialogEXKey::InitializeMNumDLG(&mpCMNumAdvanced, pCParentWindow, wxT("Advanced Setting"));

    pDLG->mTextWidth = 160;
    pDLG->CombinePointer(_GP_BOOL, &GetPCData()->mCbShade.mbBody,
			  _("shade in clrmap"));
    pDLG->CombinePointer(_GP_BOOL, &GetPCData()->mCbTransNullRegion.mbBody,
			  _("ClipBy Val."));
    pDLG->CombinePointer(_GP_BOOL, &GetPCData()->mCbSmooth.mbBody,
			  wxT("smooth"));
    pDLG->CombinePointer(_GP_BOOL, &GetPCData()->mCbDrawFrame.mbBody,
			  _("Draw Frame"));
    int indexRM = pDLG->CombinePointer(_GP_BOOL, &GetPCData()->mCbPostSceneCommand.mbBody,
					wxT("Auto remove tmpfile"));
    pDLG->FinishSettingDLG(FALSE);

    pDLG->mVCPointers[indexRM].GetPCtrlWindow()->SetToolTip(wxT("Works at pov-ray 3.6 LINUX only. [Shellout Security] must be allowed in povray.conf."));

    //pDLG->SetScreenRectPos(&msCRectMNumStaticMembers);
}

void PovCrossSection_cls::
AdvancedSetting(){
    AdvancedSettingCommon();
    MakeTexture1D(GetPCData()->mCTexProperty.mCColorType.mBody, FALSE);
    FilterCtrl_cls::FuncHookRefreshTop(mpCGUIPanel->mpCMNumPanel, NULL);
    mpCGUIPanel->HideAndShowItems();
}

void PovCrossSection_cls::
UpdateColors(){
    ((PovCrossSectionGUI_cls*)mpCGUIPanel)->UpdateColorList();
}

bool PovCrossSection_cls::
IsReprocessRequired(){
    if (mpCData->mCbValid.mbBody == FALSE) return FALSE;
    return FALSE;
}

double PovCrossSection_cls::
GetPos(int axis, double minmax){
    if (((PovCrossSectionData_cls*)mpCData)->mCAxis.mBody != axis) return minmax;
    double pos;
    double offset;
    if (minmax == 0.0001) offset = +0.001; // EdȂȂ߂
    if (minmax == 0.9999) offset = -0.001;
    switch (axis){
    case X:
	pos = mpCData->GetPInterpolated()[_C_SECTION_LAYER] / mSizeX + offset;
	break;
    case Y:
	pos = mpCData->GetPInterpolated()[_C_SECTION_LAYER] / mSizeY + offset;
	break;
    case Z:
	pos = mpCData->GetPInterpolated()[_C_SECTION_LAYER] / mSizeZ + offset;
	break;
    }
    return pos;
}

void PovCrossSection_cls::
RefreshFilter(unsigned char *pData){
    if (mpCParentCtrl->mpCDF3SeqParent->GetPDF3()->IsAllocated() == FALSE)
	return;

    int dataSlotIndex = mpCParentCtrl->mpCDF3SeqParent->mSelfIndex;
    if (pData == NULL)
	pData = mpCParentCtrl->mpCDF3SeqParent->GetPDF3()->mpMainXYZ[Z];
    
    int sizeX = mspCDF3SeqCtrlLink->GetCurrentSizeOf1Data(X, dataSlotIndex);
    int sizeY = mspCDF3SeqCtrlLink->GetCurrentSizeOf1Data(Y, dataSlotIndex);
    int sizeZ = mspCDF3SeqCtrlLink->GetCurrentSizeOf1Data(Z, dataSlotIndex);

    double emboss = GetEmboss();

    /*
    double min[3] = {0, 0 ,0}, max[3] = {1, 1, 1};
    GetClippingInformation(min, max);
    */

    bool bChanged = mpCParentCtrl->IsReprocessRequired
	(GetRemappedIndex(), GetRemappedIndexDouble(), this);

    mSizeX = sizeX; mSizeY = sizeY; mSizeZ = sizeZ;
    if (bChanged == TRUE)
	switch(((PovCrossSectionData_cls*)mpCData)->mCAxis.mBody){
	case 0:
	    ConstructVerticesX(pData, emboss); break;
	case 1:
	    ConstructVerticesY(pData, emboss); break;
	case Z:
	    ConstructVerticesZ(pData, emboss); break;
	}
    
    mColorType = GetPCData()->mCTexProperty.mCColorType.mBody;
}

void PovCrossSection_cls::
ClearCrossSection(){
    // xNg̃xNg̓fXgNgĂc͂
    mVVField.clear();
    mVVNormalU.clear(); mVVNormalV.clear(); mVVNormalW.clear();
}

void PovCrossSection_cls::
AllocCrossSection(int sizeU, int sizeV){
    
    mScalePrev[0][X] = mScalePrev[0][Y] = mScalePrev[0][Z] = 1;

    if (mAllocU == sizeU && mAllocV == sizeV) return;

    mAllocU = sizeU; 
    mAllocV = sizeV;
    ClearCrossSection();

    mVVField.reserve(sizeV); mVVField.resize(sizeV);
    mVVNormalU.reserve(sizeV); mVVNormalU.resize(sizeV); 
    mVVNormalV.reserve(sizeV); mVVNormalV.resize(sizeV); 
    mVVNormalW.reserve(sizeV); mVVNormalW.resize(sizeV);

    for (unsigned int v = 0; v < mVVField.size(); v++){
	mVVField[v].reserve(sizeU); mVVField[v].resize(sizeU);
	mVVNormalU[v].reserve(sizeU); mVVNormalU[v].resize(sizeU);
	mVVNormalV[v].reserve(sizeU); mVVNormalV[v].resize(sizeU);
	mVVNormalW[v].reserve(sizeU); mVVNormalW[v].resize(sizeU);
    }
}

void PovCrossSection_cls::
ConstructVerticesX(unsigned char *pData, double emboss){
    AllocCrossSection(mSizeY, mSizeZ);
    ((PovCrossSectionGUI_cls*)mpCGUIPanel)->SetLayerIndexRange(mSizeX);
    
    ConstructVerticesCoreX(pData, mpCData->GetPInterpolated()[_C_SECTION_LAYER],
			   &mVVField);
    CalcNormal
	(&mVVField, &mVVNormalU, &mVVNormalV, &mVVNormalW,
	 mSizeY, mSizeZ, emboss, TRUE);
}    

void PovCrossSection_cls::
ConstructVerticesY(unsigned char *pData, double emboss){
    AllocCrossSection(mSizeX, mSizeZ);
    
    ((PovCrossSectionGUI_cls*)mpCGUIPanel)->SetLayerIndexRange(mSizeY);

    ConstructVerticesCoreY(pData, mpCData->GetPInterpolated()[_C_SECTION_LAYER],
			   &mVVField);
    CalcNormal
	(&mVVField, &mVVNormalU, &mVVNormalV, &mVVNormalW,
	 mSizeX, mSizeZ, emboss);
}

void PovCrossSection_cls::
ConstructVerticesZ(unsigned char *pData, double emboss){
    AllocCrossSection(mSizeX, mSizeY);
    
    ((PovCrossSectionGUI_cls*)mpCGUIPanel)->SetLayerIndexRange(mSizeZ);
    ConstructVerticesCoreZ(pData, mpCData->GetPInterpolated()[_C_SECTION_LAYER],
			   &mVVField);
    double enhance = mpCData->GetPInterpolated()[_C_SECTION_EMBOSS];
    PovCrossSectionCommon_cls::CalcNormal
	(&mVVField, &mVVNormalU, &mVVNormalV, &mVVNormalW,
	 mSizeX, mSizeY, emboss, TRUE);
}

/*
void PovCrossSection_cls::
CalcNormal(int sizeU, int sizeV, bool bInvert){
    GbGLLockForMultithread = TRUE;

    // ܂SȊO
    int lv = 0;
    unsigned char *pVFieldLine = &((mVVField)[lv][0]);
    unsigned char *pVFieldLineP = &((mVVField)[lv+1][0]);
    double *pVNormalLineU = &((mVVNormalU)[lv][0]);
    double *pVNormalLineV = &((mVVNormalV)[lv][0]);
    for (int u = 1; u < sizeU-1; u++){
	pVNormalLineU[u] = (double)(pVFieldLine[u+1] - pVFieldLine[u-1]) / 2;
	pVNormalLineV[u] = (double)(pVFieldLineP[u] - pVFieldLine[u]);
    }
    
    lv = sizeV - 1;
    pVFieldLine = &((mVVField)[lv][0]);
    unsigned char *pVFieldLineM = &((mVVField)[lv-1][0]);
    pVNormalLineU = &((mVVNormalU)[lv][0]);
    pVNormalLineV = &((mVVNormalV)[lv][0]);
    for (int u = 1; u < sizeU-1; u++){
	pVNormalLineU[u] = (double)(pVFieldLine[u+1] - pVFieldLine[u-1]) / 2;
	pVNormalLineU[u] = (double)(pVFieldLine[u] - pVFieldLineM[u]);
    }

    int lu = 0; lv = 0;
    mVVNormalU[lv][lu] = (double)(mVVField[lv][lu+1] - mVVField[lv][lu]);
    mVVNormalV[lv][lu] = (double)(mVVField[lv+1][lu] - mVVField[lv][lu]);
    
    lu = sizeU-1; lv = 0;
    mVVNormalU[lv][lu] = (double)(mVVField[lv][lu] - mVVField[lv][lu-1]);
    mVVNormalV[lv][lu] = (double)(mVVField[lv+1][lu] - mVVField[lv][lu]);

    lu = 0; lv = sizeV-1;
    mVVNormalU[lv][lu] = (double)(mVVField[lv][lu+1] - mVVField[lv][lu]);
    mVVNormalV[lv][lu] = (double)(mVVField[lv][lu] - mVVField[lv-1][lu]);

    lu = sizeU-1; lv = sizeV-1;
    mVVNormalU[lv][lu] = (double)(mVVField[lv][lu] - mVVField[lv][lu-1]);
    mVVNormalV[lv][lu] = (double)(mVVField[lv][lu] - mVVField[lv-1][lu]);

    double enhance = mpCData->GetPInterpolated()[_C_SECTION_EMBOSS];
    double enhanceU = enhance * sizeU / 4096;
    double enhanceV = enhance * sizeV / 4096;

    // S}`Xbh
    ThreadCalcNormal *pThread[_MAX_THREAD_NUM];
    int threadNum = mspCPreferenceLink->GetThreadNumFilter();

    int lineStep = 64;

    for (int lineBase = 1; lineBase < sizeV-1; lineBase += threadNum * lineStep){
	for (int thread = 0; thread < threadNum; thread++){
	    int lineIni = lineBase + thread * lineStep;
	    int lineFin = lineBase + thread * lineStep + lineStep;
	    if (lineIni > (int)sizeV-2) continue;
	    if (lineFin > (int)sizeV-1) lineFin = sizeV-1;

	    pThread[thread] = new ThreadCalcNormal;
	    pThread[thread]->SetParameters
		(&mVVField, &mVVNormalU, &mVVNormalV, &mVVNormalW,
		 sizeU, lineIni, lineFin, enhanceU, enhanceV);
	}

	for (int thread = 0; thread < threadNum; thread++){
	    int lineIni = lineBase + thread * lineStep;
	    if (lineIni > (int)sizeV-2) continue;
	    pThread[thread]->Run();
	}
	    
	for (int thread = 0; thread < threadNum; thread++){
	    int lineIni = lineBase + thread * lineStep;
	    if (lineIni > (int)sizeV-2) continue;
	    pThread[thread]->Wait();
	}

	for (int thread = 0; thread < threadNum; thread++){
	    int lineIni = lineBase + thread * lineStep;
	    if (lineIni > (int)sizeV-2) continue;
	    delete pThread[thread];
	}

    }
	    
    GbGLLockForMultithread = FALSE;

    // ŌɎc
    int v = 0;
    for (int u = 0; u < sizeU; u++){
	mVVNormalU[v][u] *= - enhanceU; mVVNormalV[v][u] *= - enhanceV;
	double scale = sqrt( mVVNormalU[v][u]* mVVNormalU[v][u] +
			     mVVNormalV[v][u]* mVVNormalV[v][u] + 1);
	mVVNormalW[v][u] = 1.0 / scale;
	mVVNormalU[v][u] *= mVVNormalW[v][u];
	mVVNormalV[v][u] *= mVVNormalW[v][u];
    }

    v = sizeV - 1;
    for (int u = 0; u < sizeU; u++){
	mVVNormalU[v][u] *= - enhanceU;	mVVNormalV[v][u] *= - enhanceV;
	double scale = sqrt( mVVNormalU[v][u]* mVVNormalU[v][u] +
			     mVVNormalV[v][u]* mVVNormalV[v][u] + 1);
	mVVNormalW[v][u] = 1.0 / scale;
	mVVNormalU[v][u] *= mVVNormalW[v][u];
	mVVNormalV[v][u] *= mVVNormalW[v][u];
    }

    // FIX_ME!!
    // x,y,zɂčlȂɍ̂ŁA
    // x,y ̎ɔ]ȂƂȂB
    // Best::{璼A
    // Better::SvZtɂŷƂ]ɂƏ}V
    if (bInvert == TRUE)
	for (int v = 0; v < sizeV; v++)
	    for (int u = 0; u < sizeU; u++){
		mVVNormalU[v][u] *= -1;
		mVVNormalV[v][u] *= -1;
		mVVNormalW[v][u] *= -1;
	    }
}

*/

/*
void PovCrossSection_cls::
RecalcNorm(double scale[3], int sizeU, int sizeV,
	   int axisU, int axisV, int axisW){
    if (scale[X] == mScalePrev[X] && 
	scale[Y] == mScalePrev[Y] && 
	scale[Z] == mScalePrev[Z]) return;
    
    double lScale[3], lScalePrev[3];
    LOOP_XYZ lScale[xyz] = scale[xyz];
    LOOP_XYZ lScalePrev[xyz] = mScalePrev[xyz];
    LOOP_XYZ if (lScale[xyz] < 0) lScale[xyz] *= -1;
    LOOP_XYZ if (lScalePrev[xyz]< 0) lScalePrev[xyz] *= -1;
    
    for (int v = 0; v < sizeV; v++)
	for (int u = 0; u < sizeU; u++){
	    mVVNormalU[v][u] *= lScale[axisU] / mScalePrev[axisU];
	    mVVNormalV[v][u] *= lScale[axisV] / mScalePrev[axisV];
	    mVVNormalW[v][u] *= lScale[axisW] / mScalePrev[axisW];
	}
    
    LOOP_XYZ mScalePrev[xyz] = scale[xyz];
}
*/

void PovCrossSection_cls::
SettingForDrawFrame(){
    glDisable(GL_CLIP_PLANE0);
    glDisable(GL_TEXTURE_1D);
    glDisable(GL_LIGHTING);
    glColor4f(0.3, 0.7, 0.3, 1);
}

double PovCrossSection_cls::
GetEmboss(){
    double emboss = mpCData->GetPInterpolated()[_C_SECTION_EMBOSS];
    // clip̊֌W0͑ʖ
    if (emboss > -0.004 && emboss < 0.004) emboss = 0.004;
    return emboss;
}

double PovCrossSection_cls::
GetCritOffset(){
    double critoffset;
    if (GetPCData()->mCbTransNullRegion.mbBody == TRUE){
	double crit = mpCData->GetPInterpolated()[_C_SECTION_CRIT];
	if (crit == 0) crit = 0.004;
	critoffset = crit;
    }
    return critoffset;
}

void PovCrossSection_cls::
AllocArray(int sizeV, int sizeUm){
    if (mAllocArrayV == sizeV && mAllocArrayUm == sizeUm) return;

    if (mAllocArrayV != -1 || mAllocArrayUm != -1){
	delete [] mpTexture;
	delete [] mpNormals;
	delete [] mpVertices;
	delete [] mpPolyIndices;
    }

    mpTexture = new float [ sizeV * sizeUm ];
    mpNormals = new float [ sizeV * sizeUm * 3];
    mpVertices = new float [ sizeV * sizeUm * 3];
    mpPolyIndices = new unsigned int [ sizeUm * 2];
    
    mAllocArrayV = sizeV;
    mAllocArrayUm = sizeUm;
}

#define MACRO_DECLAREPOINTERS				\
    float *pTexture = mpTexture;			\
    float *pNormals = mpNormals;			\
    float *pVertices = mpVertices;			\
    unsigned int *pPolyIndices = mpPolyIndices;

#define MACRO_DECLAREPOINTERS_B(axis, AXIS)		\
    const double co##AXIS = (double) axis / size##AXIS;		\
    double *pVNormalLineU = &(mVVNormalU[axis][0]);	\
    double *pVNormalLineV = &(mVVNormalV[axis][0]);	\
    double *pVNormalLineW = &(mVVNormalW[axis][0]);		\
    const unsigned char *pVFieldLine = &(mVVField[axis][0]);

#define MACRO_SETARRAYS(nX, nY, nZ, coX,coY,coZ)	\
    pNormals[index * 3 + X] = *pVNormalLine##nX++;\
    pNormals[index * 3 + Y] = *pVNormalLine##nY++;\
    pNormals[index * 3 + Z] = *pVNormalLine##nZ++;\
    pVertices[index * 3 + X] = coX;\
    pVertices[index * 3 + Y] = coY;\
    pVertices[index * 3 + Z] = coZ;

// FIX_ME!! VertexArrayg܂킷dg݂ꂽB

void PovCrossSection_cls::
DrawFieldX(double scale[3], int mappingType, int patternType, 
	   int colorType, int mappingCoord, double emboss){
    RecalcNorm(&mVVNormalU, &mVVNormalV, &mVVNormalW,
	       scale, mSizeY, mSizeZ, 0, Y, Z, X);

    double x = mpCData->GetPInterpolated()[_C_SECTION_LAYER];
    double coXorg = x / mSizeX, coX = x / mSizeX;
    
    double critoffset = 0;
    if (GetPCData()->mCbTransNullRegion.mbBody == TRUE){
	double PlaneEqXmax[4] = {0, 0, 0, 0};
	critoffset = GetCritOffset() * emboss / 16;
	if (emboss > 0){
	    PlaneEqXmax[X] = +1.0; PlaneEqXmax[3] = -coX; }
	else{
	    PlaneEqXmax[X] = -1.0; PlaneEqXmax[3] = +coX; }
	glClipPlane(GL_CLIP_PLANE0, PlaneEqXmax);
	glEnable(GL_CLIP_PLANE0);
    }
    coX -= critoffset;

    const double embossfactor = emboss / 4096;
    const int sizeZ = mSizeZ, sizeZm = mSizeZ-1;
    const int sizeY = mSizeY, sizeYm = mSizeY-1;
    
    AllocArray(sizeZ, sizeYm);
    MACRO_DECLAREPOINTERS;
    
    int   index = 0;
    for (int z = 0; z < sizeZ; z++){
	const double coZ0 = (double) z / sizeZ;
	const unsigned char *pVFieldLine = &(mVVField[z][0]);
	if (colorType != 0){
	    if (mappingType == _TEX_MAPPING_VALUE)
		for (int y = 0; y < sizeYm; y++){
		    pTexture[index] = (float)pVFieldLine[y]/256;
		    index++;
		}
	    else
		if (mappingCoord == _MAPPING_GLOBAL){
		    for (int y = 0; y < sizeYm; y++){
			double coXemb  = coX + embossfactor * pVFieldLine[y];
			double coY = (double) y / sizeY;
			float globPos[3];
			float localPos[3] = {coXemb, coY, coZ0};
			GetGlobalPos(globPos, localPos);
			pTexture[index] = (float)GetMappingValueGlobal(globPos);
			index++;
		    }
		}
		else {
		    for (int y = 0; y < sizeYm; y++){
			double coXemb  = coX + embossfactor * pVFieldLine[y];
			double coY = (double) y / sizeY;
			float localPos0[3] = {coXemb, coY, coZ0};
			pTexture[index] = (float)GetMappingValueGlobal(localPos0); // CHECK_ME!!
			index++;
		    }
		}
	}
    }

    index = 0;
    for (int z = 0; z < sizeZ; z++){
	MACRO_DECLAREPOINTERS_B(z,Z);
	for (int y = 0; y < sizeYm; y++){
	    double coXemb  = coX + embossfactor*pVFieldLine[y];
	    double coY = (double) y / sizeY;
	    MACRO_SETARRAYS(W, U, V, coXemb, coY, coZ);
	    index++;
	}
    }
    
    DrawVertexArray(colorType, sizeYm, sizeZm,
		    pTexture, pNormals, pVertices, pPolyIndices);
    
    if (GetPCData()->mCbDrawFrame.mbBody == TRUE){
	SettingForDrawFrame();
	glBegin(GL_LINE_STRIP);
	glVertex3d(coXorg, 0, 0); glVertex3d(coXorg, 1, 0);
	glVertex3d(coXorg, 1, 1); glVertex3d(coXorg, 0, 1);
	glVertex3d(coXorg, 0, 0);
	glEnd();
    }
}

void PovCrossSection_cls::
DrawFieldY(double scale[3], int mappingType, int patternType, 
	   int colorType, int mappingCoord, double emboss){
    RecalcNorm(&mVVNormalU, &mVVNormalV, &mVVNormalW,
	       scale, mSizeX, mSizeZ, 0, X, Z, Y);
    
    double y = mpCData->GetPInterpolated()[_C_SECTION_LAYER];
    double coYorg = y / mSizeY, coY = y / mSizeY;

    double critoffset = 0;
    if (GetPCData()->mCbTransNullRegion.mbBody == TRUE){
	double PlaneEqYmax[4] = {0, 0, 0, 0};
	critoffset = GetCritOffset() * emboss / 16;
	if (emboss > 0){
	    PlaneEqYmax[Y] = +1.0; PlaneEqYmax[3] = -coY; }
	else{
	    PlaneEqYmax[Y] = -1.0; PlaneEqYmax[3] = +coY; }
	glClipPlane(GL_CLIP_PLANE0, PlaneEqYmax);
	glEnable(GL_CLIP_PLANE0);
    }
    coY -= critoffset;

    const double embossfactor = emboss / 4096;
    const int sizeZ = mSizeZ, sizeZm = mSizeZ-1;
    const int sizeX = mSizeX, sizeXm = mSizeX-1;

    AllocArray(sizeZ, sizeXm);
    MACRO_DECLAREPOINTERS;
    
    int   index = 0;
    for (int z = 0; z < sizeZ; z++){
	const double coZ0 = (double) z / sizeZ;
	const unsigned char *pVFieldLine = &(mVVField[z][0]);
	if (colorType != 0)
	    if (mappingType == _TEX_MAPPING_VALUE)
		for (int x = 0; x < sizeXm; x++){
		    pTexture[index] = (float)pVFieldLine[x]/256;
		    index++;
		}
	    else
		if (mappingCoord == _MAPPING_GLOBAL){
		    for (int x = 0; x < sizeXm; x++){
			double coYemb  = coY + embossfactor*pVFieldLine[x];
			double coX = (double) x / mSizeX;
			float globPos[3];
			float localPos[3] = {coX, coYemb, coZ0};
			GetGlobalPos(globPos, localPos);
			pTexture[index] = (float)GetMappingValueGlobal(globPos);
			index++;
		    } }
		else{
		    for (int x = 0; x < sizeXm; x++){
			double coYemb  = coY + embossfactor*pVFieldLine[x];
			double coX = (double) x / mSizeX;
			float localPos[3] = {coX, coYemb, coZ0};
			pTexture[index] = (float)GetMappingValueGlobal(localPos); // CHECK_ME!!
			index++;
		    } 
		}
    }
    
    index = 0;
    for (int z = 0; z < sizeZ; z++){
	MACRO_DECLAREPOINTERS_B(z,Z);
	for (int x = 0; x < sizeXm; x++){
	    double coYemb  = coY + embossfactor*pVFieldLine[x];
	    double coX = (double) x / sizeX;
	    MACRO_SETARRAYS(U, W, V, coX, coYemb, coZ);
	    index++;
	}
    }

    DrawVertexArray(colorType, sizeXm, sizeZm,
		    pTexture, pNormals, pVertices, pPolyIndices);

    if (GetPCData()->mCbDrawFrame.mbBody == TRUE){
	SettingForDrawFrame();
	glBegin(GL_LINE_STRIP);
	glVertex3d(0, coYorg, 0); glVertex3d(1, coYorg, 0);
	glVertex3d(1, coYorg, 1); glVertex3d(0, coYorg, 1);
	glVertex3d(0, coYorg, 0);
	glEnd();
    }
}
   
void PovCrossSection_cls::
DrawFieldZ(double scale[3], int mappingType, int patternType, 
	   int colorType, int mappingCoord, double emboss){
    RecalcNorm(&mVVNormalU, &mVVNormalV, &mVVNormalW,
	       scale, mSizeX, mSizeY, 0, X, Y, Z);

    double z = mpCData->GetPInterpolated()[_C_SECTION_LAYER];
    double coZorg = z / mSizeZ, coZ = z / mSizeZ;
    
    double critoffset = 0;
    if (GetPCData()->mCbTransNullRegion.mbBody == TRUE){
	double PlaneEqZmax[4] = {0, 0, 0, 0};
	critoffset = GetCritOffset() * emboss / 16;
	if (emboss > 0){
	    PlaneEqZmax[Z] = +1.0; PlaneEqZmax[3] = -coZ; }
	else{
	    PlaneEqZmax[Z] = -1.0; PlaneEqZmax[3] = +coZ; }
	glClipPlane(GL_CLIP_PLANE0, PlaneEqZmax);
	glEnable(GL_CLIP_PLANE0);
    }
    coZ -= critoffset;

    const double embossfactor = emboss / 4096;
    const int sizeY = mSizeY, sizeYm = mSizeY-1;
    const int sizeX = mSizeX, sizeXm = mSizeX-1;

    AllocArray(sizeY, sizeXm);
    MACRO_DECLAREPOINTERS;

    int   index = 0;
    for (int y = 0; y < sizeY; y++){
	const double coY0 = (double) y / sizeY;
	const unsigned char *pVFieldLine = &(mVVField[y][0]);
	if (colorType != 0)  
	    if (mappingType == _TEX_MAPPING_VALUE)
		for (int x = 0; x < sizeXm; x++){
		    pTexture[index] = (float)pVFieldLine[x]/256;
		    index++;
		}
	    else
		if (mappingCoord == _MAPPING_GLOBAL){
		    for (int x = 0; x < sizeXm; x++){
			double coZemb  = coZ + embossfactor * pVFieldLine[x];
			double coX = (double) x / sizeX;
			float globPos[3];
			float localPos0[3] = {coX, coY0, coZemb};
			GetGlobalPos(globPos, localPos0);
			pTexture[index] = (float)GetMappingValueGlobal(globPos);
			index++;
		    } }
		else{
		    for (int x = 0; x < sizeXm; x++){
			double coZemb  = coZ + embossfactor * pVFieldLine[x];
			double coX = (double) x / sizeX;
			float localPos[3] = {coX, coY0, coZemb};
			pTexture[index] = (float)GetMappingValueGlobal(localPos); // CHECK_ME!!
			index++;
		    }
		}
    }

    index = 0;
    for (int y = 0; y < sizeY; y++){
	MACRO_DECLAREPOINTERS_B(y,Y);
	for (int x = 0; x < sizeXm; x++){
	    double coZemb  = coZ + embossfactor*pVFieldLine[x];
	    double coX = (double) x / sizeX;
	    MACRO_SETARRAYS(U, V, W, coX, coY, coZemb);
	    index++;
	}
    }

    DrawVertexArray(colorType, sizeXm, sizeYm,
		    pTexture, pNormals, pVertices, pPolyIndices);

    if (GetPCData()->mCbDrawFrame.mbBody == TRUE){
	SettingForDrawFrame();
	glBegin(GL_LINE_STRIP);
	glVertex3d(0, 0, coZorg); glVertex3d(1, 0, coZorg);
	glVertex3d(1, 1, coZorg); glVertex3d(0, 1, coZorg);
	glVertex3d(0, 0, coZorg);
	glEnd();
    }
}

void PovCrossSection_cls::
DrawBox(double center[3], double scale[3]){
    
    if (GetPCData()->mCbValid.mbBody == FALSE) return;
    if (GetPCData()->GetPParamActive()->mCbVisible.mbBody == FALSE) return;
    if (scale[X] == 0 || scale[Y] == 0 || scale[Z] == 0) return;
    if (mSizeX == 0 || mSizeY == 0 || mSizeZ == 0) return;

    glPushAttrib(GL_ALL_ATTRIB_BITS);

    glColor4f(GetPCData()->mCTexProperty.mCColor.mpBody[0],
	      GetPCData()->mCTexProperty.mCColor.mpBody[1],
	      GetPCData()->mCTexProperty.mCColor.mpBody[2], 1);
    
    glPushMatrix();
    glTranslated(-0.5, -0.5, -0.5);

    glEnable(GL_LIGHTING);
    glEnable(GL_DEPTH_TEST);
    glDepthMask(GL_TRUE);

    GLuint showType = (msCShowMode.mBody == 0) ? GL_TRIANGLES : GL_LINES;
    int colorType = GetPCData()->mCTexProperty.mCColorType.mBody;
    int mappingType = GetPCData()->mCTexProperty.mCMappingType.mBody;
    int mappingCoord = GetPCData()->mCTexProperty.mCMappingCoord.mBody;
    int patternType = GetPCData()->mCTexProperty.mCPatternType.mBody;
    double emboss = GetEmboss();

    glLightModeli(GL_LIGHT_MODEL_TWO_SIDE,GL_TRUE);

    double offset[3];
    LOOP_XYZ offset[xyz] = center[xyz] - scale[xyz]/2;

    SetGLColoring(&GetPCData()->mCTexProperty);
    Configure1DMapping(&GetPCData()->mCTexProperty, offset, scale,
		       GetPCData()->mCbShade.mbBody);
    
    mCurrPatternType =     // CrossSection̎ɂ̂ݕKv
	GetPCData()->mCTexProperty.mCPatternType.mBody;
    switch(GetPCData()->mCAxis.mBody){
    case X:
	DrawFieldX(scale, mappingType, patternType, 
		   colorType, mappingCoord, emboss);
	break;
    case Y:
	DrawFieldY(scale, mappingType, patternType,
		   colorType, mappingCoord, emboss);
	break;
    case Z:
	DrawFieldZ(scale, mappingType, patternType,
		   colorType, mappingCoord, emboss);
	break;
    }
    
    glLightModeli(GL_LIGHT_MODEL_TWO_SIDE,GL_FALSE);
    glDisable(GL_CLIP_PLANE0);
    glPopMatrix();
    glPopAttrib();
}

bool PovCrossSection_cls::
DoesUseMapping(){
    return FALSE;
}

void PovCrossSection_cls::
MakeUV1D(TexProperty_cls *pCTexProp,
	 double offset[3], double scale[3]){
    int mappingType = pCTexProp->mCMappingType.mBody;
    int patternType = pCTexProp->mCPatternType.mBody;
    int mappingCoord = pCTexProp->mCMappingCoord.mBody;
    float *pos = pCTexProp->mCMappingPos.mpBody;
    float mapscale = pCTexProp->mCMappingScale.mBody;
    float mapturb = pCTexProp->mCMappingTurb.mBody;
    int axis = pCTexProp->mCMappingAxis.mBody;

    double rotate[4] = 
	{TexProperty_cls::msRotZ0, TexProperty_cls::msRotX0,
	 TexProperty_cls::msRotY0, TexProperty_cls::msRotZ1};

    if (IsParameterIsNewOne(mpCParentCtrl->GetRemappedDoubleIndex(),
			    mappingType, patternType, axis, mappingCoord, pos,
			    mapscale, mapturb, offset, scale, rotate) == FALSE
	&& mappingType == _TEX_MAPPING_PATTERN)
	return; 
    
    CopyCurrToPrev(pCTexProp);
}
    
wxString PovCrossSection_cls::
GetPovStrCrossSection(wxString strTag, wxString strFilePath,
		     wxString strGeometry, float treeDivideParam,
		     unsigned int depth, double baseAlpha,
		     double clipForPeriodicBoundary[3], 
		     PositionAndDirection_cls CCamLocalCoord, int frame,
		     DrawingBlock_cls* pCDrawingBlock){
    
    wxString strCrossSection;

    if (mpCData->mCbValid.mbBody == FALSE) return wxT("");

    if (IsClippingEmpty() == TRUE) return wxT("");
    /*
    double min[3] = {0, 0 ,0};
    double max[3] = {1, 1, 1};
    GetClippingInformation(min, max);
    LOOP_XYZ if (min[xyz] >= max[xyz]) return wxT("");
    */

    for (unsigned int i = 0; i < mVSAlreadyOutputedTag.size(); i++)
	if (strTag == mVSAlreadyOutputedTag[i]) return wxT("");
    mVSAlreadyOutputedTag.push_back(strTag);
    
    strCrossSection << GetPovStrHeightGeom
	(L"GEOM_C_SECTION_" + mstrId + strTag, clipForPeriodicBoundary, frame);

    bool bFlip = FALSE;
    if (CCamLocalCoord.mTgt[GetPCData()->mCAxis.mBody] > 0) bFlip = TRUE;
    
    strCrossSection << wxT("#declare C_SECTION_FINISH_") << mstrId + strTag << wxT("=finish{") << ENDLWX;
    strCrossSection << GetPCData()->mCTexProperty.GetPovStrFinish(TRUE)
		    << wxT("}") << ENDLWX;

    strCrossSection << GetPovStrCrossSecTex(mstrId + strTag, bFlip);
  
    if (GetPCData()->mCTexProperty.mCMappingType.mBody == _TEX_MAPPING_VALUE)
	strCrossSection << GetPovStrCrossSecObj
	    (mstrId + strTag, strTag, bFlip, pCDrawingBlock);
    else
	strCrossSection << GetPovStrCrossSecObjIndependentTex
	    (mstrId + strTag, strTag, bFlip, pCDrawingBlock);
    
    return strCrossSection;
    
}

wxString PovCrossSection_cls::
GetPovStrHeightGeom(wxString strTag, double clipForPeriodicBoundary[3], int frame){
    if (mAllocU == -1) return wxT("");

    wxString strCrossSection;
    /*
    double min[3] = {0, 0 ,0};
    double max[3] = {1, 1, 1};
    GetClippingInformation(min, max);
    LOOP_XYZ if (max[xyz] > clipForPeriodicBoundary[xyz])
	max[xyz] = clipForPeriodicBoundary[xyz];
    LOOP_XYZ if (min[xyz] < 0.0001) min[xyz] = 0.0001;
    */
    
    unsigned char *pData;
    if (FilterCtrl_cls::msStereoTmpFileIOMode & 1){
	pData = (unsigned char*)malloc(mAllocU * mAllocV * 3);
    
	for (int v = 0; v < mAllocV; v++){
	    int offsetV = v * mAllocU;
	    for (int u = 0; u < mAllocU; u++){
		int offsetU = offsetV + u;
		pData[offsetU*3]   = mVVField[v][u];
		pData[offsetU*3+1] = mVVField[v][u];
		pData[offsetU*3+2] = mVVField[v][u];
	    }
	}
    }

    wxString strFileOut = mspCPovRayLink->GetWorkingDirWithSep();
    strFileOut << L"Frame_" << frame << L"_" << strTag << L".png";
    
    if (GetPCData()->mCbPostSceneCommand.mbBody == TRUE && 
	(FilterCtrl_cls::msStereoTmpFileIOMode & 2)){
#ifdef WIN32
	mspCPovRayLink->mstrPostSceneCommand << L"del " << strFileOut << L";";
#else
	mspCPovRayLink->mstrPostSceneCommand << L"rm " << strFileOut << L";";
#endif
    }
    
    // delete 󂯓n
    if (FilterCtrl_cls::msStereoTmpFileIOMode & 1)
	if (GCImgIO.SaveImageFromData(mAllocU, mAllocV, strFileOut, pData) == FALSE)
	    MsgBox(NULL, "Save Error", "Height Field Image Save Error");
    
    strCrossSection << L"#declare " << strTag << L"=height_field{" << ENDLWX 
		   << L"\tpng \"" << strFileOut << L"\"" << ENDLWX;
    if (GetPCData()->mCbSmooth.mbBody == TRUE)
	strCrossSection << L"\tsmooth" << ENDLWX;
	
    strCrossSection << L"}" << ENDLWX 
		   << ENDLWX;
    
    return strCrossSection;
}

wxString PovCrossSection_cls::
GetPovStrCrossSecTex(wxString strTag, bool bFlip){

    wxString strCRTex, strFinishTag;
    strFinishTag << wxT("C_SECTION_FINISH_") << strTag;

    strCRTex << ENDLWX;
    strCRTex << L"#declare " 
	     << wxT("C_SECTION_TEX_") << strTag << L"=texture{" << ENDLWX;

    // -1 PFɂ
    int colorType = GetPCData()->mCTexProperty.mCColorType.mBody - 1;
    float trans = 1.0f - GetPCData()->GetPInterpolated()[_C_SECTION_ALPHA];
    int transmitType = GetPCData()->mCTexProperty.mCTransmitType.mBody;
    wxString strColorMap, strClr1, strClr2, strClr3;

    if (colorType >= 0){
	if (GetPCData()->mCTexProperty.mCMappingType.mBody == _TEX_MAPPING_VALUE)
	    strColorMap << L"gradient y translate -0.001*y" << ENDLWX;
	
	strColorMap << GCColoring.GetPovStrColorMap
	    (mpCParentCtrl->mSelfDF3Index,
	     colorType + _CLR_CUSTOM, FALSE, 0, NULL, FALSE,
	     1.0f - mpCData->GetPInterpolated()[_C_SECTION_ALPHA]);
	strClr1 = GCColoring.GetPovStrClr
	    (mpCParentCtrl->mSelfDF3Index,
	     GetPCData()->mCTexProperty.mCColorType.mBody - 1 + _CLR_CUSTOM, 0,
	     trans, transmitType);
	strClr2 = GCColoring.GetPovStrClr
	    (mpCParentCtrl->mSelfDF3Index,
	     GetPCData()->mCTexProperty.mCColorType.mBody - 1 + _CLR_CUSTOM, 1,
	     trans, transmitType);
	strClr3 = GCColoring.GetPovStrClr
	    (mpCParentCtrl->mSelfDF3Index,
	     GetPCData()->mCTexProperty.mCColorType.mBody - 1 + _CLR_CUSTOM, 0.5,
	     trans, transmitType);
    }
    
    double alt = mpCData->GetPInterpolated()[_C_SECTION_EMBOSS] * 0.0625;
    if (alt > -0.0003 && alt < 0.0003){
	alt = 0.0003;
	if (bFlip == TRUE) alt *= -1;
    }

    strCRTex << GetPCData()->mCTexProperty.GetPovStrTex
	(mpCData->GetPInterpolated()[_C_SECTION_ALPHA], strFinishTag, strColorMap,
	 1, 1.0f/alt, 1, GetPCData()->mCbShade.mbBody,
	 FALSE, GetPCData()->mCAxis.mBody, strClr1, strClr2, strClr3);
	 
    strCRTex << wxT("}") << ENDLWX;

    return strCRTex;
}

wxString PovCrossSection_cls::
GetPovStrCrossSecObjBase(wxString strBoxLabel, double critoffset,
			 bool bIndependentTex){
    wxString strObjBase;
    
    strObjBase << L"#declare " << L"OBJECT_C_SECTION_" << strBoxLabel << L"=object{" << ENDLWX;
    if (mAllocV == -1){
	strObjBase << wxT("\tbox{ <0, 0, 0> <0, 0, 0>}") << ENDLWX
		     << wxT("}") << ENDLWX;
	return strObjBase;
    }

    if (bIndependentTex == TRUE)
	strObjBase << wxT("\tobject {") << ENDLWX;

    if (GetPCData()->mCbTransNullRegion.mbBody == TRUE)
	strObjBase << L"\tintersection {" << ENDLWX
		     << L"\t\tbox { <0, " << critoffset << L", 0> <1, 2, 1>" << ENDLWX
		     << L"\t\t\t pigment { rgbt < 1, 1, 1, 1> } }" << ENDLWX
		     << L"\t\t" << wxT("GEOM_C_SECTION_") << strBoxLabel << ENDLWX
		     << L"\t}" << ENDLWX;
    else
	strObjBase << L"\t" << wxT("GEOM_C_SECTION_") << strBoxLabel << ENDLWX;

    return strObjBase;
}

wxString PovCrossSection_cls::
GetPovStrCrossSecObjTranslate(double critoffset, double alt){
    wxString strObjTrans;

    switch(GetPCData()->mCAxis.mBody){
    case X: {
	double x = mpCData->GetPInterpolated()[_C_SECTION_LAYER];
	double coX = (double) x / mSizeX;
	strObjTrans << L"\ttranslate <0, " << -critoffset << L", 0>" << ENDLWX
		     << L"\tscale <1, " << -alt << L", 1>" << ENDLWX
		     << L"\trotate <0, 0, 90>" << ENDLWX
		     << L"\ttranslate <" << coX << L", 0, 0>" << ENDLWX;
	break; }
    case Y: {
	double y = mpCData->GetPInterpolated()[_C_SECTION_LAYER];
	double coY = (double) y / mSizeY;
	strObjTrans << L"\ttranslate <0, " << -critoffset << L", 0>" << ENDLWX
		     << L"\tscale <1, " << alt << L", 1>" << ENDLWX
		     << L"\trotate <0, 0, 0>" << ENDLWX
		     << L"\ttranslate <0, " << coY << L", 0>" << ENDLWX;
	break; }
    case Z: {
	double z = mpCData->GetPInterpolated()[_C_SECTION_LAYER];
	double coZ = (double) z / mSizeZ;
	strObjTrans << L"\ttranslate <0, " << -critoffset << L", 0>" << ENDLWX
		     << L"\tscale <1, " << -alt << L", 1>" << ENDLWX
		     << L"\trotate <-90, 0, 0>" << ENDLWX
		     << L"\ttranslate <0, 0, " << coZ << L">" << ENDLWX;
	break; }
    }

    strObjTrans << wxT("\ttranslate < -0.5, -0.5, -0.5 > "); 

    return strObjTrans;
}

wxString PovCrossSection_cls::
GetPovStrCrossSecObjIndependentTex(wxString strBoxLabel, wxString strTag, 
				   bool bFlip,
				   DrawingBlock_cls* pCDrawingBlock){
    wxString strObjHeight;
    double critoffset = GetCritOffset();

    strObjHeight << GetPovStrCrossSecObjBase(strBoxLabel, critoffset, TRUE);
    
    double scale[3];
    LOOP_XYZ scale[xyz] = pCDrawingBlock->GetBoxScaleWorldCoord(xyz);

    double alt = mpCData->GetPInterpolated()[_C_SECTION_EMBOSS] * 0.0625;
    if (alt > -0.0003 && alt < 0.0003){
	alt = 0.0003;
	if (bFlip == TRUE) alt *= -1;
    }

    strObjHeight << GetPovStrCrossSecObjTranslate(critoffset, alt);
    
    strObjHeight << wxT("}") << ENDLWX;
    
    if (GetPCData()->mCTexProperty.mCMappingCoord.mBody == _MAPPING_LOCAL)

	strObjHeight << L"\ttexture { " << wxT("C_SECTION_TEX_") << strBoxLabel << ENDLWX
		     << wxT("\t\t") << PovOut3(wxT("scale"), 
					       1.0/scale[X], 1.0/scale[Y], 1.0/scale[Z]) << wxT(" }") << ENDLWX;
    
    strObjHeight << L"\thollow" << ENDLWX
		 << wxT("}") << ENDLWX;

    if (GetPCData()->mCTexProperty.mCMappingCoord.mBody == _MAPPING_GLOBAL)
	strObjHeight << wxT("#declare CROSSTEXGLOBAL_") << strBoxLabel << wxT("=1;") << ENDLWX << ENDLWX;
    
    return strObjHeight;
}

wxString PovCrossSection_cls::
GetPovStrCrossSecObj(wxString strBoxLabel, wxString strTag, bool bFlip,
		     DrawingBlock_cls* pCDrawingBlock){
		
    wxString strObjHeight;
    double critoffset = GetCritOffset();

    strObjHeight << ENDLWX;
    strObjHeight << GetPovStrCrossSecObjBase(strBoxLabel, critoffset, FALSE);

    double scale[3];
    LOOP_XYZ scale[xyz] = pCDrawingBlock->GetBoxScaleWorldCoord(xyz);
    strObjHeight << L"\ttexture { " << wxT("C_SECTION_TEX_") << strBoxLabel << ENDLWX;
    
    double alt = mpCData->GetPInterpolated()[_C_SECTION_EMBOSS] * 0.0625;
    if (alt > -0.0003 && alt < 0.0003){
	alt = 0.0003;
	if (bFlip == TRUE) alt *= -1;
    }

    // FIX_ME!! tϊ̂߂
    // XP[݂ŊΗǂ
    // ɂčWςB
    // ܂AXCXʂ̈ʒuɊւĂ␳v
    if (GetPCData()->mCTexProperty.mCMappingType.mBody != _TEX_MAPPING_VALUE){
	switch(GetPCData()->mCAxis.mBody){
	case Y:
	    // CHECK_ME!!
	    strObjHeight << L"\t\t" << PovOut3(wxT("scale"), 1.0/scale[X], 1.0/scale[Y]/alt, 1.0/scale[X]);
	    break;
	case Z:
	    strObjHeight << L"\t\t" << PovOut3(wxT("scale"), 1.0/scale[X], 1.0/scale[Z]/alt, 1.0/scale[Y]) << ENDLWX;
	    break;
	}
	strObjHeight << L"\t\t" << PovOut3(wxT("translate"), 0.5, 0.5, 0.5) << ENDLWX;
    }
    strObjHeight << L"\t}" << ENDLWX
		 << L"\thollow" << ENDLWX;
   
    strObjHeight << GetPovStrCrossSecObjTranslate(critoffset, alt);
   
    //strObjHeight << L"\ttranslate < -0.5, -0.5, -0.5 >" << ENDLWX;
    
    strObjHeight << L"}" << ENDLWX << ENDLWX ;
    
    return strObjHeight;
}

// ------------------

wxString PovCrossSection_cls::
GetFilterStatusStr(){
    wxString strStatus;
    strStatus << wxT("CrossSection::") << GetPCData()->mCbValid.mbBody;
    
    if (GetPCData()->mCbValid.mbBody == FALSE)
	strStatus<< wxT("::");
    else
	strStatus << wxT(":") <<
	    GetPCData()->mCAxis.mBody << wxT(":") << 
	    GetPCData()->GetPInterpolated()[_C_SECTION_LAYER] << wxT(":") << 
	    GetPCData()->GetPInterpolated()[_C_SECTION_EMBOSS] << wxT("::");

    return strStatus;
}

MACRO_SerializeConfP(PovCrossSection)
MACRO_GetNewPReadDataBlock(PovCrossSection)

wxString PovCrossSection_cls::
SerializeStaticConf(){
    return 
	msCbCullFace.Serialize() + msCShowMode.Serialize();
    
}

void PovCrossSection_cls::
ReadStrLineStaticConf(std::wstring strLine){
    msCbCullFace.ReadStrLine(strLine);
    msCShowMode.ReadStrLine(strLine);
}

ConfItemBOOL_cls PovCrossSection_cls::msCbCullFace(L"PovCrossSectionCullFace=", L"0");
ConfItemUINT_cls PovCrossSection_cls::msCShowMode(L"PovCrossSectionShowMode=", L"0");
