// "clsPovCrossSection.cpp"
// (c-basic-offset 4)

#ifndef _POV_CROSS_SECTION_H_
#define _POV_CROSS_SECTION_H_

#include <string>

class PovCrossSectionData_cls;

#include "clsPovSerialize.h"
#include "clsPovCrossSectionCommon.h"
#include "ISOSURFACE/clsMarchingCube.h"
#include "../CONFITEM/clsConfItem.h"
#include "../DF3/clsDF3SeqCtrl.h"
#include "../FILTER/clsFilterBase.h"
#include "../FILTER/clsFilterWithParameter.h"
#include "../FILTER/clsFilterWithTexture.h"
#include "../MYGL/clsTextureMapping.h"
#include "../PARAMETER/clsParameters.h"
#include "../FILTER/clsFilterWithSelect.h"

class DF3SeqGUI_cls;
class PovRay_cls;
class PovCrossSection_cls;
class TexProperty_cls;

#define _C_SECTION_LAYER 0
#define _C_SECTION_EMBOSS 1 
#define _C_SECTION_ALPHA 2
#define _C_SECTION_CRIT 3

#include <wx/thread.h>

class PovCrossSectionGUI_cls : public FilterWithTextureGUI_cls {

    MACRO_DefGUIMainSettings(PovCrossSection);
    MACRO_DefVirtualCustmFunctions;

    int mIndexCrit;
    int mIndexLayer;
    void SetLayerIndexRange(int max);
};

class PovCrossSectionData_cls : public FilterWithParameterData_cls, public FilterWithTextureData_cls {
 public:
    PovCrossSectionData_cls(FilterCtrl_cls* pCCtrl, 
			    bool bConnectToStaticParam = TRUE);

    void ReDefineList();

    ConfItemUINT_cls    mCAxis, mCCliping;
    ConfItemBOOL_cls    mCbShade, mCbTransNullRegion, mCbSmooth;
    ConfItemBOOL_cls    mCbPostSceneCommand, mCbDrawFrame;

    // |C^ĊmۂňړȂ悤ɂB(UNDO݂ł܂)
    // *todo _MAX_ITEM_NUMBERɂ鏈
    static std::vector < Parameters_cls > msVCParam[_DF3_MAX_SLOT];
    static std::vector < bool > msVbParamUsed[_DF3_MAX_SLOT];
    static void InitializeStaticMember(int df3index);
    Parameters_cls* GetPParamActive();
    
    // UndoŁẢ\Parameter̊mۂSɕKvȂȂJB
    // !! Complete Me !!
    static void GarbageCollect();
    
    void MakeFilterInstanceAndAddToList
	(int index, FilterCtrl_cls *pCParentCtrl);
    wxString SerializeConfPolymorph();
    void ReadStrLinePolymorph(std::wistream &istream, std::wstring strLine);
};

// ----

/*
class ThreadCalcNormal : public wxThread {
 public: 
    ThreadCalcNormal();

    void SetParameters(PovCrossSection_cls *pCParent,
		       std::vector < std::vector < unsigned char > > *pVVField,
		       std::vector < std::vector < double > > *pNormalU,
		       std::vector < std::vector < double > > *pNormalV,
		       std::vector < std::vector < double > > *pNormalW,
		       int sizeU, int iniV, int finV,
		       double enhanceU, double enhanceV);

    virtual ExitCode Entry();

    PovCrossSection_cls *mpCParent;
    std::vector < std::vector < unsigned char > > *mpVVField;
    std::vector < std::vector < double > > *mpVVNormalU;
    std::vector < std::vector < double > > *mpVVNormalV;
    std::vector < std::vector < double > > *mpVVNormalW;
    int mSizeU;
    int mIniV, mFinV;
    double mEnhanceU, mEnhanceV;
};
*/

class PovCrossSection_cls : public PovSerialize_cls, public PovCrossSectionCommon_cls, /*public FilterWithParameter_cls,*/ public TextureMapping_cls, FilterObject_cls {
 public:
    PovCrossSection_cls(FilterCtrl_cls *pCParentCtrl,
			PovCrossSectionData_cls *pCInitData = NULL);
    ~PovCrossSection_cls();
    
    //--
    virtual void AddFilterItemPolymorph(wxBoxSizer *pBoxSizer, FilterPanels_cls *pCFilterPanel, unsigned int index);
    static void InitializeStaticMember(int df3index);
    PovCrossSectionData_cls* GetPCData();

    //--

    void SetMNumAdvanced(wxWindow *pCParentWindow);
    void AdvancedSetting();
    void UpdateColors();

    static ConfItemBOOL_cls  msCbCullFace;
    static ConfItemUINT_cls  msCShowMode;

    bool IsReprocessRequired();
    double GetPos(int axis, double minmax);

    //GLuint  mTexId;
    //int  mPrevColorType, mColorRefreshId;
    void RefreshFilter(unsigned char *pData);
    void ClearCrossSection();
    void AllocCrossSection(int sizeU, int sizeV);
    void ConstructVerticesX(unsigned char *pData, double emboss);
    void ConstructVerticesY(unsigned char *pData, double emboss);
    void ConstructVerticesZ(unsigned char *pData, double emboss);
    void CalcClrField(int sizeU, int sizeV);

    void SettingForDrawFrame();
    double GetEmboss();
    double GetCritOffset();

    void DrawFieldX(double scale[3], int mappingType, int patternType,
		    int colorType, int mappingCoord, double emboss);
    void DrawFieldY(double scale[3], int mappingType, int patternType,
		    int colorType, int mappingCoord, double emboss);
    void DrawFieldZ(double scale[3], int mappingType, int patternType,
		    int colorType, int mappingCoord, double emboss);
    void DrawBox(double center[3], double scale[3]);
    bool DoesUseMapping();
    void MakeUV1D(TexProperty_cls *pCTexProp,
		  double offset[3], double scale[3]); 
    
    int mAllocU, mAllocV;
    std::vector < std::vector < unsigned char > > mVVField;
    std::vector < std::vector < double > > mVVNormalU;
    std::vector < std::vector < double > > mVVNormalV;
    std::vector < std::vector < double > > mVVNormalW;

    void AllocArray(int sizeV, int sizeUm);
    int mAllocArrayV, mAllocArrayUm;
    float *mpTexture, *mpNormals, *mpVertices;
    unsigned *mpPolyIndices;
        
    wxString GetPovStrCrossSection
	(wxString strTag, wxString strFilePath,
	 wxString strGeometry, float treeDivideParam, unsigned int depth,
	 double baseAlpha, double clipForPeriodicBoundary[3], 
	 PositionAndDirection_cls CCamLocalCoord, int frame,
	 DrawingBlock_cls* pCDrawingBlock);

    wxString GetPovStrHeightGeom
	(wxString strTag, double clipForPeriodicBoundary[3], int frame);
    wxString GetPovStrCrossSecTex(wxString strTag, bool bFlip);
    wxString GetPovStrCrossSecObjBase
	(wxString strBoxLabel, double critoffset, bool bIndependentTex);
    wxString GetPovStrCrossSecObjTranslate
	(double critoffset, double alt);
    wxString GetPovStrCrossSecObjIndependentTex
	(wxString strBoxLabel, wxString strTag,	bool bFlip,
	 DrawingBlock_cls *pCDrawingBlock); 
    wxString GetPovStrCrossSecObj
	(wxString strBoxLabel, wxString strTag,	bool bFlip,
	 DrawingBlock_cls *pCDrawingBlock); 
    
    // --

    wxString GetFilterStatusStr();
    wxString SerializeConf();
    static PovCrossSectionData_cls*
	GetNewPReadDataBlock(FilterCtrl_cls* pCCtrl,
			     std::wistream &istream);
    
    static wxString SerializeStaticConf();
    static void ReadStrLineStaticConf(std::wstring strLine);
};

#endif
