
#ifndef _POV_FOG_H_
#define _POV_FOG_H_

class PovFogData_cls;

#include "clsPovSerialize.h"
#include "../CONFITEM/clsConfItem.h"
#include "../FILTER/clsFilterBase.h"
#include "../FILTER/clsFilterWithSelect.h"

class PovRay_cls;
class PovFog_cls;

class PovFogGUI_cls : public FilterWithTargetGUI_cls {
 public:
    PovFogGUI_cls(PovFog_cls *pCParent);

    PovFog_cls *mpCParent;

    int mIndexEmission;
    int mIndexAbsorption;
    int mIndexScattering;
    int mIndexGlobalType;
    int mIndexDistance;
    int mIndexLayerOffset;
    int mIndexLayerScaleHeight;

    void SetMNumPanel(wxBoxSizer *pBoxSizer, wxWindow *pCParentWindow,
		      unsigned int index);
    MACRO_DefVirtualCustmFunctions;

    static void  FuncHookHideItem(void *pArg, void *pEvent);

    void ChooseColor();
};

class PovFogData_cls : public FilterData_cls {
 public:
    PovFogData_cls();

    void ReDefineList();
    ConfItemFLOAT_cls mCEmission;
    ConfItemFLOAT_cls mCAbsorption;
    ConfItemFLOAT_cls mCScatter;
    ConfItemFLOAT_cls mCDistance;
    ConfItemUINT_cls  mCFogGlobalType;
    ConfItemFLOAT_cls  mCFogLayerOffset;
    ConfItemFLOAT_cls  mCFogLayerScaleHeight;
    ConfItemFLOATARRAY_cls mCColor;
    ConfItemSTR_cls   mCConfTargetStr;
    ConfItemUINT_cls  mCGlobalFogContainer;
    ConfItemFLOATARRAY_cls mCContainerHalfSize, mCScatterColor;
    ConfItemUINT_cls  mCScatterType;
    
    void MakeFilterInstanceAndAddToList
	(int index, FilterCtrl_cls *pCParentCtrl);
};

class PovFog_cls : public PovSerialize_cls, public FilterBase_cls {
 public:
    PovFog_cls(FilterCtrl_cls *pCParentCtrl,
	       PovFogData_cls *pCInitData = NULL);
    ~PovFog_cls();

    PovFogData_cls mCData;
    FilterData_cls*  GetPData();
    void     UpdateTarget();
    void     UpdateTargetInfo();

    void ChooseColor();

    // ---
    virtual void AddFilterItemPolymorph(wxBoxSizer *pBoxSizer, FilterPanels_cls *pCFilterPanel, unsigned int index);
    PovFogData_cls* GetPCData();
    //--

    int mIndexScatterColor;
    
    static PovFog_cls *mspCConnectedToDLG;
    void SetMNumAdvanced(wxWindow *pCParentWindow);
    //void AdvancedSetting();

    void   GetColorAtInf(float pColor[3]);
    double GetFogDistance();
    wxString GetPovStrFogGlobal();
    wxString GetPovStrFogGlobalFunc(wxString strFogTag);
    wxString GetPovStrFogGlobal2(wxString strFogTag);
    wxString GetPovStrFog(wxString strVolumeRenderParam);
    wxString GetPovStrFogForUse();

    static void FuncHookScatterColor(void *pArg, void *pEvent);

    // ----

    wxString GetFilterStatusStr();
    wxString SerializeConf();
    static PovFogData_cls ReadDataBlock(std::wistream &istream);

};

// ------

#endif
