// "clsPovObject.h"
// (setq c-basic-offset 4)

#include "clsPovObject.h"
#include "clsPovRay.h"
#include "clsPovFog.h"

#include "PLUGINOBJ/clsPovObjectWavefront.h"

#include "../COMMON/MyVector.h"
#include "../DF3/clsDF3SeqGUI.h"
#include "../DF3/clsDF3SeqCtrl.h"
#include "../DF3/clsDF3Sequence.h"
#include "../DF3/GL/clsPreviewProperty.h"
#include "../DF3/GL/clsColoring.h"
extern Coloring_cls GCColoring;
#include "../FILTER/clsFilterCtrl.h"
#include "../GLOBJ/GLOBJECTS.h"
#include "../MAINCANVAS/clsPreference.h"
#include "../MAINCANVAS/clsPreviewPanel.h"
#include "../MYAPI/MsgBox.h"
#include "../WIDGETCTRL/clsAtoWXSTextCtrl.h"
#include "../WIDGETCTRL/clsGraphPanel.h"
#include "../WIDGETCTRL/clsMultiNumericalInputs.h"
#include "../WIDGETCTRL/EX/clsCheckBoxEX.h"
#include "../WIDGETCTRL/EX/clsTextCtrlEX.h"

#include "../../clsDrawingBox.h"

#include "../../wxWidgetEnumMenu.h"

extern int displayListSphere;
extern int displayListCylinder;
extern int displayListCylinderOpen;
extern int displayListCone;
extern int displayListWireBox[5];
extern bool GbGLLockForMultithread;
extern bool GbGLLockForLoading;

#include "../../wxWidgetEnum.h"

#include <wx/wx.h>
#include <wx/wfstream.h> 
#include <wx/mstream.h> 
#include <wx/txtstrm.h>
#ifdef WIN32
#include <GL/glu.h>
#include <GL/glext.h>
#else
#define GL_GLEXT_PROTOTYPES 
#include <GL/glu.h>
#endif

#include <sstream>

#define X 0
#define Y 1
#define Z 2
#define LOOP_XYZ for(int xyz = 0; xyz < 3; xyz++)
#define R 0
#define G 1
#define B 2
#define LOOP_RGB for(int rgb = 0; rgb < 3; rgb++)
#define _MANIP_TRANSLATE 0

#define _RAD 3.14159 / 180

#define ENDLWX wxT("\n")

#ifdef _DEBUG
#include <stdlib.h>
#include <crtdbg.h>
#define new new(_NORMAL_BLOCK, __FILE__, __LINE__)
#endif

MACRO_FilterConstructor(PovObject, WithTexture,);

void PovObjectGUI_cls::
SetMNumPanel(wxBoxSizer *pBoxSizer, wxWindow *pCParentWindow, 
	     unsigned int index){
    PovObjectData_cls *pCData = mpCParent->GetPCData();
    MultiNumericalInputsPanel_cls* pCurr = InitializeMNumPanel(pCParentWindow);

    pCurr->mTextWidth = 65;
    int boxWidth = 2;

    pCurr->mItemWidth = -1;
#ifdef WIN32
    pCurr->mComboWidth = 108;
#else
    pCurr->mComboWidth = 98;
#endif

    wxString listType[9] = { _("Plane"), _("Box"), _("Sphere"), _("Cylinder/Cone"), _("Arrow"), _("Text"), _("Wired Box"), wxT("Mesh"), wxT("PlugIn")};
    mIndexObjType = pCurr->CombinePointer
	(_GP_UNSIGNED_INT_LIST, &pCData->mCObjType.mBody, wxT("Object Type"), TRUE, 9, listType);
    
    wxString listPlugin[1] = { wxT("TOMTREE.inc") };
    mIndexPluginType = pCurr->CombinePointer(_GP_BOXSIZERHORIZONTAL, &boxWidth, wxT(""));
    pCurr->CombinePointer
	(_GP_UNSIGNED_INT_LIST, &pCData->mCPluginType.mBody, wxT(""), TRUE, 1, listPlugin);
    mIndexCustomA = pCurr->CombinePointerButton
	(buttonCtrlPanelItemsCustomA, _("Plugin Help"));

    mIndexPluginTree = pCurr->CombinePointer(_GP_BOXSIZERHORIZONTAL, &boxWidth, wxT(""));
    wxString listPluginTree[3] = { wxT("Birch"), wxT("Olive"), wxT("Palm") };
    pCurr->CombinePointer
	(_GP_UNSIGNED_INT_LIST, &pCData->mCPluginTree.mBody, wxT(""), TRUE, 3, listPluginTree);
    wxString listPluginQuality[2] = { wxT("Low Quality"), wxT("High Quality") };
    pCurr->CombinePointer
	(_GP_UNSIGNED_INT_LIST, &pCData->mCPluginQuality.mBody, wxT(""), TRUE, 2, listPluginQuality);
    
    mIndexColorTypeAndButton = pCurr->CombinePointer(_GP_BOXSIZERHORIZONTAL, &boxWidth, wxT(""));
    
    wxString listColor[1] = { wxT("Mono Color") };
    mIndexColorType = pCurr->CombinePointer
	(_GP_UNSIGNED_INT_LIST, &pCData->mCTexProperty.mCColorType.mBody,
	 wxT(""), TRUE, 1, listColor);

    InitializeColorPanel(pCurr, this, &GetColorR, &GetColorG, &GetColorB,
			 _("Texture"));
    mIndexColorBar = pCurr->CombinePointer(_GP_WXPANEL, mpCPanelColorBar);

    mIndexShapeParam = pCurr->CombinePointer(_GP_BOXSIZERHORIZONTAL, &boxWidth, wxT("Shape Param"));
    pCurr->CombinePointer(_GP_FLOAT_SLIDER, 
			  &pCData->mCShapeParam.mBody);
    pCurr->SetRange(0, 200, _MN_LASTITEM, 100);
    pCurr->CombinePointer(_GP_FLOAT, 
			  &pCData->mCShapeParam.mBody);

    pCurr->mTextWidth = 45;
    wxString listFont[3] = { wxT("cyrvetic"), wxT("timrom"), _("crystal(fixed)")};
    mIndexFontType = pCurr->CombinePointer
	(_GP_UNSIGNED_INT_LIST, &pCData->mCFontType.mBody, _("Font"), TRUE, 3, listFont);

    mIndexText = pCurr->CombinePointer
	(_GP_WXSTRING, &pCData->mCTextStr.msBody, wxT("Text"), TRUE);
    mIndexPath = pCurr->CombinePointer
	(_GP_WXSTRING_PATH, &pCData->mCPathStr.msBody, wxT("Path"), TRUE);

    pCurr->CombinePointer(_GP_BOXSIZERHORIZONTAL, &boxWidth, wxT(""));
    pCurr->mTextWidth = -1;
    mIndexMeshOffset = pCurr->CombinePointer
	(_GP_BOOL, &pCData->mCbUseMeshOffset.mbBody, wxT("offset 0.5"));
    mIndexCustomB = pCurr->CombinePointerButton
	(buttonCtrlPanelItemsCustomB, _("Auto Resize"));

    mIndexOpen = pCurr->CombinePointer
	(_GP_BOOL, &pCData->mCbOpen.mbBody, wxT("open"));
    
    pCurr->FinishSetting(pBoxSizer, FALSE, index);

    ((AtoWXSTextPathCtrl_cls*)pCurr->mVCPointers[mIndexPath].mpPointerCtrl)->
	mpstrDefaultDirLink = &mpCParent->mspCPovRayLink->mCConfWorkingDir.msBody;
    ((AtoWXSTextPathCtrl_cls*)pCurr->mVCPointers[mIndexPath].mpPointerCtrl)->
	mstrFilter = wxT("all|*|WaveFront OBJ (*.obj)|*.obj|Povray Mesh2 (*.pov)|*.pov");
    
    mpObjectForCustomA = pCurr->mVCPointers[mIndexCustomA].mpPointerCtrl;
    mpObjectForCustomB = pCurr->mVCPointers[mIndexCustomB].mpPointerCtrl;
    
    UpdateColorList();

    pCurr->SetFuncHook(&PovObjectGUI_cls::FuncHookAssign, _MN_HOOK_ASSIGN);
    pCurr->SetFuncHook(&FilterCtrl_cls::FuncHookRefreshTop, _MN_HOOK_ASSIGN);
    pCurr->SetFuncHook(&FilterCtrl_cls::FuncHookAssign, _MN_HOOK_ASSIGN);
    pCurr->SetFuncHook(&FuncHookHideItem, _MN_HOOK_COMBOBOX_CHANGE);
    pCurr->SetFuncHook(&FilterWithTextureGUI_cls::FuncHookUpdateTextureDLG,
		       _MN_HOOK_COMBOBOX_CHANGE);
    pCurr->SetFuncHook(&FuncHookOpenTextureDLG, _MN_HOOK_PANELCLICK);
    pCurr->SetFuncHook(&FilterCtrl_cls::FuncHookChanged, _MN_HOOK_CHANGE);

    ((TextCtrlEX_cls*)pCurr->mVCPointers[mIndexText].mpPointerCtrl)->
	EnableHookSpace(FALSE);
	
    HideAndShowItems();
}

MACRO_SetCustomFunctions(PovObjectGUI_cls,CustomButtonA(),CustomButtonB(),)

void PovObjectGUI_cls::
CustomButtonA(){
    mpCParent->ShowPluginHelp();
}

void PovObjectGUI_cls::
CustomButtonB(){
    mpCParent->AutoResize();
}

void PovObjectGUI_cls::
HideAndShowItems(){
    int type = mpCParent->GetPCData()->mCObjType.mBody;

    mpCMNumPanel->ShowItems(mIndexFontType, 1, type == _OBJECT_TYPE_TEXT);
    mpCMNumPanel->ShowItems(mIndexText, 1, type == _OBJECT_TYPE_TEXT);
    mpCMNumPanel->mVCPointers[mIndexPath].Show(type == _OBJECT_TYPE_MESH);
    mpCMNumPanel->mVCPointers[mIndexMeshOffset].Show(type == _OBJECT_TYPE_MESH);
    mpCMNumPanel->mVCPointers[mIndexCustomB].Show(type == _OBJECT_TYPE_MESH || type == _OBJECT_TYPE_WIRED_BOX);
    mpCMNumPanel->ShowItems(mIndexOpen, 1, type == _OBJECT_TYPE_CONE);
    mpCMNumPanel->ShowItems
	(mIndexShapeParam, 3, 
	 (type == _OBJECT_TYPE_CONE) || (type == _OBJECT_TYPE_ARROW) || (type == _OBJECT_TYPE_WIRED_BOX));
	 
    bool bPlugin = (type == _OBJECT_TYPE_PLUGIN);
    int plugin = mpCParent->GetPCData()->mCPluginType.mBody;
    mpCMNumPanel->ShowItems(mIndexPluginType, 3, bPlugin);
    mpCMNumPanel->ShowItems
	(mIndexPluginTree, 3, bPlugin & (plugin == _PLUGIN_TOMTREE));
    mpCMNumPanel->ShowItems(mIndexColorTypeAndButton, 3, !bPlugin);
    
    RefreshColorBar();
    
    mpCMNumPanel->GetSizer()->Layout();
    mpCParent->mpCParentCtrl->mpCFilterPanelsLink->UpdatePanelLayout();
}

MACRO_FuncHookHideItem(PovObject);

void PovObjectGUI_cls::
FuncHookAssign(void *pArg, void *pEvent){
    PovObjectGUI_cls *pThis = ((PovObjectGUI_cls*)DF3SeqCtrl_cls::GetPFilterGUI(pArg));
    pThis->mpCParent->RefreshFilter(pThis->mpCParent->mpFieldDataLink,
				    pThis->mpCParent->mSize);
}

// -----

PovObjectData_cls::
PovObjectData_cls(FilterCtrl_cls* pCCtrl, 
		  bool bConnectToStaticParam,
		  int initType) : 
    FilterWithParameterData_cls(pCCtrl)
{
    wxString strType; strType << initType;
    
    ReDefineList();
    mCConfList.Add(&mCObjType,   wxT("PovObjectType="), strType);
    mCConfList.mbSetWithInitValue = FALSE;
    
    Parameters_cls CParam(11, L"PovObject");
    double initParam[11] = {0, 0, 0,
			    1, 1, 1,
			    0, 0, 0, 0, 1};
    CParam.ExecCommandInitSet(initParam);

    // !! todo !! _MAX_PARAMETER_NUMBER 𒴂̏
    if (bConnectToStaticParam == TRUE){
	mParamNumber = -1;
	for (size_t i = 0; i < msVbParamUsed[mpCCtrl->mSelfDF3Index].size(); i++)
	    if (msVbParamUsed[mpCCtrl->mSelfDF3Index][i] == FALSE){
		mParamNumber = (int)i;
		msVCParam[mpCCtrl->mSelfDF3Index][mParamNumber].CopyFromP(&CParam);
		msVbParamUsed[mpCCtrl->mSelfDF3Index][mParamNumber] = TRUE;
		i = _MAX_PARAMETER_NUMBER;
	    }
	if (mParamNumber == -1){
	    mParamNumber = (int)msVbParamUsed[mpCCtrl->mSelfDF3Index].size();
	    msVCParam[mpCCtrl->mSelfDF3Index].push_back(CParam);
	    msVbParamUsed[mpCCtrl->mSelfDF3Index].push_back(TRUE);
	}
    }
}

void PovObjectData_cls::
ReDefineList(){
    FilterData_cls::ReDefineListBase();
    mCConfList.Add(&mCObjType,   wxT("PovObjectType="));
    mCConfList.Add(&mCFontType,  wxT("PovObjectFont="), L"0");
    mCConfList.Add(&mCTextStr,   wxT("PovObjectStr="), L"Text");
    mCConfList.Add(&mCPathStr,   wxT("PovObjectPath="), L"");
    mCConfList.Add(&mCbUseClipping,   wxT("PovObjectClipping="), L"0");
    mCConfList.Add(&mCbUseMeshOffset, wxT("PovObjectMeshOffset="), L"1");
    mCConfList.Add(&mCbOpen, wxT("PovObjectOpen="), L"0");
    mCConfList.Add(&mCShapeParam, wxT("PovObjectShapeParam="), L"1");
    mCConfList.Add(&mCPluginType, wxT("PovObjectPluginType="), L"0");
    mCConfList.Add(&mCPluginTree, wxT("PovObjectPluginTree="), L"0");
    mCConfList.Add(&mCPluginQuality, wxT("PovObjectPluginQuality="), L"0");

    mCTexProperty.mCConfList.mbSetWithInitValue = mCConfList.mbSetWithInitValue;
    mCTexProperty.ReDefineList();
}

MACRO_MakeInstanceAndAddToList(PovObject)

wxString PovObjectData_cls::
SerializeConfPolymorph(){
    return mCTexProperty.Serialize() + msVCParam[mpCCtrl->mSelfDF3Index][mParamNumber].Serialize();
}

void PovObjectData_cls::
ReadStrLinePolymorph(std::wistream &istream, std::wstring strLine){
    mCTexProperty.ReadStrLine(strLine);
    msVCParam[mpCCtrl->mSelfDF3Index][mParamNumber].ReadStrLine(istream, strLine);
}

void PovObjectData_cls::
InitializeStaticMember(int df3index){
    msVCParam[df3index].reserve(_MAX_PARAMETER_NUMBER);
    msVbParamUsed[df3index].reserve(_MAX_PARAMETER_NUMBER);
}

Parameters_cls* PovObjectData_cls::
GetPParamActive(){
    return &msVCParam[mpCCtrl->mSelfDF3Index][mParamNumber];
}

std::vector < Parameters_cls > PovObjectData_cls::msVCParam[_DF3_MAX_SLOT];
std::vector < bool > PovObjectData_cls::msVbParamUsed[_DF3_MAX_SLOT];

// ----

PovObject_cls::
PovObject_cls(FilterCtrl_cls *pCParentCtrl, PovObjectData_cls *pCInitData) :
    FilterWithParameter_cls(pCParentCtrl)
{
    mpCData = new PovObjectData_cls(pCParentCtrl, (pCInitData == NULL));
    if (pCInitData != NULL) *GetPCData() = *pCInitData;
    GetPCData()->mCTexProperty.LinkFilterParameter(this, _OBJECT_ALPHA);

    mPrevObjectType = -1;
    mPrevShapeParam = -9999;

    ConstructorCommon(pCParentCtrl, _("Object"), _FILTER_POV_OBJECT);
    mpCGUIPanel = new PovObjectGUI_cls(this);
    mpFieldDataLink = NULL;
}

PovObject_cls::
~PovObject_cls(){
    if (FilterWithTextureGUI_cls::mspCLinkTexpropertyCtrl->mpCConnected == &GetPCData()->mCTexProperty)
	FilterWithTextureGUI_cls::mspCLinkTexpropertyCtrl->ConnectProperty(NULL, wxT("No Item is Linked"));
    if (mspCDF3SeqGUI != NULL)
	mspCDF3SeqGUI->mpCPanelList->Remove(mstrLabel);

    /*
      if (mTexId != -1)
      glDeleteTextures(1, &mTexId);
    */
}

MACRO_AddFilterItemPolymorphP(PovObject,RefreshTop());
MACRO_InitializeStaticMemberP(PovObject);
MACRO_GetPCData(PovObject);

//--

void PovObject_cls::
SetMNumAdvanced(wxWindow *pCParentWindow){
    MultiNumericalInputs_cls* pCurr = 
	wxDialogEXKey::InitializeMNumDLG(&mpCMNumAdvanced, pCParentWindow, wxT("Advanced Setting"));

    pCurr->mTextWidth = 160;
    pCurr->CombinePointer(_GP_BOOL, &GetPCData()->mCbUseClipping.mbBody,
			  _("Use Clipping"));
    
    pCurr->FinishSettingDLG(FALSE);
}

void PovObject_cls::
UpdateColors(){
    ((PovObjectGUI_cls*)mpCGUIPanel)->UpdateColorList();
}

void PovObject_cls::
ShowPluginHelp(){
    wxString strMessage;

    strMessage = _("Description of TOMTREE.inc");

    MsgBox(mpCGUIPanel->mpCMNumPanel, strMessage, _("Plugin description"));
}

void PovObject_cls::
AutoResize(){
    double scale[3];
    double pos[3];
    LOOP_XYZ scale[xyz] = DrawingBlock_cls::mspCBoxSize->mpInterpolatedValue[3+xyz] - DrawingBlock_cls::mspCBoxSize->mpInterpolatedValue[xyz];
    LOOP_XYZ pos[xyz] = (DrawingBlock_cls::mspCBoxSize->mpInterpolatedValue[3+xyz] + DrawingBlock_cls::mspCBoxSize->mpInterpolatedValue[xyz])/2;

    LOOP_XYZ mpCData->GetPParamActive()->mpInterpolatedValue[_OBJECT_TRANS_X + xyz] = pos[xyz];
    LOOP_XYZ mpCData->GetPParamActive()->mpInterpolatedValue[_OBJECT_SCALE_X + xyz] = scale[xyz];
    SetKeyIfChanged(_PARAM_CURRENT_DINDEX);
    FilterCtrl_cls::FuncHookRefreshTop(mpCGUIPanel->mpCMNumPanel, NULL);
}

bool PovObject_cls::
IsReprocessRequired(){
    if (mpCData->mCbValid.mbBody == FALSE) return FALSE;
    // CHECK_ME!!
    if (mPrevMappingType == _TEX_MAPPING_VALUE &&
	mPrevDoubleIndex != mpCParentCtrl->GetRemappedDoubleIndex())
	return TRUE;
    return FALSE;
}

void PovObject_cls::
SetPFieldData(unsigned char *pData, unsigned int size[3]){
    mpFieldDataLink = pData;
    LOOP_XYZ mSize[xyz] = size[xyz];
}

bool PovObject_cls::
DoesUseMapping(){
    if (mpCTexPropLink->mCColorType.mBody == 0) return FALSE;
    if (mpCTexPropLink->mCMappingType.mBody == _TEX_MAPPING_VALUE) return TRUE;
    return mpCTexPropLink->IsUVPatternReady();
}

#define MACRO_PATTERN_CASE(pattern, TAG)\
    case _TEX_PATTERN_##TAG:\
    if (mappingCoord == _MAPPING_GLOBAL){ \
	float globPos[3];						\
	for (int i = 0; i < iSize; i+=3){				\
	    GetGlobalPos(globPos, &mVVertices[i]);			\
	    mVUV1D.push_back(GetMappingValueGlobal##pattern(globPos, pos)); \
	} }								\
    else \
	for (int i = 0; i < iSize; i+=3)\
	    mVUV1D.push_back(GetMappingValueLocal##pattern(&mVVertices[i], localPivot));\
    break;

#define MACRO_PATTERN_CASEB(pattern, TAG)\
    case _TEX_PATTERN_##TAG:\
    if (mappingCoord == _MAPPING_GLOBAL){ \
	float globPos[3];						\
	for (int i = 0; i < iSize; i+=3){				\
	    GetGlobalPos(globPos, &mVVertices[i]);			\
	    mVUV1D.push_back(GetMappingValueGlobal##pattern(globPos, pos, mCurrMapAxis)); \
	} }								\
    else \
	for (int i = 0; i < iSize; i+=3)\
	    mVUV1D.push_back(GetMappingValueLocal##pattern(&mVVertices[i], localPivot, mCurrMapAxis)); \
    break;

void PovObject_cls::
MakeUV1D(TexProperty_cls *pCTexProp,
	 double offset[3], double scale[3]){
    int mappingType = pCTexProp->mCMappingType.mBody;
    int patternType = pCTexProp->mCPatternType.mBody;
    int mappingCoord = pCTexProp->mCMappingCoord.mBody;
    float *pos = pCTexProp->mCMappingPos.mpBody;
    float mapscale = pCTexProp->mCMappingScale.mBody;
    float mapturb = pCTexProp->mCMappingTurb.mBody;
    int axis = pCTexProp->mCMappingAxis.mBody;
    
    size_t size = mVUV1D.size(); // VKlʂɂȂĂ0ɂȂ

    double doubleIndex = mpCParentCtrl->GetRemappedDoubleIndex();
    if ((mappingType != _TEX_MAPPING_VALUE) &&
	IsParameterIsNewOne
	(doubleIndex, mappingType, patternType, axis, mappingCoord,
	 pos, mapscale, mapturb, offset, scale, 
	 &mpCData->GetPInterpolated()[_OBJECT_ROT_Y]) == FALSE && 
	size != 0)
	return;
    
    int iSize = (int)mVVertices.size();
    
    // ̊mۗ̈悲Clear@(TCY0̈ꎞxNgƌ)
    std::vector<float>().swap(mVUV1D);
    mVUV1D.reserve(iSize);

    unsigned int sizeY = mSize[Y];
    unsigned int sizeZ = mSize[Z];
    double offsetX = offset[X], scaleX = scale[X];
    double offsetY = offset[Y], scaleY = scale[Y];
    double offsetZ = offset[Z], scaleZ = scale[Z];
    double centerX = mpCData->GetPInterpolated()[_OBJECT_TRANS_X + X];
    double centerY = mpCData->GetPInterpolated()[_OBJECT_TRANS_X + Y];
    double centerZ = mpCData->GetPInterpolated()[_OBJECT_TRANS_X + Z];
    
    double rotZ1 = mpCData->GetPInterpolated()[_OBJECT_ROT_Y2] * _RAD;
    double rotY0 = mpCData->GetPInterpolated()[_OBJECT_ROT_R] * _RAD;
    double rotX0 = mpCData->GetPInterpolated()[_OBJECT_ROT_P] * _RAD;
    double rotZ0 = mpCData->GetPInterpolated()[_OBJECT_ROT_Y] * _RAD;
    double cosZ1 = cos(-rotZ1), sinZ1 = sin(-rotZ1);
    double cosY0 = cos(-rotY0), sinY0 = sin(-rotY0);
    double cosX0 = cos(-rotX0), sinX0 = sin(-rotX0);
    double cosZ0 = cos(-rotZ0), sinZ0 = sin(-rotZ0);
    
    if (mappingType == _TEX_MAPPING_VALUE){
	if (mpFieldDataLink == NULL)
	    for (int i = 0; i < iSize; i+=3)
		mVUV1D.push_back(0.5);
	else{ 
	    unsigned int sizeX = mSize[X];
	    
	    if (rotZ1 == 0 && rotY0 == 0 && rotX0 == 0 && rotZ0 == 0)
		for (int i = 0; i < iSize; i+=3){
		    double tmpPos1[3], localPos[3];
		    // global
		    tmpPos1[X] = mVVertices[i+X] * scaleX+ offsetX; 
		    tmpPos1[Y] = mVVertices[i+Y] * scaleY+ offsetY; 
		    tmpPos1[Z] = mVVertices[i+Z] * scaleZ+ offsetZ;

		    if (TexProperty_cls::IsRotationRequired() == TRUE)
			TexProperty_cls::ConvertGlobal2Local(tmpPos1, localPos);
		    else
			TexProperty_cls::ConvertGlobal2LocalNoRot(tmpPos1, localPos);
		    mVUV1D.push_back(GetAveragedValue(mSize, localPos, mpFieldDataLink)/257 + 0.004);
		}
	    else
		for (int i = 0; i < iSize; i+=3){
		    double tmpPos0[3], tmpPos1[3], localPos[3];
		    // global
		    tmpPos1[X] = mVVertices[i+X] * scaleX + offsetX - centerX;
		    tmpPos1[Y] = mVVertices[i+Y] * scaleY + offsetY - centerY; 
		    tmpPos0[Z] = mVVertices[i+Z] * scaleZ + offsetZ - centerZ; 
	    
		    tmpPos0[X] = tmpPos1[X] * cosZ1 + tmpPos1[Y] * sinZ1;
		    tmpPos0[Y] = - tmpPos1[X] * sinZ1 + tmpPos1[Y] * cosZ1;
		    //tmpPos0[Z] = tmpPos1[Z]; // ȗ
		    
		    tmpPos1[X] = - tmpPos0[Z] * sinY0 + tmpPos0[X] * cosY0;
		    tmpPos1[Y] = tmpPos0[Y];
		    tmpPos1[Z] = tmpPos0[Z] * cosY0 + tmpPos0[X] * sinY0;
		    
		    tmpPos0[X] = tmpPos1[X];
		    tmpPos0[Y] = tmpPos1[Y] * cosX0 + tmpPos1[Z] * sinX0;
		    tmpPos0[Z] = - tmpPos1[Y] * sinX0 + tmpPos1[Z] * cosX0;
		    
		    tmpPos1[X] = tmpPos0[X] * cosZ0 + tmpPos0[Y] * sinZ0;
		    tmpPos1[Y] = - tmpPos0[X] * sinZ0 + tmpPos0[Y] * cosZ0;
		    //tmpPos1[Z] = tmpPos0[Z]; // ȗ
		    
		    tmpPos1[X] += centerX;
		    tmpPos1[Y] += centerY;
		    tmpPos1[Z] = tmpPos0[Z] + centerZ;

		    if (TexProperty_cls::IsRotationRequired() == TRUE)
			TexProperty_cls::ConvertGlobal2Local(tmpPos1, localPos);
		    else
			TexProperty_cls::ConvertGlobal2LocalNoRot(tmpPos1, localPos);
		    mVUV1D.push_back(GetAveragedValue(mSize, localPos, mpFieldDataLink)/257 + 0.004);
		}
	}
    }

    float localPivot[3];
    LOOP_XYZ localPivot[xyz] = (pos[xyz] - offset[xyz]) / scale[xyz];

    if (mappingType == _TEX_MAPPING_PATTERN){
	switch(patternType){
	    MACRO_PATTERN_CASE(Agate, AGATE);
	    MACRO_PATTERN_CASE(Bozo, BOZO);
	    MACRO_PATTERN_CASE(Checker, CHECKER);
	    MACRO_PATTERN_CASEB(Cylindrical, CYLINDRICAL);
	    MACRO_PATTERN_CASE(Dents, DENTS);
	    MACRO_PATTERN_CASEB(Gradient, GRADIENT);
	    MACRO_PATTERN_CASE(Granite, GRANITE);
	    MACRO_PATTERN_CASEB(Hexagon, HEXAGON);
	    MACRO_PATTERN_CASE(Radial, RADIAL);
	}
    }
    
    CopyCurrToPrev(pCTexProp);
}

void PovObject_cls::
DrawPlane(double delta){
    for (double y = -15; y < 15-1e-4; y+=delta) {
	glBegin(GL_QUAD_STRIP);
	glNormal3d(0, 0, 1); 
	for (double x = -15; x <= 15+1e-4; x+=delta){
	    glVertex3d(x, y+delta, +0.01); glVertex3d(x, y, +0.01);
	}
	glEnd();
    }
    for (double y = -15; y < 15-1e-4; y+=delta) {
	glBegin(GL_QUAD_STRIP);
	glNormal3d(0, 0, -1); 
	for (double x = -15; x <= 15+1e-4; x+=delta){
	    glVertex3d(x, y, -0.01); glVertex3d(x, y+delta, -0.01);
	}
	glEnd();
    }
}

void PovObject_cls::
DrawGlobal(double viewscale){
    if (GetPCData()->mCbValid.mbBody == FALSE) return;
    if (GetPCData()->GetPParamActive()->mCbVisible.mbBody == FALSE) return;

    double min[3] = {0, 0, 0};
    double max[3] = {1, 1, 1};
    GetClippingInformation(min, max, _("Object"));
    
    bool bClipping[3] = {TRUE, TRUE, TRUE};
    LOOP_XYZ if (min[xyz] == 0 && max[xyz] == 1) bClipping[xyz] = FALSE;
    LOOP_XYZ if (GetPCData()->mCbUseClipping.mbBody == FALSE) 
	bClipping[xyz] = FALSE;

    glPushMatrix();

    SetGLMatrix(mpCData->GetPInterpolated(), NULL);

    if ((GetPCData()->mCObjType.mBody == _OBJECT_TYPE_MESH ||
	 GetPCData()->mCObjType.mBody == _OBJECT_TYPE_BOX ||
	 GetPCData()->mCObjType.mBody == _OBJECT_TYPE_CONE ||
	 GetPCData()->mCObjType.mBody == _OBJECT_TYPE_SPHERE ||
	 GetPCData()->mCObjType.mBody == _OBJECT_TYPE_PLANE) &&
	GetPCData()->mCbUseMeshOffset.mbBody == TRUE)
	glTranslated(-0.5, -0.5, -0.5);

    if (bClipping[X] == TRUE){
	double PlaneEqXmin[]={+1.0, 0, 0, -min[X]};
	double PlaneEqXmax[]={-1.0, 0, 0, max[X]};
	glClipPlane(GL_CLIP_PLANE0, PlaneEqXmin);
	glClipPlane(GL_CLIP_PLANE1, PlaneEqXmax); }
    if (bClipping[Y] == TRUE){
	double PlaneEqYmin[]={0, +1.0, 0, -min[Y]};
	double PlaneEqYmax[]={0, -1.0, 0, max[Y]};
	glClipPlane(GL_CLIP_PLANE2, PlaneEqYmin);
	glClipPlane(GL_CLIP_PLANE3, PlaneEqYmax); }
    if (bClipping[Z] == TRUE){
	double PlaneEqZmin[]={0, 0, +1.0, -min[Z]};
	double PlaneEqZmax[]={0, 0, -1.0, max[Z]};
	glClipPlane(GL_CLIP_PLANE4, PlaneEqZmin);
	glClipPlane(GL_CLIP_PLANE5, PlaneEqZmax); }

    if (bClipping[X] == TRUE){
	glEnable(GL_CLIP_PLANE0);
	glEnable(GL_CLIP_PLANE1); }
    if (bClipping[Y] == TRUE){
	glEnable(GL_CLIP_PLANE2);
	glEnable(GL_CLIP_PLANE3); }
    if (bClipping[Z] == TRUE){
	glEnable(GL_CLIP_PLANE4);
	glEnable(GL_CLIP_PLANE5); }

    glEnable(GL_LIGHTING);
    glEnable(GL_DEPTH_TEST);
    glDepthMask(GL_TRUE);
    glDisable(GL_TEXTURE_2D);

    SetGLColoring(&GetPCData()->mCTexProperty, 0.5);
    GLboolean bCulling;
    glGetBooleanv(GL_CULL_FACE, &bCulling);
    glDisable(GL_CULL_FACE);
	
    glEnable( GL_NORMALIZE );
    switch(GetPCData()->mCObjType.mBody){
    case _OBJECT_TYPE_WIRED_BOX: 
	glPushMatrix();
	glLineWidth(1 + GetPCData()->mCShapeParam.mBody);
	glTranslated(-0.5, -0.5, -0.5);
	glCallList(displayListWireBox[4]);
	glLineWidth(1);
	glPopMatrix();
	break;
    case _OBJECT_TYPE_ARROW: {
	double shape = GetPCData()->mCShapeParam.mBody;
	glPushMatrix();
	glTranslated(0, 0, -0.6 + 0.3 * (2.0 - shape));
	glScaled(0.1, 0.1, 0.3 * (2.0 - shape));
	glCallList(displayListCylinder);
	glPopMatrix();
	glTranslated(0, 0, 0.6 - 0.3 * shape);
	glScaled(0.25, 0.25, 0.3 * shape);
	glCallList(displayListCone);
	break; }
    case _OBJECT_TYPE_TEXT:{
	void* font = GLUT_BITMAP_HELVETICA_12;
	if (mpCData->GetPInterpolated()[_OBJECT_SCALE_X] > 1) font = GLUT_BITMAP_HELVETICA_18;
	GLOBJ::Strings2D::Draw3DPos(font, GetPCData()->mCTextStr.msBody.ToAscii(), 0, 0, 0);
	break; } 
    case _OBJECT_TYPE_PLANE:
    case _OBJECT_TYPE_BOX:
    case _OBJECT_TYPE_SPHERE:
    case _OBJECT_TYPE_CONE:
    case _OBJECT_TYPE_MESH: {

	if (GetPCData()->mCObjType.mBody == _OBJECT_TYPE_MESH &&
	    mstrLoaded == wxT("")) break;
	
	glLightModeli(GL_LIGHT_MODEL_TWO_SIDE,GL_TRUE);
	
	if (mVVertices.size() == 0) {
	    RefreshFilter(mpFieldDataLink, mSize);
	    if (mVVertices.size() == 0) break; }
	
	int colorType = GetPCData()->mCTexProperty.mCColorType.mBody;
	double offset[3], scale[3];
	LOOP_XYZ offset[xyz] = mpCData->GetPInterpolated()[_OBJECT_TRANS_X + xyz];
	LOOP_XYZ scale[xyz] = mpCData->GetPInterpolated()[_OBJECT_SCALE_X + xyz];
	if (GetPCData()->mCbUseMeshOffset.mbBody == TRUE)
	    LOOP_XYZ offset[xyz] -= 0.5 * scale[xyz];
	
	Configure1DMapping(&GetPCData()->mCTexProperty, offset,
			   &mpCData->GetPInterpolated()[_OBJECT_SCALE_X]);
	
	if (mVVertices.size() == mVNormals.size()) {
	    
	    glEnableClientState(GL_VERTEX_ARRAY);
	    glEnableClientState(GL_NORMAL_ARRAY);
	    if (DoesUseMapping() == TRUE)
		glEnableClientState(GL_TEXTURE_COORD_ARRAY);
	    	    
	    glVertexPointer(3, GL_FLOAT, 0, &mVVertices[0]);
	    glNormalPointer(GL_FLOAT, 0, &mVNormals[0]);
	    if (DoesUseMapping() == TRUE)
		glTexCoordPointer(1, GL_FLOAT, 0, &mVUV1D[0]);

	    glDrawElements(GL_TRIANGLES, (GLsizei)mVIndex.size() , 
			   GL_UNSIGNED_INT, &mVIndex[0]);
	    
	    glDisableClientState(GL_TEXTURE_COORD_ARRAY);
	    glDisableClientState(GL_VERTEX_ARRAY);
	    glDisableClientState(GL_NORMAL_ARRAY);
	}
	else{
	    glBegin(GL_TRIANGLES);
	    int indexSize = (int)mVIndex.size();
	    for (int i = 0; i < indexSize; i+=3){
		for (int j = 0; j < 3; j++){
		    int normalOffset = mVIndexNormal[i+j] * 3;
		    glNormal3d(mVNormals[normalOffset + X],
			       mVNormals[normalOffset + Y],
			       mVNormals[normalOffset + Z]);
		    int vertexOffset = mVIndex[i+j] * 3;
		    glVertex3d(mVVertices[vertexOffset + X],
			       mVVertices[vertexOffset + Y],
			       mVVertices[vertexOffset + Z]);
		}
	    }
	    glEnd();
	}

	if (bCulling == TRUE)
	    glEnable(GL_CULL_FACE);

	break; }
    case _OBJECT_TYPE_PLUGIN:
	DrawGLPlugin(GetPCData()->mCPluginType.mBody,
		     GetPCData()->mCPluginTree.mBody);
	break;
    }
    glDisable(GL_NORMALIZE);

    glDisable(GL_CLIP_PLANE5);
    glDisable(GL_CLIP_PLANE4);
    glDisable(GL_CLIP_PLANE3);
    glDisable(GL_CLIP_PLANE2);
    glDisable(GL_CLIP_PLANE1);
    glDisable(GL_CLIP_PLANE0);
    
    glPopMatrix();
    
    glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_BLEND);
    glBindTexture(GL_TEXTURE_1D, 0);
    glDisable(GL_TEXTURE_1D);
    glDisable(GL_LIGHTING);
    glDepthMask(GL_FALSE);
}

// -----

void PovObject_cls::
ClearMesh(){
    // ̊mۗ̈悲Clear@(TCY0̈ꎞxNgƌ)
    std::vector<float>().swap(mVVertices);
    std::vector<float>().swap(mVUV1D);
    std::vector<float>().swap(mVNormals);
    std::vector<unsigned int>().swap(mVIndex);
    std::vector<unsigned int>().swap(mVIndexNormal);
}

#define _BOX_RESOL 100

void PovObject_cls::
MakeMeshPlaneTile(double offsetX, double offsetY, 
		  double scaleX, double scaleY, int resolution){
    double y, x;
    for (int iy = 0; iy < resolution; iy++){
	y = ((double)iy) / (resolution - 1);
	y *= scaleY; y += offsetY;
	for (int ix = 0; ix < resolution; ix++){
	    x = ((double)ix) / (resolution - 1);
	    x *= scaleX; x += offsetX;
	    mVVertices.push_back(x);
	    mVVertices.push_back(y);
	    mVVertices.push_back(0.5);
	    mVNormals.push_back(0);
	    mVNormals.push_back(0);
	    mVNormals.push_back(1);
	}
    }
}

void PovObject_cls::
MakeMeshPlane(){
    ClearMesh();

    MakeMeshPlaneTile(-13, -13, 9, 9, 100);
    MakeMeshPlaneTile(-4 , -13, 9, 9, 100);
    MakeMeshPlaneTile( 5 , -13, 9, 9, 100);
    MakeMeshPlaneTile(-13, -4, 9, 9, 100);
    MakeMeshPlaneTile( 5 , -4, 9, 9, 100);
    MakeMeshPlaneTile(-13, 5, 9, 9, 100);
    MakeMeshPlaneTile(-4 , 5, 9, 9, 100);
    MakeMeshPlaneTile( 5 , 5, 9, 9, 100);
    
    for (int i = 0; i < 8; i++)
	MakeMeshBoxIndex(i * 100 * 100, 100);
    MakeMeshPlaneTile(-4 , -4, 9, 9, 200); // ^񒆂ׂ͍
    MakeMeshBoxIndex(8 * 100 * 100, 200);
}

// FIX_ME!! |ŠCɂĂȂI
void PovObject_cls::
MakeMeshBoxVertexX(double x, double normalx, bool bFlip){
    double y, z;
    for (int iz = 0; iz < _BOX_RESOL; iz++){
	z = ((double)iz) / (_BOX_RESOL - 1);
	if (bFlip == TRUE) z = 1.0f - z;
	for (int iy = 0; iy < _BOX_RESOL; iy++){
	    y = ((double)iy) / (_BOX_RESOL - 1);
	    mVVertices.push_back(x);
	    mVVertices.push_back(y);
	    mVVertices.push_back(z);
	    mVNormals.push_back(normalx);
	    mVNormals.push_back(0);
	    mVNormals.push_back(0);
	}
    }
}

void PovObject_cls::
MakeMeshBoxVertexY(double y, double normaly, bool bFlip){
    double x, z;
    for (int iz = 0; iz < _BOX_RESOL; iz++){
	z = ((double)iz) / (_BOX_RESOL - 1);
	if (bFlip == TRUE) z = 1.0f - z;
	for (int ix = 0; ix < _BOX_RESOL; ix++){
	    x = ((double)ix) / (_BOX_RESOL - 1);
	    mVVertices.push_back(x);
	    mVVertices.push_back(y);
	    mVVertices.push_back(z);
	    mVNormals.push_back(0);
	    mVNormals.push_back(normaly);
	    mVNormals.push_back(0);
	}
    }
}

void PovObject_cls::
MakeMeshBoxVertexZ(double z, double normalz, bool bFlip){
    double y, x;
    for (int iy = 0; iy < _BOX_RESOL; iy++){
	y = ((double)iy) / (_BOX_RESOL - 1);
	if (bFlip == TRUE) y = 1.0f - y;
	for (int ix = 0; ix < _BOX_RESOL; ix++){
	    x = ((double)ix) / (_BOX_RESOL - 1);
	    mVVertices.push_back(x);
	    mVVertices.push_back(y);
	    mVVertices.push_back(z);
	    mVNormals.push_back(0);
	    mVNormals.push_back(0);
	    mVNormals.push_back(normalz);
	}
    }
}

void PovObject_cls::
MakeMeshBoxIndex(int offset, int resolution){
    for (int iv = 0; iv < (resolution - 1); iv++){
	int indexV = iv * resolution;
	for (int iu = 0; iu < (resolution - 1); iu++){
	    int index = indexV + iu;
	    mVIndex.push_back(offset + index);
	    mVIndex.push_back(offset + index + 1);
	    mVIndex.push_back(offset + index + resolution);
	    mVIndex.push_back(offset + index + resolution);
	    mVIndex.push_back(offset + index + 1);
	    mVIndex.push_back(offset + index + resolution + 1);
	    mVIndexNormal.push_back(offset + index);
	    mVIndexNormal.push_back(offset + index + 1);
	    mVIndexNormal.push_back(offset + index + resolution);
	    mVIndexNormal.push_back(offset + index + resolution);
	    mVIndexNormal.push_back(offset + index + 1);
	    mVIndexNormal.push_back(offset + index + resolution + 1);
	}
    }
}

void PovObject_cls::
MakeMeshBox(){
    ClearMesh();
    MakeMeshBoxVertexX(0, -1, TRUE);
    MakeMeshBoxVertexX(1, 1, FALSE);
    MakeMeshBoxVertexY(0, -1, FALSE);
    MakeMeshBoxVertexY(1, 1, TRUE);
    MakeMeshBoxVertexZ(0, -1, TRUE);
    MakeMeshBoxVertexZ(1, 1, FALSE);
    for (int i = 0; i < 6; i++)
	MakeMeshBoxIndex(i * _BOX_RESOL * _BOX_RESOL, _BOX_RESOL);
}

void PovObject_cls::
MakeMeshSphere(){
    ClearMesh();

    // dllstd::vector̂肷̂
    // vc++2005ł͖肪炵BTCYςȂ悤ɗ\߁B
    // 3-3960-3840, 4-15480-15360
    mVVertices.reserve(61560); mVNormals.reserve(61560);
    mVIndex.reserve(61440)   ; mVIndexNormal.reserve(61440);
    GLOBJ::Sphere::MakeMeshSphere(5, &mVVertices, &mVNormals,
				  &mVIndex, &mVIndexNormal);
    
    for (int i = 0; i < mVVertices.size(); i++)
	mVVertices[i] *= 0.5;
    for (int i = 0; i < mVVertices.size(); i++)
	mVVertices[i] += 0.5;
}

void PovObject_cls::
MakeMeshCone(){
    ClearMesh();

    // dllstd::vector̂肷̂
    // vc++2005ł͖肪炵BTCYςȂ悤ɗ\߁B
    mVVertices.reserve(120000); mVNormals.reserve(120000);
    mVIndex.reserve(120000)   ; mVIndexNormal.reserve(120000);
    GLOBJ::Cone::MakeMeshCone(&mVVertices, &mVNormals,
			      &mVIndex, &mVIndexNormal,
			      120, 48, GetPCData()->mCShapeParam.mBody,
			      GetPCData()->mCbOpen.mbBody);
    
    for (int i = 0; i < mVVertices.size(); i++)
	mVVertices[i] *= 0.5;
    for (int i = 0; i < mVVertices.size(); i++)
	mVVertices[i] += 0.5;
}

void PovObject_cls::
ConstructNormalVectors(){
    mVNormals.resize(mVVertices.size());
    
    int normalSize = mVNormals.size();
    int normalNum = normalSize / 3;
    for (int i = 0; i < normalSize; i++)
	mVNormals[i] = 0;
    std::vector < unsigned char > mVOverlap(normalNum);
    
    int faceSize = mVIndex.size();
    int faceNum = faceSize / 3;
    for (int i = 0; i < faceNum; i++){
	int index0 = mVIndex[i*3 + 0];
	int index1 = mVIndex[i*3 + 1];
	int index2 = mVIndex[i*3 + 2];
	float *p0 = &mVVertices[index0*3];
	float *p1 = &mVVertices[index1*3];
	float *p2 = &mVVertices[index2*3];

	double normal[3];
	normal[X] = (p1[Y]-p0[Y])*(p2[Z]-p1[Z]) - (p1[Z]-p0[Z])*(p2[Y]-p1[Y]);
	normal[Y] = (p1[Z]-p0[Z])*(p2[X]-p1[X]) - (p1[X]-p0[X])*(p2[Z]-p1[Z]);
	normal[Z] = (p1[X]-p0[X])*(p2[Y]-p1[Y]) - (p1[Y]-p0[Y])*(p2[X]-p1[X]);
	
	MyVector::Normalize(normal, 1);

	int overlap;

	mVOverlap[index0]++;
	overlap = mVOverlap[index0];
	LOOP_XYZ mVNormals[index0*3 + xyz] =
	    (mVNormals[index0*3 + xyz] * (overlap - 1) + normal[xyz]) / overlap;
	
	mVOverlap[index1]++;
	overlap = mVOverlap[index1];
	LOOP_XYZ mVNormals[index1*3 + xyz] =
	    (mVNormals[index1*3 + xyz] * (overlap - 1) + normal[xyz]) / overlap;

	mVOverlap[index2]++;
	overlap = mVOverlap[index2];
	LOOP_XYZ mVNormals[index2*3 + xyz] =
	    (mVNormals[index2*3 + xyz] * (overlap - 1) + normal[xyz]) / overlap;

    }

    for (int i = 0; i < normalNum; i++){
	if (MyVector::GetNorm(&mVNormals[i*3]) == 0){
	    mVNormals[i*3+X] = 0;
	    mVNormals[i*3+Y] = 0;
	    mVNormals[i*3+Z] = 1;
	}
	MyVector::Normalize(&mVNormals[i*3], 1);
    }
}

void PovObject_cls::
ReadObjFile(wxString strFile){
    FILE *fp = fopen(strFile.ToAscii(), "rb");
    if (fp == NULL) {
	mstrLoaded = strFile; return; }

    fseek( fp, 0, SEEK_END );
    long fileSize = ftell( fp );
    fseek( fp, 0, SEEK_SET);
    
    unsigned char *pBuffer = new unsigned char [fileSize];
    fread( pBuffer, 1, fileSize, fp);
    fclose(fp);
    
    // ɈU߂قfgcB
    wxMemoryInputStream CMStream(pBuffer, fileSize);
	
    wxString sep = wxT(" \t\n");
    wxTextInputStream CTStream(CMStream, sep);

    int smooth;
 
    ClearMesh();
    
    mVIndex.reserve(fileSize / 3 / 7);
    mVIndexNormal.reserve(fileSize / 3 / 7);
    mVVertices.reserve(fileSize / 3 / 10);
    mVUV1D.reserve(fileSize / 3 / 10);
    mVNormals.reserve(fileSize / 3 / 10);

    bool bSliceChecked = FALSE;
    bool bIsSliceExist = FALSE;

    wxString strWord;
    strWord = CTStream.ReadWord();
    while (!strWord.Matches(L"o")){
	strWord = CTStream.ReadWord();
    }
    strWord = CTStream.ReadWord();
    strWord = CTStream.ReadWord();
    while (strWord.Matches(L"v")){
	float vertexX, vertexY, vertexZ;
	CTStream >> vertexX >> vertexY >> vertexZ;
	mVVertices.push_back(vertexX); //QdzƂȂ̂ŁAڂ
	mVVertices.push_back(vertexY);
	mVVertices.push_back(vertexZ);
	if (CMStream.CanRead() == FALSE) break;
	strWord = CTStream.ReadWord();
    }
    while (strWord.Matches(L"vn")){
	float normalX, normalY, normalZ;
	CTStream >> normalX >> normalY >> normalZ;
	mVNormals.push_back(normalX);
	mVNormals.push_back(normalY);
	mVNormals.push_back(normalZ);
	if (CMStream.CanRead() == FALSE) break;
	strWord = CTStream.ReadWord();
    }
    while (CMStream.CanRead() == TRUE){
	if (strWord.Matches(L"f") == TRUE){
	    if (bSliceChecked == FALSE){
		size_t pos = CMStream.TellI();
		// Nomalʂǂ
		// FIX_ME "*/*/*" tBbgꍇ͂܂ʁI
		wxString strInit = CTStream.ReadWord();
		if (strInit.Matches(L"*//*")){
		    bIsSliceExist = TRUE;
		    CTStream.SetStringSeparators(L" \t\n/");
		}
		bSliceChecked = TRUE;
		CMStream.SeekI(pos, wxFromStart);
	    }
	    if (bIsSliceExist == TRUE){
		unsigned int index0, index1, index2;
		unsigned int indexNorm0, indexNorm1, indexNorm2;
		CTStream >> index0 >> indexNorm0 >> index1 >> indexNorm1 >> index2 >> indexNorm2;
		mVIndex.push_back(index0-1); //Obj͔z񂪂PX^[g
		mVIndex.push_back(index1-1);
		mVIndex.push_back(index2-1);
		mVIndexNormal.push_back(indexNorm0-1); 
		mVIndexNormal.push_back(indexNorm1-1);
		mVIndexNormal.push_back(indexNorm2-1);
	    }
	    else{
		long index0, index1, index2;
		CTStream.ReadWord().ToLong(&index0);
		CTStream.ReadWord().ToLong(&index1);
		CTStream.ReadWord().ToLong(&index2);
		mVIndex.push_back(index0-1); //Obj͔z񂪂PX^[g
		mVIndex.push_back(index1-1);
		mVIndex.push_back(index2-1);
		mVIndexNormal.push_back(index0-1);
		mVIndexNormal.push_back(index1-1);
		mVIndexNormal.push_back(index2-1);
	    }
	}
	if (strWord.Matches(L"s") == TRUE){
	    wxString strSmooth = CTStream.ReadWord();
	    if (strSmooth.Matches(L"off") == TRUE) smooth = 0;
	    if (strSmooth.Matches(L"1") == TRUE) smooth = 1;
	}
	strWord = CTStream.ReadWord();
    }

    delete pBuffer;
    mstrLoaded = GetPCData()->mCPathStr.msBody;

    // @xNg
    if (mVNormals.size() == 0)
	ConstructNormalVectors();
}

ThreadReadMesh2Sub::
ThreadReadMesh2Sub(unsigned char *pBuffer, int fileSize, int posStart,
		   int itemNum, int skipLine,
		   std::vector < float > *pVData) :
    wxThread(wxTHREAD_JOINABLE)
{
    mpBuffer = pBuffer;
    mFileSize = fileSize;
    mPosStart = posStart;
    mItemNum = itemNum;
    mSkipLine = skipLine;
    mpVData = pVData;
    
    if ( Create() != wxTHREAD_NO_ERROR) 
	MsgBoxExit(NULL, "Error!", "Can't create thread");
}

wxThread::ExitCode ThreadReadMesh2Sub::
Entry(){
    wxMemoryInputStream CMStream(mpBuffer + mPosStart, mFileSize - mPosStart);

    wxString sep = wxT("\n");
    wxTextInputStream CTStream(CMStream, sep);

    int itemNum = mItemNum;
    float vectorX, vectorY, vectorZ;

    for (int i = 0; i < mSkipLine; i++) CTStream.ReadLine();

    // tab邱ƂOɂĂBxƔėpǂH
    std::vector <float> *pVData = mpVData;
    
    int item = 0;
    while(TRUE){
	wxString strLine = CTStream.ReadLine();
	wxWritableCharBuffer charBuffer = strLine.char_str();
	char *ptr = charBuffer;
	
	while(TRUE){
	    ptr = strchr(ptr, '<');
	    if (ptr == NULL) break;
	    int scanNum = sscanf(ptr+1, "%f,%f,%f", 
				 &vectorX, &vectorY, &vectorZ);
	    if (scanNum == 0) break;
	    pVData->push_back(vectorX);
	    pVData->push_back(vectorY);
	    pVData->push_back(vectorZ);
	    item++; ptr++;
	}

	if (item >= itemNum) break;
    }

    /*
    for (int i = 0; i < itemNum; i++){
	wxString strLine = CTStream.ReadLine();
	sscanf(((char*)strLine.char_str()+3), "%f,%f,%f", 
	       &vectorX, &vectorY, &vectorZ);
	pVData->push_back(vectorX);
	pVData->push_back(vectorY);
	pVData->push_back(vectorZ);
    }
    */

    return 0;
}

void PovObject_cls::
ReadMesh2File(wxString strFile){

    FILE *fp = fopen(strFile.ToAscii(), "rb");
    if (fp == NULL) {
	mstrLoaded = strFile; return; }

    fseek( fp, 0, SEEK_END );
    long fileSize = ftell( fp );
    fseek( fp, 0, SEEK_SET);
    
    unsigned char *pBuffer = new unsigned char [fileSize];
    fread( pBuffer, 1, fileSize, fp);
    fclose(fp);

    // ɈU߂قfgcB
    wxMemoryInputStream CMStream(pBuffer, fileSize);
	
    GbGLLockForMultithread = TRUE;

    wxString sep = wxT(" \t\n=,{}");
    wxTextInputStream CTStream(CMStream, sep);

    ClearMesh();

    mVIndex.reserve(fileSize / 3 / 7);
    mVIndexNormal.reserve(fileSize / 3 / 7);
    mVVertices.reserve(fileSize / 3 / 10);
    mVUV1D.reserve(fileSize / 3 / 10);
    mVNormals.reserve(fileSize / 3 / 10);

    int posNormal = -1, posIndex = -1;

    wxString strWord;
    strWord = CTStream.ReadWord();
    while (!strWord.Matches(L"#declare")){
	if (strWord.Matches(L"//normal_start_at"))
	    CTStream >> posNormal;
	if (strWord.Matches(L"//index_start_at"))
	    CTStream >> posIndex;
	strWord = CTStream.ReadWord();
    }
    mstrPovLabel = CTStream.ReadWord();
    while (!strWord.Matches(L"vertex_vectors")){
	strWord = CTStream.ReadWord();
    }
    int vertexNum;
    CTStream >> vertexNum;
    mVVertices.reserve(vertexNum * 3);

    // Verticex ǂݍ݂ʃXbhŊJn
    ThreadReadMesh2Sub CThreadVertices
	(pBuffer, fileSize, CMStream.TellI(), vertexNum,
	 1, &mVVertices);
    CThreadVertices.Run();

    // m[}ʒum肵ĂȂΉsłǂĂ
    if (posNormal == -1){
	CTStream.ReadLine(); //dummy
	for (int i = 0; i < vertexNum; i++)
	    wxString strLine = CTStream.ReadLine();
    }
    else
	CMStream.SeekI(posNormal);
    
    int normalNum = -1;
    strWord = CTStream.ReadWord();
    printf ("%ls\n", strWord.c_str());
    if (strWord.Matches(L"normal_vectors")){
	CTStream >> normalNum;
	mVNormals.reserve(normalNum * 3);
    }

    ThreadReadMesh2Sub CThreadNormal
	(pBuffer, fileSize, CMStream.TellI(), normalNum,
	 1, &mVNormals);
    if (normalNum != -1) CThreadNormal.Run();

    // Indexʒum肵ĂȂΉsłǂĂ
    if (normalNum != -1){
	if (posIndex == -1){
	    CTStream.ReadLine(); //dummy
	    for (int i = 0; i < vertexNum; i++)
		wxString strLine = CTStream.ReadLine();
	}
	else
	    CMStream.SeekI(posIndex);
	
	// normal΁AstrWord͐Vɓǂ܂Ɉێ
	strWord = CTStream.ReadWord();
    }
    
    if (strWord.Matches(L"face_indices")){
	int faceNum;
	CTStream >> faceNum;
	mVIndex.reserve(faceNum * 3);

	int indexX, indexY, indexZ;
	//CTStream.ReadLine(); //dummy
	int item = 0;
	while(TRUE){
	    wxString strLine = CTStream.ReadLine();
	    wxWritableCharBuffer charBuffer = strLine.char_str();
	    char *ptr = charBuffer;
	    
	    while(TRUE){
		ptr = strchr(ptr, '<');
		if (ptr == NULL) break;
		int scanNum = sscanf(ptr+1, "%d,%d,%d", 
				     &indexX, &indexY, &indexZ);
		if (scanNum == 0) break;
		mVIndex.push_back(indexX);
		mVIndex.push_back(indexY);
		mVIndex.push_back(indexZ);
		item++; ptr++;
	    }
	    
	    if (item >= faceNum) break;
	}
	
	/*
	for (int i = 0; i < faceNum; i++){
	    wxString strLine = CTStream.ReadLine();
	    sscanf(((char*)strLine.char_str()+3), "%d,%d,%d", &indexX, &indexY, &indexZ);
	    mVIndex.push_back(indexX);
	    mVIndex.push_back(indexY);
	    mVIndex.push_back(indexZ);
	}
	*/
    }

    CThreadVertices.Wait();
    if (normalNum != -1) CThreadNormal.Wait();

    delete pBuffer;
    mstrLoaded = GetPCData()->mCPathStr.msBody;

    GbGLLockForMultithread = FALSE;
}

void PovObject_cls::
RefreshFilter(unsigned char *pSource, unsigned int size[3]){
    if (GbGLLockForLoading == TRUE) return;

    bool bMesh = FALSE;
    int objectType = GetPCData()->mCObjType.mBody;
    float objectShapeParam = GetPCData()->mCShapeParam.mBody;
    
    switch(objectType){
    case _OBJECT_TYPE_PLANE:
	if (mPrevObjectType != objectType) MakeMeshPlane();
	bMesh = TRUE;
	break;
    case _OBJECT_TYPE_BOX:
	if (mPrevObjectType != objectType) MakeMeshBox();
	bMesh = TRUE;
	break;
    case _OBJECT_TYPE_SPHERE:
	if (mPrevObjectType != objectType) MakeMeshSphere();
	bMesh = TRUE;
	break;
    case _OBJECT_TYPE_CONE:
	if (mPrevObjectType != objectType || 
	    mPrevShapeParam != objectShapeParam) MakeMeshCone();
	
	bMesh = TRUE;
	break;
    case _OBJECT_TYPE_MESH:{
	if (mPrevObjectType != objectType) mstrLoaded = wxT("");
	wxString strFile = GetPCData()->mCPathStr.msBody;
	if (strFile != mstrLoaded){
	    if (strFile.Matches(L"*.obj"))
		ReadObjFile(strFile);
	    if (strFile.Matches(L"*.pov"))
		ReadMesh2File(strFile);
	}
	bMesh = TRUE;
	break; }
    }
	
    mPrevObjectType = objectType;
    mPrevShapeParam = objectShapeParam;
	
    if (bMesh == TRUE){

	bool bChanged = mpCParentCtrl->IsReprocessRequired
	(GetRemappedIndex(), GetRemappedIndexDouble(), this);

	if ((bChanged | IsReprocessRequired()) == FALSE) return;
	
	double offset[3], scale[3];
	LOOP_XYZ offset[xyz] = mpCData->GetPInterpolated()[_OBJECT_TRANS_X + xyz];
	LOOP_XYZ scale[xyz] = mpCData->GetPInterpolated()[_OBJECT_SCALE_X + xyz];
	if (GetPCData()->mCbUseMeshOffset.mbBody == TRUE)
	    LOOP_XYZ offset[xyz] -= 0.5 * scale[xyz];
	
	// _TEX_MAPPING_VALUE ̎͂ł̂ ReTexƂ
	SetPFieldData(pSource, size);
	MakeUV1D(&GetPCData()->mCTexProperty,
		 offset, &mpCData->GetPInterpolated()[_OBJECT_SCALE_X]);
    }
}

// -----

void PovObject_cls::
SetMatrix(Parameters_cls* pParam, int i, double dpos[3], int flag){
    double pos[3] = {
	pParam->GetPKeyFrameValue(i)[0] + dpos[0],
	pParam->GetPKeyFrameValue(i)[1] + dpos[1],
	pParam->GetPKeyFrameValue(i)[2] + dpos[2]};
    Direction_cls CDir;
    GLOBJ::SetMatrix3dv3(pos, CDir.mTgt, CDir.mTop);
    //glScalef(mScale, mScale, mScale);
}

bool PovObject_cls::
IsTetureAvailable(){
    if (GetPCData()->mCObjType.mBody == _OBJECT_TYPE_PLUGIN &&
	GetPCData()->mCPluginType.mBody == _PLUGIN_TOMTREE)
	return FALSE;
    return TRUE;
}

void PovObject_cls::
DrawGLGuide(GLGuides_cls *pCGLGuides, double dpos[3], double scale,
	    int manipMode, double dScale[3], double dRot[4]){
    
    glPushMatrix();
    if (DrawSelectedKey(pCGLGuides, GetPCData()->GetPParamActive(), NULL, NULL, -1,
			dpos, scale, 0, _MANIP_TRANSLATE, 0) == FALSE)
	DrawGLGuideCommon(pCGLGuides, dpos, scale, manipMode, 
			  dScale, dRot,
			  GetPCData()->GetPInterpolated(),
			  GetPCData()->mCObjType.mBody,
			  GetPCData()->mCShapeParam.mBody);
    glPopMatrix();
}

wxString PovObject_cls::
GetPovStrObject(int coordinateType, wxString strTag,
		PositionAndDirection_cls CCamPos,
		wxString strFilePath){
    
    if (mpCData->mCbValid.mbBody == FALSE) return wxT("");
    if (GetPCData()->mCbUseClipping.mbBody == TRUE &&
	IsClippingEmpty() == TRUE) return wxT("");

    int objectType = GetPCData()->mCObjType.mBody;

    // _łlocalWƂČĂяô͂Ȃ
    if (coordinateType == _POV_OBJECT_LOCAL_CALL) return wxT("");
    
    double min[3] = {0, 0 ,0};
    double max[3] = {1, 1, 1};
    GetClippingInformation(min, max, _("Object"));
    LOOP_XYZ if (min[xyz] < 0.0005) min[xyz] = 0.0005; // Volumei
    LOOP_XYZ if (max[xyz] > 0.9995) max[xyz] = 0.9995;

    wxString strObjGeom, strInclude, strTab;

    if (objectType == _OBJECT_TYPE_MESH && mstrLoaded.Matches(L"*.pov"))
	strInclude << wxT("#include \"") << mstrLoaded << wxT("\"") << ENDLWX;

    if (objectType == _OBJECT_TYPE_MESH && mstrLoaded.Matches(L"*.obj"))
	strObjGeom << Wavefront_cls::GetMesh2Format
	    (mstrId, TRUE, &mVVertices, &mVNormals, &mVIndex);
    
    if (objectType == _OBJECT_TYPE_PLUGIN)
	strObjGeom << GetPovStrPluginParameters
	    (GetPCData()->mCPluginType.mBody, GetPCData()->mCPluginTree.mBody,
	     GetPCData()->mCPluginQuality.mBody);
    
    strObjGeom << wxT("#declare ") << wxT("POVOBJ_GEOM_") << mstrId << wxT("=");
    
    if (GetPCData()->mCbUseClipping.mbBody == TRUE){
	strObjGeom << wxT("intersection {") << ENDLWX;
	strTab << wxT("\t");
    }
    
    switch (objectType){
    case _OBJECT_TYPE_PLANE:
	strObjGeom 
	    << strTab << wxT("plane{ z, 0") << ENDLWX;
	break;
    case _OBJECT_TYPE_BOX:
	strObjGeom 
	    << strTab << wxT("box{") << ENDLWX
	    << strTab << wxT("\t<-0.5, -0.5, -0.5> <0.5, 0.5, 0.5>") << ENDLWX;
	break;
    case _OBJECT_TYPE_WIRED_BOX: {
	// ̖̑肪̂ŁAXP[O͎͂
	float ptA[3] = {-0.5, -0.5, -0.5}, ptB[3] = {0.5, 0.5, 0.5};
	LOOP_XYZ ptA[xyz] *= mpCData->GetPInterpolated()[_OBJECT_SCALE_X + xyz];
	LOOP_XYZ ptB[xyz] *= mpCData->GetPInterpolated()[_OBJECT_SCALE_X + xyz];
	// ]Aړ͂Ȃ
	/*
	LOOP_XYZ ptA[xyz] += mpCData->GetPInterpolated()[_OBJECT_TRANS_X + xyz];
	LOOP_XYZ ptB[xyz] += mpCData->GetPInterpolated()[_OBJECT_TRANS_X + xyz];
	*/
	strObjGeom 
	    << strTab << wxT("object { ") << ENDLWX;
	strObjGeom 
	    << wxT("Wire_Box(") << PovOut3f(wxT(""), ptA) << PovOut3f(wxT(","), ptB) << wxT(",") << 0.003 * GetPCData()->mCShapeParam.mBody << wxT(", 1)") << ENDLWX;
	break; }
    case _OBJECT_TYPE_SPHERE:
	strObjGeom 
	    << strTab << wxT("sphere{ <0, 0, 0>, 0.5") << ENDLWX;
	break;
    case _OBJECT_TYPE_CONE:
	strObjGeom
	    << strTab << wxT("cone{ <0, 0, -0.5>, 0.5, <0, 0, 0.5> ") << GetPCData()->mCShapeParam.mBody * 0.5;
	if (GetPCData()->mCbOpen.mbBody == TRUE) strObjGeom << wxT(" open");
	strObjGeom << ENDLWX;
	
	break;
    case _OBJECT_TYPE_ARROW: {
	double shape = GetPCData()->mCShapeParam.mBody;
	strObjGeom << strTab << wxT("object {") << ENDLWX
		   << strTab << wxT("\tunion {") << ENDLWX
		   << strTab << wxT("\t\tcylinder { <0, 0, -0.6>, <0, 0, ") << 0.6 - 0.6 * shape + 0.001<< wxT(" >, 0.1 }") << ENDLWX
		   << strTab << wxT("\t\tcone { <0, 0, ") << 0.6 - 0.6 * shape - 0.001 << wxT(" >, 0.25, <0, 0, 0.6>, 0 }") << ENDLWX
		   << strTab << wxT("\t}") << ENDLWX;
	break; }
    case _OBJECT_TYPE_TEXT: {// ARIALN
	wxString strFont;
	switch(GetPCData()->mCFontType.mBody){
	case 0:
	    strFont = wxT("cyrvetic.ttf"); break;
	case 1:
	    strFont = wxT("timrom.ttf"); break;
	case 2:
	    strFont = wxT("crystal.ttf"); break;
	}
	strObjGeom 
	    << strTab << wxT("text{ ttf \"") << strFont << wxT("\", \"") << GetPCData()->mCTextStr.msBody << wxT("\", 0.01, <0,0,0>") << ENDLWX
	    << strTab << wxT("\trotate <90, 0, 90>") 
	    << strTab << wxT("\tscale SCALE * <0.03, 0.03, 0.03>") << ENDLWX
	    << strTab << wxT("\tMatrixYZ2Cam()") << ENDLWX;
	break; }
    case _OBJECT_TYPE_MESH: 
	if (mstrLoaded.Matches(L"*.obj"))
	    strObjGeom 
		<< strTab << wxT("object{ MESH2OBJ_") << mstrId << ENDLWX;
	else
	    strObjGeom 
		<< strTab << wxT("object{") << ENDLWX
		<< strTab << wxT("\t") << mstrPovLabel << ENDLWX;
	break;
    case _OBJECT_TYPE_PLUGIN:
	strObjGeom << GetPovStrPluginObject
	    (GetPCData()->mCPluginType.mBody,
	     GetPCData()->mCPluginTree.mBody);
	break;
    }

   
    if (GetPCData()->mCbUseClipping.mbBody == TRUE)
	strObjGeom << wxT("\t}") << ENDLWX 
		  << wxT("\tbox {") << ENDLWX
		  << PovOut3d(wxT(""), min) << PovOut3d(wxT(""), max) << ENDLWX
		  << wxT("}") << ENDLWX;
    
    if (objectType == _OBJECT_TYPE_MESH &&
	GetPCData()->mCbUseMeshOffset.mbBody == TRUE)
	strObjGeom << wxT("\ttranslate <-0.5, -0.5, -0.5>") << ENDLWX;

    
    // CHECK_ME!! ̕ӂ͂قB
    if (objectType != _OBJECT_TYPE_WIRED_BOX)
	strObjGeom << PovOut3d(wxT("\tscale"), &mpCData->GetPInterpolated()[_OBJECT_SCALE_X]);
    wxString strRotate;
    wxString strTranslate;
    strRotate << PovOutRotation(wxT("\t"), &mpCData->GetPInterpolated()[_OBJECT_ROT_Y]);
    strTranslate << wxT("\t") << PovOut3d(wxT("translate"), &mpCData->GetPInterpolated()[_OBJECT_TRANS_X]) << ENDLWX;
	
    if (GetPCData()->mCTexProperty.mCMappingCoord.mBody == _MAPPING_GLOBAL){
	strObjGeom << strRotate << ENDLWX;
	strObjGeom << strTranslate;
    }
    
    strObjGeom << wxT("}") << ENDLWX;

    wxString strObjTex, strFinishId;
    strFinishId << wxT("POVOBJ_FINISH_") << mstrId;
   
    strObjTex << wxT("#declare ") << strFinishId << wxT("=finish{") << ENDLWX;
    strObjTex << GetPCData()->mCTexProperty.GetPovStrFinish(TRUE)
	      << wxT("}") << ENDLWX;
    
    strObjTex << wxT("#declare POVOBJ_TEX_") << mstrId << wxT("=texture{") << ENDLWX;
    
    float trans = 1.0f - mpCData->GetPInterpolated()[_OBJECT_ALPHA];
    int transmitType = GetPCData()->mCTexProperty.mCTransmitType.mBody;
    wxString strClrMap, strClr1, strClr2, strClr3;

    if (GetPCData()->mCTexProperty.mCColorType.mBody == 0)
	strObjTex << GetPCData()->mCTexProperty.GetPovStrTex(mpCData->GetPInterpolated()[_OBJECT_ALPHA], strFinishId, wxT(""), 1, 1, 1, TRUE, TRUE);
    else {
	std::vector < wxString > Vstr = 
	    GetPCData()->mCTexProperty.GetVPovStrColors
	    (mpCParentCtrl->mSelfDF3Index, trans);
	strClrMap = Vstr[0];
	strClr1 = Vstr[1];
	strClr2 = Vstr[2];
	strClr3 = Vstr[3];
	
	double globalBoxMin[3], globalBoxMax[3];
	LOOP_XYZ globalBoxMin[xyz] = TexProperty_cls::msBoxMinWorld[xyz];
	LOOP_XYZ globalBoxMax[xyz] = TexProperty_cls::msBoxMaxWorld[xyz];
	double globalBoxCenter[3], globalBoxSize[3];
	LOOP_XYZ globalBoxCenter[xyz] = (globalBoxMax[xyz] + globalBoxMin[xyz]) / 2;
	LOOP_XYZ globalBoxSize[xyz] = (globalBoxMax[xyz] - globalBoxMin[xyz]);
	
	wxString strTransDF3;
	strTransDF3 << wxT("\ttranslate <-0.5, -0.5, -0.5>") << ENDLWX
		    << PovOut3d(wxT("\tscale"), globalBoxSize) << ENDLWX
		    << PovOut3d(wxT("\ttranslate"), globalBoxCenter) << ENDLWX
		    << PovOutRotation(wxT("\t"), TexProperty_cls::msBoxRotParam);
	GetPCData()->mCTexProperty.SetDensityFile(strFilePath);
	GetPCData()->mCTexProperty.SetTranslationForDensityFile(strTransDF3);
	strObjTex << GetPCData()->mCTexProperty.GetPovStrTex
	    (mpCData->GetPInterpolated()[_OBJECT_ALPHA], 
	     strFinishId, strClrMap, 1, 1, 1, TRUE, TRUE, 0, 
	     strClr1, strClr2, strClr3);
    }
    
    strObjTex << wxT("}") << ENDLWX;

    wxString strIOR = GetPCData()->mCTexProperty.GetPovStrInterior();

    if (GetPCData()->mCTexProperty.mCColorType.mBody != 0 &&
	GetPCData()->mCTexProperty.mCMappingType.mBody == _TEX_MAPPING_PLUGINS)
	strObjTex << GetPCData()->mCTexProperty.GetPovStrPluginsParameters(CCamPos, strClr1, strClr2, strClr3);
    
    wxString strObject;
    strObject 
	<< wxT("#declare POVOBJ_") << mstrId << wxT("=") << ENDLWX
	<< wxT("object {") << ENDLWX
	<< wxT("\tPOVOBJ_GEOM_") << mstrId <<  ENDLWX;
    
    if (IsTetureAvailable() == TRUE)
	strObject << wxT("\ttexture { POVOBJ_TEX_") << mstrId << wxT("}") << ENDLWX;

    wxString strOption = GetPCData()->mCTexProperty.GetPovStrObjectOption();
    if (strOption != wxT(""))
        strObject << wxT("\t") << strOption << ENDLWX;
    
    if (GetPCData()->mCTexProperty.mCColorType.mBody != 0 &&
	GetPCData()->mCTexProperty.mCMappingType.mBody == _TEX_MAPPING_PLUGINS)
	strObject << GetPCData()->mCTexProperty.GetPovStrPluginsInObject
	    ((wxString)wxT("POVOBJ_FINISH_") + mstrId);
    
    if (strIOR != wxT(""))
	strObject << wxT("\tinterior { ") << strIOR << wxT("}") << ENDLWX;

    double alpha = mpCData->GetPInterpolated()[_OBJECT_ALPHA];
    double reflectionMin = GetPCData()->mCTexProperty.mCReflectionMin.mBody;
    double reflectionMax = GetPCData()->mCTexProperty.mCReflectionMin.mBody;
    bool bKillTarget = FALSE;
    // ̂̂targetɂȂ
    if (objectType == _OBJECT_TYPE_PLANE) bKillTarget = TRUE;
    strObject << PovRay_cls::GetPovStrPhotonSetting
	(alpha, reflectionMin, reflectionMax, bKillTarget);

    FilterBase_cls* pFog = mpCParentCtrl->GetPFogTargettingMe(mstrLabel);
    while (pFog != NULL){
	strObject << L"\tinterior{" << ENDLWX;
	strObject << L"\t" << ((PovFog_cls*)pFog)->GetPovStrFogForUse();
	pFog = mpCParentCtrl->GetPFogTargettingMe(mstrLabel, FALSE);
	strObject << L"\t}" << ENDLWX;
    }

    if (GetPCData()->mCTexProperty.mCMappingCoord.mBody == _MAPPING_LOCAL){
	strObject << strRotate;
	strObject << strTranslate;
    }

    strObject 
	<< wxT("\thollow") << ENDLWX
	<< wxT("}") << ENDLWX;
    
    return strInclude + strObjGeom + strObjTex + strObject;
} 

wxString PovObject_cls::
GetFilterStatusStr(){
    wxString strStatus;
    strStatus << wxT("PovObject::");
    
    return strStatus;
}

MACRO_SerializeConfP(PovObject)
MACRO_GetNewPReadDataBlock(PovObject)
