// "clsPovSerialize.h"

#include "clsPovSerialize.h"

#define ENDLWX wxT("\n")

wxString PovSerialize_cls::
PovOut3d(wxString str, double vec[3], int digit){
    wxString strFormat = wxString::Format
	(wxT("<%%.%df,%%.%df,%%.%df>"), digit, digit, digit);
    str << wxString::Format(strFormat, vec[0], vec[1], vec[2]);
    return str;
}

wxString PovSerialize_cls::
PovOut3dS(wxString str, double vec[3], int digit){
    wxString strFormat = wxString::Format(wxT("%%.%df"), digit);
    str << wxT("<") << GetShortString(wxString::Format(strFormat, vec[0]))
	<< wxT(",") << GetShortString(wxString::Format(strFormat, vec[1]))
	<< wxT(",") << GetShortString(wxString::Format(strFormat, vec[2]))
	<< wxT(">");
    return str;
}

wxString PovSerialize_cls::
PovOut3f(wxString str, float vec[3], int digit){
    wxString strFormat = wxString::Format
	(wxT("<%%.%df,%%.%df,%%.%df>"), digit, digit, digit);
    str << wxString::Format(strFormat, vec[0], vec[1], vec[2]);
    return str;
}

wxString PovSerialize_cls::
PovOut3fS(wxString str, float vec[3], int digit){
    wxString strFormat = wxString::Format(wxT("%%.%df"), digit);
    str << wxT("<") << GetShortString(wxString::Format(strFormat, vec[0]))
	<< wxT(",") << GetShortString(wxString::Format(strFormat, vec[1]))
	<< wxT(",") << GetShortString(wxString::Format(strFormat, vec[2]))
	<< wxT(">");
    return str;
}

wxString PovSerialize_cls::
PovOut4f(wxString str, float vec[4], int digit){
    wxString strFormat = wxString::Format
	(wxT("<%%.%df,%%.%df,%%.%df,%%.%df>"), digit, digit, digit, digit);
    str << wxString::Format(strFormat,
			    vec[0], vec[1], vec[2], vec[3]);
    return str;
}

wxString PovSerialize_cls::
PovOut4(wxString str, float a, float b, float c, float d){
    str << wxString::Format(wxT("<%g,%g,%g,%g>"),
			       a, b, c, d);
    return str;
}

wxString PovSerialize_cls::
PovOut3(wxString str, float a, float b, float c){
    str << wxString::Format(wxT("<%g,%g,%g>"), 
			       a, b, c);
    return str;
}

wxString PovSerialize_cls::
PovOutRotation(wxString strTab, double pRot[4]){
    wxString strRot;
    if (pRot[3] != 0)
	strRot << strTab << PovOut3(L"rotate", 0, 0, pRot[3]) << ENDLWX; 
    if (pRot[2] != 0)
	strRot << strTab << PovOut3(L"rotate", 0, pRot[2], 0) << ENDLWX; 
    if (pRot[1] != 0)
	strRot << strTab << PovOut3(L"rotate", pRot[1], 0, 0) << ENDLWX; 
    if (pRot[0] != 0)
	strRot << strTab << PovOut3(L"rotate", 0, 0, pRot[0]) << ENDLWX; 
    return strRot;
}

wxString PovSerialize_cls::
GetCutoffString(float value, int digit){
    wxString str;
    wxString strFormat = wxString::Format(wxT("%%.%df"), digit);
    str << wxString::Format(strFormat, value);
    return str;
}

wxString PovSerialize_cls::
GetShortString(float value){
    wxString str;
    str << value;
    return GetShortString(str);
}

wxString PovSerialize_cls::
GetShortString(wxString str){
    if (str.Find('.') == wxNOT_FOUND) return str;
    while (str.GetChar(str.Len()-1) == wxT('0'))
	str.RemoveLast();
    if (str.GetChar(str.Len()-1) == '.')
	str.RemoveLast();
    return str;
}

void PovSerialize_cls::
PushBackPovOut3f(wxString *pstrTgt, 
		 wxString str, float vec[3], int digit){
    wxString strFormat = wxString::Format
	(wxT("<%%.%df,%%.%df,%%.%df>"), digit, digit, digit);
    *pstrTgt << str << wxString::Format(strFormat, vec[0], vec[1], vec[2]);
}

wxString PovSerialize_cls::
mAstrAxis[3] = {wxT("x"), wxT("y"), wxT("z")};

wxString PovSerialize_cls::
mAstrAxisUC[3] = {wxT("X"), wxT("Y"), wxT("Z")};
