// "clsPovThreeView.h"
// (setq c-basic-offset 4)

#include "clsPovThreeView.h"

#include "clsPovRay.h"

#include "../DF3/clsDF3SeqGUI.h"
#include "../DF3/GL/clsColoring.h"
extern Coloring_cls GCColoring;
#include "../FILTER/clsFilterCtrl.h"
#include "../MAINCANVAS/clsPreviewPanel.h"
#include "../GRAPHIC/clsImageIO.h"
extern ImageIO_cls GCImgIO;
#include "../WIDGETCTRL/clsMultiNumericalInputs.h"

#include "../../clsDrawingBox.h"

#include <wx/wx.h>
#include <GL/glu.h>

#define X 0
#define Y 1
#define Z 2
#define LOOP_XYZ for (int xyz = 0; xyz < 3; xyz++)

#define ENDLWX wxT("\n")

#ifdef DEBUG
#include <stdlib.h>
#include <crtdbg.h>
#define new new(_NORMAL_BLOCK, __FILE__, __LINE__)
#endif

PovThreeViewGUI_cls::
PovThreeViewGUI_cls(PovThreeView_cls *pCParent) : 
    FilterWithTextureGUI_cls(pCParent) 
{
    mpCParent = pCParent;
    mFilterType = pCParent->mFilterType;
}

void PovThreeViewGUI_cls::
SetMNumPanel(wxBoxSizer *pBoxSizer, wxWindow *pCParentWindow, 
	     unsigned int index){
    PovThreeViewData_cls *pCData = mpCParent->GetPCData();
    MultiNumericalInputsPanel_cls* pCurr = InitializeMNumPanel(pCParentWindow);

    pCurr->mTextWidth = 60;

#ifdef WIN32
    pCurr->mComboWidth = 108;
#else
    pCurr->mComboWidth = 98;
#endif
    
    int boxWidth = 2;

    pCurr->CombinePointer(_GP_BOXSIZERHORIZONTAL, &boxWidth, wxT(""));
    
    wxString listColor[1] = { wxT("Use Texture") };
    mIndexColorType = pCurr->CombinePointer
	(_GP_UNSIGNED_INT_LIST, &pCData->mCTexProperty.mCColorType.mBody,
	 wxT(""), TRUE, 1, listColor);
    InitializeColorPanel(pCurr, this, &GetColorR, &GetColorG, &GetColorB,
			 _("Texture"));
    mIndexColorBar = pCurr->CombinePointer(_GP_WXPANEL, mpCPanelColorBar);

    wxString listMode[4] = { _("Average"), _("Maximum"), _("Minimum"), _("Cross-section") };
    pCurr->CombinePointer
	(_GP_UNSIGNED_INT_LIST, &mpCParent->GetPCData()->mCMode.mBody,
	 wxT("Mode"), TRUE, 4, listMode);
    
    // CHECK_ME!! {bNX̒SɂĂ悳
    pCData->GetPInterpolated()[_THREE_LAYER+X] = 0;
    pCData->GetPInterpolated()[_THREE_LAYER+Y] = 0;
    pCData->GetPInterpolated()[_THREE_LAYER+Z] = 0;
    pCData->GetPInterpolated()[_THREE_EMBOSS] = 0;
    pCData->GetPInterpolated()[_THREE_ALPHA] = 1;
    pCData->GetPInterpolated()[_THREE_CRIT] = 0;
    
    boxWidth = 3;
    pCurr->CombinePointer(_GP_BOXSIZERHORIZONTAL, &boxWidth, 
			  _("Show"));

    pCurr->CombinePointer
	(_GP_BOOL, &mpCParent->GetPCData()->mCbShow0.mpbBody[X], wxT("-X"));
    pCurr->CombinePointer
	(_GP_BOOL, &mpCParent->GetPCData()->mCbShow0.mpbBody[Y], wxT("-Y"));
    pCurr->CombinePointer
	(_GP_BOOL, &mpCParent->GetPCData()->mCbShow0.mpbBody[Z], wxT("-Z"));
    pCurr->CombinePointer(_GP_BOXSIZERHORIZONTAL, &boxWidth, 
			  wxT(" "));
    pCurr->CombinePointer
	(_GP_BOOL, &mpCParent->GetPCData()->mCbShow1.mpbBody[X], wxT("+X"));
    pCurr->CombinePointer
	(_GP_BOOL, &mpCParent->GetPCData()->mCbShow1.mpbBody[Y], wxT("+Y"));
    pCurr->CombinePointer
	(_GP_BOOL, &mpCParent->GetPCData()->mCbShow1.mpbBody[Z], wxT("+Z"));

    boxWidth = 2;

    wxString tagListLayer[3] = 
	{wxT("layer X"), wxT("layer Y"), wxT("layer Z")};
    LOOP_XYZ{
	mIndexLayer[xyz] = pCurr->CombinePointer(_GP_BOXSIZERHORIZONTAL, &boxWidth, tagListLayer[xyz]);
	pCurr->CombinePointer
	    (_GP_DOUBLE_SLIDER, &pCData->GetPInterpolated()[_THREE_LAYER+xyz]);
	pCurr->SetRange(0, 100, _MN_LASTITEM, 1);
	pCurr->CombinePointer
	    (_GP_DOUBLE, &pCData->GetPInterpolated()[_THREE_LAYER+xyz]);
	pCurr->SetRange(0, 100, _MN_LASTITEM, 1);
    }

    wxString tagListOffset[3] = 
	{wxT("offset X"), wxT("offset Y"), wxT("offset Z")};
    LOOP_XYZ {
	mIndexOffset[X] = pCurr->CombinePointer(_GP_BOXSIZERHORIZONTAL, &boxWidth, tagListOffset[xyz]);
	pCurr->CombinePointer(_GP_FLOAT_SLIDER, &pCData->mCOffset.mpBody[xyz]);
	pCurr->SetRange(0, 100, _MN_LASTITEM, 100);
	pCurr->CombinePointer(_GP_FLOAT, &pCData->mCOffset.mpBody[xyz]);
	pCurr->SetRange(0, 100, _MN_LASTITEM, 100);
    }

    pCurr->CombinePointer(_GP_BOXSIZERHORIZONTAL, &boxWidth, 
			  _("Emboss"));
    pCurr->CombinePointer(_GP_DOUBLE_SLIDER, 
			  &pCData->GetPInterpolated()[_THREE_EMBOSS]);
    pCurr->SetRange(-400, 400, _MN_LASTITEM, 100);
    pCurr->CombinePointer(_GP_DOUBLE, &pCData->GetPInterpolated()[_THREE_EMBOSS]);
    pCurr->SetRange(-400, 400, _MN_LASTITEM, 100);

    mIndexCrit = pCurr->CombinePointer(_GP_BOXSIZERHORIZONTAL, &boxWidth, 
				       _("ClipBy Val."));
    pCurr->CombinePointer(_GP_DOUBLE_SLIDER, 
			  &pCData->GetPInterpolated()[_THREE_CRIT]);
    pCurr->SetRange(0, 100, _MN_LASTITEM, 100);
    pCurr->CombinePointer(_GP_DOUBLE, &pCData->GetPInterpolated()[_THREE_CRIT]);
    
    pCurr->FinishSetting(pBoxSizer, FALSE, index);

    UpdateColorList();
    pCurr->SetFuncHook(&FilterCtrl_cls::FuncHookAssign, _MN_HOOK_ASSIGN);
    pCurr->SetFuncHook(&FilterCtrl_cls::FuncHookRefreshTop, _MN_HOOK_ASSIGN);
    pCurr->SetFuncHook(&FuncHookHideItem, _MN_HOOK_COMBOBOX_CHANGE);
    pCurr->SetFuncHook(&FilterWithTextureGUI_cls::FuncHookUpdateTextureDLG,
		       _MN_HOOK_COMBOBOX_CHANGE);
    pCurr->SetFuncHook(&FuncHookOpenTextureDLG, _MN_HOOK_PANELCLICK);
    pCurr->SetFuncHook(&FilterCtrl_cls::FuncHookChanged, _MN_HOOK_CHANGE);
    

    HideAndShowItems();
}

MACRO_SetCustomFunctions(PovThreeViewGUI_cls,,,);

void PovThreeViewGUI_cls::
HideAndShowItems(){
    bool bLayer = FALSE;
    if (mpCParent->GetPCData()->mCMode.mBody == _THREEVIEW_CROSSSECTION) bLayer = TRUE;
    LOOP_XYZ mpCMNumPanel->ShowItems(mIndexLayer[xyz], 3, bLayer);

    mpCMNumPanel->ShowItems(mIndexCrit, 3, 
			    mpCParent->GetPCData()->mCbTransNullRegion.mbBody);
    
    mpCParent->mpCParentCtrl->mpCFilterPanelsLink->UpdatePanelLayout();
}

MACRO_FuncHookHideItem(PovThreeView);

void PovThreeViewGUI_cls::
SetLayerIndexRange(int axis, int max){
    MultiNumericalInputsPanel_cls* pCurr = mpCMNumPanel;

    pCurr->SetRange(0, max-1, mIndexLayer[axis] + 1, 1);
    pCurr->SetRange(0, max-1, mIndexLayer[axis] + 2, 1);
    pCurr->mVCPointers[mIndexLayer[axis]+1].ApplyRange();
    pCurr->mVCPointers[mIndexLayer[axis]+2].ApplyRange();
}

// ----

PovThreeViewData_cls::
PovThreeViewData_cls(FilterCtrl_cls* pCCtrl,
		     bool bConnectToStaticParam) :
    FilterWithParameterData_cls(pCCtrl)
{
    mCConfList.Add(&mCbShade,           wxT("ThreeViewShade="), L"1");
    mCConfList.Add(&mCbTransNullRegion, wxT("ThreeViewTransNull="), L"0");
    mCConfList.Add(&mCbSmooth,     wxT("ThreeViewSmooth="), L"1");
    mCConfList.Add(&mCbShow0, wxT("ThreeViewShow0="), L"0 0 0");
    mCConfList.Add(&mCbShow1, wxT("ThreeViewShow1="), L"1 1 1");
    mCConfList.Add(&mCMode, wxT("ThreeViewMode="), L"1");
    mCConfList.Add(&mCOffset, wxT("ThreeViewOffset="), L"0 0 0");
    mCConfList.Add(&mCbMultiply, wxT("ThreeViewMultiply="), L"0");
    mCConfList.Add(&mCbDrawFrame, wxT("ThreeViewDrawFrame="), L"0");
    mCConfList.Add(&mCbAddFiller, wxT("ThreeViewAddFiller="), L"1");

    double initParam[6] = {0, 0, 0, 0, 1, 0};    
    Parameters_cls CParam(sizeof(initParam)/sizeof(double), L"ThreeView");
    CParam.ExecCommandInitSet(initParam);

    // !! todo !! _MAX_PARAMETER_NUMBER 𒴂̏
    if (bConnectToStaticParam == TRUE){
	mParamNumber = -1;
	for (size_t i = 0; i < msVbParamUsed[mpCCtrl->mSelfDF3Index].size(); i++)
	    if (msVbParamUsed[mpCCtrl->mSelfDF3Index][i] == FALSE){
		mParamNumber = (int)i;
		msVCParam[mpCCtrl->mSelfDF3Index][mParamNumber].CopyFromP(&CParam);
		msVbParamUsed[mpCCtrl->mSelfDF3Index][mParamNumber] = TRUE;
		i = _MAX_PARAMETER_NUMBER;
	    }
	if (mParamNumber == -1){
	    mParamNumber = (int)msVbParamUsed[mpCCtrl->mSelfDF3Index].size();
	    msVCParam[mpCCtrl->mSelfDF3Index].push_back(CParam);
	    msVbParamUsed[mpCCtrl->mSelfDF3Index].push_back(TRUE);
	}
    }
}

void PovThreeViewData_cls::
ReDefineList(){
    FilterData_cls::ReDefineListBase();

    mCConfList.Add(&mCbShade,           wxT("ThreeViewShade="));
    mCConfList.Add(&mCbTransNullRegion, wxT("ThreeViewTransNull="));
    mCConfList.Add(&mCbSmooth,     wxT("ThreeViewSmooth="));
    mCConfList.Add(&mCbShow0, wxT("ThreeViewShow0="));
    mCConfList.Add(&mCbShow1, wxT("ThreeViewShow1="));
    mCConfList.Add(&mCMode, wxT("ThreeViewMode="));
    mCConfList.Add(&mCOffset, wxT("ThreeViewOffset="));
    mCConfList.Add(&mCbMultiply, wxT("ThreeViewMultiply="));
    mCConfList.Add(&mCbDrawFrame, wxT("ThreeViewDrawFrame="));
    mCConfList.Add(&mCbAddFiller, wxT("ThreeViewAddFiller="));
    
    mCTexProperty.ReDefineList();
}

MACRO_MakeInstanceAndAddToList(PovThreeView)

wxString PovThreeViewData_cls::
SerializeConfPolymorph(){
    return mCTexProperty.Serialize() + msVCParam[mpCCtrl->mSelfDF3Index][mParamNumber].Serialize();
}

void PovThreeViewData_cls::
ReadStrLinePolymorph(std::wistream &istream, std::wstring strLine){
    mCTexProperty.ReadStrLine(strLine);
    msVCParam[mpCCtrl->mSelfDF3Index][mParamNumber].ReadStrLine(istream, strLine);
}

void PovThreeViewData_cls::
InitializeStaticMember(int df3index){
    msVCParam[df3index].reserve(_MAX_PARAMETER_NUMBER);
    msVbParamUsed[df3index].reserve(_MAX_PARAMETER_NUMBER);
}

Parameters_cls* PovThreeViewData_cls::
GetPParamActive(){
    return &msVCParam[mpCCtrl->mSelfDF3Index][mParamNumber];
}

std::vector < Parameters_cls > PovThreeViewData_cls::msVCParam[_DF3_MAX_SLOT];
std::vector < bool > PovThreeViewData_cls::msVbParamUsed[_DF3_MAX_SLOT];

#include "../MYAPI/MsgBox.h"

PovThreeView_cls::
PovThreeView_cls(FilterCtrl_cls *pCParentCtrl, PovThreeViewData_cls *pCInitData) :
    //FilterWithParameter_cls(pCParentCtrl)
    PovCrossSectionCommon_cls(pCParentCtrl)
{
    mpCData = new PovThreeViewData_cls(pCParentCtrl, (pCInitData == NULL));
    if (pCInitData != NULL) *(PovThreeViewData_cls*)mpCData = *pCInitData;

    TexProperty_cls *pCTexProp = &GetPCData()->mCTexProperty;
    if (msbConstructedFromMenu == TRUE){
	pCTexProp->mCDiffuse.mBody = 0.2;
	pCTexProp->mCAmbient.mBody = 0.8;
	if (GCColoring.mpCCustomColor->mCItemNum.mBody > 0)
	    pCTexProp->mCColorType.mBody = 1;
    }
    
    pCTexProp->LinkFilterParameter(this, _THREE_ALPHA);
    
    ConstructorCommon(pCParentCtrl, _("Three-view"), _FILTER_THREEVIEW);
    
    mpCGUIPanel = new PovThreeViewGUI_cls(this);
    mPrevMode = -1;
    LOOP_XYZ mPrevLayer[xyz] = -1;

    mSizeX = mSizeY = mSizeZ = 0;
    LOOP_XYZ mAllocU[xyz] = mAllocV[xyz] = -1;
    LOOP_XYZ mAllocArrayV[xyz] = mAllocArrayUm[xyz] = -1;

    mTexId = -1;
    mColorRefreshId = -1;
}

PovThreeView_cls::
~PovThreeView_cls(){
    if (FilterWithTextureGUI_cls::mspCLinkTexpropertyCtrl->mpCConnected == &((PovThreeViewData_cls*)mpCData)->mCTexProperty)
	FilterWithTextureGUI_cls::mspCLinkTexpropertyCtrl->ConnectProperty(NULL, wxT("No Item is Linked"));
    if (mspCDF3SeqGUI != NULL)
	mspCDF3SeqGUI->mpCPanelList->Remove(mstrLabel);

    if (mTexId != -1)
	glDeleteTextures(1, &mTexId);

    LOOP_XYZ 
	if (mAllocArrayV[xyz] != -1 || mAllocArrayUm[xyz] != -1){
	    delete [] mpTexture[xyz];
	    delete [] mpNormals[xyz];
	    delete [] mpVertices[xyz];
	    delete [] mpPolyIndices[xyz];
	}
}

MACRO_AddFilterItemPolymorphP(PovThreeView,RefreshTop());
MACRO_InitializeStaticMemberP(PovThreeView);
MACRO_GetPCData(PovThreeView);

//--

void PovThreeView_cls::
SetMNumAdvanced(wxWindow *pCParentWindow){
    MultiNumericalInputs_cls* pDLG = 
	wxDialogEXKey::InitializeMNumDLG(&mpCMNumAdvanced, pCParentWindow, wxT("Advanced Setting"));

    pDLG->mTextWidth = 160;
    pDLG->CombinePointer(_GP_BOOL, &GetPCData()->mCbShade.mbBody,
			 _("shade in clrmap"));
    pDLG->CombinePointer(_GP_BOOL, &GetPCData()->mCbTransNullRegion.mbBody,
			 _("ClipBy Val."));
    pDLG->CombinePointer(_GP_BOOL, &GetPCData()->mCbSmooth.mbBody,
			 wxT("smooth"));
    pDLG->CombinePointer(_GP_BOOL, &GetPCData()->mCbMultiply.mbBody,
			 wxT("multiply density"));
    pDLG->CombinePointer(_GP_BOOL, &GetPCData()->mCbAddFiller.mbBody,
			 wxT("Add Filler"));
    pDLG->CombinePointer(_GP_BOOL, &GetPCData()->mCbDrawFrame.mbBody,
			 _("Draw Frame"));
    /*
      int indexRM = pDLG->CombinePointer(_GP_BOOL, &GetPCData()->mCbPostSceneCommand.mbBody,
      wxT("Auto remove tmpfile"));
    */
    pDLG->FinishSettingDLG(FALSE);

    /*
      pDLG->mVCPointers[indexRM].GetPCtrlWindow()->SetToolTip(wxT("Works at pov-ray 3.6 LINUX only. [Shellout Security] must be allowed in povray.conf."));
    */
    
    //pDLG->SetScreenRectPos(&msCRectMNumStaticMembers);
}

void PovThreeView_cls::
AdvancedSetting(){
    AdvancedSettingCommon();
    MakeTexture1D(GetPCData()->mCTexProperty.mCColorType.mBody,
		  GetPCData()->mCbMultiply.mbBody);
    FilterCtrl_cls::FuncHookRefreshTop(mpCGUIPanel->mpCMNumPanel, NULL);
    mpCGUIPanel->HideAndShowItems();
}

void PovThreeView_cls::
UpdateColors(){
    ((PovThreeViewGUI_cls*)mpCGUIPanel)->UpdateColorList();
}

bool PovThreeView_cls::
IsReprocessRequired(){
    if (mpCData->mCbValid.mbBody == FALSE) return FALSE;
    if (mPrevEmboss != GetEmboss()) return TRUE;
    if (mPrevMode != GetPCData()->mCMode.mBody) return TRUE;
    LOOP_XYZ if (mPrevLayer[xyz] != mpCData->GetPInterpolated()[_THREE_LAYER+xyz]) 
	return TRUE;
    LOOP_XYZ 
	if ((mPrevShow[xyz] == FALSE) && 
	    ((GetPCData()->mCbShow0.mpbBody[xyz] | GetPCData()->mCbShow1.mpbBody[xyz])== TRUE)) 
	    return TRUE;
    return FALSE;
}

void PovThreeView_cls::
RefreshFilter(unsigned char *pData){
    if (mpCParentCtrl->mpCDF3SeqParent->GetPDF3()->IsAllocated() == FALSE)
	return;

    int slotIndex = mpCParentCtrl->mpCDF3SeqParent->mSelfIndex;
    if (pData == NULL)
	pData = mpCParentCtrl->mpCDF3SeqParent->GetPDF3()->mpMainXYZ[Z];

    int sizeX = mspCDF3SeqCtrlLink->GetCurrentSizeOf1Data(X, slotIndex);
    int sizeY = mspCDF3SeqCtrlLink->GetCurrentSizeOf1Data(Y, slotIndex);
    int sizeZ = mspCDF3SeqCtrlLink->GetCurrentSizeOf1Data(Z, slotIndex);

    double emboss = GetEmboss();
    bool bChangedSize = (mSizeX != sizeX ) || (mSizeY != sizeY) || (mSizeZ != sizeZ);
    
    bool bChanged = bChangedSize | 
	IsReprocessRequired() | 
	mpCParentCtrl->IsReprocessRequired
	(GetRemappedIndex(), GetRemappedIndexDouble(), this);

    mSizeX = sizeX; mSizeY = sizeY; mSizeZ = sizeZ;
    if ((bChanged || mPrevLayer[X] != mpCData->GetPInterpolated()[_THREE_LAYER+X]) &&
	(GetPCData()->mCbShow0.mpbBody[X] == TRUE || 
	 GetPCData()->mCbShow1.mpbBody[X] == TRUE))
	ConstructVerticesX(pData, emboss); 
    if ((bChanged || mPrevLayer[Y] != mpCData->GetPInterpolated()[_THREE_LAYER+Y]) &&
	(GetPCData()->mCbShow0.mpbBody[Y] == TRUE ||
	 GetPCData()->mCbShow1.mpbBody[Y] == TRUE))
	ConstructVerticesY(pData, emboss); 
    if ((bChanged || mPrevLayer[Z] != mpCData->GetPInterpolated()[_THREE_LAYER+Z]) &&
	(GetPCData()->mCbShow0.mpbBody[Z] == TRUE ||
	 GetPCData()->mCbShow1.mpbBody[Z] == TRUE))
	ConstructVerticesZ(pData, emboss); 
    
    mPrevEmboss = emboss;
    mColorType = GetPCData()->mCTexProperty.mCColorType.mBody;
    mPrevMode = GetPCData()->mCMode.mBody;
    LOOP_XYZ mPrevLayer[xyz] = mpCData->GetPInterpolated()[_THREE_LAYER+xyz];
    LOOP_XYZ mPrevShow[xyz] = GetPCData()->mCbShow0.mpbBody[xyz] | GetPCData()->mCbShow1.mpbBody[xyz];
}

void PovThreeView_cls::
ClearFieldData(int axis){
    // xNg̃xNg̓fXgNgĂc͂
    mVVField[axis].clear();
    mVVNormalU[axis].clear(); 
    mVVNormalV[axis].clear(); 
    mVVNormalW[axis].clear();
}

void PovThreeView_cls::
AllocFieldData(int axis, int sizeU, int sizeV){

    mScalePrev[axis][X] = mScalePrev[axis][Y] = mScalePrev[axis][Z] = 1;
    
    if (mAllocU[axis] == sizeU && mAllocV[axis] == sizeV) return;

    mAllocU[axis] = sizeU; 
    mAllocV[axis] = sizeV;
    ClearFieldData(axis);

    mVVField[axis].reserve(sizeV); mVVField[axis].resize(sizeV);
    mVVNormalU[axis].reserve(sizeV); mVVNormalU[axis].resize(sizeV); 
    mVVNormalV[axis].reserve(sizeV); mVVNormalV[axis].resize(sizeV); 
    mVVNormalW[axis].reserve(sizeV); mVVNormalW[axis].resize(sizeV);

    for (unsigned int v = 0; v < mVVField[axis].size(); v++){
	mVVField[axis][v].reserve(sizeU); mVVField[axis][v].resize(sizeU);
	mVVNormalU[axis][v].reserve(sizeU); mVVNormalU[axis][v].resize(sizeU);
	mVVNormalV[axis][v].reserve(sizeU); mVVNormalV[axis][v].resize(sizeU);
	mVVNormalW[axis][v].reserve(sizeU); mVVNormalW[axis][v].resize(sizeU);
    }
}

void PovThreeView_cls::
ConstructVerticesX(unsigned char *pData, double emboss){
    AllocFieldData(X, mSizeY, mSizeZ);

    ((PovThreeViewGUI_cls*)mpCGUIPanel)->SetLayerIndexRange(X, mSizeX);

    switch(GetPCData()->mCMode.mBody){
    case _THREEVIEW_AVERAGE:
	for (int z = 0; z < mSizeZ; z++){
	    int lBaseIndex = mSizeX * mSizeY * z;
	    for (int y = 0; y < mSizeY; y++){
		int lOffsetY = mSizeX * y;
		int sum = 0;
		for (int x = 0; x < mSizeX; x++)
		    sum += pData[lBaseIndex + lOffsetY + x];
		mVVField[X][z][y] = sum / mSizeX;
	    }
	}
	break;
    case _THREEVIEW_MAX:
	for (int z = 0; z < mSizeZ; z++){
	    int lBaseIndex = mSizeX * mSizeY * z;
	    for (int y = 0; y < mSizeY; y++){
		int lOffsetY = mSizeX * y;
		unsigned char max = 0;
		for (int x = 0; x < mSizeX; x++)
		    if (max < pData[lBaseIndex + lOffsetY + x])
			max = pData[lBaseIndex + lOffsetY + x];
		mVVField[X][z][y] = max;
	    }
	}
	break;
    case _THREEVIEW_MIN:
	for (int z = 0; z < mSizeZ; z++){
	    int lBaseIndex = mSizeX * mSizeY * z;
	    for (int y = 0; y < mSizeY; y++){
		int lOffsetY = mSizeX * y;
		unsigned char min = 255;
		for (int x = 0; x < mSizeX; x++)
		    if (min > pData[lBaseIndex + lOffsetY + x])
			min = pData[lBaseIndex + lOffsetY + x];
		mVVField[X][z][y] = min;
	    }
	}
	break;
    case _THREEVIEW_CROSSSECTION:
	ConstructVerticesCoreX(pData, mpCData->GetPInterpolated()[_THREE_LAYER + X],
			       &mVVField[X]);
	break;
    }

    CalcNormal
	(&mVVField[X], &mVVNormalU[X], &mVVNormalV[X], &mVVNormalW[X],
	 mSizeY, mSizeZ, emboss, TRUE);
};

void PovThreeView_cls::
ConstructVerticesY(unsigned char *pData, double emboss){
    AllocFieldData(Y, mSizeX, mSizeZ);

    ((PovThreeViewGUI_cls*)mpCGUIPanel)->SetLayerIndexRange(Y, mSizeY);

    int sizeXY = mSizeX * mSizeY;
    switch(GetPCData()->mCMode.mBody){
    case _THREEVIEW_AVERAGE:
	for (int z = 0; z < mSizeZ; z++){
	    int lBaseIndex = sizeXY * z;
	    for (int x = 0; x < mSizeX; x++){
		int sum = 0;
		for (int y = 0; y < mSizeY; y++)
		    sum += pData[lBaseIndex + mSizeX * y + x];
		mVVField[Y][z][x] = sum / mSizeY;
	    }
	}
	break;
    case _THREEVIEW_MAX:
	for (int z = 0; z < mSizeZ; z++){
	    int lBaseIndex = sizeXY * z;
	    for (int x = 0; x < mSizeX; x++){
		unsigned char max = 0;
		for (int y = 0; y < mSizeY; y++)
		    if (max < pData[lBaseIndex + mSizeX * y + x])
			max = pData[lBaseIndex + mSizeX * y + x];
		mVVField[Y][z][x] = max;
	    }
	}
	break;
    case _THREEVIEW_MIN:
	for (int z = 0; z < mSizeZ; z++){
	    int lBaseIndex = sizeXY * z;
	    for (int x = 0; x < mSizeX; x++){
		unsigned char min = 255;
		for (int y = 0; y < mSizeY; y++)
		    if (min > pData[lBaseIndex + mSizeX * y + x])
			min = pData[lBaseIndex + mSizeX * y + x];
		mVVField[Y][z][x] = min;
	    }
	}
	break;
    case _THREEVIEW_CROSSSECTION:
	ConstructVerticesCoreY(pData, mpCData->GetPInterpolated()[_THREE_LAYER + Y],
			       &mVVField[Y]);
	break;
    }

    CalcNormal
	(&mVVField[Y], &mVVNormalU[Y], &mVVNormalV[Y], &mVVNormalW[Y],
	 mSizeX, mSizeZ, emboss);
};

void PovThreeView_cls::
ConstructVerticesZ(unsigned char *pData, double emboss){
    AllocFieldData(Z, mSizeX, mSizeY);

    ((PovThreeViewGUI_cls*)mpCGUIPanel)->SetLayerIndexRange(Z, mSizeZ);

    int sizeX = mSizeX;
    int sizeZ = mSizeZ;
    switch(GetPCData()->mCMode.mBody){
    case _THREEVIEW_AVERAGE:
	for (int y = 0; y < mSizeY; y++){
	    int lOffsetY = sizeX * y;
	    for (int x = 0; x < sizeX; x++){
		int sum = 0;
		for (int z = 0; z < sizeZ; z++)
		    sum += pData[mSizeX * mSizeY * z + lOffsetY + x];
		mVVField[Z][y][x] = sum / mSizeZ;
	    }
	}
	break;
    case _THREEVIEW_MAX:
	for (int y = 0; y < mSizeY; y++){
	    int lOffsetY = sizeX * y;
	    for (int x = 0; x < sizeX; x++){
		unsigned char max = 0;
		for (int z = 0; z < sizeZ; z++)
		    if (max < pData[mSizeX * mSizeY * z + lOffsetY + x])
			max = pData[mSizeX * mSizeY * z + lOffsetY + x];
		mVVField[Z][y][x] = max;
	    }
	}
	break;
    case _THREEVIEW_MIN:
	for (int y = 0; y < mSizeY; y++){
	    int lOffsetY = sizeX * y;
	    for (int x = 0; x < sizeX; x++){
		unsigned char min = 255;
		for (int z = 0; z < sizeZ; z++)
		    if (min > pData[mSizeX * mSizeY * z + lOffsetY + x])
			min = pData[mSizeX * mSizeY * z + lOffsetY + x];
		mVVField[Z][y][x] = min;
	    }
	}
	break;
    case _THREEVIEW_CROSSSECTION:
	ConstructVerticesCoreZ(pData, mpCData->GetPInterpolated()[_THREE_LAYER + Z],
			       &mVVField[Z]);
	break;
    }

    CalcNormal
	(&mVVField[Z], &mVVNormalU[Z], &mVVNormalV[Z], &mVVNormalW[Z],
	 mSizeX, mSizeY, emboss, TRUE);
};

void PovThreeView_cls::
SettingForDrawFrame(){
    glDisable(GL_CLIP_PLANE0);
    glDisable(GL_TEXTURE_1D);
    glDisable(GL_LIGHTING);
    glDisable(GL_LINE_SMOOTH);
    glLineWidth(FilterBase_cls::msBestLineWidth);
    glColor4f(0.3, 0.7, 0.3, 1);
}

double PovThreeView_cls::
GetEmboss(){
    double emboss = mpCData->GetPInterpolated()[_THREE_EMBOSS];
    // clip̊֌W0͑ʖ
    if (emboss > -0.004 && emboss < 0.004) emboss = 0.004;
    return emboss;
}

double PovThreeView_cls::
GetCritOffset(){
    double critoffset;
    if (GetPCData()->mCbTransNullRegion.mbBody == TRUE){
	double crit = mpCData->GetPInterpolated()[_THREE_CRIT];
	if (crit == 0) crit = 0.004;
	critoffset = crit;
    }
    return critoffset;
}

void PovThreeView_cls::
AllocArray(int axis, int sizeV, int sizeUm){

    if (mAllocArrayV[axis] == sizeV && mAllocArrayUm[axis] == sizeUm) return;

    if (mAllocArrayV[axis] != -1 || mAllocArrayUm[axis] != -1){
	delete [] mpTexture[axis];
	delete [] mpNormals[axis];
	delete [] mpVertices[axis];
	delete [] mpPolyIndices[axis];
    }

    mpTexture[axis] = new float [ sizeV * sizeUm ];
    mpNormals[axis] = new float [ sizeV * sizeUm * 3];
    mpVertices[axis] = new float [ sizeV * sizeUm * 3];
    mpPolyIndices[axis] = new unsigned int [ sizeUm * 2];
    
    mAllocArrayV[axis] = sizeV;
    mAllocArrayUm[axis] = sizeUm;
}

#define MACRO_DECLAREPOINTERS(axis)			\
    float *pTexture = mpTexture[axis];			\
    float *pNormals = mpNormals[axis];			\
    float *pVertices = mpVertices[axis];		\
    unsigned int *pPolyIndices = mpPolyIndices[axis];

#define MACRO_DECLAREPOINTERS_B(baseaxis, axis, AXIS)			\
    const double co##AXIS = (double) axis / size##AXIS;			\
    double *pVNormalLineU = &(mVVNormalU[baseaxis][axis][0]);		\
    double *pVNormalLineV = &(mVVNormalV[baseaxis][axis][0]);		\
    double *pVNormalLineW = &(mVVNormalW[baseaxis][axis][0]);		\
    const unsigned char *pVFieldLine = &(mVVField[baseaxis][axis][0]);

#define MACRO_SETARRAYS(nX, nY, nZ, coX,coY,coZ)	\
    pNormals[index * 3 + X] = *pVNormalLine##nX++;	\
    pNormals[index * 3 + Y] = *pVNormalLine##nY++;	\
    pNormals[index * 3 + Z] = *pVNormalLine##nZ++;	\
    pVertices[index * 3 + X] = coX;			\
    pVertices[index * 3 + Y] = coY;			\
    pVertices[index * 3 + Z] = coZ;

void PovThreeView_cls::
DrawFillerXQuadStripCore(double value, int directionA, float normalV[3],
			 double coX, double coY, double coZ0, double coZ1){
    if ( directionA == -1){
	glTexCoord1f(value); glNormal3fv(normalV); glVertex3d(coX, coY, coZ0);
	glTexCoord1f(value); glNormal3fv(normalV); glVertex3d(coX, coY, coZ1);
    }
    else{
	glTexCoord1f(value); glNormal3fv(normalV); glVertex3d(coX, coY, coZ1);
	glTexCoord1f(value); glNormal3fv(normalV); glVertex3d(coX, coY, coZ0);
    }
}

#define _FILLER_SKIP 2.0

void PovThreeView_cls::
DrawFillerXQuadStrip(double value, int directionA, int directionB, 
		     float normalV[3], double coX, 
		     double y0, double y1, double z0, double z1){
    int sizeY = (y1-y0) * mSizeY / _FILLER_SKIP, sizeZ = (z1-z0) * mSizeZ / _FILLER_SKIP;
    double scaleY = _FILLER_SKIP / mSizeY, scaleZ = _FILLER_SKIP / mSizeZ;
    
    if (directionB == -1)
	for (int z = 0; z <= sizeZ; z++){
	    double coZ0 = z0 + scaleZ * z, coZ1 = z0 + scaleZ * (z+1);
	    if (z == sizeZ) coZ1 = z1;
	    glBegin(GL_QUAD_STRIP);
	    for (int y = 0; y < sizeY; y++){
		double coY = y0 + scaleY * y;
		DrawFillerXQuadStripCore(value, directionA, normalV, coX, coY, coZ0, coZ1);
	    }
	    DrawFillerXQuadStripCore(value, directionA, normalV, coX, y1, coZ0, coZ1);
	    glEnd();
	}
    else
	for (int z = 0; z <= sizeZ; z++){
	    double coZ0 = z0 + scaleZ * z, coZ1 = z0 + scaleZ * (z+1);
	    if (z == sizeZ) coZ1 = z1;
	    glBegin(GL_QUAD_STRIP);
	    for (int y = 0; y < sizeY; y++){
		double coY = y0 + scaleY * y;
		DrawFillerXQuadStripCore(value, -directionA, normalV, 
					 coX, coY, coZ0, coZ1);
	    }
	    DrawFillerXQuadStripCore(value, -directionA, normalV, 
				     coX, y1, coZ0, coZ1);
	    glEnd();
	}
}

void PovThreeView_cls::
AddFillerX(double scale[3], int directionA, 
	   bool bShowYMinus, bool bShowYPlus, float offsetY,
	   bool bShowZMinus, bool bShowZPlus, float offsetZ){
    glColor4f(1, 1, 1, 1);
    glEnable(GL_TEXTURE_1D);
    glEnable(GL_LIGHTING);

    int x;
    double coX;
    float normalV[3];
    if (directionA == -1){
	x = 0;
	coX = 0 - GetPCData()->mCOffset.mpBody[X];
	normalV[X] = -1; normalV[Y] = 0; normalV[Z] = 0; 
    }
    else{
	x = mSizeX - 1;
	coX = 1 + GetPCData()->mCOffset.mpBody[X];
	normalV[X] = 1; normalV[Y] = 0; normalV[Z] = 0; 
    }

    if (bShowYMinus == TRUE)
	DrawFillerXQuadStrip(0, directionA, -1, normalV, coX, 
			     -offsetY, 0, 0, 1);
    if (bShowYPlus == TRUE)
	DrawFillerXQuadStrip(0, -directionA, +1, normalV, coX, 
			     1 - 2.0/mSizeY, 1.0 + offsetY, 0, 1);
    if (bShowZMinus == TRUE)
	DrawFillerXQuadStrip(0, directionA, -1, normalV, coX,
			     0, 1, -offsetZ, 0);
    if (bShowZPlus == TRUE)
	DrawFillerXQuadStrip(0, -directionA, +1, normalV, coX,
			     0, 1, 1 - 1.0/mSizeZ, 1 + offsetZ);
    if (bShowYMinus == TRUE && bShowZMinus == TRUE)
	DrawFillerXQuadStrip(0, directionA, -1, normalV, coX, 
			     -offsetY, 0, -offsetZ, 0);
    if (bShowYMinus == TRUE && bShowZPlus == TRUE)
	DrawFillerXQuadStrip(0, directionA, -1, normalV, coX, 
			     -offsetY, 0, 1.0 - 1.0/mSizeZ, 1 + offsetZ);
    if (bShowYPlus == TRUE && bShowZMinus == TRUE)
	DrawFillerXQuadStrip(0, -directionA, +1, normalV, coX, 
			     1 - 1.0/mSizeY, 1.0 + offsetY, -offsetZ, 0);
    if (bShowYPlus == TRUE && bShowZPlus == TRUE)
	DrawFillerXQuadStrip(0, -directionA, +1, normalV, coX, 
			     1 - 1.0/mSizeY, 1.0 + offsetY, 1.0 - 1.0/mSizeZ, 1 + offsetZ);
}

void PovThreeView_cls::
DrawFieldX(double scale[3], int mappingType, int patternType,
	   int colorType, int mappingCoord, double emboss, int direction){
    RecalcNorm(&mVVNormalU[X], &mVVNormalV[X], &mVVNormalW[X],
	       scale, mSizeY, mSizeZ, X, Y, Z, X);

    glColor4f(1, 1, 1, 1);
    glEnable(GL_TEXTURE_1D);
    glEnable(GL_LIGHTING);
    double coX;
    float normalV[3];
    if (direction == -1){
	coX = 0 - GetPCData()->mCOffset.mpBody[X];
	normalV[X] = -1; normalV[Y] = 0; normalV[Z] = 0; 
    }
    else{
	coX = 1 + GetPCData()->mCOffset.mpBody[X];
	normalV[X] = 1; normalV[Y] = 0; normalV[Z] = 0; 
    }

    double critoffset = 0;
    if (GetPCData()->mCbTransNullRegion.mbBody == TRUE){
	double PlaneEqXmax[4] = {0, 0, 0, 0};
	critoffset = GetCritOffset() * emboss / 16;
	if (emboss * direction < 0){
	    PlaneEqXmax[X] = +1.0; PlaneEqXmax[3] = -coX; }
	else{
	    PlaneEqXmax[X] = -1.0; PlaneEqXmax[3] = +coX; }
	glClipPlane(GL_CLIP_PLANE0, PlaneEqXmax);
	glEnable(GL_CLIP_PLANE0);
    }
    coX += direction * critoffset;

    const double embossfactor = emboss / 4096;
    const int sizeZ = mSizeZ, sizeZm = mSizeZ-1;
    const int sizeY = mSizeY, sizeYm = mSizeY-1;

    AllocArray(X, sizeZ, sizeYm);
    MACRO_DECLAREPOINTERS(X);

    int   index = 0;
    for (int z = 0; z < sizeZ; z++){
	const double coZ0 = (double) z / sizeZ;
	const unsigned char *pVFieldLine = &(mVVField[X][z][0]);
	if (colorType != 0){
	    if (mappingType == _TEX_MAPPING_VALUE)
		for (int y = 0; y < sizeYm; y++){
		    pTexture[index] = (float)pVFieldLine[y]/256;
		    index++;
		}
	    else
		if (mappingCoord == _MAPPING_GLOBAL){
		    for (int y = 0; y < sizeYm; y++){
			double coXemb  = coX + embossfactor * pVFieldLine[y];
			double coY = (double) y / sizeY;
			float globPos[3];
			float localPos[3] = {coXemb, coY, coZ0};
			GetGlobalPos(globPos, localPos);
			pTexture[index] = (float)GetMappingValueGlobal(globPos);
			index++;
		    }
		}
		else {
		    for (int y = 0; y < sizeYm; y++){
			double coXemb  = coX + embossfactor * pVFieldLine[y];
			double coY = (double) y / sizeY;
			float localPos0[3] = {coXemb, coY, coZ0};
			pTexture[index] = (float)GetMappingValueGlobal(localPos0); // CHECK_ME!!
			index++;
		    }
		}
	}
    }

    index = 0;
    for (int z = 0; z < sizeZ; z++){
	MACRO_DECLAREPOINTERS_B(X,z,Z);
	for (int y = 0; y < sizeYm; y++){
	    double coXemb  = /*coX +*/ embossfactor*pVFieldLine[y];
	    double coY = (double) y / sizeY;
	    MACRO_SETARRAYS(W, U, V, coXemb, coY, coZ);
	    index++;
	}
    }

    glPushMatrix();
    glTranslated(coX, 0, 0);
    if (direction == 1)
	glScaled(-1, 1, 1);
    DrawVertexArray(colorType, sizeYm, sizeZm,
		    pTexture, pNormals, pVertices, pPolyIndices,
		    (direction == 1));
    glPopMatrix();
    glDisable(GL_CLIP_PLANE0);
    
    double frameX = mpCData->GetPInterpolated()[_THREE_LAYER + X] / mSizeX;
    double frameY = mpCData->GetPInterpolated()[_THREE_LAYER + Y] / mSizeY;
    double frameZ = mpCData->GetPInterpolated()[_THREE_LAYER + Z] / mSizeZ;
    if (GetPCData()->mCbDrawFrame.mbBody == TRUE){
	SettingForDrawFrame();
	glBegin(GL_LINE_STRIP);
	glVertex3d(frameX, 0.001, 0.001); glVertex3d(frameX, 0.999, 0.001);
	glVertex3d(frameX, 0.999, 0.999); glVertex3d(frameX, 0.001, 0.999);
	glVertex3d(frameX, 0.001, 0.001);
	glEnd();
	if (GetPCData()->mCbShow0.mpbBody[Y] || GetPCData()->mCbShow0.mpbBody[Y]){
	    glBegin(GL_LINES);
	    glVertex3d(frameX, frameY, 0); glVertex3d(frameX, frameY, 1);
	    glEnd();
	}
	if (GetPCData()->mCbShow0.mpbBody[Z] || GetPCData()->mCbShow0.mpbBody[Z]){
	    glBegin(GL_LINES);
	    glVertex3d(frameX, 0, frameZ); glVertex3d(frameX, 1, frameZ);
	    glEnd();
	}
    }
}

void PovThreeView_cls::
DrawFillerYQuadStripCore(double value, int directionA, float normalV[3],
			 double coX, double coY, double coZ0, double coZ1){
    if ( directionA == -1){
	glTexCoord1f(value); glNormal3fv(normalV); glVertex3d(coX, coY, coZ1);
	glTexCoord1f(value); glNormal3fv(normalV); glVertex3d(coX, coY, coZ0);
    }
    else{
	glTexCoord1f(value); glNormal3fv(normalV); glVertex3d(coX, coY, coZ0);
	glTexCoord1f(value); glNormal3fv(normalV); glVertex3d(coX, coY, coZ1);
    }
}

void PovThreeView_cls::
DrawFillerYQuadStrip(double value, int directionA, int directionB, 
		     float normalV[3], double coY, 
		     double x0, double x1, double z0, double z1){
    int sizeX = (x1-x0) * mSizeX / _FILLER_SKIP, sizeZ = (z1-z0) * mSizeZ / _FILLER_SKIP;
    double scaleX = _FILLER_SKIP / mSizeY, scaleZ = _FILLER_SKIP / mSizeZ;

    if (directionB == -1)
	for (int z = 0; z <= sizeZ; z++){
	    double coZ0 = z0 + scaleZ * z, coZ1 = z0 + scaleZ * (z+1);
	    if (z == sizeZ) coZ1 = z1;
	    glBegin(GL_QUAD_STRIP);
	    for (int x = 0; x < sizeX; x++){
		double coX = x0 + scaleX * x;
		DrawFillerYQuadStripCore(value, directionA, normalV, 
					 coX, coY, coZ0, coZ1);
	    }
	    DrawFillerYQuadStripCore(value, directionA, normalV, 
				     x1, coY, coZ0, coZ1);
	    glEnd();
	}
    else
	for (int z = 0; z <= sizeZ; z++){
	    double coZ0 = z0 + scaleZ * z, coZ1 = z0 + scaleZ * (z+1);
	    if (z == sizeZ) coZ1 = z1;
	    glBegin(GL_QUAD_STRIP);
	    for (int x = 0; x < sizeX; x++){
		double coX = x0 + scaleX * x;
		DrawFillerYQuadStripCore(value, -directionA, normalV, 
					 coX, coY, coZ0, coZ1);
	    }
	    DrawFillerYQuadStripCore(value, -directionA, normalV, 
				     x1, coY, coZ0, coZ1);
	    glEnd();
	}
}

void PovThreeView_cls::
AddFillerY(double scale[3], int directionA, 
	   bool bShowXMinus, bool bShowXPlus, float offsetX,
	   bool bShowZMinus, bool bShowZPlus, float offsetZ){
    glColor4f(1, 1, 1, 1);
    glEnable(GL_TEXTURE_1D);
    glEnable(GL_LIGHTING);

    int y;
    double coY;
    float normalV[3];
    if (directionA == -1){
	y = 0;
	coY = 0 - GetPCData()->mCOffset.mpBody[Y];
	normalV[X] = 0; normalV[Y] = -1; normalV[Z] = 0; 
    }
    else{
	y = mSizeY - 1;
	coY = 1 + GetPCData()->mCOffset.mpBody[Y];
	normalV[X] = 0; normalV[Y] = 1; normalV[Z] = 0; 
    }

    if (bShowXMinus == TRUE)
	DrawFillerYQuadStrip(0, directionA, -1, normalV, coY, 
			     -offsetX, 0, 0, 1);
    if (bShowXPlus == TRUE)
	DrawFillerYQuadStrip(0, -directionA, +1, normalV, coY, 
			     1 - 2.0/mSizeX, 1.0 + offsetX, 0, 1);
    if (bShowZMinus == TRUE)
	DrawFillerYQuadStrip(0, directionA, -1, normalV, coY,
			     0, 1, -offsetZ, 0);
    if (bShowZPlus == TRUE)
	DrawFillerYQuadStrip(0, -directionA, +1, normalV, coY,
			     0, 1, 1 - 1.0/mSizeZ, 1 + offsetZ);
    if (bShowXMinus == TRUE && bShowZMinus == TRUE)
	DrawFillerYQuadStrip(0, directionA, -1, normalV, coY, 
			     -offsetX, 0, -offsetZ, 0);
    if (bShowXMinus == TRUE && bShowZPlus == TRUE)
	DrawFillerYQuadStrip(0, directionA, -1, normalV, coY, 
			     -offsetX, 0, 1 - 1.0/mSizeZ, 1 + offsetZ);
    if (bShowXPlus == TRUE && bShowZMinus == TRUE)
	DrawFillerYQuadStrip(0, -directionA, +1, normalV, coY, 
			     1 - 1.0/mSizeX, 1.0 + offsetX, -offsetZ, 0);
    if (bShowXPlus == TRUE && bShowZPlus == TRUE)
	DrawFillerYQuadStrip(0, -directionA, +1, normalV, coY, 
			     1 - 1.0/mSizeX, 1.0 + offsetX, 1 - 1.0/mSizeZ, 1 + offsetZ);
}

void PovThreeView_cls::
DrawFieldY(double scale[3], int mappingType, int patternType, 
	   int colorType, int mappingCoord, double emboss, int direction){
    RecalcNorm(&mVVNormalU[Y], &mVVNormalV[Y], &mVVNormalW[Y],
	       scale, mSizeX, mSizeZ, Y, X, Z, Y);
    
    //glDisable(GL_COLOR_MATERIAL);
    glColor4f(1, 1, 1, 1);
    glEnable(GL_TEXTURE_1D);
    glEnable(GL_LIGHTING);
    int y;
    double coY;
    float normalV[3];
    if (direction == -1){
	y = 0;//mpCData->GetPInterpolated()[_HEIGHT_LAYER];
	coY = 0 - GetPCData()->mCOffset.mpBody[Y];
	normalV[X] = 0; normalV[Y] = -1; normalV[Z] = 0; 
    }
    else{
	y = mSizeY - 1;//mpCData->GetPInterpolated()[_HEIGHT_LAYER];
	coY = 1 + GetPCData()->mCOffset.mpBody[Y];
	normalV[X] = 0; normalV[Y] = 1; normalV[Z] = 0; 
    }

    double critoffset = 0;
    if (GetPCData()->mCbTransNullRegion.mbBody == TRUE){
	double PlaneEqYmax[4] = {0, 0, 0, 0};
	critoffset = GetCritOffset() * emboss / 16;
	if (emboss * direction < 0){
	    PlaneEqYmax[Y] = +1.0; PlaneEqYmax[3] = -coY; }
	else{
	    PlaneEqYmax[Y] = -1.0; PlaneEqYmax[3] = +coY; }
	glClipPlane(GL_CLIP_PLANE0, PlaneEqYmax);
	glEnable(GL_CLIP_PLANE0);
    }
    coY += direction * critoffset;

    const double embossfactor = emboss / 4096;
    const int sizeZ = mSizeZ, sizeZm = mSizeZ-1;
    const int sizeX = mSizeX, sizeXm = mSizeX-1;
    
    AllocArray(Y, sizeZ, sizeXm);
    MACRO_DECLAREPOINTERS(Y);

    int   index = 0;
    for (int z = 0; z < sizeZ; z++){
	const double coZ0 = (double) z / sizeZ;
	const unsigned char *pVFieldLine = &(mVVField[Y][z][0]);
	if (colorType != 0)
	    if (mappingType == _TEX_MAPPING_VALUE)
		for (int x = 0; x < sizeXm; x++){
		    pTexture[index] = (float)pVFieldLine[x]/256;
		    index++;
		}
	    else
		if (mappingCoord == _MAPPING_GLOBAL){
		    for (int x = 0; x < sizeXm; x++){
			double coYemb  = coY + embossfactor*pVFieldLine[x];
			double coX = (double) x / mSizeX;
			float globPos[3];
			float localPos[3] = {coX, coYemb, coZ0};
			GetGlobalPos(globPos, localPos);
			pTexture[index] = (float)GetMappingValueGlobal(globPos);
			index++;
		    } }
		else{
		    for (int x = 0; x < sizeXm; x++){
			double coYemb  = coY + embossfactor*pVFieldLine[x];
			double coX = (double) x / mSizeX;
			float localPos[3] = {coX, coYemb, coZ0};
			pTexture[index] = (float)GetMappingValueGlobal(localPos); // CHECK_ME!!
			index++;
		    } 
		}
    }
    
    index = 0;
    for (int z = 0; z < sizeZ; z++){
	MACRO_DECLAREPOINTERS_B(Y,z,Z);
	for (int x = 0; x < sizeXm; x++){
	    double coYemb  = /*coY +*/ embossfactor*pVFieldLine[x];
	    double coX = (double) x / sizeX;
	    MACRO_SETARRAYS(U, W, V, coX, coYemb, coZ);
	    index++;
	}
    }

    glPushMatrix();
    glTranslated(0, coY, 0);
    if (direction == 1)
	glScaled(1, -1, 1);
    DrawVertexArray(colorType, sizeXm, sizeZm,
		    pTexture, pNormals, pVertices, pPolyIndices,
		    (direction == 1));
    glPopMatrix();
    glDisable(GL_CLIP_PLANE0);

    //double frameX = mpCData->GetPInterpolated()[_THREE_LAYER + X] / mSizeX;
    double frameY = mpCData->GetPInterpolated()[_THREE_LAYER + Y] / mSizeY;
    double frameZ = mpCData->GetPInterpolated()[_THREE_LAYER + Z] / mSizeZ;
    if (GetPCData()->mCbDrawFrame.mbBody == TRUE){
	SettingForDrawFrame();
	glBegin(GL_LINE_STRIP);
	glVertex3d(0.001, frameY, 0.001); glVertex3d(0.999, frameY, 0.001);
	glVertex3d(0.999, frameY, 0.999); glVertex3d(0.001, frameY, 0.999);
	glVertex3d(0.001, frameY, 0.001);
	glEnd();
	if (GetPCData()->mCbShow0.mpbBody[Z] || GetPCData()->mCbShow0.mpbBody[Z]){
	    glBegin(GL_LINE_STRIP);
	    glVertex3d(0, frameY, frameZ); glVertex3d(1, frameY, frameZ);
	    glEnd();
	}
    }
}

void PovThreeView_cls::
DrawFillerZQuadStripCore(double value, int directionA, float normalV[3],
			 double coX, double coY0, double coY1, double coZ){
    if ( directionA == -1){
	glTexCoord1f(value); glNormal3fv(normalV); glVertex3d(coX, coY0, coZ);
	glTexCoord1f(value); glNormal3fv(normalV); glVertex3d(coX, coY1, coZ);
    }
    else{
	glTexCoord1f(value); glNormal3fv(normalV); glVertex3d(coX, coY1, coZ);
	glTexCoord1f(value); glNormal3fv(normalV); glVertex3d(coX, coY0, coZ);
    }
}

void PovThreeView_cls::
DrawFillerZQuadStrip(double value, int directionA, int directionB, 
		     float normalV[3], double coZ, 
		     double x0, double x1, double y0, double y1){
    int sizeX = (x1-x0) * mSizeX/ _FILLER_SKIP, sizeY = (y1-y0) * mSizeY / _FILLER_SKIP;
    double scaleX = _FILLER_SKIP / mSizeX, scaleY = _FILLER_SKIP / mSizeY;

    if (directionB == -1)
	for (int y = 0; y <= sizeY; y++){
	    double coY0 = y0 + scaleY * y, coY1 = y0 + scaleY * (y+1);
	    if (y == sizeY) coY1 = y1;
	    glBegin(GL_QUAD_STRIP);
	    for (int x = 0; x < sizeX; x++){
		double coX = x0 + scaleX * x;
		DrawFillerZQuadStripCore(value, directionA, normalV, 
					 coX, coY0, coY1, coZ);
	    }
	    DrawFillerZQuadStripCore(value, directionA, normalV, 
				     x1, coY0, coY1, coZ);
	    glEnd();
	}
    else
	for (int y = 0; y <= sizeY; y++){
	    double coY0 = y0 + scaleY * y, coY1 = y0 + scaleY * (y+1);
	    if (y == sizeY) coY1 = y1;
	    glBegin(GL_QUAD_STRIP);
	    for (int x = 0; x < sizeX; x++){
		double coX = x0 + scaleX * x;
		DrawFillerZQuadStripCore(value, -directionA, normalV, 
					 coX, coY0, coY1, coZ);
	    }
	    DrawFillerZQuadStripCore(value, -directionA, normalV, 
				     x1, coY0, coY1, coZ);
	    glEnd();
	}
}

void PovThreeView_cls::
AddFillerZ(double scale[3], int directionA, 
	   bool bShowXMinus, bool bShowXPlus, float offsetX,
	   bool bShowYMinus, bool bShowYPlus, float offsetY){
    glColor4f(1, 1, 1, 1);
    glEnable(GL_TEXTURE_1D);
    glEnable(GL_LIGHTING);

    int z;
    double coZ;
    float normalV[3];
    if (directionA == -1){
	z = 0;
	coZ = 0 - GetPCData()->mCOffset.mpBody[Z];
	normalV[X] = 0; normalV[Y] = 0; normalV[Z] = -1; 
    }
    else{
	z = mSizeZ - 1;
	coZ = 1 + GetPCData()->mCOffset.mpBody[Z];
	normalV[X] = 0; normalV[Y] = 0; normalV[Z] = 1; 
    }

    if (bShowXMinus == TRUE)
	DrawFillerZQuadStrip(0, directionA, -1, normalV, coZ, 
			     -offsetX, 0, 0, 1);
    if (bShowXPlus == TRUE)
	DrawFillerZQuadStrip(0, -directionA, +1, normalV, coZ, 
			     1 - 2.0/mSizeX, 1.0 + offsetX, 0, 1);
    if (bShowYMinus == TRUE)
	DrawFillerZQuadStrip(0, directionA, -1, normalV, coZ,
			     0, 1, -offsetY, 0);
    if (bShowYPlus == TRUE)
	DrawFillerZQuadStrip(0, -directionA, +1, normalV, coZ,
			     0, 1, 1 - 1.0/mSizeY, 1 + offsetY);

    if (bShowXMinus == TRUE && bShowYMinus == TRUE)
	DrawFillerZQuadStrip(0, directionA, -1, normalV, coZ, 
			     -offsetX, 0, -offsetY, 0);
    if (bShowXMinus == TRUE && bShowYPlus == TRUE)
	DrawFillerZQuadStrip(0, directionA, -1, normalV, coZ, 
			     -offsetX, 0, 1 - 1.0/mSizeY, 1 + offsetY);
    if (bShowYPlus == TRUE && bShowYMinus == TRUE)
	DrawFillerZQuadStrip(0, -directionA, +1, normalV, coZ, 
			     1 - 1.0/mSizeX, 1.0 + offsetX, -offsetY, 0);
    if (bShowYPlus == TRUE && bShowYPlus == TRUE)
	DrawFillerZQuadStrip(0, -directionA, +1, normalV, coZ, 
			     1 - 1.0/mSizeX, 1.0 + offsetX, 1 - 1.0/mSizeY, 1 + offsetY);
}

void PovThreeView_cls::
DrawFieldZ(double scale[3], int mappingType, int patternType,
	   int colorType, int mappingCoord, double emboss, int direction){
    RecalcNorm(&mVVNormalU[Z], &mVVNormalV[Z], &mVVNormalW[Z],
	       scale, mSizeX, mSizeY, Z, X, Y, Z);

    //glDisable(GL_COLOR_MATERIAL);
    glColor4f(1, 1, 1, 1);
    glEnable(GL_TEXTURE_1D);
    glEnable(GL_LIGHTING);
    int z;
    double coZ;
    float normalV[3];
    if (direction == -1){
	z = 0;//mpCData->GetPInterpolated()[_HEIGHT_LAYER];
	coZ = 0 - GetPCData()->mCOffset.mpBody[Z];
	normalV[X] = 0; normalV[Y] = 0; normalV[Z] = -1; 
    }
    else{
	z = mSizeZ - 1;//mpCData->GetPInterpolated()[_HEIGHT_LAYER];
	coZ = 1 + GetPCData()->mCOffset.mpBody[Z];
	normalV[X] = 0; normalV[Y] = 0; normalV[Z] = 1; 
    }

    double critoffset = 0;
    if (GetPCData()->mCbTransNullRegion.mbBody == TRUE){
	double PlaneEqZmax[4] = {0, 0, 0, 0};
	critoffset = GetCritOffset() * emboss / 16;
	if (emboss * direction < 0){
	    PlaneEqZmax[Z] = +1.0; PlaneEqZmax[3] = -coZ; }
	else{
	    PlaneEqZmax[Z] = -1.0; PlaneEqZmax[3] = +coZ; }
	glClipPlane(GL_CLIP_PLANE0, PlaneEqZmax);
	glEnable(GL_CLIP_PLANE0);
    }
    coZ += direction * critoffset;

    const double embossfactor = emboss / 4096;
    const int sizeY = mSizeY, sizeYm = mSizeY-1;
    const int sizeX = mSizeX, sizeXm = mSizeX-1;

    AllocArray(Z, sizeY, sizeXm);
    MACRO_DECLAREPOINTERS(Z);

    int   index = 0;
    for (int y = 0; y < sizeY; y++){
	const double coY0 = (double) y / sizeY;
	const unsigned char *pVFieldLine = &(mVVField[Z][y][0]);
	if (colorType != 0)  
	    if (mappingType == _TEX_MAPPING_VALUE)
		for (int x = 0; x < sizeXm; x++){
		    pTexture[index] = (float)pVFieldLine[x]/256;
		    index++;
		}
	    else
		if (mappingCoord == _MAPPING_GLOBAL){
		    for (int x = 0; x < sizeXm; x++){
			double coZemb  = coZ + embossfactor * pVFieldLine[x];
			double coX = (double) x / sizeX;
			float globPos[3];
			float localPos0[3] = {coX, coY0, coZemb};
			GetGlobalPos(globPos, localPos0);
			pTexture[index] = (float)GetMappingValueGlobal(globPos);
			index++;
		    } }
		else{
		    for (int x = 0; x < sizeXm; x++){
			double coZemb  = coZ + embossfactor * pVFieldLine[x];
			double coX = (double) x / sizeX;
			float localPos[3] = {coX, coY0, coZemb};
			pTexture[index] = (float)GetMappingValueGlobal(localPos); // CHECK_ME!!
			index++;
		    }
		}
    }

    index = 0;
    for (int y = 0; y < sizeY; y++){
	MACRO_DECLAREPOINTERS_B(Z,y,Y);
	for (int x = 0; x < sizeXm; x++){
	    double coZemb  = /*coZ +*/ embossfactor*pVFieldLine[x];
	    double coX = (double) x / sizeX;
	    MACRO_SETARRAYS(U, V, W, coX, coY, coZemb);
	    index++;
	}
    }

    glPushMatrix();

    glTranslated(0, 0, coZ);
    if (direction == 1)
	glScaled(1, 1, -1);
    DrawVertexArray(colorType, sizeXm, sizeYm,
		    pTexture, pNormals, pVertices, pPolyIndices,
		    (direction == 1));
    
    glPopMatrix();
    
    //double frameX = mpCData->GetPInterpolated()[_THREE_LAYER + X] / mSizeX;
    //double frameY = mpCData->GetPInterpolated()[_THREE_LAYER + Y] / mSizeY;
    double frameZ = mpCData->GetPInterpolated()[_THREE_LAYER + Z] / mSizeZ;
    if (GetPCData()->mCbDrawFrame.mbBody == TRUE){
	SettingForDrawFrame();
	glBegin(GL_LINE_STRIP);
	glVertex3d(0.001, 0.001, frameZ); glVertex3d(0.999, 0.001, frameZ);
	glVertex3d(0.999, 0.999, frameZ); glVertex3d(0.001, 0.999, frameZ);
	glVertex3d(0.001, 0.001, frameZ);
	glEnd();
    }

    glDisable(GL_CLIP_PLANE0);
}

void PovThreeView_cls::
DrawBox(double center[3], double scale[3]){
    if (GetPCData()->mCbValid.mbBody == FALSE) return;
    if (GetPCData()->GetPParamActive()->mCbVisible.mbBody == FALSE) return;
    if (scale[X] == 0 || scale[Y] == 0 || scale[Z] == 0) return;
    if (mSizeX == 0 || mSizeY == 0 || mSizeZ == 0) return;

    glPushAttrib(GL_ALL_ATTRIB_BITS);

    glColor4f(GetPCData()->mCTexProperty.mCColor.mpBody[0],
	      GetPCData()->mCTexProperty.mCColor.mpBody[1],
	      GetPCData()->mCTexProperty.mCColor.mpBody[2], 1);

    glPushMatrix();
    glTranslated(-0.5, -0.5, -0.5);

    glEnable(GL_NORMALIZE);
    glEnable(GL_LIGHTING);
    glEnable(GL_DEPTH_TEST);
    int depthFunc; glGetIntegerv(GL_DEPTH_FUNC, &depthFunc);
    if (depthFunc == GL_GREATER)
	glDepthMask(GL_FALSE);
    else
	glDepthMask(GL_TRUE);
    
    //GLuint showType = (msCShowMode.mBody == 0) ? GL_TRIANGLES : GL_LINES;
    int colorType = GetPCData()->mCTexProperty.mCColorType.mBody;
    int mappingType = GetPCData()->mCTexProperty.mCMappingType.mBody;
    int mappingCoord = GetPCData()->mCTexProperty.mCMappingCoord.mBody;
    int patternType = GetPCData()->mCTexProperty.mCPatternType.mBody;
    double emboss = GetEmboss();

    glLightModeli(GL_LIGHT_MODEL_TWO_SIDE,GL_TRUE);

    double offset[3];
    LOOP_XYZ offset[xyz] = center[xyz] - scale[xyz]/2;
    
    SetGLColoring(&GetPCData()->mCTexProperty);
    Configure1DMapping(&GetPCData()->mCTexProperty, offset, scale,
		       GetPCData()->mCbShade.mbBody, 
		       TRUE, GetPCData()->mCbMultiply.mbBody);
    
    /*
      mCurrPatternType =     // CrossSection̎ɂ̂ݕKv
      GetPCData()->mCTexProperty.mCPatternType.mBody;
    */

    bool bFiller = GetPCData()->mCbAddFiller.mbBody;
    bool *pbShow0 = GetPCData()->mCbShow0.mpbBody;
    bool *pbShow1 = GetPCData()->mCbShow1.mpbBody;
    float *pOffset = GetPCData()->mCOffset.mpBody;

    if (pbShow0[X] == TRUE){
	DrawFieldX(scale, mappingType, patternType, colorType, 
		   mappingCoord, emboss, -1); 
	if (bFiller == TRUE)
	    AddFillerX(scale, -1, 
		       pbShow0[Y], pbShow1[Y], pOffset[Y],
		       pbShow0[Z], pbShow1[Z], pOffset[Z]);
    }
    if (GetPCData()->mCbShow0.mpbBody[Y] == TRUE){
	DrawFieldY(scale, mappingType, patternType, colorType,
		   mappingCoord, emboss, -1); 
	if (bFiller == TRUE)
	    AddFillerY(scale, -1,
		       pbShow0[X], pbShow1[X], pOffset[X],
		       pbShow0[Z], pbShow1[Z], pOffset[Z]);
    }
    if (GetPCData()->mCbShow0.mpbBody[Z] == TRUE){
	DrawFieldZ(scale, mappingType, patternType, colorType,
		   mappingCoord, emboss, -1); 
	if (bFiller == TRUE)
	    AddFillerZ(scale, -1,
		       pbShow0[X], pbShow1[X], pOffset[X],
		       pbShow0[Y], pbShow1[Y], pOffset[Y]);
    }
    
    if (GetPCData()->mCbShow1.mpbBody[X] == TRUE){
	DrawFieldX(scale, mappingType, patternType, colorType, 
		   mappingCoord, emboss, +1); 
	if (bFiller == TRUE)
	    AddFillerX(scale, +1, 
		       pbShow0[Y], pbShow1[Y], pOffset[Y],
		       pbShow0[Z], pbShow1[Z], pOffset[Z]);
    }
    if (GetPCData()->mCbShow1.mpbBody[Y] == TRUE){
	DrawFieldY(scale, mappingType, patternType, colorType, 
		   mappingCoord, emboss, +1); 
	if (bFiller == TRUE)
	    AddFillerY(scale, +1,
		       pbShow0[X], pbShow1[X], pOffset[X],
		       pbShow0[Z], pbShow1[Z], pOffset[Z]);
    }
    if (GetPCData()->mCbShow1.mpbBody[Z] == TRUE){
	DrawFieldZ(scale, mappingType, patternType, colorType, 
		   mappingCoord, emboss, +1); 
	if (bFiller == TRUE)
	    AddFillerZ(scale, +1,
		       pbShow0[X], pbShow1[X], pOffset[X],
		       pbShow0[Y], pbShow1[Y], pOffset[Y]);
    }

    glLightModeli(GL_LIGHT_MODEL_TWO_SIDE,GL_FALSE);
    glPopAttrib();
    glPopMatrix();
}

bool PovThreeView_cls::
DoesUseMapping(){
    return FALSE;
}

void PovThreeView_cls::
MakeUV1D(TexProperty_cls *pCTexProp,
	 double offset[3], double scale[3]){
    int mappingType = pCTexProp->mCMappingType.mBody;
    int patternType = pCTexProp->mCPatternType.mBody;
    int mappingCoord = pCTexProp->mCMappingCoord.mBody;
    float *pos = pCTexProp->mCMappingPos.mpBody;
    float mapscale = pCTexProp->mCMappingScale.mBody;
    float mapturb = pCTexProp->mCMappingTurb.mBody;
    int axis = pCTexProp->mCMappingAxis.mBody;
    
    double rotate[4] = 
	{TexProperty_cls::msRotZ0, TexProperty_cls::msRotX0,
	 TexProperty_cls::msRotY0, TexProperty_cls::msRotZ1};

    if (IsParameterIsNewOne(mpCParentCtrl->GetRemappedDoubleIndex(),
			    mappingType, patternType, axis, mappingCoord, pos,
			    mapscale, mapturb, offset, scale, rotate) == FALSE
	&& mappingType == _TEX_MAPPING_PATTERN)
	return; 
    
    CopyCurrToPrev(pCTexProp);
}

wxString PovThreeView_cls::
GetPovStrThreeView(int axis, wxString strTag, wxString strFilePath,
		   wxString strGeometry, float treeDivideParam,
		   unsigned int depth, double baseAlpha,
		   double clipForPeriodicBoundary[3], 
		   PositionAndDirection_cls CCamLocalCoord, int frame,
		   DrawingBlock_cls* pCDrawingBlock){

    wxString strThreeView;

    if (mpCData->mCbValid.mbBody == FALSE) return wxT("");

    if (IsClippingEmpty() == TRUE) return wxT("");

    // FIX_ME!!
    /*
      for (unsigned int i = 0; i < mVSAlreadyOutputedTag.size(); i++){
      if (strTag == mVSAlreadyOutputedTag[i])
      return wxT("");
      }
      mVSAlreadyOutputedTag.push_back(strTag);
    */

    strThreeView << GetPovStrThreeViewGeom
	(axis, L"GEOM_THREE_VIEW_" + mAstrAxisUC[axis] + L"_" + mstrId + strTag, clipForPeriodicBoundary, frame);

    if (GetPCData()->mCTexProperty.mCMappingType.mBody == _TEX_MAPPING_VALUE){
	strThreeView << wxT("#declare THREE_VIEW_FINISH_") << mAstrAxisUC[axis] << wxT("_") << mstrId + strTag << wxT("=finish{") << ENDLWX;
	strThreeView << GetPCData()->mCTexProperty.GetPovStrFinish(TRUE)
		     << wxT("}") << ENDLWX;
    }
    else
	if (axis == X){ // ʂ̏ꍇ
	    strThreeView << wxT("#declare THREE_VIEW_FINISH_") << mstrId + strTag << wxT("=finish{") << ENDLWX;
	    strThreeView << GetPCData()->mCTexProperty.GetPovStrFinish(TRUE)
			 << wxT("}") << ENDLWX;
	}
    
    if (GetPCData()->mCTexProperty.mCMappingType.mBody == _TEX_MAPPING_VALUE){
	strThreeView << GetPovStrThreeViewTex
	    (axis, mstrId + strTag, FALSE/*bFlip*/);
	strThreeView << GetPovStrThreeViewObj
	    (axis, -1, mstrId + strTag, strTag, FALSE/*bFlip*/,
	     pCDrawingBlock);
	strThreeView << GetPovStrThreeViewObj
	    (axis, +1, mstrId + strTag, strTag, TRUE/*bFlip*/,
	     pCDrawingBlock);
    }
    else{
	if (axis == X) 
	    strThreeView << GetPovStrThreeViewTex
		(-1, mstrId + strTag, FALSE/*bFlip*/);
	strThreeView << GetPovStrThreeViewObjIndependentTex
	    (axis, -1, mstrId + strTag, strTag, FALSE,
	     pCDrawingBlock);
	strThreeView << GetPovStrThreeViewObjIndependentTex
	    (axis, +1, mstrId + strTag, strTag, TRUE,
	     pCDrawingBlock);
    }
    
    return strThreeView;
}

wxString PovThreeView_cls::
GetPovStrThreeViewColorMap(wxString strTag){
    wxString strColorMap;
    int colorType = GetPCData()->mCTexProperty.mCColorType.mBody - 1;

    strColorMap << wxT("#declare THREE_VIEW_CLRMAP_") << mstrId + strTag << wxT("=");
    strColorMap << GCColoring.GetPovStrColorMap
	(mpCParentCtrl->mSelfDF3Index,
	 colorType + _CLR_CUSTOM, FALSE, 0, NULL, GetPCData()->mCbMultiply.mbBody,
	 1.0f - mpCData->GetPInterpolated()[_THREE_ALPHA]);
    strColorMap << ENDLWX;
    return strColorMap;
}

wxString PovThreeView_cls::
GetPovStrThreeViewTex(int axis, wxString strTag, bool bFlip){
    
    wxString strCRTex, strFinishTag;
    
    if (axis < 0){ // ʂ̏ꍇ
	strFinishTag << wxT("THREE_VIEW_FINISH_") << strTag;
	strCRTex << ENDLWX;
	strCRTex << L"#declare " 
		 << wxT("THREE_VIEW_TEX_") << strTag << L"=texture{" << ENDLWX;
    }
    else{
	strFinishTag << wxT("THREE_VIEW_FINISH_") << mAstrAxisUC[axis] << wxT("_") << strTag;
	
	strCRTex << ENDLWX;
	strCRTex << L"#declare " 
		 << wxT("THREE_VIEW_TEX_") << mAstrAxisUC[axis] << wxT("_") << strTag << L"=texture{" << ENDLWX;
    }
    
    // -1 PFɂ
    int colorType = GetPCData()->mCTexProperty.mCColorType.mBody - 1;
    float trans = 1.0f - GetPCData()->GetPInterpolated()[_THREE_ALPHA];
    int transmitType = GetPCData()->mCTexProperty.mCTransmitType.mBody;
    wxString strColorMap, strClr1, strClr2, strClr3;

    if (colorType >= 0){
	if (GetPCData()->mCTexProperty.mCMappingType.mBody == _TEX_MAPPING_VALUE)
	    strColorMap << wxT("\tgradient y translate -0.001*y") << ENDLWX;
	
	strColorMap << wxT("\tcolor_map { THREE_VIEW_CLRMAP_") << strTag << wxT("}") << ENDLWX;
	/*
	  strColorMap << GCColoring.GetPovStrColorMap
	  (mpCParentCtrl->mSelfDF3Index,
	  colorType + _CLR_CUSTOM, FALSE, 0, NULL, GetPCData()->mCbMultiply.mbBody,
	  1.0f - mpCData->GetPInterpolated()[_THREE_ALPHA]);
	*/
	strClr1 = GCColoring.GetPovStrClr
	    (mpCParentCtrl->mSelfDF3Index,
	     GetPCData()->mCTexProperty.mCColorType.mBody - 1 + _CLR_CUSTOM, 0,
	     trans, transmitType);
	strClr2 = GCColoring.GetPovStrClr
	    (mpCParentCtrl->mSelfDF3Index,
	     GetPCData()->mCTexProperty.mCColorType.mBody - 1 + _CLR_CUSTOM, 1,
	     trans, transmitType);
	strClr3 = GCColoring.GetPovStrClr
	    (mpCParentCtrl->mSelfDF3Index,
	     GetPCData()->mCTexProperty.mCColorType.mBody - 1 + _CLR_CUSTOM, 0.5,
	     trans, transmitType);
    }
    
    double alt = mpCData->GetPInterpolated()[_THREE_EMBOSS] * 0.0625;
    if (alt > -0.0003 && alt < 0.0003){
	alt = 0.0003;
	if (bFlip == TRUE) alt *= -1;
    }

    strCRTex << GetPCData()->mCTexProperty.GetPovStrTex
	(mpCData->GetPInterpolated()[_THREE_ALPHA], strFinishTag, strColorMap,
	 1, 1.0f/alt, 1, GetPCData()->mCbShade.mbBody,
	 FALSE, axis, strClr1, strClr2, strClr3);
	 
    strCRTex << L"}" << ENDLWX;

    return strCRTex;
}

wxString PovThreeView_cls::
GetPovStrThreeViewGeom(int axis, wxString strTag, 
		       double clipForPeriodicBoundary[3], int frame){
    if (mAllocU[axis] == -1) return wxT("");

    wxString strThreeView;
    /*
      double min[3] = {0, 0 ,0};
      double max[3] = {1, 1, 1};
      GetClippingInformation(min, max);
      LOOP_XYZ if (max[xyz] > clipForPeriodicBoundary[xyz])
      max[xyz] = clipForPeriodicBoundary[xyz];
      LOOP_XYZ if (min[xyz] < 0.0001) min[xyz] = 0.0001;
    */
    
    unsigned char *pData;
    if (FilterCtrl_cls::msStereoTmpFileIOMode & 1){
	pData = (unsigned char*)malloc(mAllocU[axis] * mAllocV[axis] * 3);
	
	for (int v = 0; v < mAllocV[axis]; v++){
	    int offsetV = v * mAllocU[axis];
	    for (int u = 0; u < mAllocU[axis]; u++){
		int offsetU = offsetV + u;
		pData[offsetU*3]   = mVVField[axis][v][u];
		pData[offsetU*3+1] = mVVField[axis][v][u];
		pData[offsetU*3+2] = mVVField[axis][v][u];
	    }
	}
    }

    wxString strFileOut = mspCPovRayLink->GetWorkingDirWithSep
      (mspCPovRayLink->mbPovOutForRender);
    strFileOut << L"Frame_" << frame << L"_" << strTag << L".png";

    wxString strFileOutAbs = mspCPovRayLink->GetWorkingDirWithSep(TRUE);
    strFileOutAbs << L"Frame_" << frame << L"_" << strTag << L".png";
    
    /*
      if (GetPCData()->mCbPostSceneCommand.mbBody == TRUE && 
      (FilterCtrl_cls::msStereoTmpFileIOMode & 2)){
      #ifdef WIN32
      mspCPovRayLink->mstrPostSceneCommand << L"del " << strFileOut << L";";
      #else
      mspCPovRayLink->mstrPostSceneCommand << L"rm " << strFileOut << L";";
      #endif
      }
    */
    
    // delete 󂯓n
    if (FilterCtrl_cls::msStereoTmpFileIOMode & 1)
	if (GCImgIO.SaveImageFromData(mAllocU[axis], mAllocV[axis], strFileOutAbs, pData) == FALSE)
	    MsgBox(NULL, "Save Error", "Height Field Image Save Error");
    
    strThreeView << L"#declare " << strTag << L"=height_field{" << ENDLWX 
		 << L"\tpng \"" << strFileOut << L"\"" << ENDLWX;

    if (GetPCData()->mCbSmooth.mbBody == TRUE)
	strThreeView << L"\tsmooth" << ENDLWX;
    
    strThreeView << L"}" << ENDLWX 
		 << ENDLWX;
    
    return strThreeView;
}

wxString PovThreeView_cls::
GetPovStrThreeViewFiller(int axis, int direction){
    wxString strFiller;
    bool bFillerHN = FALSE, bFillerHP = FALSE;
    bool bFillerVN = FALSE, bFillerVP = FALSE;
    float offsetH, offsetV;

    switch (axis){
    case X:
	offsetH = GetPCData()->mCOffset.mpBody[Y];
	offsetV = GetPCData()->mCOffset.mpBody[Z];
	if (GetPCData()->mCbShow0.mpbBody[Y] == TRUE) bFillerHN = TRUE;  
	if (GetPCData()->mCbShow1.mpbBody[Y] == TRUE) bFillerHP = TRUE; 
	if (GetPCData()->mCbShow0.mpbBody[Z] == TRUE) bFillerVN = TRUE;  
	if (GetPCData()->mCbShow1.mpbBody[Z] == TRUE) bFillerVP = TRUE; 
	break;
    case Y:
	offsetH = GetPCData()->mCOffset.mpBody[X];
	offsetV = GetPCData()->mCOffset.mpBody[Z];
	if (GetPCData()->mCbShow0.mpbBody[X] == TRUE) bFillerHN = TRUE;  
	if (GetPCData()->mCbShow1.mpbBody[X] == TRUE) bFillerHP = TRUE; 
	if (GetPCData()->mCbShow0.mpbBody[Z] == TRUE) bFillerVN = TRUE;  
	if (GetPCData()->mCbShow1.mpbBody[Z] == TRUE) bFillerVP = TRUE; 
	break;
    case Z:
	offsetH = GetPCData()->mCOffset.mpBody[X];
	offsetV = GetPCData()->mCOffset.mpBody[Y];
	if (GetPCData()->mCbShow0.mpbBody[X] == TRUE) bFillerHN = TRUE;  
	if (GetPCData()->mCbShow1.mpbBody[X] == TRUE) bFillerHP = TRUE; 
	if (GetPCData()->mCbShow0.mpbBody[Y] == TRUE) bFillerVN = TRUE;  
	if (GetPCData()->mCbShow1.mpbBody[Y] == TRUE) bFillerVP = TRUE; 
	break;
    }

    if (bFillerHN == TRUE && offsetH != 0)
	strFiller << wxT("\t\tpolygon { 5") 
		  << PovOut3(wxT(","), 0, 0, 0) 
		  << PovOut3(wxT(","), -offsetH, 0, 0) 
		  << PovOut3(wxT(","), -offsetH, 0, 1) 
		  << PovOut3(wxT(","), 0, 0, 1) 
		  << PovOut3(wxT(","), 0, 0, 0) << wxT(" }") << ENDLWX;
    if (bFillerHP == TRUE && offsetH != 0)
	strFiller << wxT("\t\tpolygon { 5") 
		  << PovOut3(wxT(","), 1, 0, 0) 
		  << PovOut3(wxT(","), 1+offsetH, 0, 0) 
		  << PovOut3(wxT(","), 1+offsetH, 0, 1) 
		  << PovOut3(wxT(","), 1, 0, 1) 
		  << PovOut3(wxT(","), 1, 0, 0) << wxT(" }") << ENDLWX;
    if (bFillerVN == TRUE && offsetV != 0)
	strFiller << wxT("\t\tpolygon { 5") 
		  << PovOut3(wxT(","), 0, 0, 0) 
		  << PovOut3(wxT(","), 0, 0, -offsetV) 
		  << PovOut3(wxT(","), 1, 0, -offsetV) 
		  << PovOut3(wxT(","), 1, 0, 0) 
		  << PovOut3(wxT(","), 0, 0, 0) << wxT(" }") << ENDLWX;
    if (bFillerVP == TRUE && offsetV != 0)
	strFiller << wxT("\t\tpolygon { 5") 
		  << PovOut3(wxT(","), 0, 0, 1) 
		  << PovOut3(wxT(","), 0, 0, 1+offsetV) 
		  << PovOut3(wxT(","), 1, 0, 1+offsetV) 
		  << PovOut3(wxT(","), 1, 0, 1) 
		  << PovOut3(wxT(","), 0, 0, 1) << wxT(" }") << ENDLWX;

    if (bFillerHN == TRUE && bFillerVN == TRUE &&
	offsetH != 0 && offsetV != 0)
	strFiller << wxT("\t\tpolygon { 5") 
		  << PovOut3(wxT(","), 0, 0, -offsetV)
		  << PovOut3(wxT(","), -offsetH, 0, -offsetV)
		  << PovOut3(wxT(","), -offsetH, 0, 0)
		  << PovOut3(wxT(","), 0, 0, 0) 
		  << PovOut3(wxT(","), 0, 0, -offsetV) << wxT(" }") << ENDLWX;
    if (bFillerHN == TRUE && bFillerVP == TRUE &&
	offsetH != 0 && offsetV != 0)
	strFiller << wxT("\t\tpolygon { 5") 
		  << PovOut3(wxT(","), 0, 0, 1) 
		  << PovOut3(wxT(","), -offsetH, 0, 1) 
		  << PovOut3(wxT(","), -offsetH, 0, 1+offsetV) 
		  << PovOut3(wxT(","), 0, 0, 1+offsetV) 
		  << PovOut3(wxT(","), 0, 0, 1) << wxT(" }") << ENDLWX;
    if (bFillerHP == TRUE && bFillerVN == TRUE &&
	offsetH != 0 && offsetV != 0)
	strFiller << wxT("\t\tpolygon { 5") 
		  << PovOut3(wxT(","), 1, 0, -offsetV) 
		  << PovOut3(wxT(","), 1+offsetH, 0, -offsetV) 
		  << PovOut3(wxT(","), 1+offsetH, 0, 0) 
		  << PovOut3(wxT(","), 1, 0, 0) 
		  << PovOut3(wxT(","), 1, 0, -offsetV) << wxT(" }") << ENDLWX;
    if (bFillerHP == TRUE && bFillerVP == TRUE &&
	offsetH != 0 && offsetV != 0)
	strFiller << wxT("\t\tpolygon { 5") 
		  << PovOut3(wxT(","), 1, 0, 1) 
		  << PovOut3(wxT(","), 1+offsetH, 0, 1) 
		  << PovOut3(wxT(","), 1+offsetH, 0, 1+offsetV) 
		  << PovOut3(wxT(","), 1, 0, 1+offsetV) 
		  << PovOut3(wxT(","), 1, 0, 1) << wxT(" }") << ENDLWX;
    return strFiller;
}

wxString PovThreeView_cls::
GetPovStrThreeViewObjBase(int axis, int direction, wxString strBoxLabel, 
			  double critoffset, bool bIndependentTex){
    wxString strObjBase;
    
    wxString strDirection;
    if (direction == -1) 
	strDirection = wxT("_MINUS_");
    else
	strDirection = wxT("_PLUS_");

    strObjBase << L"#declare " << L"OBJECT_THREE_VIEW_" << mAstrAxisUC[axis] << strDirection << strBoxLabel << L"=object{" << ENDLWX;
    if (mAllocV[axis] == -1){
	strObjBase << wxT("\tbox{ <0, 0, 0> <0, 0, 0>}") << ENDLWX;
	return strObjBase;
    }

    if (bIndependentTex == TRUE)
	strObjBase << wxT("\tobject {") << ENDLWX;

    if (GetPCData()->mCbTransNullRegion.mbBody == TRUE)
	strObjBase << L"\tintersection {" << ENDLWX
		   << L"\t\tbox { <0, " << critoffset << L", 0> <1, 2, 1>" << ENDLWX
		   << L"\t\t\t pigment { rgbt < 1, 1, 1, 1> } }" << ENDLWX
		   << L"\t\t" << wxT("GEOM_THREE_VIEW_") << mAstrAxisUC[axis] << wxT("_") << strBoxLabel << ENDLWX
		   << L"\t}" << ENDLWX;
    else

    strObjBase << wxT("\tunion {") << ENDLWX 
	       << wxT("\t\tobject{ GEOM_THREE_VIEW_") << mAstrAxisUC[axis] << wxT("_") << strBoxLabel << wxT(" }") << ENDLWX
	       << GetPovStrThreeViewFiller(axis, direction)
	       << wxT("\t}") << ENDLWX;
    
    return strObjBase;
}

wxString PovThreeView_cls::
GetPovStrThreeViewTranslate(int axis, int direction, double critoffset, double alt){
    wxString strObjTrans;

    double co;
    if (direction == -1) 
	co = 0 - GetPCData()->mCOffset.mpBody[axis];
    else
	co = 1 + GetPCData()->mCOffset.mpBody[axis];
    
    if (direction == 1) alt *= -1;

    switch(axis){
    case X: {
	strObjTrans << L"\ttranslate <0, " << -critoffset << L", 0>" << ENDLWX
		     << L"\tscale <1, " << -alt << L", 1>" << ENDLWX
		     << L"\trotate <0, 0, 90>" << ENDLWX
		     << L"\ttranslate <" << co << L", 0, 0>" << ENDLWX;
	break; }
    case Y: {
	strObjTrans << L"\ttranslate <0, " << -critoffset << L", 0>" << ENDLWX
		     << L"\tscale <1, " << alt << L", 1>" << ENDLWX
		     << L"\trotate <0, 0, 0>" << ENDLWX
		     << L"\ttranslate <0, " << co << L", 0>" << ENDLWX;
	break; }
    case Z: {
	strObjTrans << L"\ttranslate <0, " << -critoffset << L", 0>" << ENDLWX
		     << L"\tscale <1, " << -alt << L", 1>" << ENDLWX
		     << L"\trotate <-90, 0, 0>" << ENDLWX
		     << L"\ttranslate <0, 0, " << co << L">" << ENDLWX;
	break; }
    }
    
    strObjTrans << wxT("\ttranslate < -0.5, -0.5, -0.5 > "); 

    return strObjTrans;
}

wxString PovThreeView_cls::
GetPovStrThreeViewObjIndependentTex(int axis, int direction, 
				    wxString strBoxLabel, 
				    wxString strTag, bool bFlip,
				    DrawingBlock_cls* pCDrawingBlock){
    wxString strObjHeight;
    double critoffset = GetCritOffset();

    strObjHeight << GetPovStrThreeViewObjBase(axis, direction, strBoxLabel, critoffset, TRUE);
    
    double scale[3];
    LOOP_XYZ scale[xyz] = pCDrawingBlock->GetBoxScaleWorldCoord(xyz);

    double alt = mpCData->GetPInterpolated()[_THREE_EMBOSS] * 0.0625;
    if (alt > -0.0003 && alt < 0.0003){
	alt = 0.0003;
	if (bFlip == TRUE) alt *= -1;
    }

    strObjHeight << GetPovStrThreeViewTranslate(axis, direction, critoffset, alt);
    
    strObjHeight << wxT("}") << ENDLWX;

    if (GetPCData()->mCTexProperty.mCMappingCoord.mBody == _MAPPING_LOCAL)

	strObjHeight << L"\ttexture { " << wxT("THREE_VIEW_TEX_") << strBoxLabel << ENDLWX
		     << wxT("\t\t") << PovOut3(wxT("scale"), 
					       1.0/scale[X], 1.0/scale[Y], 1.0/scale[Z]) << wxT(" }") << ENDLWX;
    
    strObjHeight << L"\thollow" << ENDLWX
		 << wxT("}") << ENDLWX;

    if (GetPCData()->mCTexProperty.mCMappingCoord.mBody == _MAPPING_GLOBAL)
	strObjHeight << wxT("#declare THREEVIEWGLOBAL_") << strBoxLabel << wxT("=1;") << ENDLWX << ENDLWX;
    
    return strObjHeight;
}

wxString PovThreeView_cls::
GetPovStrThreeViewObj(int axis, int direction, wxString strBoxLabel, 
		      wxString strTag, bool bFlip,
		      DrawingBlock_cls* pCDrawingBlock){
    
    wxString strObjThreeView;
    double critoffset = GetCritOffset();

    strObjThreeView << ENDLWX;
    strObjThreeView << GetPovStrThreeViewObjBase(axis, direction, strBoxLabel, critoffset, FALSE);

    double scale[3];
    LOOP_XYZ scale[xyz] = pCDrawingBlock->GetBoxScaleWorldCoord(xyz);
    strObjThreeView << L"\ttexture { " << wxT("THREE_VIEW_TEX_") << mAstrAxisUC[axis] << wxT("_") << strBoxLabel << ENDLWX;

    double alt = mpCData->GetPInterpolated()[_THREE_EMBOSS] * 0.0625;
    if (alt > -0.0003 && alt < 0.0003){
	alt = 0.0003;
	if (bFlip == TRUE) alt *= -1;
    }

    if (GetPCData()->mCTexProperty.mCMappingType.mBody != _TEX_MAPPING_VALUE){
	switch(axis){
	case Y:
	    // CHECK_ME!!
	    strObjThreeView << L"\t\t" << PovOut3(wxT("scale"), 1.0/scale[X], 1.0/scale[Y]/alt, 1.0/scale[X]);
	    break;
	case Z:
	    strObjThreeView << L"\t\t" << PovOut3(wxT("scale"), 1.0/scale[X], 1.0/scale[Z]/alt, 1.0/scale[Y]) << ENDLWX;
	    break;
	}
	strObjThreeView << L"\t\t" << PovOut3(wxT("translate"), 0.5, 0.5, 0.5) << ENDLWX;
    }
    strObjThreeView << L"\t}" << ENDLWX
		    << L"\thollow" << ENDLWX;

    strObjThreeView << GetPovStrThreeViewTranslate(axis, direction, critoffset, alt);
    
    strObjThreeView << L"}" << ENDLWX << ENDLWX ;

    return strObjThreeView;
}

// ------------------

wxString PovThreeView_cls::
GetFilterStatusStr(){
    wxString strStatus;
    strStatus << wxT("ThreeView::") << GetPCData()->mCbValid.mbBody;
    
    if (GetPCData()->mCbValid.mbBody == FALSE)
	strStatus<< wxT("::");
    else
	;
    /* FIX_ME!! Ƃ肠ȗ
	strStatus << wxT(":") <<
	    GetPCData()->mCAxis.mBody << wxT(":") << 
	    GetPCData()->GetPInterpolated()[_THREE_LAYER] << wxT(":") << 
	    GetPCData()->GetPInterpolated()[_THREE_EMBOSS] << wxT("::");
    */

    return strStatus;
}

MACRO_SerializeConfP(PovThreeView)
MACRO_GetNewPReadDataBlock(PovThreeView)
