// -*- c -*- 
// (setq c-basic-offset 4)
// "clsTreeBoxRule.h"

#include "clsTreeBoxRule.h"
#include "clsPovVolume.h"
#include "../../wxWidgetEnum.h"
#include "../../clsDrawingBox.h"
#include "../../clsFrameMain.h"
#include "../../clsMain.h"

#include "../../SRC/DF3/clsDF3SeqCtrl.h"

#include <wx/statline.h>
#include "../WIDGETCTRL/EX/clsButtonEX.h"

#ifdef WIN32
#define WCHARCONV(x) (wxString)wxConvLibc.cMB2WC(x)
#else
#define WCHARCONV(x) (wxString)wxConvUTF8.cMB2WC(x)
#endif

#define X 0
#define Y 1
#define Z 2
#define LOOP_XYZ for (int xyz = 0; xyz < 3; xyz++)

extern FrameMain_cls* GpCMainFrameCLS;

MultiNumericalInputsPanel_cls* TreeBoxRuleGUI_cls::mpCMNumRuleA;
MultiNumericalInputsPanel_cls* TreeBoxRuleGUI_cls::mpCMNumRuleB;

BEGIN_EVENT_TABLE(TreeBoxRuleGUI_cls, wxDialog)
     EVT_BUTTON(wxID_CANCEL, TreeBoxRuleGUI_cls::OnButtonClose)
     //EVT_BUTTON(buttonCtrlTreeApply, TreeBoxRuleGUI_cls::OnButtonApply)
     //EVT_BUTTON(buttonCtrlTreeHotSpot, TreeBoxRuleGUI_cls::OnButtonHotSpot)
     END_EVENT_TABLE()

     TreeBoxRuleGUI_cls::
TreeBoxRuleGUI_cls(TreeBoxRule_cls* pCParent, TreeBoxRuleGUI_cls **ppToThis,
		   wxWindow *pC, wxPoint pos, wxSize size) :
    wxDialogEXKey(pC, wxID_ANY, _("Tree Configure"),
		  pos, size, pCParent->mpBitmapLink)
{
    mppToThis = ppToThis;
    mpCParent = pCParent;
    mspCThis = this;
    SetScreenRectPos(&pCParent->mCScreenRect);
    
    /*
#ifdef WIN32
    wxIcon icon(wxT("ICONS/Tree.ico"), wxBITMAP_TYPE_ICO);
#else
    wxIcon icon(wxT("ICONS/Tree.png"), wxBITMAP_TYPE_PNG);
#endif
    wxIcon icon();
    SetIcon(icon);
    */

    // TCU[
    wxBoxSizer   *pBoxSizerSrc   = new wxBoxSizer(wxVERTICAL);

    /*
    mpCCurrentPath = new wxStaticText
	(this, wxID_ANY, GpCMainFrameCLS->GetCurrentActiveFileWXStr(),
	 wxDefaultPosition, wxDefaultSize, wxALIGN_RIGHT);

    wxStaticLine *pCStaticLine1 = new wxStaticLine(this);
    
    mpCConvertedPath = new wxStaticText
	(this, wxID_ANY, wxT(""), GpCMainFrameCLS->GetCurrentActiveFileWXStr(),
	 wxDefaultPosition, wxDefaultSize, wxALIGN_RIGHT);

    pBoxSizerSrc->Add( mpCCurrentPath, 0, wxEXPAND);
    pBoxSizerSrc->Add( pCStaticLine1, 0, wxEXPAND);
    pBoxSizerSrc->Add( mpCConvertedPath, 0, wxEXPAND);
    */

    // PARAM
    SetMNumRuleA(pBoxSizerSrc);

    //wxStaticLine *pCStaticLine2 = new wxStaticLine(this);
    //pBoxSizerSrc->Add( pCStaticLine2, 0, wxEXPAND);
    
    SetMNumRuleB(pBoxSizerSrc);
    
    SetSizerAndFit(pBoxSizerSrc);
    
    // -----

    int minimumWidth = GetClientSize().GetWidth() - 8;
    //mpCCurrentPath->SetSize(minimumWidth, -1);
    //mpCConvertedPath->SetSize(minimumWidth, -1);
    minimumWidth = mpCMNumRuleA->GetPaddingWidth(minimumWidth);
    minimumWidth = mpCMNumRuleB->GetPaddingWidth(minimumWidth);
    mpCMNumRuleA->SetPaddingWidth(minimumWidth);
    mpCMNumRuleB->SetPaddingWidth(minimumWidth);

    HideAndShow();
}

void TreeBoxRuleGUI_cls::
SetMNumRuleA(wxBoxSizer *pBoxSizer){
    MultiNumericalInputsPanel_cls* pCurr =
	InitializeMNumPanel(&mpCMNumRuleA, this);
    int boxWidth = 2;
    pCurr->mTextWidth       = 140;

    wxString pListAlias[2] = 
	{_("Not use alias"), _("Use alias file")};
    mIndexAlias = pCurr->CombinePointer(_GP_UNSIGNED_INT_LIST, &mpCParent->mCUseReplaceRule.mBody,
			  _("Alias"), TRUE, 2, pListAlias);
    
    mIndexReplaceFrom = pCurr->CombinePointer
	(_GP_WXSTRING, &/*mpCParent->mstrRuleFrom*/mpCParent->mCRuleFrom.msBody, _("replace from"));
    mIndexReplaceTo = pCurr->CombinePointer
	(_GP_WXSTRING, &/*mpCParent->mstrRuleTo*/mpCParent->mCRuleTo.msBody,  _("replace to"));

#ifdef WIN32
    mIndexCurrentPath = pCurr->CombinePointer
	(_GP_WXSTRING, &mstrCurrentPath, wxT(""), FALSE);
    mIndexConvertedPath = pCurr->CombinePointer
	(_GP_WXSTRING, &mstrConvertedPath, wxT(""), FALSE);
#else
    // LINUX  disable ƕ\Ȃc@ TRUEłH
    mIndexCurrentPath = pCurr->CombinePointer
	(_GP_WXSTRING, &mstrCurrentPath, wxT(""), TRUE);
    mIndexConvertedPath = pCurr->CombinePointer
	(_GP_WXSTRING, &mstrConvertedPath, wxT(""), TRUE);
#endif
    
    pCurr->FinishSetting(pBoxSizer, TRUE);

    ((wxTextCtrl*)pCurr->mVCPointers[mIndexCurrentPath].GetPCtrlWindow())->
	SetWindowStyle(wxTE_RIGHT|wxTE_READONLY);
    ((wxTextCtrl*)pCurr->mVCPointers[mIndexConvertedPath].GetPCtrlWindow())->
	SetWindowStyle(wxTE_RIGHT|wxTE_READONLY);

    pCurr->SetFuncHook(HookComboBox, _MN_HOOK_COMBOBOX);
    pCurr->SetFuncHook(HookAssign, _MN_HOOK_ASSIGN);

    pCurr->mVCPointers[mIndexAlias].
	GetPCtrlWindow()->SetToolTip(_("Use other files in rendering then previewing,\nusing following rule."));
}

void TreeBoxRuleGUI_cls::
SetMNumRuleB(wxBoxSizer *pBoxSizer){
    MultiNumericalInputsPanel_cls* pCurr = 
	InitializeMNumPanel(&mpCMNumRuleB, this);
    pCurr->mTextWidth       = 140;
    
    wxString pListTree[2] = {_("Octo Tree"), _("Nested Grid")};
    pCurr->CombinePointer(_GP_UNSIGNED_INT_LIST, &mpCParent->mCType.mBody,
			  _("Tree Type"), TRUE, 2, pListTree);
    
    int boxWidth = 2;
    pCurr->CombinePointer(_GP_BOXSIZERHORIZONTAL, &boxWidth,
			  _("Min / Max "));
    pCurr->CombinePointer(_GP_UNSIGNED_INT, &mpCParent->mCDepthMin.mBody);
    pCurr->CombinePointer(_GP_UNSIGNED_INT, &mpCParent->mCDepthMax.mBody);

    wxString pListFocus[3] = 
	{_("Camera Position"), _("Stereo Focus"), _("Anchor Pos")};
    mIndexTreeFocus = pCurr->CombinePointer
	(_GP_UNSIGNED_INT_LIST, &mpCParent->mCFocusType.mBody,
	 _("Tree Focus"), TRUE, 3, pListFocus);


    mIndexNestScale = pCurr->CombinePointer
	(_GP_FLOAT, &mpCParent->mCNestScale.mBody, _("Nest Scale"));
    
    boxWidth = 3;
    mIndexNestOffset = pCurr->CombinePointer(_GP_BOXSIZERHORIZONTAL, &boxWidth,
					     _("Nest Offset"));
    pCurr->CombinePointer(_GP_FLOAT, &mpCParent->mCNestOffset.mpBody[X]);
    pCurr->CombinePointer(_GP_FLOAT, &mpCParent->mCNestOffset.mpBody[Y]);
    pCurr->CombinePointer(_GP_FLOAT, &mpCParent->mCNestOffset.mpBody[Z]);

    boxWidth = 2;    
    mIndexRoudedCurve = pCurr->CombinePointer(_GP_BOXSIZERHORIZONTAL, &boxWidth,
					     _("rounded corner"));
    pCurr->CombinePointer(_GP_FLOAT_SLIDER, &mpCParent->mCRoundedCurve.mBody);
    pCurr->SetRange(0, 49, _MN_LASTITEM, 100);
    pCurr->CombinePointer(_GP_FLOAT, &mpCParent->mCRoundedCurve.mBody);    
    pCurr->SetRange(0, 49, _MN_LASTITEM, 100);

    boxWidth = 2;
    mIndexCrit = pCurr->CombinePointer(_GP_BOXSIZERHORIZONTAL, &boxWidth,
				       _("Critical Factor"));
    pCurr->CombinePointer(_GP_DOUBLE_SLIDER, &mpCParent->mCCritScale.mBody);
    pCurr->SetRange(0, 60, _MN_LASTITEM, 20);
    pCurr->CombinePointer(_GP_DOUBLE, &mpCParent->mCCritScale.mBody);

    pCurr->CombinePointer(_GP_BOXSIZERHORIZONTAL, &boxWidth,
			  _("Use Tree"));
    pCurr->CombinePointer(_GP_BOOL, 
			  &GpCMainFrameCLS->mpCParent->mpCDBoxMain->mCb8Tree.mbBody,
			  _("Main Box"));
    pCurr->CombinePointer(_GP_BOOL, 
			  &GpCMainFrameCLS->mpCParent->mpCDBoxMain->mCb8TreeForCopy.mbBody,
			  _("Copied Boxes"));

    pCurr->CombinePointer(_GP_BOXSIZERHORIZONTAL, &boxWidth,
			  _("Scan Files"));
    pCurr->CombinePointer(_GP_BOOL,
			  &mpCParent->mCbCheckFile.mbBody,
			  _("Real Time"));
    pCurr->CombinePointer(_GP_STATIC_TEXT, NULL);

    pCurr->CombinePointer(_GP_BOXSIZERHORIZONTAL, &boxWidth,
				       _("Split Box"));
    pCurr->CombinePointer(_GP_FLOAT_SLIDER, 
			  &PovVolume_cls::msCSplitBox.mBody);
    pCurr->SetRange(-60,-20, _MN_LASTITEM, 10);
    pCurr->CombinePointer(_GP_FLOAT, 
			  &PovVolume_cls::msCSplitBox.mBody);
    pCurr->SetRange(-6,-2);

    pCurr->CombinePointer(_GP_WXSTRING, &mpCParent->msCStrDataSlot.msBody,
			  _("Data Slot with Tree"));

    wxString pListQuality[5] = 
	{_("Constant for world coordinate"), _("deminish factor 1.75"), _("deminish factor 1.5"), _("deminish factor 1.25"), _("Constant for nesting box")};
    mIndexVolumeQuality = pCurr->CombinePointer
	(_GP_UNSIGNED_INT_LIST, &mpCParent->mCVolumeQuality.mBody,
	 _("Volume Quality"), TRUE, 5, pListQuality);

    /*
    for (int i = 0; i < 5; i++){
	pCurr->CombinePointer(_GP_BOXSIZERHORIZONTAL, &boxWidth,
			      wxString::Format(_T("%s %d"),
					       _("Depth Factor"), i+1));
	pCurr->CombinePointer(_GP_DOUBLE_SLIDER, &mpCParent->mCTreeDepthParam[i].mBody);
	pCurr->SetRange(70, 130, _MN_LASTITEM, 100);
	pCurr->CombinePointer(_GP_DOUBLE, &mpCParent->mCTreeDepthParam[i].mBody);
    }
        
    pCurr->mButtonWidth = 40;

    pCurr->CombinePointer(_GP_BOOL, &DrawingBlock_cls::msThread,
			  wxT("thread"));
    */

    //pCurr->CombinePointerButton(buttonCtrlTreeHotSpot, wxT("Set Hot Spot"));
    
    pCurr->SetFuncHook(HookComboBox, _MN_HOOK_COMBOBOX);

    pCurr->FinishSetting(pBoxSizer, TRUE);
}


TreeBoxRuleGUI_cls::
~TreeBoxRuleGUI_cls(){
    *mppToThis = NULL;
}

void TreeBoxRuleGUI_cls::
UpdateDisplay(){
    //mpCCurrentPath  ->SetLabel(GpCMainFrameCLS->GetCurrentActiveFileWXStr());
    //mpCConvertedPath->SetLabel(mpCParent->GetConvertedStrWX());
    mstrCurrentPath = GpCMainFrameCLS->GetCurrentActiveFileWXStr();
    mstrConvertedPath = mpCParent->GetConvertedStrWX();
    
    mpCMNumRuleA->UpdateValues();
}

void TreeBoxRuleGUI_cls::
HideAndShow(){
    MultiNumericalInputsPanel_cls *pCurr = mpCMNumRuleA;

    bool bAlias = (mpCParent->mCUseReplaceRule.mBody == 1);

    pCurr->ShowItems(mIndexReplaceFrom, 2, bAlias);

    //mpCCurrentPath->Show(bAlias);
    //mpCConvertedPath->Show(bAlias);
    pCurr->ShowItems(mIndexCurrentPath, 1, bAlias);
    pCurr->ShowItems(mIndexConvertedPath, 1, bAlias);
    pCurr->Refresh(TRUE);
    
    pCurr = mpCMNumRuleB;

    bool bNested = (mpCParent->mCType.mBody == _TREE_NESTED);

    pCurr->ShowItems(mIndexTreeFocus, 1, !bNested);
    pCurr->ShowItems(mIndexNestScale, 1, bNested);
    pCurr->ShowItems(mIndexNestOffset, 4, bNested);
    pCurr->ShowItems(mIndexRoudedCurve, 3, bNested);
    pCurr->ShowItems(mIndexCrit, 3, !bNested);

    UpdateDisplay();
    pCurr->GetSizer()->Layout();
    ResizeDialog();
}

void TreeBoxRuleGUI_cls::
OnButtonClose(wxCommandEvent &event){
    //UpdateDisplay();
    mpCParent->UpdateItems();
    CloseEXKey();
}

void TreeBoxRuleGUI_cls::
HookAssign(void *pArg, void *pEvent){
    mspCThis->UpdateDisplay();
}

void TreeBoxRuleGUI_cls::
HookComboBox(void *pArg, void *pEvent){
    mspCThis->HideAndShow();
    mspCThis->UpdateDisplay();
}

TreeBoxRuleGUI_cls* TreeBoxRuleGUI_cls::mspCThis = NULL;

// ----------------------

TreeBoxRule_cls::
TreeBoxRule_cls(wxWindow *pC, wxBitmap *pBitmap)
{
    mpBitmapLink = pBitmap;

    mCConfList.Clear();
    mCConfList.Add(&mCType,            L"TreeType=", L"0");
    mCConfList.Add(&mCNestScale,       L"TreeNestScale=", L"0.5");
    mCConfList.Add(&mCNestOffset,      L"TreeNestOffset=", L"0 0 0");
    mCConfList.Add(&mCRoundedCurve,    L"TreeNestRoundCurve=", L"0");
    mCConfList.Add(&mCFocusType,       L"TreeFocusType=", L"0");
    mCConfList.Add(&mCUseReplaceRule,  L"AliasRuleUse=", L"0");
    mCConfList.Add(&mCRuleFrom,        L"AliasRuleBaseFrom=", L"from");
    mCConfList.Add(&mCRuleTo,          L"AliasRuleBaseTo="  , L"to");
    mCConfList.Add(&mCbCheckFile,      L"TreeScanFile="    , L"0");
    mCConfList.Add(&mCDepthMax,        L"TreeDepthMax="    , L"3");
    mCConfList.Add(&mCDepthMin,        L"TreeDepthMin="    , L"0");
    //mCConfList.Add(&mCDepthOffset,     L"TreeDepthOffset=" , L"0");
    mCConfList.Add(&mCCritScale,       L"TreeCritScale="   , L"1");
    mCConfList.Add(&mCVolumeQuality,   L"TreeVolumeQuality=", L"0");
    mCConfList.Add(&mCTreeDepthParam[0],  L"TreeDepthParam0="  , L"1");
    mCConfList.Add(&mCTreeDepthParam[1],  L"TreeDepthParam1="  , L"1");
    mCConfList.Add(&mCTreeDepthParam[2],  L"TreeDepthParam2="  , L"1");
    mCConfList.Add(&mCTreeDepthParam[3],  L"TreeDepthParam3="  , L"1");
    mCConfList.Add(&mCTreeDepthParam[4],  L"TreeDepthParam4="  , L"1");
    InitGUI(pC);
}

TreeBoxRule_cls::
~TreeBoxRule_cls(){
    if (mpCGUI != NULL) delete mpCGUI;
}

#include "../MYAPI/MsgBox.h"

void TreeBoxRule_cls::
InitGUI(wxWindow *pC){
    mpCGUI = new TreeBoxRuleGUI_cls(this, &mpCGUI, pC, 
				    mCScreenRect.GetPosition(),
				    mCScreenRect.GetSize());
    SetPDialog(mpCGUI);
}

void TreeBoxRule_cls::
UpdateItems(bool bForce){
    mpCGUI->mpCMNumRuleA->UpdateValuesAll(bForce);
    mpCGUI->mpCMNumRuleB->UpdateValuesAll(bForce);
}

std::vector < wxString > TreeBoxRule_cls::
GetConvertedStrVector(){
    std::vector < wxString > VstrOrg;
    for (int i = 0; i < _DF3_MAX_SLOT; i++){
	wxString strOrg = GpCMainFrameCLS->GetFilePathWXStr(i);
	if (mCUseReplaceRule.mBody == 1)
	    strOrg.Replace(mCRuleFrom.msBody, mCRuleTo.msBody);
	VstrOrg.push_back(strOrg);
    }
    
    // TimeRemappɎ̃Xebv̖O
    for (int i = 0; i < _DF3_MAX_SLOT; i++){
	wxString strOrg = GpCMainFrameCLS->GetFilePathNextWXStr(i);
	if (mCUseReplaceRule.mBody == 1)
	    strOrg.Replace(mCRuleFrom.msBody, mCRuleTo.msBody);
	VstrOrg.push_back(strOrg);
    }

    return VstrOrg;
    /* ݊mFłĂȂ̂ł΂炭c
    std::wstring strOrg = 
	wxConvLibc.cWX2WC(GpCMainFrameCLS->GetCurrentActiveFileWXStr());
    std::wstring::size_type pos = 
	strOrg.find(mCRuleFrom.msBody);
    if (pos != std::wstring::npos)
	strOrg.replace(pos,
		       mCRuleFrom.msBody.size(),
		       mCRuleTo.msBody);
    return strOrg;
    */
}

wxString TreeBoxRule_cls::
GetConvertedStrWX(){
    //return wxConvFile.cWC2WX(GetConvertedStr().c_str());
    wxString strOrg = GpCMainFrameCLS->GetCurrentActiveFileWXStr();

    if (mCUseReplaceRule.mBody == 0) return strOrg;

    int pos = strOrg.find(/*mstrRuleFrom*/mCRuleFrom.msBody);
    if (pos == wxNOT_FOUND) return strOrg;
    wxString strRep = strOrg.SubString(0, pos-1) + /*mstrRuleTo*/mCRuleTo.msBody + strOrg.SubString(pos + /*mstrRuleFrom*/mCRuleFrom.msBody.size(), strOrg.Length());
    return strRep;
}

void TreeBoxRule_cls::
GetChildNestPos(float minPos[3], float maxPos[3]){
    LOOP_XYZ {
	minPos[xyz] = 0.5 - 0.5 * mCNestScale.mBody;
	maxPos[xyz] = 0.5 + 0.5 * mCNestScale.mBody; }

    LOOP_XYZ{
	minPos[xyz] += mCNestOffset.mpBody[xyz];
	maxPos[xyz] += mCNestOffset.mpBody[xyz]; }
}

void TreeBoxRule_cls::
GetCoordinateInChild(float coef1[3], float coef0[3]){
    LOOP_XYZ coef1[xyz] = 1 / mCNestScale.mBody;
    LOOP_XYZ coef0[xyz] = 0.5 + mCNestOffset.mpBody[xyz] -
	0.5 / mCNestScale.mBody;
}

// -----

wxString TreeBoxRule_cls::
SerializeConf(){
    return mCConfList.SerializeAll() + msCStrDataSlot.Serialize();
}

void TreeBoxRule_cls::
ReadStrLine(std::wstring strLine){
    mCConfList.ReadStrLineAll(strLine);
    msCStrDataSlot.ReadStrLine(strLine);
}

ConfItemSTR_cls TreeBoxRule_cls::msCStrDataSlot(L"TreeBoxDataSlot=", L"0123");
