// (setq c-basic-offset 4)
// "clsAtoiSpinCtrl.h"

#include "clsSpinCtrlEX.h"

SpinCtrlEX_cls::
SpinCtrlEX_cls(wxWindow *parent, wxWindowID id, wxString initStr,
	       wxPoint pos, wxSize size, long style, int min, int max) 
    : wxSpinCtrl(parent, id, initStr,
		 pos, size, style, min, max)
{
    mbAssignByTab = TRUE;
    mbReturnForTab = TRUE;
    mbHookWBK_SPACE = TRUE;

    SetWindowStyle(GetWindowStyle() | wxWANTS_CHARS);
    
    Connect(id, wxEVT_SET_FOCUS,
	    wxCommandEventHandler(SpinCtrlEX_cls::OnFocus));

    Connect(id, wxEVT_KILL_FOCUS,
	    wxCommandEventHandler(SpinCtrlEX_cls::OnKillFocus));
    Connect(id, wxEVT_COMMAND_SPINCTRL_UPDATED,
	    wxSpinEventHandler(SpinCtrlEX_cls::OnSpinUpdate));
    Connect(id, wxEVT_KEY_DOWN,
	    wxKeyEventHandler(SpinCtrlEX_cls::OnKeyDown));
    Connect(id, wxEVT_CHAR,
	    wxKeyEventHandler(SpinCtrlEX_cls::OnChar));
}

void SpinCtrlEX_cls::
EnableHookSpace(bool flag){
    mbHookWBK_SPACE = flag;
}

void SpinCtrlEX_cls::
OnKillFocus(wxCommandEvent& event){
    UpdateValueFromText(TRUE);
    event.Skip(); 
}

void SpinCtrlEX_cls::
OnSpinUpdate(wxSpinEvent& event){
    event.Skip();
    UpdateValueFromText(/*TRUE*/);
}

void SpinCtrlEX_cls::
OnFocus(wxCommandEvent& event){
    SetSelection(-1, -1);
    event.Skip();
}

void SpinCtrlEX_cls::
OnChar(wxKeyEvent& event){
    // $B>e$N(Bwindow$B$G%?%V0\F0$5$l$J$1$l$P$3$3$K%$%Y%s%H$,Mh$k$N$G<+A0$G(B
    
    //MsgBox(NULL, "tab", "tabevent");
    if (event.GetKeyCode() == WXK_TAB){	
	if (mbAssignByTab == TRUE) UpdateValueFromText(TRUE);
	if (OnCharTab(event) == FALSE){
	    if ((event.GetModifiers() & wxMOD_SHIFT) ||
		(event.GetModifiers() & wxMOD_CONTROL))
		Navigate(wxNavigationKeyEvent::IsBackward);
	    else
		Navigate(wxNavigationKeyEvent::IsForward);
	}
#ifndef WIN32
	// KillFocus$B$NJ}$,CY$/$J$k$N<+A0$G$b=hM}(B
	/*
	wxCommandEvent dummyEvent1;
	OnKillFocus(dummyEvent1);
	wxChildFocusEvent dummyEvent2;
	GetParent()->AddPendingEvent(dummyEvent2);
	*/
#endif 	
	return;
    }

    if (mbHookWBK_SPACE == TRUE && event.GetKeyCode() == WXK_SPACE){
	wxCommandEvent dummyEvent1;
	OnKillFocus(dummyEvent1);
	SetSelection(-1, -1);
	GetParent()->AddPendingEvent(event);
	return;
    }

    if (event.GetKeyCode() == WXK_RETURN){
#ifndef WIN32
	// KillFocus$B$NJ}$,CY$/$J$k$N<+A0$G$b=hM}(B
	wxCommandEvent dummyEvent1;
	OnKillFocus(dummyEvent1);
	/*
	wxChildFocusEvent dummyEvent2;
	GetParent()->AddPendingEvent(dummyEvent2);
	*/
#endif 	
	GetParent()->AddPendingEvent(event);
	if (mbReturnForTab == TRUE)
	    Navigate(wxNavigationKeyEvent::IsForward);
	return;
    }

    event.Skip();
}

void SpinCtrlEX_cls::
OnKeyDown(wxKeyEvent& event){
    if (event.GetModifiers() == wxMOD_NONE || event.GetKeyCode() == WXK_TAB)
	event.Skip();

    if (event.GetKeyCode() != WXK_TAB)
	if (event.GetKeyCode() <= '0' && event.GetKeyCode() >= '9') {
	    wxGetTopLevelParent(this)->AddPendingEvent(event);
	    //wxPostEvent(GetParent()->GetEventHandler(), event);
	}
    event.Skip();
}
