// -*- c -*- 
// (setq c-basic-offset 4)
// "clsAtoSTextCtrl.h"

#include "clsAtoWXSTextCtrl.h"
#include "../MYAPI/MsgBox.h"
#include "../COMMON/clsFilename.h"

#include <wx/filename.h>

AtoWXSTextCtrl_cls::
AtoWXSTextCtrl_cls(wxWindow *parent, wxWindowID id, wxString strInit,
		   wxPoint pos, wxSize size, long style, 
		   const wxValidator& validator) : 
TextCtrlEX_cls(parent, id, strInit,
	       pos, size, style, validator)
{
    mwsValue = strInit;

    Connect(id, wxEVT_KILL_FOCUS,
	    wxFocusEventHandler(AtoWXSTextCtrl_cls::OnKillFocus));
}

void AtoWXSTextCtrl_cls::
UpdateValueFromText(/*bool assign*/){
    mwsValue = GetLineText(0);
    
    if (/*assign ==*/TRUE){
	wxKeyEvent dummy(wxEVT_CHAR);
	dummy.m_keyCode = WXK_RETURN;
	dummy.SetId(GetId());
	GetParent()->AddPendingEvent(dummy);
    }
}

void AtoWXSTextCtrl_cls::
UpdateDisplay(){
    SetValue(mwsValue);
}

wxString AtoWXSTextCtrl_cls::
GetWXStr(){
    return mwsValue;
}

void AtoWXSTextCtrl_cls::
SetValueWXStr(wxString strValue){
    mwsValue = strValue;
    UpdateDisplay();
}

void AtoWXSTextCtrl_cls::
OnKillFocus(wxFocusEvent &event){
    UpdateValueFromText();
    UpdateDisplay();
    event.Skip();
}

// -----

AtoWXSTextPathCtrl_cls::
AtoWXSTextPathCtrl_cls(wxWindow *parent, wxWindowID id, wxString strInit,
		       wxPoint pos, wxSize size, long style,
		       const wxValidator& validator): 
wxPanel(parent, id, pos, size, style)
{
    mpCTextCtrl = new AtoWXSTextCtrl_cls(this, wxID_ANY, strInit);
    mpCButton = new wxButtonEX(this, wxID_ANY, wxT(".."), wxDefaultPosition, wxSize(30,-1));
    Connect(mpCButton->GetId(), wxEVT_COMMAND_BUTTON_CLICKED,
	    wxCommandEventHandler(AtoWXSTextPathCtrl_cls::OnButton));
    mpstrDefaultDirLink = NULL;
    mStyle = wxFD_FILE_MUST_EXIST;
	    
    wxBoxSizer *pBoxSizer = new wxBoxSizer(wxHORIZONTAL);
    
    pBoxSizer->Add(mpCTextCtrl, 1, wxEXPAND);
    pBoxSizer->Add(mpCButton, 0, wxEXPAND);
    
    SetSizerAndFit(pBoxSizer);
}

AtoWXSTextPathCtrl_cls::
~AtoWXSTextPathCtrl_cls(){
    delete mpCTextCtrl;
    delete mpCButton;
}

void AtoWXSTextPathCtrl_cls::
UpdateValueFromText(/*bool assign*/){
    mpCTextCtrl->UpdateValueFromText(/*assign*/);
}

void AtoWXSTextPathCtrl_cls::
UpdateDisplay(){
    mpCTextCtrl->UpdateDisplay();
};

wxString AtoWXSTextPathCtrl_cls::
GetWXStr(){
    return mpCTextCtrl->mwsValue;
}

void AtoWXSTextPathCtrl_cls::
SetValueWXStr(wxString strValue){
    mpCTextCtrl->SetValueWXStr(strValue);
}

void AtoWXSTextPathCtrl_cls::
OnButton(wxCommandEvent& event){
    wxString strDefaultDir;
    wxString strDefaultFileName = mstrDefaultFileName;
    if (mpstrDefaultDirLink == NULL)
	strDefaultDir = wxT("");
    else
	strDefaultDir = *mpstrDefaultDirLink;

    wxFileName CTmpFile(GetWXStr());
    SplitPathWX_cls CSplit(GetWXStr());    
    if (CTmpFile.IsFileReadable() == TRUE){
	strDefaultDir = CSplit.GetPathWXStr(_FN_DRIVE_DIR);
	strDefaultFileName = CSplit.GetPathWXStr(_FN_FNAME_EXT);
    }

    wxFileDialog *pDialog = new wxFileDialog
	(this, wxT("Choose File"), strDefaultDir, strDefaultFileName, mstrFilter,
	 mStyle);
    
    if (pDialog->ShowModal() == wxID_OK){
	SetValueWXStr(pDialog->GetPath());
	event.SetId(GetId());
	GetParent()->AddPendingEvent(event);
    }

    delete pDialog;
}
