// -*- c -*-
// "clsEditString.h"
// (setq c-basic-offset 4)

#include "clsEditString.h"

void EditString_cls::
SetItems(wxWindow *pCParent, std::string strLabel, wxSize size, int type, int ID){

    mpCParent = pCParent;
    mpCButtonEdit = NULL;
    mpCButtonSelect = NULL;

    msLabel = strLabel;
    msBody = "NONE";
    mType = type;
    
    switch(mType){
    case _STREDIT_LABEL_TXT:
	mpCTextLabel = 
	    new wxStaticText(pCParent, ID, wxString::FromAscii(msLabel.c_str()),
			     wxDefaultPosition, size);
	break;
    case _STREDIT_LABEL_BUTTON:
	mpCButtonLabel = 
	    new wxButton(pCParent, ID, wxString::FromAscii(msLabel.c_str()),
			 wxDefaultPosition, size);
	break;
    }
    
    mpCBody   =	new wxStaticText(pCParent, wxID_ANY, wxT("None"));

    
}

// -----
void EditString_cls::
SetEdit (int ID, wxPoint pos, wxSize size, wxString strLabel){
    mpCButtonEdit = new wxButton (mpCParent, ID, strLabel, pos, size);
}

void EditString_cls::
SetSelect(int ID, wxPoint pos, wxSize size, wxString strLabel){
    mpCButtonSelect = new wxButton (mpCParent, ID, strLabel, pos, size);
}

void EditString_cls::
Connect2Sizer(wxFlexGridSizer *pSizer){
    if (mpCButtonEdit != NULL)
	pSizer->Add(mpCButtonEdit, 0, wxALIGN_CENTER_VERTICAL | wxEXPAND);
    if (mpCButtonSelect != NULL)
	pSizer->Add(mpCButtonSelect, 0, wxALIGN_CENTER_VERTICAL | wxEXPAND);
    if (mType == _STREDIT_LABEL_TXT)
	pSizer->Add(mpCTextLabel, 0, wxALIGN_CENTER_VERTICAL);
    else
	pSizer->Add(mpCButtonLabel, 0, wxALIGN_CENTER_VERTICAL);

    pSizer->Add(mpCBody, 0, wxALIGN_CENTER_VERTICAL);
}

// -----

void EditString_cls::
SelectFile(wxString strFilter, wxString strLabel){
    wxFileDialog *pDialog = new wxFileDialog
	(mpCParent, 
	 strLabel, wxT(""), wxT(""),
	 strFilter, wxFD_FILE_MUST_EXIST);
    if (pDialog->ShowModal() == wxID_OK){
	msBody = (std::string)(pDialog->GetPath().ToAscii());
	ConvertDos2UNIX();
    }
    delete pDialog;
}

void EditString_cls::
SelectDirectory(wxString strLabel){
    wxDirDialog *pDialog = new wxDirDialog(mpCParent, strLabel);
    if (pDialog->ShowModal() == wxID_OK){
	msBody = (std::string)(pDialog->GetPath().ToAscii());
	ConvertDos2UNIX();
    }
    delete pDialog;
}

// -----

void EditString_cls::
SetLabels(){
    if (mType == _STREDIT_LABEL_TXT)
	mpCTextLabel->SetLabel( wxString::FromAscii(msLabel.c_str()));
    mpCBody  ->SetLabel( wxString::FromAscii(msBody  .c_str()));
}

bool EditString_cls::
ReadItems(std::string strLine){
    std::string::size_type loc = strLine.find(msLabel, 0);
    if (loc != std::string::npos){
	msBody = strLine.c_str() + loc + strlen(msLabel.c_str());
	return TRUE;
    }
    return FALSE;
}

void EditString_cls::
ConvertDos2UNIX(){
    for (unsigned int i = 0; i < msBody.size(); i++){
	if (msBody[i] == '\\') msBody[i] = '/';
	if (msBody[i] == ' '){
	    msBody.insert(i, "\\"); 
	    i++; }
    }
}
