// -*- c -*-
// "clsMultiPointInput.cpp"

#ifndef _MULTI_POINT_INPUT_H_
#define _MULTI_POINT_INPUT_H_

#include "clsDialogController.h"
#include "../PARAMETER/clsMultiParameters.h"
#include "../MAINCANVAS/clsDrawItem.h"

class MultiNumericalInputsPanel_cls; 
class FrameMain_cls; 
class MultiPointInput_cls;

class MultiPointInputGUI_cls : 
public MultiParametersGUI_cls,
public MultiParameters_cls
{
 public:
    MultiPointInputGUI_cls(wxWindow *pC, MultiPointInput_cls* pCParent,
			   wxString strTitle, 
			   wxPoint pos, wxSize size, 
			   std::wstring strItemNum, std::wstring strTag,
			   unsigned int dimension, wxBitmap *pBitmap = NULL);
    
    MultiPointInput_cls *mpCParentPInputBase;
    
    virtual void ReconnectMNumParam() = 0;
    
    void UpdateValues();
    void UpdateInterpolatedValues(double doubleIndex);

    void OnApplyBase();
    
    //void UpdateComboBox();
    void UpdateComboBoxPropagate();

    void AddItemPropagate();
    void RemoveItemPropagate();
};

// ------------------------

class MultiPointInput_cls : public DialogControl_cls, DrawItem_cls
{ 
 public:
    MultiPointInput_cls();

    MultiPointInputGUI_cls* mpCGUIBase;
    void SetPGUI(MultiPointInputGUI_cls* pCGUI);

    wxString mTagStr;
    void SetTag(wxString strTag);
    void SetParent(FrameMain_cls *pC);
    FrameMain_cls*   mpCParentFrame;

    virtual void InitGUI(wxWindow *pC) = 0;
    void UpdateItems(bool bForce = FALSE);
    int  GetSelectedIndex();
    void DrawGLPath(unsigned int dispList, double scale, int index);

    void UpdateActiveOnTL();
    void UpdateActiveFromTag(wxString strTag);
    bool UpdateInterpolatedValues();
};

#endif
