// -*- c++ -*- 
// (setq c-basic-offset 4)
// "clsMain.cpp"

#ifndef _MAIN_H_
#define _MAIN_H_

#include <fstream>

#include "SRC/CONFITEM/clsConfItem.h"
#include "SRC/PARAMETER/clsParameters.h"
#include "SRC/MAINCANVAS/clsFilePathEditor.h"

class CustomColor_cls;
class DF3_cls;
class DF3SeqCtrl_cls;
class DF3Sequence_cls;
class DrawingBlock_cls;
class FilterCtrl_cls;
class FrameMain_cls;
class ImgSequence_cls;
class ImportList_cls;
class LightSRC_cls;
class Main_cls;
class Parameters_cls;
class TexPropertyCtrl_cls;
class TimeCtrl_cls;
class TreeBoxRule_cls;
class Scene_cls;

#ifdef _DEBUG
#include <stdlib.h>
#include <crtdbg.h>
#define new new(_NORMAL_BLOCK, __FILE__, __LINE__)
#endif

class Main_cls{
 public:
    Main_cls();
    ~Main_cls();

    int mPID;

    // Global ̑
    std::vector < Parameters_cls* > mVPParamInstancePrim;
    void UpdateParamInstancePrim();
    Parameters_cls* mpCBoxSize; // e̕TCY
    Parameters_cls* mpCBoxRotate; // ẻ]

    TimeCtrl_cls*   mpCTime;
    Scene_cls*      mpCScene; 
    FrameMain_cls*  mpCFrame;
    DF3SeqCtrl_cls* mpCDF3SeqCtrlLink;
    DF3Sequence_cls* GetPDF3SeqActive();
    DF3_cls*         GetPDF3Active();

    ConfItemBOOL_cls mCbToolTip;
    FPathEdit_cls mCFPathEditDLG;

    wxBitmap *mpBitmapColor, *mpBitmapLight;

    //----

    DrawingBlock_cls* mpCDBoxMain;
    TreeBoxRule_cls*  mpCTreeBoxRule;
    LightSRC_cls*     mpCLightSRC;
    
    ImportList_cls*  mpCImportList;
    CustomColor_cls* mpCCustomColor;

    TexPropertyCtrl_cls* mpCTexPropertyCtrl;

    //----

    bool bOneTimeWarningShowed_SceneLength;
    //----

    void RefreshDialogs();
    
    //----
    
    ImgSequence_cls* mpCImgSequence;
    
    void OpenFileSequence(wxString strFilename);
    void AddFileSequence(wxString strFilename, bool bImageTimeSequence = FALSE);

    void ImportParamInitialize();
    void ImportParamMain(std::wistream &istream, std::wstring strLine);
    void ImportParam(unsigned int type);

    void OpenFileEdit(wxString strTitle, bool mbAddMode);

    bool IsPovrayCondistionSatisfiled();
    bool ProcOutputPovRay(int stereo);
    void OutputPovStrObjDensity(std::wfstream &ofstream,
				std::vector < DrawingBlock_cls > &VCDrawingCls, 
				PositionAndDirection_cls CCamGlobalCoord, int frame);
    void OutputPovRayMain(std::wfstream &ofstream, int frame);
    bool OutputPovRayIO(std::wstring strFile, int frame);
    bool OutputPovRayIOAnim(unsigned int *pInit, unsigned int *pFin, 
			    bool bQuery = FALSE);
    
    void ExportDF3Seq();
    void ExportImgSeq();

    // ----
    void ReadStrLine(std::wstring strLine);
    wxString Serialize();

};

#endif
