// -*- c++ -*-
// "clsTimeCtrl.h"

#ifndef _TIME_CTRL_H
#define _TIME_CTRL_H

#include "SRC/CONFITEM/clsConfItem.h"
#include "SRC/PARAMETER/clsParameters.h"
#include "SRC/WIDGETCTRL/clsMultiNumericalInputs.h"

#include <wx/wx.h>
#include <fstream>
#include <string>

#define _TIME_CTRL_CURRENT -1

#define _TIME_CTRL_PLAY_TEX    0
#define _TIME_CTRL_PLAY_MEM_XY 1
#define _TIME_CTRL_PLAY_MEM_Z  2
#define _TIME_CTRL_PLAY_FULL   3

class DF3SeqCtrl_cls;

class TimeCtrl_cls{
 public:
    TimeCtrl_cls();

    bool mbPlayTex;
    int  mPlayMode;
    int  mPlayDirection;

    //static DF3SeqGUI_cls *mspCDF3SeqGUI;
    static DF3SeqCtrl_cls *mspCDF3SeqCtrlLink;

    Parameters_cls   mCTimeRemap;

    unsigned int mFrame;    // ݂̃t[
    unsigned int mCustomRegionMin, mCustomRegionMax; //JX^͈

    ConfItemList_cls mCConfListTime;
    ConfItemUINT_cls mCMaxFrame; // Ō̃Xebv܂
    ConfItemUINT_cls mCWAMin;
    ConfItemUINT_cls mCWAMax; // Ō̃Xebv܂
    ConfItemUINT_cls mCAAMin;
    ConfItemUINT_cls mCAAMax; // Ō̃Xebv܂

    ConfItemBOOL_cls mCbUseTimeRemap;
    ConfItemINT_cls  mCStep;
    ConfItemBOOL_cls mCbRepeat;

    ConfItemUINT_cls mCSceneLengthType;

    void DispatchTimeData();
    void UpdateDF3SeqGUI(bool bUpdateParent = FALSE);
    void UpdateDF3SeqGUISlider();
    void SetWorkingArea(int maxIndex);
    void CheckWorkingArea();

    void RemapParameterKeys(double rate);

    void SetBUseTimeRemap(bool bUse);

    unsigned int GetRemappedIndex(int frame);
    double GetRemappedIndexDouble(int frame);
    static int GetInterval(int frameNumber = -1);
    double GetDoubleIndex(int frame = -1);
    double GetDoubleIndexWAMin();
    double GetDoubleIndexWAMax();
    double GetDoubleIndexAAMin();
    double GetDoubleIndexAAMax();
    
    int GetOffsetForImgSeq();
    unsigned int CalcNextStep(int increment, bool bForceWA = TRUE, 
			      bool bCheckRepeat = TRUE);
    unsigned int GetIndexFromDouble(double doubleIndex);

    bool IsWorkingArea(unsigned int frame);
    void SetIndexWithinWA();
    void SetMaxFrame(unsigned int maxFrame);
    void CheckAfterMaxFrameChange();
    bool OpenCustomRegionDialog(wxWindow *pC);
    void ZoomIn();
    void ZoomOut();

    void EmptySnippingTag();
    void SnipNext();
    void SnipPrev();
    void SetWAInHere();
    void SetWAOutHere();
    
    void SetIndexFromDouble(double doubleIndex);
    void SetIndex(unsigned int index);

    void FrameStep(int step, bool bForceWA = TRUE);
    void FrameMoveL(int step);

    // ---

    wxString GetPovStrLength();
    void ReadStrLine(std::wistream &istream, std::wstring strLine);
    wxString SerializeParam();
};

#endif
